class EUTServerAdmin expands WebApplication config;

var localized string MyRoot;
var class<GameInfo> GameClass;
var string GameClassName;

var ListItem IncludeMutators;
var ListItem ExcludeMutators;

var config string MenuPage;
var config string RootPage;
var config string CurrentPage;
var config string DefaultsPage;
var config string DefaultBG;
var config string HighlightedBG;

var bool    bHitSounds,
            bCheckDefaults,
            bEnhancedSprees,
            bEnhancedMessages,
            bShowIPS,
            bLogMods,
            bDemoRequest,
            bTeamBeacon,
            bLeaderBeacon,
            bAutoTaunts,
            bAntiTimer,
            bIpToCountry,
            bEnhancedDeathMessages,
            bKickSpeedHack,
            bReport,
            bCTF,
            bTDM,
            bDM,
            bStatLink,
            bAlwaysRecordTourney,
            bKickMinY,
            bNoOverTime,
            bScoreBoardEff,
            bUsesCustomWeapon,
            bSuddenDeathOverTime,
            bNoFlockPawns,
            bNoDroppedFlags;

var string  AnnouncerLevel,
            FlagCap,
            AssistsBonus,
            FlagKill,
            CoversBonus,
            SealsBonus,
            DeniedBonus,
            SavesBonus,
            RedTeamName,
            BlueTeamName,
            TraceDistance,
            MinY,
            TransKillMessage,
            ImpactKillMessage,
            EnforcerKillMessage,
            BioKillMessage,
            ShockRifleKillMessage,
            PulseGunKillMessage,
            RipperKillMessage,
            MiniGunKillMessage,
            FlakCannonKillMessage,
            RocketLauncherKillMessage,
            SniperRifleKillMessage,
            CustomWeaponKillMessage,
            AerialKillBio,
            AerialKillRipper,
            AerialKillFlak,
            AerialKillRockets,
            AerialKillSniper,
            AerialKillSuper,
            AerialKillTrans,
            AerialKillCombo,
            AerialKillEnforcer,
            AerialKillPulse,
            AerialKillMini,
            AerialKillPiston,
            AerialKillCustom,
            IpToCountryTexturePackage,
            CustomWeaponName,
            SetFOV,
            MessageOfTheDay,
            FlagSaveDistance,
            FlagDeniedDistance,
            FlagCoverVisibleDistance,
            FlagCoverHiddenDistance;

event Init()
{
	local SmartCTFGame MyGame;
	local EUTTeamGamePlus TGP;
	local EUTDeathMatchPlus DMG;
	local string ClassName;

	Super.Init();

    bCTF = false;
    bTDM = false;
    bDM = false;

	foreach Level.AllActors(class'SmartCTFGame', MyGame)
	{
	    if(MyGame != none)
	    {
	       GameClass = class<GameInfo>(DynamicLoadObject("EUTSource.SmartCTFGame", class'Class'));
	       GameClassName = GetClassName(string(GameClass));
           log("EUT CTF Web Server Initialized",'EUT');
        }
        else
           log("EUT CTF Web Server Failure",'Warning');
    }
    foreach Level.AllActors(class'EUTTeamGamePlus', TGP)
	{
	    if(TGP != none)
	    {
	       GameClass = class<GameInfo>(DynamicLoadObject("EUTSource.EUTTeamGamePlus", class'Class'));
	       GameClassName = GetClassName(string(GameClass));
           log("EUT TDM Web Server Initialized",'EUT');
        }
        else
           log("EUT TDM Web Server Failure",'Warning');
    }
    foreach Level.AllActors(class'EUTDeathMatchPlus', DMG)
	{
	    if(DMG != none)
	    {
	       GameClass = class<GameInfo>(DynamicLoadObject("EUTSource.EUTDeathMatchPlus", class'Class'));
	       GameClassName = GetClassName(string(GameClass));
           log("EUT DM Web Server Initialized",'EUT');
        }
        else
           log("EUT DM Web Server Failure",'Warning');
    }
    LoadDefaults();
    LoadMutators();
}

function string GetClassName(string ClassName)
{
    ClassName = mid(ClassName, instr(ClassName, ".") + 1);
    ClassName = caps(ClassName);
    return ClassName;
}

function LoadDefaults()
{
    switch(GameClassName)
    {
        case "SMARTCTFGAME":
            bHitSounds = class<SmartCTFGame>(GameClass).default.bHitSounds;
            bCheckDefaults = class<SmartCTFGame>(GameClass).default.bCheckDefaults;
            bEnhancedSprees = class<SmartCTFGame>(GameClass).default.bEnhancedSprees;
            bEnhancedMessages = class<SmartCTFGame>(GameClass).default.bEnhancedMessages;
            bShowIPS = class<SmartCTFGame>(GameClass).default.bShowIPS;
            bLogMods = class<SmartCTFGame>(GameClass).default.bLogMods;
            bDemoRequest = class<SmartCTFGame>(GameClass).Default.bDemoRequest;
            bTeamBeacon = class<SmartCTFGame>(GameClass).Default.bTeamBeacon;
            bEnhancedDeathMessages = class<SmartCTFGame>(GameClass).Default.bEnhancedDeathMessages;
            bKickSpeedHack = class<SmartCTFGame>(GameClass).Default.bKickSpeedHack;
            bReport = class<SmartCTFGame>(GameClass).Default.bReport;
            bAutoTaunts = class<SmartCTFGame>(GameClass).Default.bAutoTaunts;
            bStatLink = class<SmartCTFGame>(GameClass).Default.bStatLink;
            bAlwaysRecordTourney = class<SmartCTFGame>(GameClass).default.bAlwaysRecordTourney;
            bKickMinY = class<SmartCTFGame>(GameClass).default.bKickMinY;
            bNoOverTime = class<SmartCTFGame>(GameClass).Default.bNoOverTime;
            bScoreBoardEff = class<SmartCTFGame>(GameClass).Default.bScoreBoardEff;
            bIpToCountry = class<SmartCTFGame>(GameClass).Default.bIpToCountry;
            bUsesCustomWeapon = class<SmartCTFGame>(GameClass).Default.bUsesCustomWeapon;
            bAntiTimer = class<SmartCTFGame>(GameClass).Default.bAntiTimer;
            bNoFlockPawns = class<SmartCTFGame>(GameClass).Default.bNoFlockPawns;
            bNoDroppedFlags = class<SmartCTFGame>(GameClass).Default.bNoDroppedFlags;

            TransKillMessage = class<SmartCTFGame>(GameClass).default.TransKillMessage;
            ImpactKillMessage = class<SmartCTFGame>(GameClass).default.ImpactKillMessage;
            EnforcerKillMessage = class<SmartCTFGame>(GameClass).default.EnforcerKillMessage;
            BioKillMessage = class<SmartCTFGame>(GameClass).default.BioKillMessage;
            ShockRifleKillMessage = class<SmartCTFGame>(GameClass).default.ShockRifleKillMessage;
            PulseGunKillMessage = class<SmartCTFGame>(GameClass).default.PulseGunKillMessage;
            RipperKillMessage = class<SmartCTFGame>(GameClass).default.RipperKillMessage;
            MiniGunKillMessage = class<SmartCTFGame>(GameClass).default.MiniGunKillMessage;
            FlakCannonKillMessage = class<SmartCTFGame>(GameClass).default.FlakCannonKillMessage;
            RocketLauncherKillMessage = class<SmartCTFGame>(GameClass).default.RocketLauncherKillMessage;
            SniperRifleKillMessage = class<SmartCTFGame>(GameClass).default.SniperRifleKillMessage;
            CustomWeaponKillMessage = class<SmartCTFGame>(GameClass).Default.CustomWeaponKillMessage;
            AerialKillBio = class<SmartCTFGame>(GameClass).default.AerialKillBio;
            AerialKillRipper = class<SmartCTFGame>(GameClass).default.AerialKillRipper;
            AerialKillFlak = class<SmartCTFGame>(GameClass).default.AerialKillFlak;
            AerialKillRockets = class<SmartCTFGame>(GameClass).default.AerialKillRockets;
            AerialKillSniper = class<SmartCTFGame>(GameClass).default.AerialKillSniper;
            AerialKillSuper = class<SmartCTFGame>(GameClass).default.AerialKillSuper;
            AerialKillTrans = class<SmartCTFGame>(GameClass).default.AerialKillTrans;
            AerialKillCombo = class<SmartCTFGame>(GameClass).default.AerialKillCombo;
            AerialKillEnforcer = class<SmartCTFGame>(GameClass).default.AerialKillEnforcer;
            AerialKillPulse = class<SmartCTFGame>(GameClass).default.AerialKillPulse;
            AerialKillMini = class<SmartCTFGame>(GameClass).default.AerialKillMini;
            AerialKillPiston = class<SmartCTFGame>(GameClass).default.AerialKillPiston;
            AerialKillCustom = class<SmartCTFGame>(GameClass).Default.AerialKillCustom;
            RedTeamName = class<SmartCTFGame>(GameClass).default.RedTeamName;
            BlueTeamName = class<SmartCTFGame>(GameClass).default.BlueTeamName;
            CustomWeaponName = class<SmartCTFGame>(GameClass).Default.CustomWeaponName;
            IpToCountryTexturePackage = class<SmartCTFGame>(GameClass).Default.IpToCountryTexturePackage;
            MessageOfTheDay = class<SmartCTFGame>(GameClass).Default.MessageOfTheDay;

            MinY = String(class<SmartCTFGame>(GameClass).Default.MinY);
            TraceDistance = String(class<SmartCTFGame>(GameClass).Default.TraceDistance);
            AnnouncerLevel = String(class<SmartCTFGame>(GameClass).Default.AnnouncerLevel);
            FlagCap = String(class<SmartCTFGame>(GameClass).Default.FlagCap);
            AssistsBonus = String(class<SmartCTFGame>(GameClass).Default.AssistsBonus);
            FlagKill = String(class<SmartCTFGame>(GameClass).Default.FlagKill);
            CoversBonus = String(class<SmartCTFGame>(GameClass).Default.CoversBonus);
            SealsBonus = String(class<SmartCTFGame>(GameClass).Default.SealsBonus);
            DeniedBonus = String(class<SmartCTFGame>(GameClass).Default.DeniedBonus);
            SavesBonus = String(class<SmartCTFGame>(GameClass).Default.SavesBonus);
            SetFOV =  String(class<SmartCTFGame>(GameClass).Default.SetFOV);
            FlagSaveDistance = String(class<SmartCTFGame>(GameClass).Default.FlagSaveDistance);
            FlagDeniedDistance = String(class<SmartCTFGame>(GameClass).Default.FlagDeniedDistance);
            FlagCoverVisibleDistance = String(class<SmartCTFGame>(GameClass).Default.FlagCoverVisibleDistance);
            FlagCoverHiddenDistance = String(class<SmartCTFGame>(GameClass).Default.FlagCoverHiddenDistance);
            break;

        case "EUTTEAMGAMEPLUS":
            bHitSounds = class<EUTTeamGamePlus>(GameClass).default.bHitSounds;
            bCheckDefaults = class<EUTTeamGamePlus>(GameClass).default.bCheckDefaults;
            bEnhancedSprees = class<EUTTeamGamePlus>(GameClass).default.bEnhancedSprees;
            bEnhancedMessages = class<EUTTeamGamePlus>(GameClass).default.bEnhancedMessages;
            bShowIPS = class<EUTTeamGamePlus>(GameClass).default.bShowIPS;
            bLogMods = class<EUTTeamGamePlus>(GameClass).default.bLogMods;
            bDemoRequest = class<EUTTeamGamePlus>(GameClass).Default.bDemoRequest;
            bTeamBeacon = class<EUTTeamGamePlus>(GameClass).Default.bTeamBeacon;
            bEnhancedDeathMessages = class<EUTTeamGamePlus>(GameClass).Default.bEnhancedDeathMessages;
            bKickSpeedHack = class<EUTTeamGamePlus>(GameClass).Default.bKickSpeedHack;
            bReport = class<EUTTeamGamePlus>(GameClass).Default.bReport;
            bAutoTaunts = class<EUTTeamGamePlus>(GameClass).Default.bAutoTaunts;
            bStatLink = class<EUTTeamGamePlus>(GameClass).default.bStatLink;
            bAlwaysRecordTourney = class<EUTTeamGamePlus>(GameClass).default.bAlwaysRecordTourney;
            bKickMinY = class<EUTTeamGamePlus>(GameClass).default.bKickMinY;
            bNoOverTime = class<EUTTeamGamePlus>(GameClass).Default.bNoOverTime;
            bScoreBoardEff = class<EUTTeamGamePlus>(GameClass).Default.bScoreBoardEff;
            bIpToCountry = class<EUTTeamGamePlus>(GameClass).Default.bIpToCountry;
            bUsesCustomWeapon = class<EUTTeamGamePlus>(GameClass).Default.bUsesCustomWeapon;
            bAntiTimer = class<EUTTeamGamePlus>(GameClass).Default.bAntiTimer;
            bSuddenDeathOverTime = class<EUTTeamGamePlus>(GameClass).Default.bSuddenDeathOverTime;
            bNoFlockPawns = class<EUTTeamGamePlus>(GameClass).Default.bNoFlockPawns;

            EnforcerKillMessage = class<EUTTeamGamePlus>(GameClass).default.EnforcerKillMessage;
            BioKillMessage = class<EUTTeamGamePlus>(GameClass).default.BioKillMessage;
            ShockRifleKillMessage = class<EUTTeamGamePlus>(GameClass).default.ShockRifleKillMessage;
            PulseGunKillMessage = class<EUTTeamGamePlus>(GameClass).default.PulseGunKillMessage;
            RipperKillMessage = class<EUTTeamGamePlus>(GameClass).default.RipperKillMessage;
            MiniGunKillMessage = class<EUTTeamGamePlus>(GameClass).default.MiniGunKillMessage;
            FlakCannonKillMessage = class<EUTTeamGamePlus>(GameClass).default.FlakCannonKillMessage;
            RocketLauncherKillMessage = class<EUTTeamGamePlus>(GameClass).default.RocketLauncherKillMessage;
            SniperRifleKillMessage  = class<EUTTeamGamePlus>(GameClass).default.SniperRifleKillMessage;
            AerialKillCustom = class<EUTTeamGamePlus>(GameClass).Default.AerialKillCustom;
            CustomWeaponKillMessage = class<EUTTeamGamePlus>(GameClass).Default.CustomWeaponKillMessage;
            AerialKillBio = class<EUTTeamGamePlus>(GameClass).default.AerialKillBio;
            AerialKillRipper = class<EUTTeamGamePlus>(GameClass).default.AerialKillRipper;
            AerialKillFlak = class<EUTTeamGamePlus>(GameClass).default.AerialKillFlak;
            AerialKillRockets = class<EUTTeamGamePlus>(GameClass).default.AerialKillRockets;
            AerialKillSniper = class<EUTTeamGamePlus>(GameClass).default.AerialKillSniper;
            AerialKillSuper = class<EUTTeamGamePlus>(GameClass).default.AerialKillSuper;
            AerialKillTrans = class<EUTTeamGamePlus>(GameClass).default.AerialKillTrans;
            AerialKillCombo = class<EUTTeamGamePlus>(GameClass).default.AerialKillCombo;
            AerialKillEnforcer = class<EUTTeamGamePlus>(GameClass).default.AerialKillEnforcer;
            AerialKillPulse = class<EUTTeamGamePlus>(GameClass).default.AerialKillPulse;
            AerialKillMini = class<EUTTeamGamePlus>(GameClass).default.AerialKillMini;
            AerialKillPiston = class<EUTTeamGamePlus>(GameClass).default.AerialKillPiston;
            ImpactKillMessage = class<EUTTeamGamePlus>(GameClass).default.ImpactKillMessage;
            TransKillMessage = class<EUTTeamGamePlus>(GameClass).default.TransKillMessage;
            RedTeamName = class<EUTTeamGamePlus>(GameClass).default.RedTeamName;
            BlueTeamName = class<EUTTeamGamePlus>(GameClass).default.BlueTeamName;
            IpToCountryTexturePackage = class<EUTTeamGamePlus>(GameClass).default.IpToCountryTexturePackage;
            CustomWeaponName = class<EUTTeamGamePlus>(GameClass).Default.CustomWeaponName;
            MessageOfTheDay = class<EUTTeamGamePlus>(GameClass).Default.MessageOfTheDay;

            MinY = String(class<EUTTeamGamePlus>(GameClass).Default.MinY);
            TraceDistance = String(class<EUTTeamGamePlus>(GameClass).Default.TraceDistance);
            AnnouncerLevel = String(class<EUTTeamGamePlus>(GameClass).Default.AnnouncerLevel);
            SetFOV =  String(class<EUTTeamGamePlus>(GameClass).Default.SetFOV);

            break;

        case "EUTDEATHMATCHPLUS":
            bHitSounds = class<EUTDeathMatchPlus>(GameClass).default.bHitSounds;
            bCheckDefaults = class<EUTDeathMatchPlus>(GameClass).default.bCheckDefaults;
            bEnhancedSprees = class<EUTDeathMatchPlus>(GameClass).default.bEnhancedSprees;
            bEnhancedMessages = class<EUTDeathMatchPlus>(GameClass).default.bEnhancedMessages;
            bShowIPS = class<EUTDeathMatchPlus>(GameClass).default.bShowIPS;
            bLogMods = class<EUTDeathMatchPlus>(GameClass).default.bLogMods;
            bDemoRequest = class<EUTDeathMatchPlus>(GameClass).Default.bDemoRequest;
            bLeaderBeacon = class<EUTDeathMatchPlus>(GameClass).Default.bLeaderBeacon;
            bEnhancedDeathMessages = class<EUTDeathMatchPlus>(GameClass).Default.bEnhancedDeathMessages;
            bKickSpeedHack = class<EUTDeathMatchPlus>(GameClass).Default.bKickSpeedHack;
            bReport = class<EUTDeathMatchPlus>(GameClass).Default.bReport;
            bAutoTaunts = class<EUTDeathMatchPlus>(GameClass).Default.bAutoTaunts;
            bStatLink = class<EUTDeathMatchPlus>(GameClass).default.bStatLink;
            bAlwaysRecordTourney = class<EUTDeathMatchPlus>(GameClass).default.bAlwaysRecordTourney;
            bKickMinY = class<EUTDeathMatchPlus>(GameClass).default.bKickMinY;
            bNoOverTime = class<EUTDeathMatchPlus>(GameClass).Default.bNoOverTime;
            bScoreBoardEff = class<EUTDeathMatchPlus>(GameClass).Default.bScoreBoardEff;
            bIpToCountry = class<EUTDeathMatchPlus>(GameClass).Default.bIpToCountry;
            bUsesCustomWeapon = class<EUTDeathMatchPlus>(GameClass).Default.bUsesCustomWeapon;
            bAntiTimer = class<EUTDeathMatchPlus>(GameClass).Default.bAntiTimer;
            bNoFlockPawns = class<EUTDeathMatchPlus>(GameClass).Default.bNoFlockPawns;

            EnforcerKillMessage = class<EUTDeathMatchPlus>(GameClass).default.EnforcerKillMessage;
            BioKillMessage = class<EUTDeathMatchPlus>(GameClass).default.BioKillMessage;
            ShockRifleKillMessage = class<EUTDeathMatchPlus>(GameClass).default.ShockRifleKillMessage;
            PulseGunKillMessage = class<EUTDeathMatchPlus>(GameClass).default.PulseGunKillMessage;
            RipperKillMessage = class<EUTDeathMatchPlus>(GameClass).default.RipperKillMessage;
            MiniGunKillMessage = class<EUTDeathMatchPlus>(GameClass).default.MiniGunKillMessage;
            FlakCannonKillMessage = class<EUTDeathMatchPlus>(GameClass).default.FlakCannonKillMessage;
            RocketLauncherKillMessage = class<EUTDeathMatchPlus>(GameClass).default.RocketLauncherKillMessage;
            SniperRifleKillMessage  = class<EUTDeathMatchPlus>(GameClass).default.SniperRifleKillMessage;
            AerialKillCustom = class<EUTDeathMatchPlus>(GameClass).Default.AerialKillCustom;
            CustomWeaponKillMessage = class<EUTDeathMatchPlus>(GameClass).Default.CustomWeaponKillMessage;
            AerialKillBio = class<EUTDeathMatchPlus>(GameClass).default.AerialKillBio;
            AerialKillRipper = class<EUTDeathMatchPlus>(GameClass).default.AerialKillRipper;
            AerialKillFlak = class<EUTDeathMatchPlus>(GameClass).default.AerialKillFlak;
            AerialKillRockets = class<EUTDeathMatchPlus>(GameClass).default.AerialKillRockets;
            AerialKillSniper = class<EUTDeathMatchPlus>(GameClass).default.AerialKillSniper;
            AerialKillSuper = class<EUTDeathMatchPlus>(GameClass).default.AerialKillSuper;
            AerialKillTrans = class<EUTDeathMatchPlus>(GameClass).default.AerialKillTrans;
            AerialKillCombo = class<EUTDeathMatchPlus>(GameClass).default.AerialKillCombo;
            AerialKillEnforcer = class<EUTDeathMatchPlus>(GameClass).default.AerialKillEnforcer;
            AerialKillPulse = class<EUTDeathMatchPlus>(GameClass).default.AerialKillPulse;
            AerialKillMini = class<EUTDeathMatchPlus>(GameClass).default.AerialKillMini;
            AerialKillPiston = class<EUTDeathMatchPlus>(GameClass).default.AerialKillPiston;
            ImpactKillMessage = class<EUTDeathMatchPlus>(GameClass).default.ImpactKillMessage;
            TransKillMessage = class<EUTDeathMatchPlus>(GameClass).default.TransKillMessage;
            IpToCountryTexturePackage = class<EUTDeathMatchPlus>(GameClass).default.IpToCountryTexturePackage;
            CustomWeaponName = class<EUTDeathMatchPlus>(GameClass).Default.CustomWeaponName;
            MessageOfTheDay = class<EUTDeathMatchPlus>(GameClass).Default.MessageOfTheDay;

            MinY = String(class<EUTDeathMatchPlus>(GameClass).Default.MinY);
            TraceDistance = String(class<EUTDeathMatchPlus>(GameClass).Default.TraceDistance);
            AnnouncerLevel = String(class<EUTDeathMatchPlus>(GameClass).Default.AnnouncerLevel);
            SetFOV =  String(class<EUTDeathMatchPlus>(GameClass).Default.SetFOV);

            break;
    }
}

function bool AuthenticateAdmin(WebRequest Request, WebResponse Response)
{
	local string AdminUser, AdminPass;

	AdminUser = class'UTServerAdmin'.default.AdminUserName;
	AdminPass = class'UTServerAdmin'.default.AdminPassword;

	if((AdminUser ~= "" || (Caps(Request.UserName) != Caps(AdminUser)))
	|| (AdminPass ~= "" || (Caps(Request.Password) != Caps(AdminPass))))
	{
		return false;
	}
	return true;
}

event Query(WebRequest Request, WebResponse Response)
{
	if(AuthenticateAdmin(Request, Response))
	{
		response.Subst("BugAddress", "help@help.net");

		switch(Mid(Request.URI, 1))
		{
			case "":
			    break;
			case "root":
				QueryRoot(Request, Response);
                break;
            case "menu":
				QueryMenu(Request, Response);
                break;
            case "main":
				QueryMain(Request, Response);
                break;
            case "main_menu":
				QueryMainMenu(Request, Response);
                break;
            case "options":
				QueryOptions(Request, Response);
                break;
            case "options_restart":
		        QueryRestartPage(Request, Response);
                break;
            case "home":
		        QueryHomePage(Request, Response);
                break;
            case "messages":
				QueryMessages(Request, Response);
                break;

			default:
				Response.SendText("<html><body><B>ERROR: Page not found or enabled.</B></html></body>");
		}
     }
    if(!AuthenticateAdmin(Request, Response))
	{
		Response.FailAuthentication(class'UTServerAdmin'.default.AdminRealm);
	}
}

function QueryRoot(WebRequest Request, WebResponse Response)
{
	Response.Subst("MenuURI", "menu");
	Response.Subst("MainURI", "main");

	Response.IncludeUHTM(MyRoot$"/root.uhtm");
}

function QueryMenu(WebRequest Request, WebResponse Response)
{
	Response.IncludeUHTM(MyRoot$"/menu.uhtm");
	Response.ClearSubst();
}

function QueryMain(WebRequest Request, WebResponse Response)
{
	local string page;

	page = Request.GetVariable("Page", "options");
	Response.Subst("IndexURI", "main_menu");
	Response.Subst("MainURI", Page);

	Response.IncludeUHTM(MyRoot$"/main.uhtm");
	Response.ClearSubst();
}

function QueryMainMenu(WebRequest Request, WebResponse Response)
{
    local string page;

	page = Request.GetVariable("Page", "options");

	Response.Subst("HomeURI", "main?Page=Home");
    Response.Subst("OptionsURI", "main?Page=options");
    Response.Subst("messagesURI", "main?Page=messages");
	Response.Subst("RestartURI", "main?Page=options_restart");

	Response.IncludeUHTM(MyRoot$"/main_menu.uhtm");
	Response.ClearSubst();
}

function QueryOptions(WebRequest Request, WebResponse Response)
{
    LoadDefaults();

    if(Request.GetVariable("Apply", "") != "")
    {
        switch(GameClassName)
        {
            case "SMARTCTFGAME":
                bHitSounds = bool(Request.GetVariable("HitSounds", "false"));
                class<SmartCTFGame>(GameClass).default.bHitSounds = bHitSounds;
                bCheckDefaults = bool(Request.GetVariable("CheckDefaults", "false"));
                class<SmartCTFGame>(GameClass).default.bCheckDefaults = bCheckDefaults;
                bEnhancedSprees = bool(Request.GetVariable("EnhancedSprees", "false"));
                class<SmartCTFGame>(GameClass).default.bEnhancedSprees = bEnhancedSprees;
                bEnhancedMessages = bool(Request.GetVariable("EnhancedMessages", "false"));
                class<SmartCTFGame>(GameClass).Default.bEnhancedMessages = bEnhancedMessages;
                bShowIPS = bool(Request.GetVariable("ShowIPS", "false"));
		        class<SmartCTFGame>(GameClass).Default.bShowIPS = bShowIPS;
		        bLogMods = bool(Request.GetVariable("LogMods", "false"));
		        class<SmartCTFGame>(GameClass).Default.bLogMods = bLogMods;
		        bDemoRequest = bool(Request.GetVariable("DemoRequest", "false"));
		        class<SmartCTFGame>(GameClass).Default.bDemoRequest = bDemoRequest;
		        bTeamBeacon =  bool(Request.GetVariable("TeamBeacon", "false"));
		        class<SmartCTFGame>(GameClass).Default.bTeamBeacon = bTeamBeacon;
		        bEnhancedDeathMessages = bool(Request.GetVariable("EnhancedDeathMessages", "false"));
		        class<SmartCTFGame>(GameClass).Default.bEnhancedDeathMessages = bEnhancedDeathMessages;
		        bKickSpeedHack = bool(Request.GetVariable("bKickSpeedHack", "false"));
		        class<SmartCTFGame>(GameClass).Default.bKickSpeedHack = bKickSpeedHack;
		        bReport = bool(Request.GetVariable("bReport", "false"));
		        class<SmartCTFGame>(GameClass).Default.bReport = bReport;
		        bAutoTaunts = bool(Request.GetVariable("bAutoTaunts", "false"));
		        class<SmartCTFGame>(GameClass).Default.bAutoTaunts = bAutoTaunts;
		        bAntiTimer = bool(Request.GetVariable("bAntiTimer", "false"));
		        class<SmartCTFGame>(GameClass).Default.bAntiTimer = bAntiTimer;
		        bStatLink = bool(Request.GetVariable("bStatLink", "false"));
		        class<SmartCTFGame>(GameClass).Default.bStatLink = bStatLink;
		        bAlwaysRecordTourney = bool(Request.GetVariable("bAlwaysRecordTourney", "false"));
		        class<SmartCTFGame>(GameClass).Default.bAlwaysRecordTourney = bAlwaysRecordTourney;
		        bKickMinY = bool(Request.GetVariable("bKickMinY", "false"));
		        class<SmartCTFGame>(GameClass).Default.bKickMinY = bKickMinY;
		        bNoOverTime = bool(Request.GetVariable("bNoOverTime", "false"));
		        class<SmartCTFGame>(GameClass).Default.bNoOverTime = bNoOverTime;
		        bScoreBoardEff = bool(Request.GetVariable("bScoreBoardEff", "false"));
		        class<SmartCTFGame>(GameClass).Default.bScoreBoardEff = bScoreBoardEff;
		        bIpToCountry = bool(Request.GetVariable("bIpToCountry", "false"));
		        class<SmartCTFGame>(GameClass).Default.bIpToCountry = bIpToCountry;
		        bUsesCustomWeapon = bool(Request.GetVariable("bUsesCustomWeapon", "false"));
		        class<SmartCTFGame>(GameClass).Default.bUsesCustomWeapon = bUsesCustomWeapon;
                bNoFlockPawns = bool(Request.GetVariable("bNoFlockPawns", "false"));
		        class<SmartCTFGame>(GameClass).Default.bNoFlockPawns = bNoFlockPawns;
                bNoDroppedFlags = bool(Request.GetVariable("bNoDroppedFlags", "false"));
		        class<SmartCTFGame>(GameClass).Default.bNoDroppedFlags = bNoDroppedFlags;

                RedTeamName = Request.GetVariable("RedTeamName", "");
    		    class<SmartCTFGame>(GameClass).Default.RedTeamName = RedTeamName;
                BlueTeamName = Request.GetVariable("BlueTeamName", "");
    		    class<SmartCTFGame>(GameClass).Default.BlueTeamName = BlueTeamName;
                IpToCountryTexturePackage = Request.GetVariable("IpToCountryTexturePackage","false");
    		    class<SmartCTFGame>(GameClass).Default.IpToCountryTexturePackage = IpToCountryTexturePackage;
                CustomWeaponName = Request.GetVariable("CustomWeaponName", "false");
    		    class<SmartCTFGame>(GameClass).Default.CustomWeaponName = CustomWeaponName;
                AnnouncerLevel = Request.GetVariable("AnnouncerLevel", String(class<SmartCTFGame>(GameClass).Default.AnnouncerLevel));
    	        AnnouncerLevel = String(max(int(AnnouncerLevel), 0));
    	        class<SmartCTFGame>(GameClass).Default.AnnouncerLevel = int(AnnouncerLevel);
                FlagCap = Request.GetVariable("FlagCap", String(class<SmartCTFGame>(GameClass).Default.FlagCap));
        	    FlagCap = String(max(int(FlagCap), 0));
        	    class<SmartCTFGame>(GameClass).Default.FlagCap = int(FlagCap);
        	    AssistsBonus = Request.GetVariable("AssistsBonus", String(class<SmartCTFGame>(GameClass).Default.AssistsBonus));
        	    AssistsBonus = String(max(int(AssistsBonus), 0));
        	    class<SmartCTFGame>(GameClass).Default.AssistsBonus = int(AssistsBonus);
        	    FlagKill = Request.GetVariable("FlagKill", String(class<SmartCTFGame>(GameClass).Default.FlagKill));
        	    FlagKill = String(max(int(FlagKill), 0));
        	    class<SmartCTFGame>(GameClass).Default.FlagKill = int(FlagKill);
        	    CoversBonus = Request.GetVariable("CoversBonus", String(class<SmartCTFGame>(GameClass).Default.CoversBonus));
        	    CoversBonus = String(max(int(CoversBonus), 0));
        	    class<SmartCTFGame>(GameClass).Default.CoversBonus = int(CoversBonus);
        	    SealsBonus = Request.GetVariable("SealsBonus", String(class<SmartCTFGame>(GameClass).Default.SealsBonus));
        	    SealsBonus = String(max(int(SealsBonus), 0));
        	    class<SmartCTFGame>(GameClass).Default.SealsBonus = int(SealsBonus);
        	    DeniedBonus = Request.GetVariable("DeniedBonus", String(class<SmartCTFGame>(GameClass).Default.DeniedBonus));
        	    DeniedBonus = String(max(int(DeniedBonus), 0));
        	    class<SmartCTFGame>(GameClass).Default.DeniedBonus = int(DeniedBonus);
        	    SavesBonus = Request.GetVariable("SavesBonus", String(class<SmartCTFGame>(GameClass).Default.SavesBonus));
        	    SavesBonus = String(max(int(SavesBonus), 0));
        	    class<SmartCTFGame>(GameClass).Default.SavesBonus = int(SavesBonus);
        	    TraceDistance = Request.GetVariable("TraceDistance", String(class<SmartCTFGame>(GameClass).Default.TraceDistance));
        	    TraceDistance = String(max(int(TraceDistance), 0));
        	    class<SmartCTFGame>(GameClass).Default.TraceDistance = int(TraceDistance);
        	    MinY = Request.GetVariable("MinY", String(class<SmartCTFGame>(GameClass).Default.MinY));
        	    MinY = String(max(float(MinY), 0));
        	    class<SmartCTFGame>(GameClass).Default.MinY = float(MinY);
        	    SetFOV = Request.GetVariable("SetFOV", String(class<SmartCTFGame>(GameClass).Default.SetFOV));
        	    SetFOV = String(max(byte(SetFOV), 0));
        	    class<SmartCTFGame>(GameClass).Default.SetFOV = byte(SetFOV);
        	    MessageOfTheDay = Request.GetVariable("MessageOfTheDay", "");
    		    class<SmartCTFGame>(GameClass).Default.MessageOfTheDay = MessageOfTheDay;
    		    FlagSaveDistance = Request.GetVariable("FlagSaveDistance", String(class<SmartCTFGame>(GameClass).Default.FlagSaveDistance));
        	    FlagSaveDistance = String(max(float(FlagSaveDistance), 0));
        	    class<SmartCTFGame>(GameClass).Default.FlagSaveDistance = float(FlagSaveDistance);
        	    FlagDeniedDistance = Request.GetVariable("FlagDeniedDistance", String(class<SmartCTFGame>(GameClass).Default.FlagDeniedDistance));
        	    FlagDeniedDistance = String(max(float(FlagDeniedDistance), 0));
        	    class<SmartCTFGame>(GameClass).Default.FlagDeniedDistance = float(FlagDeniedDistance);
                FlagCoverVisibleDistance = Request.GetVariable("FlagCoverVisibleDistance", String(class<SmartCTFGame>(GameClass).Default.FlagCoverVisibleDistance));
        	    FlagCoverVisibleDistance = String(max(float(FlagCoverVisibleDistance), 0));
        	    class<SmartCTFGame>(GameClass).Default.FlagCoverVisibleDistance = float(FlagCoverVisibleDistance);
        	    FlagCoverHiddenDistance = Request.GetVariable("FlagCoverHiddenDistance", String(class<SmartCTFGame>(GameClass).Default.FlagCoverHiddenDistance));
        	    FlagCoverHiddenDistance = String(max(float(FlagCoverHiddenDistance), 0));
        	    class<SmartCTFGame>(GameClass).Default.FlagCoverHiddenDistance = float(FlagCoverHiddenDistance);

                break;

            case "EUTTEAMGAMEPLUS":
                bHitSounds = bool(Request.GetVariable("HitSounds", "false"));
                class<EUTTeamGamePlus>(GameClass).default.bHitSounds = bHitSounds;
                bCheckDefaults = bool(Request.GetVariable("CheckDefaults", "false"));
                class<EUTTeamGamePlus>(GameClass).default.bCheckDefaults = bCheckDefaults;
                bEnhancedSprees = bool(Request.GetVariable("EnhancedSprees", "false"));
                class<EUTTeamGamePlus>(GameClass).default.bEnhancedSprees = bEnhancedSprees;
                bEnhancedMessages = bool(Request.GetVariable("EnhancedMessages", "false"));
                class<EUTTeamGamePlus>(GameClass).Default.bEnhancedMessages = bEnhancedMessages;
                bShowIPS = bool(Request.GetVariable("ShowIPS", "false"));
		        class<EUTTeamGamePlus>(GameClass).Default.bShowIPS = bShowIPS;
		        bLogMods = bool(Request.GetVariable("LogMods", "false"));
		        class<EUTTeamGamePlus>(GameClass).Default.bLogMods = bLogMods;
		        bDemoRequest = bool(Request.GetVariable("DemoRequest", "false"));
		        class<EUTTeamGamePlus>(GameClass).Default.bDemoRequest = bDemoRequest;
		        bTeamBeacon =  bool(Request.GetVariable("TeamBeacon", "false"));
		        class<EUTTeamGamePlus>(GameClass).Default.bTeamBeacon = bTeamBeacon;
                bEnhancedDeathMessages = bool(Request.GetVariable("EnhancedDeathMessages", "false"));
                class<EUTTeamGamePlus>(GameClass).Default.bEnhancedDeathMessages = bEnhancedDeathMessages;
                bKickSpeedHack = bool(Request.GetVariable("bKickSpeedHack", "false"));
                class<EUTTeamGamePlus>(GameClass).Default.bKickSpeedHack = bKickSpeedHack;
                bReport = bool(Request.GetVariable("bReport", "false"));
                class<EUTTeamGamePlus>(GameClass).Default.bReport = bReport;
                bAutoTaunts = bool(Request.GetVariable("bAutoTaunts", "false"));
                class<EUTTeamGamePlus>(GameClass).Default.bAutoTaunts = bAutoTaunts;
                bAntiTimer = bool(Request.GetVariable("bAntiTimer", "false"));
                class<EUTTeamGamePlus>(GameClass).Default.bAntiTimer = bAntiTimer;
                bStatLink = bool(Request.GetVariable("bStatLink", "false"));
                class<EUTTeamGamePlus>(GameClass).Default.bStatLink = bStatLink;
                bAlwaysRecordTourney = bool(Request.GetVariable("bAlwaysRecordTourney", "false"));
                class<EUTTeamGamePlus>(GameClass).Default.bAlwaysRecordTourney = bAlwaysRecordTourney;
                bKickMinY = bool(Request.GetVariable("bKickMinY", "false"));
                class<EUTTeamGamePlus>(GameClass).Default.bKickMinY = bKickMinY;
                bNoOverTime = bool(Request.GetVariable("bNoOverTime", "false"));
                class<EUTTeamGamePlus>(GameClass).Default.bNoOverTime = bNoOverTime;
                bScoreBoardEff = bool(Request.GetVariable("bScoreBoardEff", "false"));
                class<EUTTeamGamePlus>(GameClass).Default.bScoreBoardEff = bScoreBoardEff;
                bIpToCountry = bool(Request.GetVariable("bIpToCountry", "false"));
                class<EUTTeamGamePlus>(GameClass).Default.bIpToCountry = bIpToCountry;
                bUsesCustomWeapon = bool(Request.GetVariable("bUsesCustomWeapon", "false"));
                class<EUTTeamGamePlus>(GameClass).Default.bUsesCustomWeapon = bUsesCustomWeapon;
                bSuddenDeathOverTime = bool(Request.GetVariable("bSuddenDeathOverTime", "false"));
                class<EUTTeamGamePlus>(GameClass).Default.bSuddenDeathOverTime = bSuddenDeathOverTime;
                bNoFlockPawns = bool(Request.GetVariable("bNoFlockPawns", "false"));
		        class<EUTTeamGamePlus>(GameClass).Default.bNoFlockPawns = bNoFlockPawns;

                RedTeamName = Request.GetVariable("RedTeamName", "");
                class<EUTTeamGamePlus>(GameClass).Default.RedTeamName = RedTeamName;
                BlueTeamName = Request.GetVariable("BlueTeamName", "");
                class<EUTTeamGamePlus>(GameClass).Default.BlueTeamName = BlueTeamName;
                IpToCountryTexturePackage = Request.GetVariable("IpToCountryTexturePackage","false");
                class<EUTTeamGamePlus>(GameClass).Default.IpToCountryTexturePackage = IpToCountryTexturePackage;
                CustomWeaponName = Request.GetVariable("CustomWeaponName", "false");
                class<EUTTeamGamePlus>(GameClass).Default.CustomWeaponName = CustomWeaponName;
                AnnouncerLevel = Request.GetVariable("AnnouncerLevel", String(class<EUTTeamGamePlus>(GameClass).Default.AnnouncerLevel));
        	    AnnouncerLevel = String(max(int(AnnouncerLevel), 0));
        	    class<EUTTeamGamePlus>(GameClass).Default.AnnouncerLevel = int(AnnouncerLevel);
        	    TraceDistance = Request.GetVariable("TraceDistance", String(class<EUTTeamGamePlus>(GameClass).Default.TraceDistance));
        	    TraceDistance = String(max(int(TraceDistance), 0));
        	    class<EUTTeamGamePlus>(GameClass).Default.TraceDistance = int(TraceDistance);
        	    MinY = Request.GetVariable("MinY", String(class<EUTTeamGamePlus>(GameClass).Default.MinY));
        	    MinY = String(max(float(MinY), 0));
        	    class<EUTTeamGamePlus>(GameClass).Default.MinY = float(MinY);
        	    SetFOV = Request.GetVariable("SetFOV", String(class<EUTTeamGamePlus>(GameClass).Default.SetFOV));
        	    SetFOV = String(max(byte(SetFOV), 0));
        	    class<EUTTeamGamePlus>(GameClass).Default.SetFOV = byte(SetFOV);
        	    MessageOfTheDay = Request.GetVariable("MessageOfTheDay", "");
    		    class<EUTTeamGamePlus>(GameClass).Default.MessageOfTheDay = MessageOfTheDay;
                break;

            case "EUTDEATHMATCHPLUS":
                bHitSounds = bool(Request.GetVariable("HitSounds", "false"));
                class<EUTDeathMatchPlus>(GameClass).default.bHitSounds = bHitSounds;
                bCheckDefaults = bool(Request.GetVariable("CheckDefaults", "false"));
                class<EUTDeathMatchPlus>(GameClass).default.bCheckDefaults = bCheckDefaults;
                bEnhancedSprees = bool(Request.GetVariable("EnhancedSprees", "false"));
                class<EUTDeathMatchPlus>(GameClass).default.bEnhancedSprees = bEnhancedSprees;
                bEnhancedMessages = bool(Request.GetVariable("EnhancedMessages", "false"));
                class<EUTDeathMatchPlus>(GameClass).Default.bEnhancedMessages = bEnhancedMessages;
                bShowIPS = bool(Request.GetVariable("ShowIPS", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bShowIPS = bShowIPS;
		        bLogMods = bool(Request.GetVariable("LogMods", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bLogMods = bLogMods;
		        bDemoRequest = bool(Request.GetVariable("DemoRequest", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bDemoRequest = bDemoRequest;
		        bEnhancedDeathMessages = bool(Request.GetVariable("EnhancedDeathMessages", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bEnhancedDeathMessages = bEnhancedDeathMessages;
		        bLeaderBeacon = bool(Request.GetVariable("bLeaderBeacon", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bLeaderBeacon = bLeaderBeacon;
		        bKickSpeedHack = bool(Request.GetVariable("bKickSpeedHack", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bKickSpeedHack = bKickSpeedHack;
		        bReport = bool(Request.GetVariable("bReport", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bReport = bReport;
		        bAutoTaunts = bool(Request.GetVariable("bAutoTaunts", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bAutoTaunts = bAutoTaunts;
		        bAntiTimer = bool(Request.GetVariable("bAntiTimer", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bAntiTimer = bAntiTimer;
		        bStatLink = bool(Request.GetVariable("bStatLink", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bStatLink = bStatLink;
		        bAlwaysRecordTourney = bool(Request.GetVariable("bAlwaysRecordTourney", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bAlwaysRecordTourney = bAlwaysRecordTourney;
		        bKickMinY = bool(Request.GetVariable("bKickMinY", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bKickMinY = bKickMinY;
		        bNoOverTime = bool(Request.GetVariable("bNoOverTime", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bNoOverTime = bNoOverTime;
		        bScoreBoardEff = bool(Request.GetVariable("bScoreBoardEff", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bScoreBoardEff = bScoreBoardEff;
		        bIpToCountry = bool(Request.GetVariable("bIpToCountry", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bIpToCountry = bIpToCountry;
		        bUsesCustomWeapon = bool(Request.GetVariable("bUsesCustomWeapon", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bUsesCustomWeapon = bUsesCustomWeapon;
                bNoFlockPawns = bool(Request.GetVariable("bNoFlockPawns", "false"));
		        class<EUTDeathMatchPlus>(GameClass).Default.bNoFlockPawns = bNoFlockPawns;

		        IpToCountryTexturePackage = Request.GetVariable("IpToCountryTexturePackage","false");
    		    class<EUTDeathMatchPlus>(GameClass).Default.IpToCountryTexturePackage = IpToCountryTexturePackage;
    		    CustomWeaponName = Request.GetVariable("CustomWeaponName", "false");
    		    class<EUTDeathMatchPlus>(GameClass).Default.CustomWeaponName = CustomWeaponName;
                AnnouncerLevel = Request.GetVariable("AnnouncerLevel", String(class<EUTDeathMatchPlus>(GameClass).Default.AnnouncerLevel));
        	    AnnouncerLevel = String(max(int(AnnouncerLevel), 0));
        	    class<EUTDeathMatchPlus>(GameClass).Default.AnnouncerLevel = int(AnnouncerLevel);
        	    TraceDistance = Request.GetVariable("TraceDistance", String(class<EUTDeathMatchPlus>(GameClass).Default.TraceDistance));
        	    TraceDistance = String(max(int(TraceDistance), 0));
        	    class<EUTDeathMatchPlus>(GameClass).Default.TraceDistance = int(TraceDistance);
        	    MinY = Request.GetVariable("MinY", String(class<EUTDeathMatchPlus>(GameClass).Default.MinY));
        	    MinY = String(max(float(MinY), 0));
        	    class<EUTDeathMatchPlus>(GameClass).Default.MinY = float(MinY);
        	    SetFOV = Request.GetVariable("SetFOV", String(class<EUTDeathMatchPlus>(GameClass).Default.SetFOV));
        	    SetFOV = String(max(byte(SetFOV), 0));
        	    class<EUTDeathMatchPlus>(GameClass).Default.SetFOV = byte(SetFOV);
        	    MessageOfTheDay = Request.GetVariable("MessageOfTheDay", "");
    		    class<EUTDeathMatchPlus>(GameClass).Default.MessageOfTheDay = MessageOfTheDay;
                break;
        }
    }

    switch(GameClassName)
    {
        case "SMARTCTFGAME":
            if (bHitSounds) Response.Subst("HitSounds", " checked");
            if (bCheckDefaults) Response.Subst("CheckDefaults", " checked");
            if (bEnhancedSprees) Response.Subst("EnhancedSprees", " checked");
            if (bEnhancedMessages) Response.Subst("EnhancedMessages", " checked");
            if (bShowIPS) Response.Subst("ShowIPS", " checked");
            if (bLogMods) Response.Subst("LogMods", " checked");
            if (bDemoRequest) Response.Subst("DemoRequest", " checked");
            if (bEnhancedDeathMessages) Response.Subst("EnhancedDeathMessages", " checked");
            if (bTeamBeacon) Response.Subst("TeamBeacon", " checked");
            if (bKickSpeedHack) Response.Subst("bKickSpeedHack", " checked");
            if (bReport) Response.Subst("bReport"," checked");
            if (bAutoTaunts) Response.Subst("bAutoTaunts"," checked");
            if (bAntiTimer) Response.Subst("bAntiTimer"," checked");
            if (bStatLink) Response.Subst("bStatLink"," checked");
            if (bAlwaysRecordTourney) Response.Subst("bAlwaysRecordTourney", " checked");
            if (bKickMinY) Response.Subst("bKickMinY", " checked");
            if (bNoOverTime) Response.Subst("bNoOverTime", " checked");
            if (bScoreBoardEff) Response.Subst("bScoreBoardEff", " checked");
            if (bIpToCountry) Response.Subst("bIpToCountry", " checked");
            if (bUsesCustomWeapon) Response.Subst("bUsesCustomWeapon", " checked");
            if (bNoFlockPawns) Response.Subst("bNoFlockPawns", " checked");
            if (bNoDroppedFlags) Response.Subst("bNoDroppedFlags", " checked");


            Response.Subst("RedTeamName", RedTeamName);
            Response.Subst("BlueTeamName", BlueTeamName);
            Response.Subst("IpToCountryTexturePackage", IpToCountryTexturePackage);
            Response.Subst("CustomWeaponName",CustomWeaponName);
	        Response.Subst("AnnouncerLevel", AnnouncerLevel);
    	    Response.Subst("FlagCap", FlagCap);
    	    Response.Subst("AssistsBonus", AssistsBonus);
    	    Response.Subst("FlagKill", FlagKill);
    	    Response.Subst("CoversBonus", CoversBonus);
    	    Response.Subst("SealsBonus", SealsBonus);
    	    Response.Subst("DeniedBonus", DeniedBonus);
    	    Response.Subst("SavesBonus", SavesBonus);
    	    Response.Subst("TraceDistance", TraceDistance);
    	    Response.Subst("MinY", MinY);
    	    Response.Subst("SetFOV", SetFOV);
            Response.Subst("MessageOfTheDay", MessageOfTheDay);
            Response.Subst("FlagSaveDistance", FlagSaveDistance);
            Response.Subst("FlagDeniedDistance", FlagDeniedDistance);
            Response.Subst("FlagCoverVisibleDistance", FlagCoverVisibleDistance);
            Response.Subst("FlagCoverHiddenDistance", FlagCoverHiddenDistance);
            break;

        case "EUTTEAMGAMEPLUS":
            if (bHitSounds) Response.Subst("HitSounds", " checked");
            if (bCheckDefaults) Response.Subst("CheckDefaults", " checked");
            if (bEnhancedSprees) Response.Subst("EnhancedSprees", " checked");
            if (bEnhancedMessages) Response.Subst("EnhancedMessages", " checked");
            if (bShowIPS) Response.Subst("ShowIPS", " checked");
            if (bLogMods) Response.Subst("LogMods", " checked");
            if (bDemoRequest) Response.Subst("DemoRequest", " checked");
            if (bEnhancedDeathMessages) Response.Subst("EnhancedDeathMessages", " checked");
            if (bTeamBeacon) Response.Subst("TeamBeacon", " checked");
            if (bKickSpeedHack) Response.Subst("bKickSpeedHack", " checked");
            if (bReport) Response.Subst("bReport"," checked");
            if (bAutoTaunts) Response.Subst("bAutoTaunts"," checked");
            if (bAntiTimer) Response.Subst("bAntiTimer"," checked");
            if (bStatLink) Response.Subst("bStatLink"," checked");
            if (bAlwaysRecordTourney) Response.Subst("bAlwaysRecordTourney", " checked");
            if (bKickMinY) Response.Subst("bKickMinY", " checked");
            if (bNoOverTime) Response.Subst("bNoOverTime", " checked");
            if (bScoreBoardEff) Response.Subst("bScoreBoardEff", " checked");
            if (bIpToCountry) Response.Subst("bIpToCountry", " checked");
            if (bUsesCustomWeapon) Response.Subst("bUsesCustomWeapon", " checked");
            if (bSuddenDeathOverTime) Response.Subst("bSuddenDeathOverTime", " checked");
            if (bNoFlockPawns) Response.Subst("bNoFlockPawns", " checked");

            Response.Subst("RedTeamName", RedTeamName);
            Response.Subst("BlueTeamName", BlueTeamName);
            Response.Subst("IpToCountryTexturePackage", IpToCountryTexturePackage);
            Response.Subst("CustomWeaponName",CustomWeaponName);
    	    Response.Subst("AnnouncerLevel", AnnouncerLevel);
    	    Response.Subst("TraceDistance", TraceDistance);
    	    Response.Subst("MinY", MinY);
    	    Response.Subst("SetFOV", SetFOV);
            Response.Subst("MessageOfTheDay", MessageOfTheDay);
            break;

        case "EUTDEATHMATCHPLUS":
            if (bHitSounds) Response.Subst("HitSounds", " checked");
            if (bCheckDefaults) Response.Subst("CheckDefaults", " checked");
            if (bEnhancedSprees) Response.Subst("EnhancedSprees", " checked");
            if (bEnhancedMessages) Response.Subst("EnhancedMessages", " checked");
            if (bShowIPS) Response.Subst("ShowIPS", " checked");
            if (bLogMods) Response.Subst("LogMods", " checked");
            if (bDemoRequest) Response.Subst("DemoRequest", " checked");
            if (bEnhancedDeathMessages) Response.Subst("EnhancedDeathMessages", " checked");
            if (bLeaderBeacon) Response.Subst("bLeaderBeacon", " checked");
            if (bKickSpeedHack) Response.Subst("bKickSpeedHack", " checked");
            if (bReport) Response.Subst("bReport"," checked");
            if (bAutoTaunts) Response.Subst("bAutoTaunts"," checked");
            if (bAntiTimer) Response.Subst("bAntiTimer"," checked");
            if (bStatLink) Response.Subst("bStatLink"," checked");
            if (bAlwaysRecordTourney) Response.Subst("bAlwaysRecordTourney", " checked");
            if (bKickMinY) Response.Subst("bKickMinY", " checked");
            if (bNoOverTime) Response.Subst("bNoOverTime", " checked");
            if (bScoreBoardEff) Response.Subst("bScoreBoardEff", " checked");
            if (bIpToCountry) Response.Subst("bIpToCountry", " checked");
            if (bUsesCustomWeapon) Response.Subst("bUsesCustomWeapon", " checked");
            if (bNoFlockPawns) Response.Subst("bNoFlockPawns", " checked");

            Response.Subst("IpToCountryTexturePackage", IpToCountryTexturePackage);
            Response.Subst("CustomWeaponName",CustomWeaponName);
    	    Response.Subst("AnnouncerLevel", AnnouncerLevel);
    	    Response.Subst("TraceDistance", TraceDistance);
    	    Response.Subst("MinY", MinY);
    	    Response.Subst("SetFOV", SetFOV);
            Response.Subst("MessageOfTheDay", MessageOfTheDay);
            break;
    }

    Response.Subst("PostAction", "options");
    Response.IncludeUHTM(MyRoot$"/options.uhtm");
    GameClass.Static.StaticSaveConfig();
}
//CustomWeaponKillMessage
//AerialKillCustom
function QueryMessages(WebRequest Request, WebResponse Response)
{
    LoadDefaults();

    if(Request.GetVariable("Apply", "") != "")
    {
        EnforcerKillMessage = Request.GetVariable("EnforcerKillMessage", "");
        BioKillMessage = Request.GetVariable("BioKillMessage", "");
        ShockRifleKillMessage = Request.GetVariable("ShockRifleKillMessage", "");
        PulseGunKillMessage = Request.GetVariable("PulseGunKillMessage", "");
        RipperKillMessage = Request.GetVariable("RipperKillMessage", "");
        MiniGunKillMessage = Request.GetVariable("MiniGunKillMessage", "");
        FlakCannonKillMessage = Request.GetVariable("FlakCannonKillMessage", "");
        RocketLauncherKillMessage = Request.GetVariable("RocketLauncherKillMessage", "");
        SniperRifleKillMessage  = Request.GetVariable("SniperRifleKillMessage", "");
        CustomWeaponKillMessage = Request.GetVariable("CustomWeaponKillMessage", "");

        AerialKillBio = Request.GetVariable("AerialKillBio", "");
        AerialKillRipper = Request.GetVariable("AerialKillRipper", "");
        AerialKillFlak = Request.GetVariable("AerialKillFlak", "");
        AerialKillRockets = Request.GetVariable("AerialKillRockets", "");
        AerialKillSniper = Request.GetVariable("AerialKillSniper", "");
        AerialKillSuper = Request.GetVariable("AerialKillSuper", "");
        AerialKillTrans = Request.GetVariable("AerialKillTrans", "");
        AerialKillCombo = Request.GetVariable("AerialKillCombo", "");
        AerialKillEnforcer = Request.GetVariable("AerialKillEnforcer", "");
        AerialKillPulse = Request.GetVariable("AerialKillPulse", "");
        AerialKillMini = Request.GetVariable("AerialKillMini", "");
        AerialKillPiston = Request.GetVariable("AerialKillPiston", "");
        ImpactKillMessage = Request.GetVariable("ImpactKillMessage", "");
        TransKillMessage = Request.GetVariable("TransKillMessage", "");
        AerialKillCustom = Request.GetVariable("AerialKillCustom", "");

        switch(GameClassName)
        {
            case "SMARTCTFGAME":
                class<SmartCTFGame>(GameClass).Default.ImpactKillMessage = ImpactKillMessage;
                class<SmartCTFGame>(GameClass).Default.TransKillMessage = TransKillMessage;
                class<SmartCTFGame>(GameClass).Default.EnforcerKillMessage = EnforcerKillMessage;
                class<SmartCTFGame>(GameClass).Default.BioKillMessage = BioKillMessage;
                class<SmartCTFGame>(GameClass).Default.ShockRifleKillMessage = ShockRifleKillMessage;
                class<SmartCTFGame>(GameClass).Default.PulseGunKillMessage = PulseGunKillMessage;
                class<SmartCTFGame>(GameClass).Default.RipperKillMessage = RipperKillMessage;
                class<SmartCTFGame>(GameClass).Default.MiniGunKillMessage = MiniGunKillMessage;
                class<SmartCTFGame>(GameClass).Default.FlakCannonKillMessage = FlakCannonKillMessage;
                class<SmartCTFGame>(GameClass).Default.RocketLauncherKillMessage = RocketLauncherKillMessage;
                class<SmartCTFGame>(GameClass).Default.SniperRifleKillMessage  = SniperRifleKillMessage;
                class<SmartCTFGame>(GameClass).Default.CustomWeaponKillMessage = CustomWeaponKillMessage;
                class<SmartCTFGame>(GameClass).Default.AerialKillBio = AerialKillBio;
                class<SmartCTFGame>(GameClass).Default.AerialKillRipper = AerialKillRipper;
                class<SmartCTFGame>(GameClass).Default.AerialKillFlak = AerialKillFlak;
                class<SmartCTFGame>(GameClass).Default.AerialKillRockets = AerialKillRockets;
                class<SmartCTFGame>(GameClass).Default.AerialKillSniper = AerialKillSniper;
                class<SmartCTFGame>(GameClass).Default.AerialKillSuper = AerialKillSuper;
                class<SmartCTFGame>(GameClass).Default.AerialKillTrans = AerialKillTrans;
                class<SmartCTFGame>(GameClass).Default.AerialKillCombo = AerialKillCombo;
                class<SmartCTFGame>(GameClass).Default.AerialKillEnforcer = AerialKillEnforcer;
                class<SmartCTFGame>(GameClass).Default.AerialKillPulse = AerialKillPulse;
                class<SmartCTFGame>(GameClass).Default.AerialKillMini = AerialKillMini;
                class<SmartCTFGame>(GameClass).Default.AerialKillPiston = AerialKillPiston;
                class<SmartCTFGame>(GameClass).Default.ImpactKillMessage = ImpactKillMessage;
                class<SmartCTFGame>(GameClass).Default.AerialKillCustom = AerialKillCustom;
                break;

            case "EUTTEAMGAMEPLUS":
                class<EUTTeamGamePlus>(GameClass).Default.ImpactKillMessage = ImpactKillMessage;
                class<EUTTeamGamePlus>(GameClass).Default.TransKillMessage = TransKillMessage;
                class<EUTTeamGamePlus>(GameClass).Default.EnforcerKillMessage = EnforcerKillMessage;
                class<EUTTeamGamePlus>(GameClass).Default.BioKillMessage = BioKillMessage;
                class<EUTTeamGamePlus>(GameClass).Default.ShockRifleKillMessage = ShockRifleKillMessage;
                class<EUTTeamGamePlus>(GameClass).Default.PulseGunKillMessage = PulseGunKillMessage;
                class<EUTTeamGamePlus>(GameClass).Default.RipperKillMessage = RipperKillMessage;
                class<EUTTeamGamePlus>(GameClass).Default.MiniGunKillMessage = MiniGunKillMessage;
                class<EUTTeamGamePlus>(GameClass).Default.FlakCannonKillMessage = FlakCannonKillMessage;
                class<EUTTeamGamePlus>(GameClass).Default.RocketLauncherKillMessage = RocketLauncherKillMessage;
                class<EUTTeamGamePlus>(GameClass).Default.SniperRifleKillMessage  = SniperRifleKillMessage;
                class<EUTTeamGamePlus>(GameClass).Default.CustomWeaponKillMessage = CustomWeaponKillMessage;
                class<EUTTeamGamePlus>(GameClass).Default.AerialKillBio = AerialKillBio;
                class<EUTTeamGamePlus>(GameClass).Default.AerialKillRipper = AerialKillRipper;
                class<EUTTeamGamePlus>(GameClass).Default.AerialKillFlak = AerialKillFlak;
                class<EUTTeamGamePlus>(GameClass).Default.AerialKillRockets = AerialKillRockets;
                class<EUTTeamGamePlus>(GameClass).Default.AerialKillSniper = AerialKillSniper;
                class<EUTTeamGamePlus>(GameClass).Default.AerialKillSuper = AerialKillSuper;
                class<EUTTeamGamePlus>(GameClass).Default.AerialKillTrans = AerialKillTrans;
                class<EUTTeamGamePlus>(GameClass).Default.AerialKillCombo = AerialKillCombo;
                class<EUTTeamGamePlus>(GameClass).Default.AerialKillEnforcer = AerialKillEnforcer;
                class<EUTTeamGamePlus>(GameClass).Default.AerialKillPulse = AerialKillPulse;
                class<EUTTeamGamePlus>(GameClass).Default.AerialKillMini = AerialKillMini;
                class<EUTTeamGamePlus>(GameClass).Default.AerialKillPiston = AerialKillPiston;
                class<EUTTeamGamePlus>(GameClass).Default.AerialKillCustom = AerialKillCustom;
                break;

            case "EUTDEATHMATCHPLUS":
                class<EUTDeathMatchPlus>(GameClass).Default.ImpactKillMessage = ImpactKillMessage;
                class<EUTDeathMatchPlus>(GameClass).Default.TransKillMessage = TransKillMessage;
                class<EUTDeathMatchPlus>(GameClass).Default.EnforcerKillMessage = EnforcerKillMessage;
                class<EUTDeathMatchPlus>(GameClass).Default.BioKillMessage = BioKillMessage;
                class<EUTDeathMatchPlus>(GameClass).Default.ShockRifleKillMessage = ShockRifleKillMessage;
                class<EUTDeathMatchPlus>(GameClass).Default.PulseGunKillMessage = PulseGunKillMessage;
                class<EUTDeathMatchPlus>(GameClass).Default.RipperKillMessage = RipperKillMessage;
                class<EUTDeathMatchPlus>(GameClass).Default.MiniGunKillMessage = MiniGunKillMessage;
                class<EUTDeathMatchPlus>(GameClass).Default.FlakCannonKillMessage = FlakCannonKillMessage;
                class<EUTDeathMatchPlus>(GameClass).Default.RocketLauncherKillMessage = RocketLauncherKillMessage;
                class<EUTDeathMatchPlus>(GameClass).Default.SniperRifleKillMessage  = SniperRifleKillMessage;
                class<EUTDeathMatchPlus>(GameClass).Default.CustomWeaponKillMessage = CustomWeaponKillMessage;
                class<EUTDeathMatchPlus>(GameClass).Default.AerialKillBio = AerialKillBio;
                class<EUTDeathMatchPlus>(GameClass).Default.AerialKillRipper = AerialKillRipper;
                class<EUTDeathMatchPlus>(GameClass).Default.AerialKillFlak = AerialKillFlak;
                class<EUTDeathMatchPlus>(GameClass).Default.AerialKillRockets = AerialKillRockets;
                class<EUTDeathMatchPlus>(GameClass).Default.AerialKillSniper = AerialKillSniper;
                class<EUTDeathMatchPlus>(GameClass).Default.AerialKillSuper = AerialKillSuper;
                class<EUTDeathMatchPlus>(GameClass).Default.AerialKillTrans = AerialKillTrans;
                class<EUTDeathMatchPlus>(GameClass).Default.AerialKillCombo = AerialKillCombo;
                class<EUTDeathMatchPlus>(GameClass).Default.AerialKillEnforcer = AerialKillEnforcer;
                class<EUTDeathMatchPlus>(GameClass).Default.AerialKillPulse = AerialKillPulse;
                class<EUTDeathMatchPlus>(GameClass).Default.AerialKillMini = AerialKillMini;
                class<EUTDeathMatchPlus>(GameClass).Default.AerialKillPiston = AerialKillPiston;
                class<EUTDeathMatchPlus>(GameClass).Default.AerialKillCustom = AerialKillCustom;
                break;
        }
    }

    Response.Subst("EnforcerKillMessage", EnforcerKillMessage);
    Response.Subst("BioKillMessage", BioKillMessage);
    Response.Subst("ShockRifleKillMessage", ShockRifleKillMessage);
    Response.Subst("PulseGunKillMessage", PulseGunKillMessage);
    Response.Subst("RipperKillMessage", RipperKillMessage);
    Response.Subst("MiniGunKillMessage", MiniGunKillMessage);
    Response.Subst("FlakCannonKillMessage", FlakCannonKillMessage);
    Response.Subst("RocketLauncherKillMessage", RocketLauncherKillMessage);
    Response.Subst("SniperRifleKillMessage", SniperRifleKillMessage);
    Response.Subst("AerialKillBio", AerialKillBio);
    Response.Subst("AerialKillRipper", AerialKillRipper);
    Response.Subst("AerialKillFlak", AerialKillFlak);
    Response.Subst("AerialKillRockets", AerialKillRockets);
    Response.Subst("AerialKillSniper", AerialKillSniper);
    Response.Subst("AerialKillSuper", AerialKillSuper);
    Response.Subst("AerialKillTrans", AerialKillTrans);
    Response.Subst("AerialKillCombo", AerialKillCombo);
    Response.Subst("AerialKillEnforcer", AerialKillEnforcer);
    Response.Subst("AerialKillPulse", AerialKillPulse);
    Response.Subst("AerialKillMini", AerialKillMini);
    Response.Subst("AerialKillPiston", AerialKillPiston);
    Response.Subst("ImpactKillMessage", ImpactKillMessage);
    Response.Subst("TransKillMessage", TransKillMessage);

    Response.Subst("PostAction", "messages");
    Response.IncludeUHTM(MyRoot$"/messages.uhtm");
    GameClass.Static.StaticSaveConfig();
}

function QueryRestartPage(WebRequest Request, WebResponse Response)
{
	Level.ServerTravel(Left(string(Level), InStr(string(Level), "."))$".unr"$"?game="$Level.Game.Class$"?mutator="$UsedMutators(), false);
	Response.Subst("Title", "Please Wait");
	Response.Subst("Message", "The server is now restarting the current map.  Please allow 10-15 seconds while the server changes levels.");
	Response.IncludeUHTM(MyRoot$"/options.uhtm");
}

function QueryHomePage(WebRequest Request, WebResponse Response)
{
	Response.IncludeUHTM("/Web");
}

function LoadMutators()
{
	local int NumMutatorClasses;
	local string NextMutator, NextDesc;
	local listitem TempItem;
	local Mutator M;
	local byte k;

	ExcludeMutators = None;

	Level.GetNextIntDesc("Engine.Mutator", 0, NextMutator, NextDesc);
	while( (NextMutator != "") && (NumMutatorClasses < 250) )
	{
		TempItem = new(None) class'ListItem';

		k = InStr(NextDesc, ",");
		if (k == -1) TempItem.Tag = NextDesc;
		else TempItem.Tag = Left(NextDesc, k);

		TempItem.Data = NextMutator;

		if (ExcludeMutators == None) ExcludeMutators = TempItem;
		else ExcludeMutators.AddSortedElement(ExcludeMutators, TempItem);

		NumMutatorClasses++;
		Level.GetNextIntDesc("Engine.Mutator", NumMutatorClasses, NextMutator, NextDesc);
	}

	IncludeMutators = None;

	for (M = Level.Game.BaseMutator.NextMutator; M != None; M = M.NextMutator)
    {
		TempItem = ExcludeMutators.DeleteElement(ExcludeMutators, String(M.Class));

		if (TempItem != None)
        {
			if (IncludeMutators == None) IncludeMutators = TempItem;
			else IncludeMutators.AddElement(TempItem);
		}
		else log("Unknown Mutator in use: "@String(M.Class));
	}

}

function String UsedMutators()
{
	local ListItem TempItem;
	local String OutStr;

	if(IncludeMutators == None) return "";

	OutStr = IncludeMutators.Data;
	for (TempItem = IncludeMutators.Next; TempItem != None; TempItem = TempItem.Next)
		OutStr = OutStr$","$TempItem.Data;

	return OutStr;
}

function String PadLeft(String InStr, int Width, String PadStr)
{
	local String OutStr;

	if (Len(PadStr) == 0) PadStr = " ";
	for (OutStr=InStr; Len(OutStr) < Width; OutStr=PadStr$OutStr);
	return Right(OutStr, Width);
}

defaultproperties
{
    MyRoot="EUT"
    RootPage="root"
    DefaultBG="#aaaaaa"
    HighlightedBG="#ffffff"
}
