/*
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
               EUTCTFSB
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
*/
class EUTCTFSB expands UnrealCTFScoreboard;

var font MySmallFont;
var EUTGameReplicationInfo MyCRI;
var PlayerReplicationInfo RedPRI[32];
var PlayerReplicationInfo BluePRI[32];
var PlayerReplicationInfo SpecPRI[32];
var FontInfo _FontInfo;

var bool bTimeDown, bPlayerMoved;

var byte FlagCaps,
    FlagGrabs,
    FlagAssists,
    FlagCovers,
    BaseSeals,
    FlagKills,
    Hue;

var color SpecColor[5],
    GreenColor,
    WhiteColor,
    GoldColor,
    BlueColor,
    LightCyanColor,
    SilverColor,
    BronzeColor,
    CyanColor,
    RedColor,
    ShadeColor,
    DarkRedColor,
    DarkBlueColor;

var float ScoreStart,
    PlayerStart,
    CenterBoxX,
    CenterBoxY,
    TextureSize,
    FillBoxX,
    FillBoxY,
    FillBoxX2,
    FillBoxY2,
    Step,
    DivW,
    DivS,
    MeterScale;

var int MaxMeterLength;

var localized string MapTitleString,
    AuthorString,
    RestartString,
    ContinueString,
    GameEndedString,
    ElapsedTimeString,
    RemainingTimeString,
    FragGoalString,
    TimeLimitString,
    PlayerString,
    FragsString,
    DeathsString,
    PingString,
    TimeString,
    LossString,
    FPHString,
    MapTitleQuoteString,
    TeamName[2];

var texture TopSpan,
    BotSpan,
    LeftSpan,
    RightSpan,
    TopLeftCorner,
    TopRightCorner,
    BotLeftCorner,
    BotRightCorner,
    BoxFillBase,
    BoxFillColored,
    FlagIcon,
    Meter,
    PlayerDivider,
    Country[40];



//-------------------------------------
// PostBeginPlay
//-------------------------------------
function PostBeginPlay()
{
	Super.PostBeginPlay();
	LoadTextures();
	_FontInfo = FontInfo(Spawn(Class<Actor>(DynamicLoadObject(class'ChallengeHUD'.default.FontInfoClass, class'Class'))));
}

//-------------------------------------
// LoadTexturesS
//-------------------------------------
final function LoadTextures()
{
    MySmallFont = Font(DynamicLoadObject("EUT_Textures.EUTSmallFont", class'Font'));
    TopSpan = Texture(DynamicLoadObject("EUT_Textures.EUT_SPan_T", class'Texture'));
    BotSpan = Texture(DynamicLoadObject("EUT_Textures.EUT_SPan_B", class'Texture'));
    LeftSpan = Texture(DynamicLoadObject("EUT_Textures.EUT_SPan_L", class'Texture'));
    RightSpan = Texture(DynamicLoadObject("EUT_Textures.EUT_SPan_R", class'Texture'));
    BoxFillBase = Texture(DynamicLoadObject("EUT_Textures.EUT_Fill", class'Texture'));
    BoxFillColored = Texture(DynamicLoadObject("EUT_Textures.EUT_FillColor", class'Texture'));
    TopLeftCorner = Texture(DynamicLoadObject("EUT_Textures.EUT_TL", class'Texture'));
    TopRightCorner = Texture(DynamicLoadObject("EUT_Textures.EUT_TR", class'Texture'));
    BotLeftCorner = Texture(DynamicLoadObject("EUT_Textures.EUT_BL", class'Texture'));
    BotRightCorner = Texture(DynamicLoadObject("EUT_Textures.EUT_BR", class'Texture'));
    PlayerDivider = Texture(DynamicLoadObject("EUT_Textures.EUT_Divider", class'Texture'));
    FlagIcon = Texture(DynamicLoadObject("BotPack.GreenFlag", class'Texture'));
    Meter = Texture(DynamicLoadObject("EUT_Textures.EUT_Meter", class'Texture'));


    SpecColor[0] = GreenColor;
    SpecColor[1] = GoldColor;
    SpecColor[2] = BlueColor;
    SpecColor[3] = RedColor;
    SpecColor[4] = CyanColor;
    MapTitleQuoteString = MapTitleQuote;
}

//-------------------------------------
// ShowScores
//-------------------------------------
function ShowScores(canvas C)
{
	local GameReplicationInfo GRI;

    GRI = PlayerPawn(Owner).GameReplicationInfo;

    MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
    TeamName[0] = MyCRI.RedTeamName;
    TeamName[1] = MyCRI.BlueTeamName;

    DrawHead(C, GRI);
    DrawFoot(C);

	if (C.ClipX > 512)
	{
       DrawMain(C);
       StoreStatData();
	}
}

//-------------------------------------
// DrawMain
//-------------------------------------
function DrawMain(Canvas C)
{
    local PlayerReplicationInfo PRI;
    local PlayerPawn MyPlayer;
    local bool bLast;
    local byte i, NumRed, NumBlue, NumSpec, NumTotal[2], MaxLength, MySpot;
    local float XL, YL, XL2, YL2, TeamLoopCount[2], DrawLength, X, Y, Mid, TempY, Length;
    local int TeamPing[2], TeamPacketLoss[2];

    NumTotal[0] = 0;
    NumTotal[1] = 0;
    ClearStoredPRI();


	for (i = 0; i < 32; i++)
    {
        PRI = PlayerPawn(Owner).GameReplicationInfo.PRIArray[i];

        if (PRI != none)
        {
            if (PRI.bIsSpectator
            && (!PRI.bWaitingPlayer)
            && (PRI.PlayerName != "Player"))
            {
                SpecPRI[NumSpec] = PRI;
                NumSpec++;
                if (NumSpec == ArrayCount(SpecPRI))
                    break;
            }
            else if (PRI.Team == 0)
            {
                if (!PRI.bIsSpectator || PRI.bWaitingPlayer)
    			{
                    RedPRI[NumRed] = PRI;
                    NumRed++;
                    NumTotal[0]++;
                    TeamPing[0] += MyCRI.ClientPing[PRI.PlayerID];
    				TeamPacketLoss[0] += PRI.PacketLoss;
                    if (NumRed == ArrayCount(RedPRI))
                        break;
                }
            }
            else if (PRI.Team == 1)
            {
                if (!PRI.bIsSpectator || PRI.bWaitingPlayer)
    			{
                    BluePRI[NumBlue] = PRI;
                    NumBlue++;
                    NumTotal[1]++;
                    TeamPing[1] += MyCRI.ClientPing[PRI.PlayerID];
    				TeamPacketLoss[1] += PRI.PacketLoss;
                    if (NumBlue == ArrayCount(BluePRI))
                       break;
                }
            }
        }
    }
    SortRedScores(NumRed);
    SortBlueScores(NumBlue);

    if (C.ClipX < 1100)
    {
        TextureSize = 2;
        Mid = 24;
        TopSpan.DrawScale = 0.50;
        BotSpan.DrawScale = 0.50;
        LeftSpan.DrawScale = 0.50;
        RightSpan.DrawScale = 0.50;
        TopLeftCorner.DrawScale = 0.50;
        TopRightCorner.DrawScale = 0.50;
        BotLeftCorner.DrawScale = 0.50;
        BotRightCorner.DrawScale = 0.50;
        PlayerStart = C.CliPY / 7 + TextureSize + 24;
    }
    else
    {
        TextureSize = 4;
        Mid = 32;
        TopSpan.DrawScale = 1;
        BotSpan.DrawScale = 1;
        LeftSpan.DrawScale = 1;
        RightSpan.DrawScale = 1;
        TopLeftCorner.DrawScale = 1;
        TopRightCorner.DrawScale = 1;
        BotLeftCorner.DrawScale = 1;
        BotRightCorner.DrawScale = 1;
        PlayerStart = C.CliPY / 7 + TextureSize + 32;
    }

    bPlayerMoved = false;

    if (NumRed >= NumBlue)
        MaxLength = NumRed;
    else
        MaxLength = NumBlue;

    Length = GetYOffset(C);
    DrawLength = MaxLength * Length;

    if (DrawLength > C.ClipY - PlayerStart)
    {
        TempY = DrawLength;
        MySpot = MaxLength;
        while (TempY > C.ClipY - PlayerStart)
        {
            MySpot = MySpot - 1;
            TempY = MySpot * Length;
        }
        MoveToVisible(PlayerPawn(Owner).PlayerReplicationInfo, MySpot - 1, NumRed, NumBlue);
    }

    FillBoxX = C.ClipX / 2 - Mid - TextureSize - C.ClipX / 8;
    FillBoxY = C.ClipY / 7 - TextureSize - C.ClipY / 10;
    CenterBoxY = FillBoxY / 2 + TextureSize;
    CenterBoxX = FillBoxX / 2 + TextureSize;
    DivW = FillBoxX * 0.8;
    DivS = DivW / 256;
    X = C.ClipX / 8;
    FillBoxX2 = FillBoxX;


    if (NumRed >= 0)
    {
        C.DrawColor = SilverColor;
        C.Style = ERenderStyle.STY_Translucent;
        C.SetPos(X, C.ClipY / 10);
        C.DrawRect(TopLeftCorner, TextureSize, TextureSize);
        C.SetPos(C.ClipX / 2 - Mid, C.ClipY / 10);
        C.DrawRect(TopRightCorner, TextureSize, TextureSize);
        C.SetPos(X + TextureSize, C.ClipY / 10);
        C.DrawRect(TopSpan, FillBoxX, TextureSize);
        C.SetPos(X, C.ClipY / 7);
        C.DrawRect(BotLeftCorner, TextureSize, TextureSize);
        C.SetPos(C.ClipX / 2 - Mid, C.ClipY / 7);
        C.DrawRect(BotRightCorner, TextureSize, TextureSize);
        C.SetPos(X + TextureSize, C.ClipY / 7);
        C.DrawRect(BotSpan, FillBoxX, TextureSize);
        C.SetPos(X, C.ClipY / 10 + TextureSize);
        C.DrawRect(LeftSpan, TextureSize, FillBoxY);
        C.SetPos(C.ClipX / 2 - Mid, C.ClipY / 10 + TextureSize);
        C.DrawRect(RightSpan, TextureSize, FillBoxY);
        C.DrawColor = ShadeColor;
        C.Style = ERenderStyle.STY_Modulated;
        C.SetPos(X + TextureSize, C.ClipY / 10 + TextureSize);
        C.DrawRect(BoxFillBase, FillBoxX, FillBoxY);

        if (C.ClipX > 1100) C.Font =  _FontInfo.GetMediumFont(C.ClipX);
        if (C.ClipX < 1100) C.Font =  _FontInfo.GetStaticBigFont(900);
        if (C.ClipX < 900) C.Font =  _FontInfo.GetStaticBigFont(700);

        C.DrawColor = RedColor;
        C.Style = ERenderStyle.STY_Normal;
        C.StrLen(TeamName[0], XL, YL);
        C.SetPos(X + CenterBoxX - (XL / 2), C.ClipY / 10 + CenterBoxY - (YL / 2));
        C.DrawText(TeamName[0], false);
        C.StrLen(int(MyCRI.Teams[0].score), XL, YL);
        C.SetPos(C.ClipX / 2 - Mid - TextureSize - XL, C.ClipY / 10 + CenterBoxY - (YL / 2));
        C.DrawText(int(MyCRI.Teams[0].score), false);
        C.Font = MySmallFont;
        C.DrawColor = WhiteColor;
	    C.StrLen("#######", XL, YL);
        C.SetPos(X + (TextureSize*2), C.ClipY / 10 + CenterBoxY - (YL));
        C.DrawText("Ping:", false);
        C.SetPos(X + (TextureSize*2) + XL, C.ClipY / 10 + CenterBoxY - (YL));
        C.DrawText(TeamPing[0] / NumTotal[0], false);
        C.SetPos(X + (TextureSize*2), C.ClipY / 10 + CenterBoxY);
        C.DrawText("Loss:", false);
        C.SetPos(X + (TextureSize*2) + XL, C.ClipY / 10 + CenterBoxY);
        C.DrawText(TeamPacketLoss[0] / NumTotal[0], false);
        C.DrawColor = SilverColor;
        C.Style = ERenderStyle.STY_Translucent;
        C.SetPos(X, PlayerStart);
        C.DrawRect(TopLeftCorner, TextureSize, TextureSize);
        C.SetPos(C.ClipX / 2 - Mid, PlayerStart);
        C.DrawRect(TopRightCorner, TextureSize, TextureSize);
        C.SetPos(X + TextureSize, PlayerStart);
        C.DrawRect(TopSpan, FillBoxX2, TextureSize);
        C.SetPos(X, PlayerStart + TextureSize + DrawLength);
        C.DrawRect(BotLeftCorner, TextureSize, TextureSize);
        C.SetPos(C.ClipX / 2 - Mid, PlayerStart + TextureSize + DrawLength);
        C.DrawRect(BotRightCorner, TextureSize, TextureSize);
        C.SetPos(X + TextureSize, PlayerStart + TextureSize + DrawLength);
        C.DrawRect(BotSpan, FillBoxX2, TextureSize);
        C.SetPos(X, PlayerStart + TextureSize);
        C.DrawRect(LeftSpan, TextureSize, DrawLength);
        C.SetPos(C.ClipX / 2 - Mid, PlayerStart + TextureSize);
        C.DrawRect(RightSpan, TextureSize, DrawLength);
        C.DrawColor = DarkRedColor;
        C.Style = ERenderStyle.STY_Modulated;
        C.SetPos(X + TextureSize, PlayerStart + TextureSize);
        C.DrawRect(BoxFillBase, FillBoxX, DrawLength);
        C.SetPos(X + TextureSize, PlayerStart + TextureSize);
        C.Style = ERenderStyle.STY_Translucent;
        C.DrawRect(BoxFillColored, FillBoxX, DrawLength);
    }

    for (i = 0; i < NumRed; i++)
    {
        Y  = PlayerStart + (TextureSize*4) + (GetYOffset(C) * TeamLoopCount[0]);
        if (i == 0)
        {
            Y = PlayerStart + (TextureSize*4);
            bLast = false;
        }
        if (i == NumRed - 1)
            bLast = true;

       DrawPlayerData(C, RedPRI[i], X, Y, bLast);
       TeamLoopCount[0] += 1;
    }

    if (NumBlue >= 0)
    {
        X = C.ClipX / 2 + Mid;
        C.DrawColor = SilverColor;
        C.Style = ERenderStyle.STY_Translucent;
        C.SetPos(X, C.ClipY / 10);
        C.DrawRect(TopLeftCorner, TextureSize, TextureSize);
        C.SetPos(X + TextureSize + FillBoxX, C.ClipY / 10);
        C.DrawRect(TopRightCorner, TextureSize, TextureSize);
        C.SetPos(X + TextureSize, C.ClipY / 10);
        C.DrawRect(TopSpan, FillBoxX, TextureSize);
        C.SetPos(X, C.ClipY / 7);
        C.DrawRect(BotLeftCorner, TextureSize, TextureSize);
        C.SetPos(X + TextureSize + FillBoxX, C.ClipY / 7);
        C.DrawRect(BotRightCorner, TextureSize, TextureSize);
        C.SetPos(X + TextureSize, C.ClipY / 7);
        C.DrawRect(BotSpan, FillBoxX, TextureSize);
        C.SetPos(X, C.ClipY / 10 + TextureSize);
        C.DrawRect(LeftSpan, TextureSize, FillBoxY);
        C.SetPos(X + TextureSize + FillBoxX, C.ClipY / 10 + TextureSize);
        C.DrawRect(RightSpan, TextureSize, FillBoxY);
        C.DrawColor = ShadeColor;
        C.Style = ERenderStyle.STY_Modulated;
        C.SetPos(X + TextureSize, C.ClipY / 10 + TextureSize);
        C.DrawRect(BoxFillBase, FillBoxX, FillBoxY);
        C.Font = _FontInfo.GetMediumFont(C.ClipX);

        if (C.ClipX > 1100) C.Font =  _FontInfo.GetMediumFont(C.ClipX);
        if (C.ClipX < 1100) C.Font =  _FontInfo.GetStaticBigFont(900);
        if (C.ClipX < 900) C.Font =  _FontInfo.GetStaticBigFont(700);

        C.DrawColor = BlueColor;
        C.Style = ERenderStyle.STY_Normal;
        C.StrLen(TeamName[1], XL, YL);
        C.SetPos(X + CenterBoxX - (XL / 2), C.ClipY / 10 + CenterBoxY - (YL / 2));
        C.DrawText(TeamName[1], false);
        C.StrLen(int(MyCRI.Teams[1].score), XL, YL);
        C.SetPos(X + FillBoxX - XL, C.ClipY / 10 + CenterBoxY - (YL / 2));
        C.DrawText(int(MyCRI.Teams[1].score), false);
        C.Font = MySmallFont;
        C.DrawColor = WhiteColor;
	    C.StrLen("#######", XL, YL);
        C.SetPos(X + (TextureSize*2), C.ClipY / 10 + CenterBoxY - (YL));
        C.DrawText("Ping:",  false);
        C.SetPos(X + (TextureSize*2) + XL, C.ClipY / 10 + CenterBoxY - (YL));
        C.DrawText(TeamPing[1] / NumTotal[1], false);
        C.SetPos(X + (TextureSize*2), C.ClipY / 10 + CenterBoxY);
        C.DrawText("Loss:", false);
        C.SetPos(X + (TextureSize*2) + XL, C.ClipY / 10 + CenterBoxY);
        C.DrawText(TeamPacketLoss[1] / NumTotal[1], false);
        C.DrawColor = SilverColor;
        C.Style = ERenderStyle.STY_Translucent;
        C.SetPos(X, PlayerStart);
        C.DrawRect(TopLeftCorner, TextureSize, TextureSize);
        C.SetPos(X + TextureSize + FillBoxX, PlayerStart);
        C.DrawRect(TopRightCorner, TextureSize, TextureSize);
        C.SetPos(X + TextureSize, PlayerStart);
        C.DrawRect(TopSpan, FillBoxX2, TextureSize);
        C.SetPos(X, PlayerStart + TextureSize + DrawLength);
        C.DrawRect(BotLeftCorner, TextureSize, TextureSize);
        C.SetPos(X + TextureSize + FillBoxX, PlayerStart + TextureSize + DrawLength);
        C.DrawRect(BotRightCorner, TextureSize, TextureSize);
        C.SetPos(X + TextureSize, PlayerStart + TextureSize + DrawLength);
        C.DrawRect(BotSpan, FillBoxX2, TextureSize);
        C.SetPos(X, PlayerStart + TextureSize);
        C.DrawRect(LeftSpan, TextureSize, DrawLength);
        C.SetPos(X + TextureSize + FillBoxX, PlayerStart + TextureSize);
        C.DrawRect(RightSpan, TextureSize, DrawLength);
        C.DrawColor = DarkBlueColor;
        C.Style = ERenderStyle.STY_Modulated;
        C.SetPos(X + TextureSize, PlayerStart + TextureSize);
        C.DrawRect(BoxFillBase, FillBoxX, DrawLength);
        C.SetPos(X + TextureSize, PlayerStart + TextureSize);
        C.Style = ERenderStyle.STY_Translucent;
        C.DrawRect(BoxFillColored, FillBoxX, DrawLength);

    }

    for (i = 0; i < NumBlue; i++)
    {
        Y  = PlayerStart + (TextureSize*4) + (GetYOffset(C) * TeamLoopCount[1]);
        if (i == 0)
        {
            Y = PlayerStart + (TextureSize*4);
            bLast = false;
        }
        if (i == NumBlue - 1)
            bLast = true;

        DrawPlayerData(C, BluePRI[i], X, Y, bLast);
        TeamLoopCount[1] += 1;
    }

    for (i = 0; i < NumSpec; i++)
    {
        C.Font = C.smallfont;
        C.StrLen(SpecPRI[i].PlayerName, XL, YL);
        Y = C.ClipY / 2 + YL +(YL * i);
        X = C.ClipX - XL;
        if ( i == 0 )
            Y = C.ClipY / 2 + YL;

        DrawSpectators(C, SpecPRI[i], X, Y, i);
    }

    C.DrawColor = SilverColor;
    C.Style = ERenderStyle.STY_Normal;
    C.Font = C.smallfont;
    C.StrLen("Spectators", XL, YL);
    C.SetPos(C.ClipX - XL, C.ClipY / 2);
    C.DrawText("Spectators", false);
}

//-------------------------------------
// DrawPlayerData
//-------------------------------------
function DrawPlayerData(Canvas C, PlayerReplicationInfo PRI, float X, float Y, bool bLast)
{
    local float XL, YL, XL2, YL2, XL3, YL3, PY, MX, MY, ZX, ZY, FX;
    local bool bAdmin;
    local PlayerPawn MyPlayer;
    local int MeterLen, HueShift, eff, Time, pid;
    local Font CanvasFont;
    local color CanvasColor;
    local string Location;

    bAdmin = PRI.bAdmin;
    MyPlayer = PlayerPawn(Owner);
    pid = PRI.PlayerID;
    C.Style = ERenderStyle.STY_Normal;

    if (PRI.Team == MyPlayer.PlayerReplicationInfo.Team)
	{
		if (PRI.PlayerLocation != none) Location = PRI.PlayerLocation.LocationName;
		else if (PRI.PlayerZone != None) Location = PRI.PlayerZone.ZoneName;
		else Location = "";
        if (Location != "") Location = "Location:"@Location;
	}

    if (PRI.HasFlag != none)
    {
        C.Style = ERenderStyle.STY_Normal;
        C.SetPos(X - 32,Y);

        if (PRI.HasFlag.IsA('EUTReadyFlag'))
        {
            C.DrawColor = GreenColor;
            C.DrawIcon(Texture'Botpack.Icons.GreenFlag',1.00);
        }
        else
        {
            switch (PRI.Team)
            {
                case 0:
                    C.DrawColor = BlueColor;
                    C.DrawIcon(Texture'Botpack.Icons.BlueFlag',1.00);
                    break;
                case 1:
                    C.DrawColor = RedColor;
                    C.DrawIcon(Texture'Botpack.Icons.RedFlag',1.00);
                    break;
            }
        }
    }

    if (PRI.Team == 0) C.DrawColor = RedColor;
    else C.Drawcolor = BlueColor;
    if (PRI.PlayerName == MyPlayer.PlayerReplicationInfo.PlayerName) C.DrawColor = GoldColor;
    if (C.ClipX > 1100) C.Font =  _FontInfo.GetMediumFont(C.ClipX);
    if (C.ClipX < 1100) C.Font =  _FontInfo.GetStaticBigFont(900);
    if (C.ClipX < 900) C.Font =  _FontInfo.GetStaticBigFont(700);

    CanvasFont = C.Font;
    CanvasColor = C.DrawColor;
    FX = X + (TextureSize * 2);
    C.StrLen(PRI.PlayerName, XL, PY);

    if (MyCRI.bIpToCountry)
    {
        if (caps(MyCRI.IPCTexture[pid]) == "NONE" && (!MyPlayer.IsA('Bot')))
            MyCRI.IPCTexture[pid] = "us";

        if (MyCRI.IPCTexture[pid] != "" && caps(MyCRI.IPCTexture[pid]) != "NONE")
        {
            if (Country[pid] == none)
                Country[pid] = Texture(DynamicLoadObject(MyCRI.IpToCountryTexturePackage$"."$MyCRI.IPCTexture[pid], class'Texture'));

            else
            {
                if (_GetTextureName(string(Country[pid])) != caps(MyCRI.IPCTexture[pid]))
                    Country[pid] = Texture(DynamicLoadObject(MyCRI.IpToCountryTexturePackage$"."$MyCRI.IPCTexture[pid], class'Texture'));

                C.SetPos(FX,Y);
                C.bNoSmooth = false;
                C.DrawColor = WhiteColor;
                C.DrawIcon(Country[pid],1.0);
                C.bNoSmooth = true;
                FX = FX + Country[pid].USize + (Step*2);
            }
        }
    }

    C.DrawColor = CanvasColor;
    C.SetPos(FX,Y);
    C.DrawText(PRI.PlayerName, false);

    if (bAdmin)
    {
        C.Font = MySmallFont;
        C.StrLen("admin", XL3, YL3);
        C.SetPos(X - XL3 - TextureSize, Y);
        C.DrawText("admin", false);
        C.Font = CanvasFont;
    }
    else if (!bAdmin && bPlayerMoved && PRI.PlayerName == MyPlayer.PlayerReplicationInfo.PlayerName)
    {
        C.Font = MySmallFont;
        C.StrLen("more>>", XL3, YL3);
        C.SetPos(X - XL3 - TextureSize, Y);
        C.DrawText("more>>", false);
        C.Font = CanvasFont;
    }

    C.StrLen(string(int(PRI.Score)), XL, YL);
	C.SetPos(X + FillBoxX - XL, Y);
	C.DrawText(int(PRI.Score), False);

	C.StrLen(string(MyCRI.TotalKills[PRI.PlayerID])$"/", XL2, YL);
	C.SetPos(X + FillBoxX - XL - XL2, Y);
	C.DrawText(MyCRI.TotalKills[PRI.PlayerID]$"/",false);

	if (C.ClipX > 512)
	{
        C.DrawColor = WhiteColor;
        C.Font = _FontInfo.GetSmallestFont(C.ClipX);

        if (C.ClipX < 1100) C.Font = _FontInfo.GetSmallestFont(900);
        if (C.ClipX < 900) C.Font = MySmallFont;

        C.StrLen("#########", XL2, YL2); //Align Numbers
        MaxMeterLength = FillBoxX / 2 - XL2 - (TextureSize * 4) - (Step * 2);
        MY = YL2 / 4;
        ZX = X + (TextureSize*2);
        MX = ZX + XL2 + (Step * 2);
        ZY = Y + PY;
        MeterScale = YL2 / 4;

        if (MyCRI.IStats1[PRI.PlayerID].FlagCaps != 3)
        {
            C.StrLen("Caps:#####", XL, YL);
            C.SetPos(ZX, ZY);
            C.DrawText("Caps:", false);
            C.SetPos(ZX + XL2, ZY);
            C.DrawText(MyCRI.IStats1[PRI.PlayerID].FlagCaps, false);

            if (MyCRI.IStats1[PRI.PlayerID].FlagCaps > 0)
            {
                HueShift = Hue * loge(MyCRI.IStats1[PRI.PlayerID].FlagCaps);

                if (HueShift > 255) HueShift = 255;
                if (MyCRI.IStats1[PRI.PlayerID].FlagCaps > 3) C.DrawColor = GoldColor;
                if (MyCRI.IStats1[PRI.PlayerID].FlagCaps < 3) C.DrawColor = GetMeterColor(HueShift);

                MeterLen = GetMeterLength(MyCRI.IStats1[PRI.PlayerID].FlagCaps, FlagCaps);
                C.SetPos(MX, ZY + MeterScale);
                C.DrawRect(Meter, MeterLen, MY);
                C.DrawColor = WhiteColor;
            }
        }
        if (MyCRI.IStats1[PRI.PlayerID].FlagCaps == 3)
        {
            C.StrLen("HatTrick  ", XL, YL);
            C.SetPos(X + (TextureSize*2), ZY);
            C.DrawText("HatTrick  ", false);
            C.DrawColor = GoldColor;
            MeterLen = GetMeterLength(MyCRI.IStats1[PRI.PlayerID].FlagCaps, FlagCaps);
            C.SetPos(MX, ZY + MeterScale);
            C.DrawRect(Meter, MeterLen, MY);
            C.DrawColor = WhiteColor;
        }

        C.StrLen("Grabs:####", XL, YL);
        C.SetPos(ZX, ZY + YL2);
        C.DrawText("Grabs:", false);
        C.SetPos(ZX + XL2, ZY + YL2);
        C.DrawText(MyCRI.IStats1[PRI.PlayerID].FlagGrabs, false);

        if ( MyCRI.IStats1[PRI.PlayerID].FlagGrabs > 0 )
        {
            HueShift = Hue * loge(MyCRI.IStats1[PRI.PlayerID].FlagGrabs);

            if(HueShift > 255) HueShift = 255;

            C.DrawColor = GetMeterColor(HueShift);
            MeterLen = GetMeterLength(MyCRI.IStats1[PRI.PlayerID].FlagGrabs, FlagGrabs);
            C.SetPos(MX, ZY + YL2 + MeterScale);
            C.DrawRect(Meter, MeterLen, MY);
            C.DrawColor = WhiteColor;
        }

        C.StrLen("Assist:###", XL, YL);
        C.SetPos(ZX, ZY + (YL2 * 2));
        C.DrawText("Assist:", false);
        C.SetPos(ZX + XL2, ZY + (YL2 * 2));
        C.DrawText(MyCRI.IStats1[PRI.PlayerID].FlagAssists, false);

        if ( MyCRI.IStats1[PRI.PlayerID].FlagAssists > 0 )
        {
            HueShift = Hue * loge(MyCRI.IStats1[PRI.PlayerID].FlagAssists);

            if (HueShift > 255) HueShift = 255;

            C.DrawColor = GetMeterColor(HueShift);
            MeterLen = GetMeterLength(MyCRI.IStats1[PRI.PlayerID].FlagAssists, FlagAssists);
            C.SetPos(MX, ZY + (YL2 * 2) + MeterScale);
            C.DrawRect(Meter, MeterLen, MY);
            C.DrawColor = WhiteColor;
        }
        ZX = X + (TextureSize * 2) + (FillBoxX / 2);
        MX = ZX + XL2 + (Step * 2);

        C.StrLen("Covers:  ##", XL, YL);
        C.SetPos(ZX, ZY);
        C.DrawText("Covers:", false);
        C.SetPos(ZX + XL2, ZY);
        C.DrawText(MyCRI.IStats3[PRI.PlayerID].FlagCovers, false);

        if ( MyCRI.IStats3[PRI.PlayerID].FlagCovers > 0 )
        {
            HueShift = Hue * loge(MyCRI.IStats3[PRI.PlayerID].FlagCovers);

            if (HueShift > 255) HueShift = 255;

            C.DrawColor = GetMeterColor(HueShift);
            MeterLen = GetMeterLength(MyCRI.IStats3[PRI.PlayerID].FlagCovers, FlagCovers);
            C.SetPos(MX,  ZY + MeterScale);
            C.DrawRect(Meter, MeterLen, MY);
            C.DrawColor = WhiteColor;
        }

        C.StrLen("Seals:    ##", XL, YL);
        C.SetPos(ZX, ZY + YL2);
        C.DrawText("Seals:", false);
        C.SetPos(ZX + XL2, ZY + YL2);
        C.DrawText(MyCRI.IStats1[PRI.PlayerID].BaseSeals, false);

        if ( MyCRI.IStats1[PRI.PlayerID].BaseSeals > 0 )
        {
            HueShift = Hue * loge(MyCRI.IStats1[PRI.PlayerID].BaseSeals);

            if (HueShift > 255) HueShift = 255;

            C.DrawColor = GetMeterColor(HueShift);
            MeterLen = GetMeterLength(MyCRI.IStats1[PRI.PlayerID].BaseSeals, BaseSeals);
            C.SetPos(MX,  ZY + YL2 + MeterScale);
            C.DrawRect(Meter, MeterLen, MY);
            C.DrawColor = WhiteColor;
        }

        C.StrLen("FlgKls: ##", XL, YL);
        C.SetPos(ZX, ZY + (YL2 * 2));
        C.DrawText("FlgKls:", false);
        C.SetPos(ZX + XL2, ZY + (YL2 * 2));
        C.DrawText(MyCRI.IStats2[PRI.PlayerID].FlagKills, false);

        if (MyCRI.IStats2[PRI.PlayerID].FlagKills > 0)
        {
            HueShift = Hue * loge(MyCRI.IStats2[PRI.PlayerID].FlagKills);

            if (HueShift > 255) HueShift = 255;

            C.DrawColor = GetMeterColor(HueShift);
            MeterLen = GetMeterLength(MyCRI.IStats2[PRI.PlayerID].FlagKills, FlagKills);
            C.SetPos(MX,  ZY + (YL2 * 2) + MeterScale);
            C.DrawRect(Meter, MeterLen, MY);
            C.DrawColor = WhiteColor;
        }

        if (!bLast)
        {
            C.DrawColor = SilverColor;
            C.Style = ERenderStyle.STY_Modulated;
            C.SetPos(ZX - (DivW / 2), ZY + (YL2 * 4));
            C.DrawIcon(PlayerDivider, DivS);
            C.DrawColor = GoldColor;
            C.Style = ERenderStyle.STY_Translucent;
            C.SetPos(ZX - (DivW / 2), ZY + (YL2 * 4));
            C.DrawIcon(PlayerDivider, DivS);
        }
        Time = Max(1, (Level.TimeSeconds + MyPlayer.PlayerReplicationInfo.StartTime - PRI.StartTime) / 60);

        C.DrawColor = LightCyanColor;
        C.Style = ERenderStyle.STY_Normal;
        C.Font = MySmallFont;
        if (C.ClipX < 700)
            C.Font = _FontInfo.GetStaticAReallySmallFont(900);


        if (MyCRI.bScoreBoardEff)
        {
            eff = Clamp(int((float(MyCRI.TotalKills[PRI.PlayerID]) /
            float(MyCRI.TotalKills[PRI.PlayerID] + MyCRI.TotalDeaths[PRI.PlayerID])) * 100), 0, 100);

            C.StrLen("Time:"@Time@"Ping:"@MyCRI.ClientPing[PRI.PlayerID]@"Loss:"@PRI.PacketLoss@"Eff:"@eff, XL, YL);
            C.SetPos(X  + FillBoxX  - XL, ZY + (YL2 * 4) - YL);
            C.DrawText("Time:"@Time@"Ping:"@MyCRI.ClientPing[PRI.PlayerID]@"Loss:"@PRI.PacketLoss@"Eff:"@eff, false);
        }
        else
        {
            C.StrLen("Time:"@Time@"Ping:"@MyCRI.ClientPing[PRI.PlayerID]@"Loss:"@PRI.PacketLoss, XL, YL);
            C.SetPos(X  + FillBoxX  - XL, ZY + (YL2 * 4) - YL);
            C.DrawText("Time:"@Time@"Ping:"@MyCRI.ClientPing[PRI.PlayerID]@"Loss:"@PRI.PacketLoss, false);
        }

        C.DrawColor = LightCyanColor;
        C.SetPos(X + (TextureSize * 2), ZY + (YL2 * 4) - YL);
        C.DrawText(Location, false);
    }
}

//-------------------------------------
// DrawHead
//-------------------------------------
function DrawHead(canvas C, GameReplicationInfo GRI)
{
	local float XL, YL, XL2, YL2;
	local font CanvasFont;

	C.DrawColor = WhiteColor;

	if (C.ClipX > 1100) C.Font =  _FontInfo.GetMediumFont(C.ClipX);
    if (C.ClipX < 1100) C.Font =  _FontInfo.GetStaticBigFont(900);
    if (C.ClipX < 900) C.Font =  _FontInfo.GetStaticBigFont(700);

	C.bCenter = True;
	C.StrLen("Test", XL, YL);
	ScoreStart = 58.0 / 768.0 * C.ClipY - 50;
	CanvasFont = C.Font;

	if (GRI.GameEndedComments != "")
	{
        C.DrawColor = GoldColor;
		C.SetPos(0, 0 + YL);
		C.DrawText(GRI.GameEndedComments, True);
	}
	else
	{
		C.SetPos(0, ScoreStart);
		DrawEndGame(C);
	}
	C.bCenter = False;
	C.Font = CanvasFont;
}

//-------------------------------------
// DrawEndGam
//-------------------------------------
function DrawEndGame(Canvas C)
{
	local TournamentGameReplicationInfo TGRI;
	local float XL, YL, YL2;

	TGRI = TournamentGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
	if (TGRI == None) return;

    C.SetPos(0, 0);
	C.DrawColor.R = 255;
    C.DrawColor.G = 200;
    C.DrawColor.B = 100;
    C.DrawText("Smart"@TGRI.GameName);
	C.StrLen("Test", XL, YL);
	C.SetPos(0, 0 + YL);
	YL2 = C.CurY - YL;

	if (TGRI.GoalTeamScore > 0)
	{
		C.SetPos(0, 0 + YL);
        C.DrawColor.R = 255;
        C.DrawColor.G = 200;
        C.DrawColor.B = 100;
        C.DrawText(TGRI.GoalTeamScore$" Caps or "$TGRI.TimeLimit@"Min");
		C.StrLen("Test", XL, YL);
		C.SetPos(0, C.CurY - YL);
	}
}

//-------------------------------------
// DrawFoot
//-------------------------------------
function DrawFoot(canvas C)
{
	local byte Hours, Minutes, Seconds;
	local float XL, YL;
	local PlayerPawn MyPlayer;

	C.bCenter = true;
	C.Font = _FontInfo.GetSmallFont(C.ClipX);

	if (C.ClipX < 1100)
        C.Font = _FontInfo.GetSmallFont(900);
    if (C.ClipX < 900)
        C.Font = _FontInfo.GetStaticSmallestFont(C.ClipX);

    C.StrLen("Test", XL, YL);
	C.DrawColor.R = 255;
    C.DrawColor.G = 200;
    C.DrawColor.B = 100;
	MyPlayer = PlayerPawn(Owner);
	C.SetPos(0, C.ClipY - 2 * YL * 1.5);

	if ((Level.NetMode == NM_Standalone ) && Level.Game.IsA('DeathMatchPlus'))
	{
        if (DeathMatchPlus(Level.Game).bRatedGame)
            C.DrawText(DeathMatchPlus(Level.Game).RatedGameLadderObj.SkillText@MyPlayer.GameReplicationInfo.GameName@MapTitleString@MapTitleQuoteString$Level.Title$MapTitleQuoteString, true);
		else if (DeathMatchPlus(Level.Game).bNoviceMode)
			C.DrawText(class'ChallengeBotInfo'.default.Skills[Level.Game.Difficulty]@MyPlayer.GameReplicationInfo.GameName@MapTitleString@MapTitleQuoteString$Level.Title$MapTitleQuoteString, true);
		else
			C.DrawText(class'ChallengeBotInfo'.default.Skills[Level.Game.Difficulty + 4]@MyPlayer.GameReplicationInfo.GameName@MapTitleString@MapTitleQuoteString$Level.Title$MapTitleQuoteString, true);
	}
	else
	{
	    C.DrawColor.R = 255;
        C.DrawColor.G = 200;
        C.DrawColor.B = 100;
        C.SetPos(0, C.ClipY - 2 * YL * 1.5);
        C.DrawText(MyPlayer.GameReplicationInfo.GameName@MapTitleString@Level.Title, true);
        C.DrawColor.R = 255;
        C.DrawColor.G = 200;
        C.DrawColor.B = 100;
        C.SetPos(0, C.ClipY - 2 * YL);
        C.DrawText(MyPlayer.GameReplicationInfo.ServerName$" - "$GetTime(), true);
	    C.SetPos(0, C.ClipY - YL);
	}

	if (bTimeDown || (MyPlayer.GameReplicationInfo.RemainingTime > 0))
	{
        bTimeDown = true;
		if (MyPlayer.GameReplicationInfo.RemainingTime <= 0)
			C.DrawText(RemainingTimeString@"00:00", true);
		else
		{
			Minutes = MyPlayer.GameReplicationInfo.RemainingTime / 60;
			Seconds = MyPlayer.GameReplicationInfo.RemainingTime % 60;
			C.DrawText(RemainingTimeString@TwoDigitString(Minutes)$":"$TwoDigitString(Seconds), true);
		}
	}
	else
	{
		Seconds = MyPlayer.GameReplicationInfo.ElapsedTime;
		Minutes = Seconds / 60;
		Hours   = Minutes / 60;
		Seconds = Seconds - (Minutes * 60);
		Minutes = Minutes - (Hours * 60);
		C.DrawText(ElapsedTimeString@TwoDigitString(Hours)$":"$TwoDigitString(Minutes)$":"$TwoDigitString(Seconds), true);
	}

	if (MyPlayer.GameReplicationInfo.GameEndedComments != "")
	{
		C.bCenter = true;
		C.StrLen("Test", XL, YL);
		C.SetPos(0, C.ClipY - Min(YL*6, C.ClipY * 0.1));
		C.DrawColor = GreenColor;
		if (Level.NetMode == NM_Standalone) C.DrawText(GameEndedString@ContinueString, true);
		else C.DrawText(GameEndedString, true);
	}
	else if ((MyPlayer != None) && (MyPlayer.Health <= 0))
	{
		C.bCenter = true;
		C.StrLen("Test", XL, YL);
		C.SetPos(0, C.ClipY - Min(YL*6, C.ClipY * 0.1));
		C.DrawColor = SilverColor;
		C.DrawText(RestartString, true);
	}
	C.bCenter = false;
	C.Font = C.smallfont;
    C.DrawColor.R = 120;
    C.DrawColor.G = 120;
    C.DrawColor.B = 120;
    C.Setpos(C.ClipX - 80, C.ClipY - 20);
    C.DrawText("AutoSS:"@MyCRI.bAutoShot);
}

//-------------------------------------
// SortRedScores
//-------------------------------------
function SortRedScores(byte z)
{
	local byte i, j, Max;
	local PlayerReplicationInfo PRI;

	for (i = 0; i < z - 1; i++)
	{
		Max = i;
		for ( j = i + 1; j < z; j++ )
		{
			if (RedPRI[j].Score > RedPRI[Max].Score)
				Max = j;
			else if ((RedPRI[j].Score == RedPRI[Max].Score)
            && (RedPRI[j].Deaths < RedPRI[Max].Deaths))
				Max = j;
			else if ((RedPRI[j].Score == RedPRI[Max].Score)
            && (RedPRI[j].Deaths == RedPRI[Max].Deaths)
            && (RedPRI[j].PlayerID < RedPRI[Max].Score))
				Max = j;
		}

		PRI = RedPRI[Max];
		RedPRI[Max] = RedPRI[i];
		RedPRI[i] = PRI;
	}
}

//-------------------------------------
// SortBlueScores
//-------------------------------------
function SortBlueScores(byte z)
{
	local byte i, j, Max;
	local PlayerReplicationInfo PRI;

	for ( i = 0; i < z - 1; i++ )
	{
		Max = i;
		for ( j = i + 1; j < z; j++ )
		{
			if (BluePRI[j].Score > BluePRI[Max].Score)
				Max = j;
			else if ((BluePRI[j].Score == BluePRI[Max].Score)
            && (BluePRI[j].Deaths < BluePRI[Max].Deaths))
				Max = j;
			else if ((BluePRI[j].Score == BluePRI[Max].Score)
            && (BluePRI[j].Deaths == BluePRI[Max].Deaths)
            &&(BluePRI[j].PlayerID < BluePRI[Max].Score))
				Max = j;
		}

		PRI = BluePRI[Max];
		BluePRI[Max] = BluePRI[i];
		BluePRI[i] = PRI;
	}
}

//-------------------------------------
// GetTime
//-------------------------------------
simulated function string GetTime()
{
   local string amPm, mon, day, min;
   local byte hour;
   local PlayerPawn MyPlayer;

   MyPlayer = PlayerPawn(Owner);

   min = string(MyPlayer.level.minute);

   if (int(min) < 10) min = "0" $ min;

   if (MyPlayer.level.hour >= 12) amPm = "PM";
   else amPm = "AM";

   if (MyPlayer.level.hour > 12) hour = MyPlayer.level.hour - 12;
   else if (MyPlayer.level.hour == 0) hour = 12;
   else hour = MyPlayer.level.hour;

   switch (MyPlayer.level.month)
   {
      case 1: mon = "Jan"; break;
      case 2: mon = "Feb"; break;
      case 3: mon = "Mar"; break;
      case 4: mon = "Apr"; break;
      case 5: mon = "May"; break;
      case 6: mon = "Jun"; break;
      case 7: mon = "Jul"; break;
      case 8: mon = "Aug"; break;
      case 9: mon = "Sep"; break;
      case 10: mon = "Oct"; break;
      case 11: mon = "Nov"; break;
      case 12: mon = "Dec"; break;
   }

   switch (MyPlayer.level.dayOfWeek)
   {
      case 0: day = "Sunday"; break;
      case 1: day = "Monday"; break;
      case 2: day = "Tuesday"; break;
      case 3: day = "Wednesday"; break;
      case 4: day = "Thursday"; break;
      case 5: day = "Friday"; break;
      case 6: day = "Saturday"; break;
   }

   return hour $ ":" $ min @ amPM $ " , " $ day $ ", " $ mon @ MyPlayer.level.day $ ", " $ MyPlayer.level.year;
}

//-------------------------------------
// TwoDigitString
//-------------------------------------
function string TwoDigitString(int i)
{
	if (i < 10) return "0"$i;
	else return string(i);
}

//-------------------------------------
// GetYOffset
//-------------------------------------
function float GetYOffset(Canvas C)
{
    local float XL, YL, YL2;
    local float buf, div;

    if (C.ClipX > 1100) C.Font =  _FontInfo.GetMediumFont(C.ClipX);
    if (C.ClipX < 1100) C.Font =  _FontInfo.GetStaticBigFont(900);
    if (C.ClipX < 900) C.Font =  _FontInfo.GetStaticBigFont(700);

    C.StrLen("TEST",XL,YL);
    C.Font = _FontInfo.GetSmallestFont(C.ClipX);
    if (C.ClipX < 1100) C.Font = _FontInfo.GetSmallestFont(900);
    if (C.ClipX < 900) C.Font = MySmallFont;

    C.StrLen("#",XL,YL2);
    Step = XL;

    if (C.ClipX > 1100)
    {
       buf = 15;
       div = 4;
    }
    else
    {
       buf = 10;
       div = 2;
    }

    return YL + ( YL2 * 3 ) + ( buf * 2 ) + div;
}

//-------------------------------------
// StoreStatData
//-------------------------------------
simulated final function StoreStatData()
{
    local byte i;
    local byte a, b, c, d, e, f;

    for (i = 0; i < 32; i++)
    {
        a = MyCRI.IStats1[i].FlagCaps + a;
        b = MyCRI.IStats1[i].FlagGrabs + b;
        c = MyCRI.IStats1[i].FlagAssists + c;
        d = MyCRI.IStats3[i].FlagCovers + d;
        e = MyCRI.IStats1[i].BaseSeals + e;
        f = MyCRI.IStats2[i].FlagKills + f;
    }
    FlagCaps = a;
    FlagGrabs = b;
    FlagAssists = c;
    FlagCovers = d;
    BaseSeals = e;
    FlagKills = f;
}

//-------------------------------------
// GetMeterLength
//-------------------------------------
simulated function int GetMeterLength(int i, int NumTotal)
{
   local int rv;

   if (NumTotal == 0) return 0;
   rv = ( i * MaxMeterLength ) / NumTotal;
   if (rv > MaxMeterLength) return MaxMeterLength;
   else return rv;
}

//-------------------------------------
// DrawSpectators
//-------------------------------------
function DrawSpectators(Canvas C, PlayerReplicationInfo PRI, float X, float Y, int cid)
{
    if (cid > 5) cid = cid - 6;
    C.DrawColor = SpecColor[cid];
    C.Style = ERenderStyle.STY_Normal;
    C.Font = C.smallfont;
    C.SetPos(X,Y);
    C.DrawText(PRI.PlayerName,false);
}

//-------------------------------------
// ClearStoredPRI
//-------------------------------------
function ClearStoredPRI()
{
    local int i;
    for (i = 0; i < ArrayCount(RedPRI); i++) RedPRI[i] = None;
    for (i = 0; i < ArrayCount(BluePRI); i++) BluePRI[i] = None;
    for (i = 0; i < ArrayCount(SpecPRI); i++) SpecPRI[i] = None;
}

//-------------------------------------
// GetMeterColor
//-------------------------------------
function color GetMeterColor(int HueShift)
{
   local color rv;
   rv = WhiteColor;
   rv.R = WhiteColor.R - HueShift;
   rv.B = WhiteColor.R - HueShift;
   return rv;
}

//-------------------------------------
// _GetTextureName
//-------------------------------------
function string _GetTextureName(string T)
{
    return caps(mid(T, instr(T, ".") + 1));
}

//-------------------------------------
// MoveToVisible
//-------------------------------------
function MoveToVisible(PlayerReplicationInfo MyPRI, byte MySpot, byte Red, byte Blue)
{
    local int i;
    local PlayerReplicationInfo SwitchPRI;

    switch (MyPRI.Team)
    {
        case 0:
            for (i=0; i<Red; i++)
            {
                if (RedPRI[i].PlayerName == MyPRI.PlayerName && i > MySpot)
                {
                    SwitchPRI = RedPRI[MySpot];
                    RedPRI[MySpot] = MyPRI;
                    RedPRI[i] = SwitchPRI;
                    bPlayerMoved = true;
                    break;
                }
            }
            break;
        case 1:
            for (i=0; i<Blue; i++)
            {
                if (BluePRI[i].PlayerName == MyPRI.PlayerName && i > MySpot)
                {
                    SwitchPRI = BluePRI[MySpot];
                    BluePRI[MySpot] = MyPRI;
                    BluePRI[i] = SwitchPRI;
                    bPlayerMoved = true;
                    break;
                }
            }
            break;
    }
}

//-------------------------------------
// defaultproperties
//-------------------------------------
defaultproperties
{
    Hue=120
    GreenColor=(R=0,G=255,B=0,A=0),
    WhiteColor=(R=255,G=255,B=255,A=0),
    GoldColor=(R=255,G=255,B=0,A=0),
    BlueColor=(R=5,G=5,B=255,A=0),
    LightCyanColor=(R=128,G=255,B=255,A=0),
    SilverColor=(R=138,G=164,B=166,A=0),
    BronzeColor=(R=203,G=147,B=52,A=0),
    CyanColor=(R=0,G=128,B=255,A=0),
    RedColor=(R=255,G=5,B=5,A=0),
    ShadeColor=(R=70,G=70,B=70,A=0),
    DarkRedColor=(R=5,G=0,B=0,A=0),
    DarkBlueColor=(R=0,G=0,B=5,A=0),
    MaxMeterLength=60
    MapTitleString="in"
    AuthorString="by"
    RestartString="You got pwned.  Hit [Fire] to reSpawn!"
    ContinueString=" Hit [Fire] to continue!"
    GameEndedString="The match has ended."
    ElapsedTimeString="Elapsed Time: "
    RemainingTimeString="Remaining Time: "
    FragGoalString="Frag Limit:"
    TimeLimitString="Time Limit:"
    PlayerString="Player"
    FragsString="Frags"
    DeathsString="Deaths"
    PingString="Ping"
    TimeString="Time"
    LossString="Loss"
    FPHString="FPH"
}
