/*
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
        EUTClientReplication
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
*/

class EUTClientReplication extends ReplicationInfo;

var EUTMutator MyMut;
var EUTGameReplicationInfo MyCRI;

var PlayerPawn MyPlayer;

var transient editconst private bool
    bLogOnce,
    bTime,
    bSpeedHack,
    bILikeTheStick,
    bMyMouseCantSee;

var transient editconst bool
    bCheckTweaks,
    bAutoTaunts,
    bTDM,
    bCTF,
    bDM,
    bSpectator,
    bBasicTexturesLoaded;

var transient editconst byte
    SpecCounter,
    TextureCounter,
    GRIMode;

var float ServerTime;

var transient editconst private float
    InitialTime,
    MyTime,
    ServerTimeStamp,
    ClientTimeStamp;

var transient editconst string
    MouseSetting,
    LockedMenu,
    Stitches,
    Floor,
    LodBias,
    VersString,
    ThisVer,
    AllowedMods[10],
    BotChair;

var transient editconst private string
    MyMouseY,
    Brightness;

var transient editconst private texture
    RedFlag,
    BlueFlag,
    FacePan;

const JoyStick = "get windrv.windowsclient usejoystick";
const Brightz = "get ini:Engine.Engine.ViewportManager Brightness";
const MouseY = "get engine.input mousey";
const MouseX = "get engine.input mousex";

/*  Texture Checks are no longer performed in Uscript

var transient editconst private texture CrosshairTexture[10];

var private int CrosshairStart[10], CrosshairCheck[10];

var private byte CrosshairNotify[10], CrosshairKick[10];

const RedFlag = "BotPack.RedFlag";
const BlueFlag = "BotPack.BlueFlag";
const FacePan = "BotPack.FacePanel0";

*/


//-------------------------------------
// replication
//-------------------------------------
replication
{
	 reliable if (Role < ROLE_Authority)
	 ValidateFace,
     NotifyServer,
     SimpleLog,
     VerifySpec,
     TransferModItems,
     CheckTime,
     TransferGameData;

     reliable if (Role == ROLE_Authority)
     bCheckTweaks,
     SpecCounter,
     MouseSetting,
     LockedMenu,
     Stitches,
     Floor,
     LodBias,
     VersString,
     ThisVer,
     bAutoTaunts,
     AllowedMods,
     BotChair,
     bTDM,
     bCTF,
     bDM,
     bSpectator,
     ClientCall,
     ServerTime,
     OpenConsole;
}

//-------------------------------------
// PostNetBeginPlay
//-------------------------------------
simulated event PostNetBeginPlay()
{
    if ((Level.NetMode == NM_Client && ROLE < ROLE_SimulatedProxy) || (!bNetOwner))
		return;

	bLogOnce = False; bTime = False; bSpeedHack = False;

    if (bCTF) GRIMode = 1;
    if (bTDM) GRIMode = 2;
    if (bDM) GRIMode = 3;

    GotoState('StateOne');
}

//-------------------------------------
// StateOne
//-------------------------------------
simulated state StateOne
{
    //-------------------------------------
    // FuncA
    //-------------------------------------
    simulated function FuncA()
	{
        local private string Skin, Face;

        MyPlayer = PlayerPawn(Owner);

        MyPlayer.static.GetMultiSkin(MyPlayer, Skin, Face);
        ValidateFace(MyPlayer, Face);
        bMyMouseCantSee = MyPlayer.bAlwaysMouseLook;
        bILikeTheStick = bool(ProcessCommand(JoyStick));

        if (!bMyMouseCantSee && !bILikeTheStick)
           NotifyServer(MyPlayer, 3, "JS", "");

        MyMouseY = ProcessCommand(MouseSetting);
        SimpleLog(MyPlayer, 5, MyMouseY);
        SimpleLog(MyPlayer, 6, ProcessCommand(MouseX));
        Brightness = ProcessCommand(Brightz);
    }
Begin:
sleep(2.0);
FuncA();
}

//-------------------------------------
// StateTwo
//-------------------------------------
simulated state StateTwo
{
	//-------------------------------------
    // CheckSpec
    //-------------------------------------
    simulated function CheckSpec()
	{
	    if (bSpectator)
        {
            VerifySpec(MyPlayer);
            GotoState('StateFour');
        }
	}
    //-------------------------------------
    // GetModItems
    //-------------------------------------
    simulated function GetModItems()
	{
          local private UMenuModMenuList MML;
    	  local private UMenuModMenu MMI;
    	  local private UTConsole Con;
    	  local private int i;
       	  local private string ModItem;

          i = 0;
    	  Con = UTConsole(GetPlayerPawn().player.Console);
    	  MMI = UMenuRootWindow(Con.Root).MenuBar.Mods;
    	  MML = UMenuModMenuList(MMI.ModList.FindEntry(i));

    	  for (i = 0; MML != None; i++)
    	  {
               MML = UMenuModMenuList(MMI.ModList.FindEntry(i));
    	       if(MML != None)
    	       {
    			   ModItem = MML.MenuItemClassName;
                   TransferModItems(MyPlayer,ModItem);
                   if (MML.MenuItemClassName != AllowedMods[0]
                   && (MML.MenuItemClassName != AllowedMods[1])
                   && (MML.MenuItemClassName != AllowedMods[2])
                   && (MML.MenuItemClassName != AllowedMods[3])
                   && (MML.MenuItemClassName != AllowedMods[4])
                   && (MML.MenuItemClassName != AllowedMods[5])
                   && (MML.MenuItemClassName != AllowedMods[6])
                   && (MML.MenuItemClassName != AllowedMods[7])
                   && (MML.MenuItemClassName != AllowedMods[8])
                   && (MML.MenuItemClassName != AllowedMods[9]))
                   {
                      MML.MenuItemClassName = Left(string(self.Class),InStr(string(self.Class),".")) $LockedMenu;
                      log("Locking:"@MML.MenuItemClassName);
                   }

    		   }
    	  }
    	  ComChecks();

	}
	//-------------------------------------
    // ClientActivate
    //-------------------------------------
    simulated function ClientActivate()
    {
        GotoState('StateThree');
    }

Begin:
    CheckSpec();
    GetModItems();
    sleep(0.25);
    while (true)
    {
        sleep(1.0);
        ClientActivate();
    }
}

//-------------------------------------
// StateThree
//-------------------------------------
simulated state StateThree
{
	//-------------------------------------
    // CheckTweaks
    //-------------------------------------
    simulated function CheckTweaks()
	{
        if(bCheckTweaks)
        {
            if (Class'ZoneInfo'.Default.AmbientBrightness != 0)
                NotifyServer(MyPlayer, 4, "TW", "ZoneInfo-AmbientBrightness"@"0 :: "$Class'ZoneInfo'.Default.AmbientBrightness);
            else if (Class'ZoneInfo'.Default.AmbientSaturation != 255)
                NotifyServer(MyPlayer, 4, "TW", "ZoneInfo-AmbientSaturation"@"255 :: "$Class'ZoneInfo'.Default.AmbientSaturation);
            else if (Class'LevelInfo'.Default.AmbientBrightness != 0)
                NotifyServer(MyPlayer, 4, "TW", "LevelInfo-AmbientBrightness"@"0 :: "$Class'LevelInfo'.Default.AmbientBrightness);
            else if (Class'LevelInfo'.Default.AmbientSaturation != 255)
                NotifyServer(MyPlayer, 4, "TW", "LevelInfo-AmbientSaturation"@"255 :: "$Class'LevelInfo'.Default.AmbientSaturation);
            else if (Class'WaterZone'.Default.AmbientBrightness != 0)
                NotifyServer(MyPlayer, 4, "TW", "WaterZone-AmbientBrightness"@"0 :: "$Class'WaterZone'.Default.AmbientBrightness);
            else if (Class'WaterZone'.Default.AmbientSaturation != 255)
                NotifyServer(MyPlayer, 4, "TW", "WaterZone-AmbientSaturation"@"255 :: "$Class'WaterZone'.Default.AmbientSaturation);
            else if (Class'WaterTexture'.Default.bInvisible)
                NotifyServer(MyPlayer, 4, "TW", "WaterTexture-bInvisible"@"False :: "$Class'WaterTexture'.Default.bInvisible);
            else if (Class'Texture'.Default.DrawScale != 1)
                NotifyServer(MyPlayer, 4, "TW", "Texture-DrawScale"@"1 :: "$Class'Texture'.Default.DrawScale);
            else if (Class'Texture'.Default.bTransparent)
                NotifyServer(MyPlayer, 4, "TW", "Texture-bTransparent"@"False :: "$Class'Texture'.Default.bTransparent);
            else if (Class'Texture'.Default.bInvisible)
                NotifyServer(MyPlayer, 4, "TW", "Texture-bInvisible"@"False :: "$Class'Texture'.Default.bInvisible);
            else if (Class'Texture'.Default.bFakeBackdrop)
                NotifyServer(MyPlayer, 4, "TW", "Texture-bFakeBackdrop"@"False :: "$Class'Texture'.Default.bFakeBackdrop);
            else if (Class'SuperShockRifle'.default.FireAdjust != 1.0)
                NotifyServer(MyPlayer, 4, "TW", "SuperShockRifle-FireAdjust"@"1 :: "$Class'SuperShockRifle'.Default.FireAdjust);
            else if (Class'SniperRifle'.default.FireAdjust != 1.0)
                NotifyServer(MyPlayer, 4, "TW", "SniperRifle-FireAdjust"@"1 :: "$Class'SniperRifle'.Default.FireAdjust);
            else if (Class'ShockRifle'.default.FireAdjust != 1.0)
                NotifyServer(MyPlayer, 4, "TW", "ShockRifle-FireAdjust"@"1 :: "$Class'ShockRifle'.Default.FireAdjust);
            else if (Class'MiniGun2'.default.FireAdjust != 1.0)
                NotifyServer(MyPlayer, 4, "TW", "MiniGun2-FireAdjust"@"1 :: "$Class'MiniGun2'.Default.FireAdjust);
            else if (Class'PulseGun'.default.FireAdjust != 1.0)
                NotifyServer(MyPlayer, 4, "TW", "PulseGun-FireAdjust"@"0 :: "$Class'PulseGun'.Default.FireAdjust);
            else if (Class'ShockBeam'.Default.Mesh != LodMesh'Shockbm')
                NotifyServer(MyPlayer, 4, "TW", "ShockBeam-Mesh"@"Shockbm :: "$Class'ShockBeam'.Default.Mesh);
            else if (Class'ShockBeam'.Default.Texture != Texture'jenergy2')
                NotifyServer(MyPlayer, 4, "TW", "ShockBeam-Texture"@"Effects.jenergy2 :: "$Class'ShockBeam'.Default.Texture);
            else if (Class'ShockBeam'.Default.DrawScale != 0.44)
                NotifyServer(MyPlayer, 4, "TW", "ShockBeam-DrawScale"@"0.44 :: "$Class'ShockBeam'.Default.DrawScale);
            else if (Class'ShockBeam'.Default.LifeSpan != 0.27)
                NotifyServer(MyPlayer, 4, "TW", "ShockBeam-LifeSpan"@"0.27 :: "$Class'ShockBeam'.Default.LifeSpan);
            else if (Class'SuperShockBeam'.Default.Mesh != LodMesh'SShockbm')
                NotifyServer(MyPlayer, 4, "TW", "SuperShockBeam-Mesh"@"SShockbm :: "$Class'SuperShockBeam'.Default.Mesh);
            else if (Class'SuperShockBeam'.Default.Texture != Texture'jenergy3')
                NotifyServer(MyPlayer, 4, "TW", "SuperShockBeamm-Texture"@"Effects.jenergy3 :: "$Class'SuperShockBeam'.Default.Texture);
            else if (Class'SuperShockBeam'.Default.DrawScale != 0.44)
                NotifyServer(MyPlayer, 4, "TW", "SuperShockBeam-DrawScale"@"0.44 :: "$Class'SuperShockBeam'.Default.DrawScale);
            else if (Class'SuperShockBeam'.Default.LifeSpan != 0.27)
                NotifyServer(MyPlayer, 4, "TW", "SuperShockBeam-LifeSpan"@"0.27 :: "$Class'SuperShockBeam'.Default.LifeSpan);
            else if (Class'PBolt'.Default.Mesh != LodMesh'PBolt')
                NotifyServer(MyPlayer, 4, "TW", "PBolt-Mesh"@"PBolt :: "$Class'PBolt'.Default.Mesh);
            else if (Class'PBolt'.Default.Texture != Texture'pbolt0')
                NotifyServer(MyPlayer, 4, "TW", "PBolt-Texture"@"Skins.pbolt0 :: "$Class'PBolt'.Default.Texture);
            else if (Class'WaterTexture'.Default.bInvisible)
                NotifyServer(MyPlayer, 4, "TW", "WaterTexture-bInvisible"@"True :: "$Class'WaterTexture'.Default.bInvisible);
            else if (Class'Actor'.Default.Fatness != 128)
                NotifyServer(MyPlayer, 4, "TW", "Actor-Fatness"@"128 :: "$Class'Actor'.Default.Fatness);
            else if (Class'PlayerShadow'.Default.DrawScale != 0.50)
                NotifyServer(MyPlayer, 4, "TW", "PlayerShadow-DrawScale"@".50 :: "$Class'PlayerShadow'.Default.DrawScale);
            else if (Class'PlayerShadow'.Default.Texture != Texture'energymark')
                NotifyServer(MyPlayer, 4, "TW", "PlayerShadow-Texture"@"EnergyMark :: "$Class'PlayerShadow'.Default.Texture);
            else if (Class'TMale1'.default.AmbientGlow != 17)
                NotifyServer(MyPlayer, 4, "TW", "TMale1-AmbientGlow"@"17 :: "$Class'TMale1'.Default.AmbientGlow);
            else if (Class'TMale2'.default.AmbientGlow != 17)
                NotifyServer(MyPlayer, 4, "TW", "TMale2-AmbientGlow"@"17 :: "$Class'TMale2'.Default.AmbientGlow);
            else if (Class'TFemale1'.default.AmbientGlow != 17)
                NotifyServer(MyPlayer, 4, "TW", "TFemale1-AmbientGlow"@"17 :: "$Class'TFemale1'.Default.AmbientGlow);
            else if (Class'TFemale2'.default.AmbientGlow != 17)
                NotifyServer(MyPlayer, 4, "TW", "TFemale2-AmbientGlow"@"17 :: "$Class'TFemale2'.Default.AmbientGlow);
            else if (Class'Udamage'.default.Texture != Texture'GoldSkin2')
                NotifyServer(MyPlayer, 4, "TW", "Udamage-Texture"@"GoldSkin2 :: "$Class'Udamage'.Default.Texture);
            else if (Class'Actor'.Default.DrawScale != 1.0)
                NotifyServer(MyPlayer, 4, "TW", "Actor-DrawScale"@"1 :: "$Class'Actor'.Default.DrawScale);
            else if (Class'Actor'.Default.LODBias != 1.0)
                NotifyServer(MyPlayer, 4, "TW", "Actor-LODBias"@"1 :: "$Class'Actor'.Default.LODBias);
            else if (Class'PlayerStart'.Default.Texture != Texture'S_Player')
                NotifyServer(MyPlayer, 4, "TW", "PlayerStart-Texture"@"S_Player :: "$Class'PlayerStart'.Default.Texture);
            else if (!Class'PlayerStart'.Default.bHidden)
                NotifyServer(MyPlayer, 4, "TW", "PlayerStart-bHidden"@"True :: "$Class'PlayerStart'.Default.bHidden);
            else if (Class'UT_ShieldBeltEffect'.default.LightType != LT_None)
                NotifyServer(MyPlayer, 4, "TW", "UT_ShieldBeltEffect-LightType"@"0 :: "$Class'UT_ShieldBeltEffect'.Default.LightType);
            else if (!Class'UT_ShieldBeltEffect'.default.bUnlit)
                NotifyServer(MyPlayer, 4, "TW", "UT_ShieldBeltEffect-bUnlit"@"True :: "$Class'UT_ShieldBeltEffect'.Default.bUnlit);
            else if (Class'TranslocOutEffect'.Default.Texture != Texture'BotPack.Skins.TPEffect')
                NotifyServer(MyPlayer, 4, "TW", "TranslocOutEffect-Texture"@"Skins.TPEffect :: "$Class'TranslocOutEffect'.Default.Texture);
            else if (Class'TranslocatorTarget'.default.Mesh != LodMesh'Module')
                NotifyServer(MyPlayer, 4, "TW", "TranslocatorTarget-Mesh"@"LodMesh'Module' :: "$Class'TranslocatorTarget'.Default.Mesh);
            else if (Class'TranslocatorTarget'.default.SoundRadius != 20)
                NotifyServer(MyPlayer, 4, "TW", "TranslocatorTarget-SoundRadius"@"20 :: "$Class'TranslocatorTarget'.Default.SoundRadius);
            else if (Class'TranslocatorTarget'.default.SoundVolume != 100)
                NotifyServer(MyPlayer, 4, "TW", "TranslocatorTarget-SoundVolume"@"100 :: "$Class'TranslocatorTarget'.Default.SoundVolume);
            else if (Class'TranslocatorTarget'.default.LightBrightness != 0)
                NotifyServer(MyPlayer, 4, "TW", "TranslocatorTarget-LightBrightness"@"0 :: "$Class'TranslocatorTarget'.Default.LightBrightness);
            else if (Class'TranslocatorTarget'.default.LightType != LT_None)
                NotifyServer(MyPlayer, 4, "TW", "TranslocatorTarget-LightType"@"0 :: "$Class'TranslocatorTarget'.Default.LightType);
            else if (Class'CTFFlag'.Default.DrawScale != 0.60)
                NotifyServer(MyPlayer, 4, "TW", "CTFFlag-DrawScale"@".60 :: "$Class'CTFFlag'.Default.DrawScale);
            else if (Class'CTFFlag'.Default.Mesh != LodMesh'pflag')
                NotifyServer(MyPlayer, 4, "TW", "CTFFlag-Mesh"@".pflag :: "$Class'CTFFlag'.Default.Mesh);
            else if (Class'CTFFlag'.Default.LightRadius != 6)
                NotifyServer(MyPlayer, 4, "TW", "CTFFlag-LightRadius"@"6 :: "$Class'CTFFlag'.Default.LightRadius);
            else if (Class'CTFFlag'.Default.lighteffect != 13)
                NotifyServer(MyPlayer, 4, "TW", "CTFFlag-LightEffect"@"13 :: "$Class'CTFFlag'.Default.lighteffect);

            //anything else of any type of importance should be disabled via the huds.

            if (Class'rocketmk2'.default.texture == texture'whitetexture')
            {
                Class'rocketmk2'.default.texture = texture'JuRocket1';
                class'rocketmk2'.default.mesh = LodMesh'UTRocket';
            }
            if (Class'ut_grenade'.default.texture == texture'whitetexture')
            {
                class'ut_grenade'.default.texture = texture'JuRocket1';
                class'ut_grenade'.default.mesh = LodMesh'UTGrenade';
            }
        }
	}
	//-------------------------------------
    // CheckClient
    //-------------------------------------
    simulated function CheckClient()
    {
        local texture OldReticle;

        MyPlayer.PlayerReplicationInfo.NetUpdateFrequency = 2.0;
        if (MyCRI == none) MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
        if (MyPlayer.Health < 1) gotostate('StateFour');
        CheckMouseSettings();

        if (!bAutoTaunts && !MyPlayer.PlayerReplicationInfo.bIsSpectator && TournamentPlayer(MyPlayer).bAutoTaunt)
            ForceAutoTaunts();

        CheckTime(MyPlayer);
        VerifyTime();
        if (MyCRI.bClassInitialized)
            TransferRIData(GRIMode);
    }

Begin:
     sleep(0.025);
     CheckTweaks();
      while (true)
     {
         CheckClient();
         sleep(3.0);
     }
}

//-------------------------------------
// StateFour
//-------------------------------------
simulated state StateFour
{
    //-------------------------------------
    // FuncA
    //-------------------------------------
    simulated function FuncA()
    {
        if (!bSpectator)
            ComChecks();
    }
    //-------------------------------------
    // CheckAlive
    //-------------------------------------
    simulated function CheckAlive()
    {
        if (MyPlayer.Health > 0 && !bSpectator)
            gotostate('StateThree');

        CheckTime(MyPlayer);
        VerifyTime();
    }
begin:
    FuncA();
    while (true)
    {
        CheckAlive();
        sleep(1.0);
    }
}

//-------------------------------------
// TransferRIData
//-------------------------------------
simulated function TransferRIData(byte GameMode)
{
    switch (GameMode)
    {
        case 1:
        case 2:
        case 3:
            TransferGameData(
                MyPlayer,
                GameMode,
                MyCRI.RequestHitsounds,
                MyCRI.WeaponAccuracy.Enforcer,
                MyCRI.WeaponAccuracy.BioGun,
                MyCRI.WeaponAccuracy.ShockRifle,
                MyCRI.WeaponAccuracy.PulseGun,
                MyCRI.WeaponAccuracy.Ripper,
                MyCRI.WeaponAccuracy.MiniGun,
                MyCRI.WeaponAccuracy.FlakCannon,
                MyCRI.WeaponAccuracy.EightBall,
                MyCRI.WeaponAccuracy.SniperRifle,
                MyCRI.WeaponAccuracy.SuperShockRifle,
                MyCRI.WeaponAccuracy.CustomWeapon,
                MyCRI.MouseYRefCount,
                MyCRI.MouseYSetting);
            break;
    }
}
//-------------------------------------
// ClientCall
//-------------------------------------
simulated function ClientCall (byte c)
{
    switch (c)
    {
       case 0: GotoState('StateTwo'); break;
    }
}

//-------------------------------------
// ProcessCommand
//-------------------------------------
simulated final function string ProcessCommand(string s)
{
   return MyPlayer.ConsoleCommand(s);
}

//-------------------------------------
// GetPlayerPawn
//-------------------------------------
simulated final function PlayerPawn GetPlayerPawn()
{
	foreach AllActors(class'PlayerPawn', MyPlayer)
	{
		if (Viewport(MyPlayer.Player) != None)
			return MyPlayer;
	}
}

//-------------------------------------
// ComChecks
//-------------------------------------
simulated function ComChecks()
{
     local string rv;

     rv = ProcessCommand(Stitches);
     if (rv ~= Floor)
     {
         NotifyServer(MyPlayer, 10, "SW", "");
         gotostate('');
     }

     rv = ProcessCommand(LodBias);
     if (int(rv) > 1)
     {
        NotifyServer(MyPlayer, 11, "LB", "");
        gotostate('');
     }

     rv = ProcessCommand(MouseY);
     if (rv != MyMouseY)
        NotifyServer(MyPlayer, 3, "MMY", "");

}

//-------------------------------------
// CheckMouseSettings
//-------------------------------------
simulated final function CheckMouseSettings()
{
    local private bool bMLC;

    bMLC = MyPlayer.bAlwaysMouseLook;

    if (bMLC != bMyMouseCantSee && ( !bLogOnce ))
    {
        bLogOnce = true;
        NotifyServer(MyPlayer, 8, "ML", "");
    }
}

//-------------------------------------
// ForceAutoTaunts
//-------------------------------------
simulated final function ForceAutoTaunts()
{
    TournamentPlayer(MyPlayer).bAutoTaunt = false;
    TournamentPlayer(MyPlayer).SaveConfig();
}

//-------------------------------------
// VerifyTime
//-------------------------------------
simulated final function VerifyTime()
{
    if (ServerTime > 0 && !bTime)
    {
        MyTime = MyPlayer.Level.TimeSeconds;
        InitialTime = ServerTime;
        bTime = true;
    }
    if (bTime)
    {
        ClientTimeStamp = MyPlayer.Level.TimeSeconds - MyTime;
        ServerTimeStamp = ServerTime - InitialTime;

        if (ClientTimeStamp > ServerTimeStamp + 20 && bSpeedHack)
        {
            bSpeedHack = true;
            NotifyServer(MyPlayer, 9, "SH", "");
        }
    }
}

//-------------------------------------
// CheckTextures
// This is no longer used, but I figured I would show the old method anyways.
//-------------------------------------
/*simulated function CheckTextures()
{
    local int i, c;
    local texture CrosshairTexture;
    local string CurBrightness;

    switch (GRIMode)
    {
        case 1:
        case 2:
        case 3:
            c = MyCRI.ClientCrosshair;
            CrosshairTexture = MyCRI.ClientCrosshairTexture;
            break;
    }

    if (TextureCounter > 5)
        TextureCounter = 0;

    if (TextureCounter == 5)
    {
        CurBrightness = ProcessCommand(Brightz);
        if (CurBrightness != Brightness)
        {
            Brightness = CurBrightness;
            for ( i = 0; i < 10; i++ )
                CrosshairNotify[i] = 0;
        }
    }
    TextureCounter++;

    if (MyPlayer.IsInState('PlayerWaiting'))
        return;

    if (!bBasicTexturesLoaded)
        LoadBasicTextures();

    for (i = 0; i < 9; i++)
        CrosshairVerify(i);
}

//-------------------------------------
// LoadBasicTextures
//-------------------------------------
simulated singular final function LoadBasicTextures()
{
    bBasicTexturesLoaded = true;

    if (RedFlag == none)
    {
        RedFlag = Texture(DynamicLoadObject(RedFlag, class'Texture'));
        RedFlag.DrawScale = 0;
    }

    if (BlueFlag == none)
    {
        BlueFlag = Texture(DynamicLoadObject(BlueFlag, class'Texture'));
        BlueFlag.DrawScale = 0;
    }

    if (FacePan == none)
    {
        FacePan = Texture(FacePan, class'Texture'));
        FacePan.DrawScale = 0;
    }
}

//-------------------------------------
// CrosshairVerify
//-------------------------------------
simulated final function CrosshairVerify(byte c)
{
    local private byte i;
    local private string s;

    if (CrosshairTexture[c] == none)
    {
        c = c + 1;
        i = c;
        s = string( i );
        s = BotChair$s;
        CrosshairTexture[c] = Texture(DynamicLoadObject(s, class'Texture'));
        CrosshairStart[c] = CrosshairTexture[c].InternalTime[0];
        CrosshairNotify[c] = 0;
        CrosshairKick[c] = 0;
    }

    if (CrosshairTexture[c] != none
    && (MyPlayer.Player.bWindowsMouseAvailable)
    && (MyPlayer.Player.bShowWindowsMouse))
    {
        CrosshairStart[c] = CrosshairTexture[c].InternalTime[0];
        CrosshairCheck[c] = CrosshairStart[c];
        return;
    }

    if (CrosshairTexture[c] != none
    && (MyPlayer.Player.bWindowsMouseAvailable)
    && (!MyPlayer.Player.bShowWindowsMouse))
    {
        CrosshairCheck[c] = CrosshairTexture[c].InternalTime[0];
        if (CrosshairCheck[c] != CrosshairStart[c])
        {
            CrosshairNotify[c]++;
            CrosshairStart[c] = CrosshairTexture[c].InternalTime[0];
        }
        if (CrosshairNotify[c] > SpecCounter
        && (CrosshairKick[c] == 0)
        && (CROSSHAIR < 9)
        && (CrosshairTexture != none))
            CrosshairKick[c] = 1;
    }

    if (CrosshairKick[c] == 1)
        //Handle Logging of offense and remove client
}*/

//-------------------------------------
// OpenConsole
//-------------------------------------
simulated function OpenConsole()
{
	local private WindowConsole Con;

	Con = WindowConsole(PlayerPawn(Owner).Player.Console);
	if (Con == None)
	{
		Log("[Console Error] No Console");
		return;
	}
	if (!Con.bCreatedRoot || Con.Root == None)
	{
		Log("[Console] Creating root");
		Con.CreateRootWindow(None);
	}
	Con.bQuickKeyEnable = True;
	Con.LaunchUWindow();
	Con.ShowConsole();
}

//-------------------------------------
// NotifyServer
//-------------------------------------
function NotifyServer( PlayerPawn MyPlayer, byte Offense, string Code, string Opt)
{
   if(Len(Opt) > 100) Opt = "BL";
   MyMut.LogInfraction(MyPlayer, Offense, Code, Opt);
}

//-------------------------------------
// ValidateFace
//-------------------------------------
function ValidateFace( PlayerPawn MyPlayer, string Face)
{
   MyMut.ValidateFace(MyPlayer,Face);
}

//-------------------------------------
// SimpleLog
//-------------------------------------
function SimpleLog( PlayerPawn MyPlayer, byte c, string s)
{
    MyMut.sLogPass(MyPlayer, c, s);

    switch (c)
    {
         case 5: ClientCall(0); break;
    }
}

//-------------------------------------
// TransferModItems
//-------------------------------------
function TransferModItems( PlayerPawn MyPlayer, string ModItem)
{
    local private string s;

    s = Caps(VersString$ThisVer$LockedMenu);
    ModItem = Caps(ModItem);
    if (s != ModItem) MyMut.LogModItems(MyPlayer, ModItem);
}

//-------------------------------------
// CheckTime
//-------------------------------------
function CheckTime(PlayerPawn MyPlayer)
{
   MyMut.SendTime(MyPlayer);
}

//-------------------------------------
// VerifySpec
//-------------------------------------
function VerifySpec(PlayerPawn MyPlayer)
{
   MyMut.VerifySpectator(MyPlayer);
}

//-------------------------------------
// TransferGameData
//-------------------------------------
function TransferGameData(PlayerPawn MyPlayer,
    byte Mode,
    byte hs,
    byte ea,
    byte ba,
    byte sa,
    byte pa,
    byte ra,
    byte ma,
    byte fa,
    byte roa,
    byte sna,
    byte ia,
    byte ca,
    byte mc,
    float mmy)
{
    MyMut.RecieveGameData( MyPlayer,Mode,hs,ea,ba,sa,pa,ra,ma,fa,roa,sna,ia,ca,mc,mmy);
}

//-------------------------------------
// defaultproperties
//-------------------------------------
defaultproperties
{
    bAlwaysRelevant=False
    bAlwaysTick=True
    RemoteRole=2
    NetPriority=3.00
}
