/*
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
              EUTDMSB
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
*/
class EUTDMSB expands TournamentScoreBoard;

var font MySmallFont;
var EUTGameReplicationInfo MyCRI;
var PlayerReplicationInfo OrdPRI[32];
var PlayerReplicationInfo SpecPRI[32];
var FontInfo _FontInfo;

var bool bTimeDown, bPlayerMoved;

var color SpecColor[5],
    GreenColor,
    WhiteColor,
    GoldColor,
    BlueColor,
    LightCyanColor,
    SilverColor,
    BronzeColor,
    CyanColor,
    RedColor,
    ShadeColor,
    DarkRedColor,
    DarkBlueColor;

var float CenterBoxX,
    CenterBoxY,
    TextureSize,
    FillBoxX,
    FillBoxY,
    FillBoxX2,
    FillBoxY2,
    DivW,
    DivS,
    ScoreStart,
    PlayerStart,
    PAlign,
    SAlign,
    DAlign,
    ScoreX,
    ScoreY,
    DeathX,
    DeathY,
    Step;

var localized string MapTitleString,
    AuthorString,
    RestartString,
    ContinueString,
    GameEndedString,
    ElapsedTimeString,
    RemainingTimeString,
    FragGoalString,
    TimeLimitString,
    PlayerString,
    FragsString,
    DeathsString,
    PingString,
    TimeString,
    LossString,
    FPHString,
    MTQ;

var texture TopSpan,
    BotSpan,
    LeftSpan,
    RightSpan,
    TopLeftCorner,
    TopRightCorner,
    BotLeftCorner,
    BotRightCorner,
    BoxFillBase,
    BoxFillColored,
    FlagIcon,
    PlayerDivider,
    Country[40];


//-------------------------------------
// PostBeginPlay
//-------------------------------------
function PostBeginPlay()
{
	Super.PostBeginPlay();
	_FontInfo = FontInfo(Spawn(Class<Actor>(DynamicLoadObject(class'ChallengeHUD'.default.FontInfoClass, class'Class'))));
    LoadTextures();
}

//-------------------------------------
// LoadTextures
//-------------------------------------
final function LoadTextures()
{
    MySmallFont = Font(DynamicLoadObject("EUT_Textures.EUTSmallFont", class'Font'));
    TopSpan = Texture(DynamicLoadObject("EUT_Textures.EUT_SPan_T", class'Texture'));
    BotSpan = Texture(DynamicLoadObject("EUT_Textures.EUT_SPan_B", class'Texture'));
    LeftSpan = Texture(DynamicLoadObject("EUT_Textures.EUT_SPan_L", class'Texture'));
    RightSpan = Texture(DynamicLoadObject("EUT_Textures.EUT_SPan_R", class'Texture'));
    BoxFillBase = Texture(DynamicLoadObject("EUT_Textures.EUT_Fill", class'Texture'));
    BoxFillColored = Texture(DynamicLoadObject("EUT_Textures.EUT_FillColor", class'Texture'));
    TopLeftCorner = Texture(DynamicLoadObject("EUT_Textures.EUT_TL", class'Texture'));
    TopRightCorner = Texture(DynamicLoadObject("EUT_Textures.EUT_TR", class'Texture'));
    BotLeftCorner = Texture(DynamicLoadObject("EUT_Textures.EUT_BL", class'Texture'));
    BotRightCorner = Texture(DynamicLoadObject("EUT_Textures.EUT_BR", class'Texture'));
    PlayerDivider = Texture(DynamicLoadObject("EUT_Textures.EUT_Divider", class'Texture'));
    FlagIcon = Texture(DynamicLoadObject("BotPack.GreenFlag", class'Texture'));

    SpecColor[0]=GreenColor;
    SpecColor[1]=GoldColor;
    SpecColor[2]=BlueColor;
    SpecColor[3]=RedColor;
    SpecColor[4]=CyanColor;
    MTQ = MapTitleQuote;
}

//-------------------------------------
// ShowScores
//-------------------------------------
function ShowScores( canvas C )
{
	local GameReplicationInfo GRI;

    GRI = PlayerPawn(Owner).GameReplicationInfo;
    MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);

    DrawHead(C, GRI);
    DrawFoot(C);

	if (C.ClipX > 512) DrawMain(C);

}

//-------------------------------------
// DrawMain
//-------------------------------------
function DrawMain(Canvas C)
{
    local PlayerReplicationInfo PRI;
    local TournamentGameReplicationInfo TGRI;
    local byte i, NumPlayers, NumSpecs, MaxLength, MySpot;
    local float XL, YL, XL2, YL2, TeamLoopCount, DrawLength, X, Y, Mid, TempY, Length;
    local bool bLast;
    local PlayerPawn MyPlayer;

    TGRI = TournamentGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
	if (TGRI == None) return;

    NumPlayers = 0;

    for (i = 0; i < ArrayCount(OrdPRI); i++)
		OrdPRI[i] = None;

    for (i = 0; i < ArrayCount(SpecPRI); i++)
        SpecPRI[i] = None;

	for (i = 0; i < 32; i++)
    {
        if (PlayerPawn(Owner).GameReplicationInfo.PRIArray[i] != None)
		{
			PRI = PlayerPawn(Owner).GameReplicationInfo.PRIArray[i];
			if (!PRI.bIsSpectator || PRI.bWaitingPlayer)
			{
				OrdPRI[NumPlayers] = PRI;
				NumPlayers++;
				if (NumPlayers == ArrayCount(OrdPRI))
					break;
			}

		    if (PRI.bIsSpectator
            && (!PRI.bWaitingPlayer)
            && (PRI.PlayerName != "Player"))
            {
               SpecPRI[NumSpecs] = PRI;
               NumSpecs++;
               if (NumSpecs == ArrayCount(SpecPRI))
                  break;
            }
        }
    }
    SortScores(NumPlayers);

    if (C.ClipX < 1100)
    {
        TextureSize = 2;
        mid = 24;
        TopSpan.DrawScale = 0.50;
        BotSpan.DrawScale = 0.50;
        LeftSpan.DrawScale = 0.50;
        RightSpan.DrawScale = 0.50;
        TopLeftCorner.DrawScale = 0.50;
        TopRightCorner.DrawScale = 0.50;
        BotLeftCorner.DrawScale = 0.50;
        BotRightCorner.DrawScale = 0.50;
        PlayerStart = C.CliPY / 7 + TextureSize + 24;
    }
    else
    {
        TextureSize = 4;
        mid = 32;
        TopSpan.DrawScale = 1;
        BotSpan.DrawScale = 1;
        LeftSpan.DrawScale = 1;
        RightSpan.DrawScale = 1;
        TopLeftCorner.DrawScale = 1;
        TopRightCorner.DrawScale = 1;
        BotLeftCorner.DrawScale = 1;
        BotRightCorner.DrawScale = 1;
        PlayerStart = C.CliPY / 7 + TextureSize + 32;
    }

    bPlayerMoved = false;

    MaxLength = NumPlayers;
    Length = GetYOffset(C);
    DrawLength = MaxLength * Length;

    if (DrawLength > C.ClipY - PlayerStart)
    {
        TempY = DrawLength;
        MySpot = MaxLength;
        while (TempY > C.ClipY - PlayerStart)
        {
            MySpot = MySpot - 1;
            TempY = MySpot * Length;
        }
        MoveToVisible(PlayerPawn(Owner).PlayerReplicationInfo, MySpot - 1, NumPlayers);
    }

    FillBoxX = C.ClipX - (C.ClipX / 8 * 2) - mid - TextureSize;
    FillBoxY = C.ClipY / 7 - TextureSize - C.ClipY / 10;
    CenterBoxY = FillBoxY / 2 + TextureSize;
    CenterBoxX = FillBoxX / 2 + TextureSize;
    DivW = FillBoxX * 0.8;
    x = C.ClipX / 8;
    FillBoxX2 = FillBoxX;

    if (NumPlayers > 0)
    {
        C.DrawColor = SilverColor;
        C.Style = ERenderStyle.STY_Translucent;
        C.SetPos(x, C.ClipY / 10);
        C.DrawRect(TopLeftCorner, TextureSize, TextureSize);
        C.SetPos((C.ClipX - C.ClipX / 8) - mid, C.ClipY / 10);
        C.DrawRect(TopRightCorner, TextureSize, TextureSize);
        C.SetPos(x + TextureSize, C.ClipY / 10);
        C.DrawRect(TopSpan, FillBoxX, TextureSize);
        C.SetPos(x, C.ClipY / 7);
        C.DrawRect(BotLeftCorner, TextureSize, TextureSize);
        C.SetPos((C.ClipX - C.ClipX / 8) - mid, C.ClipY / 7);
        C.DrawRect(BotRightCorner, TextureSize, TextureSize);
        C.SetPos(x + TextureSize, C.ClipY / 7);
        C.DrawRect(BotSpan, FillBoxX, TextureSize);
        C.SetPos(x, C.ClipY / 10 + TextureSize);
        C.DrawRect(LeftSpan, TextureSize, FillBoxY);
        C.SetPos((C.ClipX - C.ClipX / 8) - mid, C.ClipY / 10 + TextureSize);
        C.DrawRect(RightSpan, TextureSize, FillBoxY);
        C.DrawColor = ShadeColor;
        C.Style = ERenderStyle.STY_Modulated;
        C.SetPos(x + TextureSize, C.ClipY / 10 + TextureSize);
        C.DrawRect(BoxFillBase, FillBoxX, FillBoxY);

        if (C.ClipX > 1100) C.Font =  _FontInfo.GetMediumFont(C.ClipX);
        if (C.ClipX < 1100) C.Font =  _FontInfo.GetStaticBigFont(900);
        if (C.ClipX < 900) C.Font =  _FontInfo.GetStaticBigFont(700);

        C.DrawColor = CyanColor;
        C.Style = ERenderStyle.STY_Normal;
        C.StrLen("Player", XL, YL);
        PAlign = x + (XL / 2);
        C.SetPos(PAlign, C.ClipY / 10 + CenterBoxY - (YL / 2));
        C.DrawText("Player", false);
        C.DrawColor = RedColor;
        C.StrLen("Deaths", DeathX, DeathY);
        DAlign = (C.ClipX - C.ClipX / 8) - mid - (DeathX * 1.5);
        C.SetPos(DAlign, C.ClipY / 10 + CenterBoxY - (YL / 2));
        C.DrawText("Deaths", false);
        C.DrawColor = LightCyanColor;
        C.StrLen("Frags", ScoreX, ScoreY);
        SAlign = (C.ClipX - C.ClipX / 8) - mid - (DeathX * 1.5) - (ScoreX * 2.0);
        C.SetPos(SAlign, C.ClipY / 10 + CenterBoxY - (YL / 2));
        C.DrawText("Frags", false);
        DivS = FillBoxX - (XL / 2) - (DeathX / 2);
        C.DrawColor = SilverColor;
        C.Style = ERenderStyle.STY_Translucent;
        C.SetPos(x, PlayerStart);
        C.DrawRect(TopLeftCorner, TextureSize, TextureSize);
        C.SetPos( (C.ClipX - C.ClipX / 8) - mid, PlayerStart);
        C.DrawRect(TopRightCorner, TextureSize, TextureSize);
        C.SetPos(x + TextureSize, PlayerStart);
        C.DrawRect(TopSpan, FillBoxX2, TextureSize);
        C.SetPos(x, PlayerStart + TextureSize + DrawLength);
        C.DrawRect(BotLeftCorner, TextureSize, TextureSize);
        C.SetPos( (C.ClipX - C.ClipX / 8) - mid, PlayerStart + TextureSize + DrawLength);
        C.DrawRect(BotRightCorner, TextureSize, TextureSize);
        C.SetPos(x + TextureSize, PlayerStart + TextureSize + DrawLength);
        C.DrawRect(BotSpan, FillBoxX2, TextureSize);
        C.SetPos(x, PlayerStart + TextureSize);
        C.DrawRect(LeftSpan, TextureSize, DrawLength);
        C.SetPos((C.ClipX - C.ClipX / 8) - mid, PlayerStart + TextureSize);
        C.DrawRect(RightSpan, TextureSize, DrawLength);
        C.DrawColor = DarkRedColor;
        C.Style = ERenderStyle.STY_Modulated;
        C.SetPos(x + TextureSize, PlayerStart + TextureSize);
        C.DrawRect(BoxFillBase, FillBoxX, DrawLength);
        C.SetPos(x + TextureSize, PlayerStart + TextureSize);
        C.Style = ERenderStyle.STY_Translucent;
        C.DrawRect(BoxFillColored, FillBoxX, DrawLength);
    }
    for (i = 0; i < NumPlayers; i++)
    {
        y  = PlayerStart + (TextureSize * 4) + (GetYOffset(C) * TeamLoopCount);
        if (i == 0)
        {
            y = PlayerStart + (TextureSize * 4);
            bLast = false;
        }
        if (i == NumPlayers - 1) bLast = true;

        DrawPlayerData(C, OrdPRI[i], x, y, bLast);
        TeamLoopCount += 1;
    }

    for (i = 0; i < NumSpecs; i++ )
    {
        C.Font = C.smallfont;
        C.StrLen(SpecPRI[i].PlayerName, XL, YL);
        y = C.ClipY / 2 + YL +(YL * i);
        x = C.ClipX - XL;
        if (i == 0)
            y = C.ClipY / 2 + YL;

        DrawSpectators(C, SpecPRI[i], x, y, i);
    }
    C.DrawColor = SilverColor;
    C.Style = ERenderStyle.STY_Normal;
    C.Font = C.smallfont;
    C.StrLen("Spectators", XL, YL);
    C.SetPos(C.ClipX - XL, C.ClipY / 2);
    C.DrawText("Spectators", false);
}

//-------------------------------------
// DrawPlayerData
//-------------------------------------
function DrawPlayerData(Canvas C, PlayerReplicationInfo PRI, float x, float y, bool bLast)
{
    local float XL, YL, XL2, YL2, XL3, YL3, PY, FX;
    local bool bAdmin;
    local PlayerPawn MyPlayer;
    local int Time, eff, pid;
    local Font CanvasFont;
    local color CanvasColor;

    bAdmin = PRI.bAdmin;
    MyPlayer = PlayerPawn(Owner);
    C.Style = ERenderStyle.STY_Normal;
    pid = PRI.PlayerID;

    if (PRI.HasFlag != none && (PRI.HasFlag.IsA('EUTReadyFlag')))
    {
        C.DrawColor = GreenColor;
        C.Style = ERenderStyle.STY_Normal;
        C.SetPos(x - 32, y);
        C.DrawIcon(Texture'Botpack.Icons.GreenFlag', 1.00);
    }
    C.DrawColor = CyanColor;

    if (PRI.PlayerName == MyPlayer.PlayerReplicationInfo.PlayerName) C.DrawColor = GoldColor;
    if (C.ClipX > 1100) C.Font =  _FontInfo.GetMediumFont(C.ClipX);
    if (C.ClipX < 1100) C.Font =  _FontInfo.GetStaticBigFont(900);
    if (C.ClipX < 900) C.Font =  _FontInfo.GetStaticSmallFont(1000);

    CanvasFont = C.Font;
    CanvasColor = C.DrawColor;
    FX = PAlign;
    C.StrLen(PRI.PlayerName, XL, PY);

    if (MyCRI.bIpToCountry)
    {
        if (caps(MyCRI.IPCTexture[pid]) == "NONE" && (!MyPlayer.IsA('Bot')))
            MyCRI.IPCTexture[pid] = "us";

        if (MyCRI.IPCTexture[pid] != "" && caps(MyCRI.IPCTexture[pid]) != "NONE")
        {
            if (Country[pid] == none)
                Country[pid] = Texture(DynamicLoadObject(MyCRI.IpToCountryTexturePackage$"."$MyCRI.IPCTexture[pid], class'Texture'));

            else
            {
                if (_GetTextureName(string(Country[pid])) != caps(MyCRI.IPCTexture[pid]))
                    Country[pid] = Texture(DynamicLoadObject(MyCRI.IpToCountryTexturePackage$"."$MyCRI.IPCTexture[pid], class'Texture'));

                C.SetPos(FX,Y);
                C.bNoSmooth = false;
                C.DrawColor = WhiteColor;
                C.DrawIcon(Country[pid],1.0);
                C.bNoSmooth = true;
                FX = FX + Country[pid].USize + (Step*2);
            }
        }
    }

    C.DrawColor = CanvasColor;
    C.SetPos(FX, y);
    C.DrawText(PRI.PlayerName, false);

    if (bAdmin)
    {
        C.Font = MySmallFont;
        C.StrLen("admin", XL3, YL3);
        C.SetPos(x - XL3 - TextureSize, y);
        C.DrawText("admin", false);
        C.Font = CanvasFont;
    }
    else if (!bAdmin && bPlayerMoved && PRI.PlayerName == MyPlayer.PlayerReplicationInfo.PlayerName)
    {
        C.Font = MySmallFont;
        C.StrLen("more>>", XL3, YL3);
        C.SetPos(X - XL3 - TextureSize, y);
        C.DrawText("more>>", false);
        C.Font = CanvasFont;
    }

    C.DrawColor = LightCyanColor;
    C.StrLen(string(int(PRI.Score)), XL, YL);
	C.SetPos(SAlign, y);
	C.DrawText(int(PRI.Score), False);
	C.DrawColor = RedColor;
    C.StrLen(string(int(PRI.Deaths)), XL, YL);
	C.SetPos(DAlign, y);
	C.DrawText(int(PRI.Deaths), False);

	if (C.ClipX > 512)
	{
        C.DrawColor = WhiteColor;
        C.Font = _FontInfo.GetSmallestFont(C.ClipX);

        if (C.ClipX < 1100) C.Font = _FontInfo.GetSmallestFont(900);
        if (C.ClipX < 900) C.Font = MySmallFont;

        C.StrLen("#########", XL2, YL2);
        if (!bLast)
        {
            C.DrawColor = SilverColor;
            C.Style = ERenderStyle.STY_Modulated;
            C.SetPos(PAlign, y + PY + (YL2 * 1));
            C.DrawRect(PlayerDivider, DivS, TextureSize);

            C.DrawColor = GoldColor;
            C.Style = ERenderStyle.STY_Translucent;
            C.SetPos(PAlign, y + PY + (YL2 * 1));
            C.DrawRect(PlayerDivider, DivS, TextureSize);
        }
        Time = Max(1, (Level.TimeSeconds + MyPlayer.PlayerReplicationInfo.StartTime - PRI.StartTime) / 60);
        C.DrawColor = LightCyanColor;
        C.Style = ERenderStyle.STY_Normal;
        C.Font = MySmallFont;

        if (C.ClipX < 700) C.Font = _FontInfo.GetStaticAReallySmallFont(900);

        if (MyCRI.bScoreBoardEff)
        {
            eff = Clamp(int((float(MyCRI.TotalKills[PRI.PlayerID]) /
            float(MyCRI.TotalKills[PRI.PlayerID] + MyCRI.TotalDeaths[PRI.PlayerID])) * 100), 0, 100);

            C.StrLen("Time:"@Time@"Ping:"@MyCRI.ClientPing[PRI.PlayerID]@"Loss:"@PRI.PacketLoss@"FPH:"@int(60 * PRI.Score / Time)@"Eff:"@eff, XL, YL);
            C.SetPos(PAlign, y + PY + (YL2 * 1) - YL);
            C.DrawText("Time:"@Time@"Ping:"@MyCRI.ClientPing[PRI.PlayerID]@"Loss:"@PRI.PacketLoss@"FPH:"@int(60 * PRI.Score / Time)@"Eff:"@eff, false);
        }
        else
        {
            C.StrLen("Time:"@Time@"Ping:"@MyCRI.ClientPing[PRI.PlayerID]@"Loss:"@PRI.PacketLoss@"FPH:"@int(60 * PRI.Score / Time), XL, YL);
            C.SetPos(PAlign, y + PY + (YL2 * 1) - YL);
            C.DrawText("Time:"@Time@"Ping:"@MyCRI.ClientPing[PRI.PlayerID]@"Loss:"@PRI.PacketLoss@"FPH:"@int(60 * PRI.Score / Time), false);
        }
    }
}

//-------------------------------------
// SortScores
//-------------------------------------
function SortScores(int x)
{
	local int I, J, Max;
	local PlayerReplicationInfo TempPRI;

	for (I = 0; I < x - 1; I++)
	{
        Max = I;
		for (J = I + 1; J < x; J++)
		{
			if (OrdPRI[J].Score > OrdPRI[Max].Score)
				Max = J;
			else if ((OrdPRI[J].Score == OrdPRI[Max].Score)
            && (OrdPRI[J].Deaths < OrdPRI[Max].Deaths))
				Max = J;
			else if ((OrdPRI[J].Score == OrdPRI[Max].Score)
            && (OrdPRI[J].Deaths == OrdPRI[Max].Deaths)
            && (OrdPRI[J].PlayerID < OrdPRI[Max].Score))
				Max = J;
		}
		TempPRI = OrdPRI[Max];
		OrdPRI[Max] = OrdPRI[I];
		OrdPRI[I] = TempPRI;
	}
}

//-------------------------------------
// DrawHead
//-------------------------------------
function DrawHead(canvas C, GameReplicationInfo GRI)
{
	local float XL, YL, XL2, YL2;
	local font CanvasFont;

    C.DrawColor = WhiteColor;

	if (C.ClipX > 1100) C.Font =  _FontInfo.GetMediumFont(C.ClipX);
    if (C.ClipX < 1100) C.Font =  _FontInfo.GetStaticBigFont(900);
    if (C.ClipX < 900) C.Font =  _FontInfo.GetStaticBigFont(700);

	C.bCenter = True;
	C.StrLen("Test", XL, YL);
	ScoreStart = 58.0 / 768.0 * C.ClipY - 50;
	CanvasFont = C.Font;
	if (GRI.GameEndedComments != "")
	{
		C.DrawColor = GoldColor;
		C.SetPos(0, 0 + YL);
		C.DrawText(GRI.GameEndedComments, True);
	}
	else
	{
		C.SetPos(0, ScoreStart);
		DrawEndGame(C);
	}
	C.bCenter = False;
	C.Font = CanvasFont;
}

//-------------------------------------
// DrawEndGame
//-------------------------------------
function DrawEndGame(Canvas C)
{
	local TournamentGameReplicationInfo TGRI;
	local float XL, YL, YL2;

	TGRI = TournamentGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
	if (TGRI == None) return;

    C.SetPos(0, 0);
	C.DrawColor.R = 255;
    C.DrawColor.G = 200;
    C.DrawColor.B = 100;
    C.DrawText(TGRI.GameName);
	C.StrLen("Test", XL, YL);
	C.SetPos(0, 0 + YL);
	YL2 = C.CurY - YL;

	if (TGRI.GoalTeamScore > 0)
	{
		C.SetPos(0, 0 + YL);
        C.DrawColor.R = 255;
        C.DrawColor.G = 200;
        C.DrawColor.B = 100;
        C.DrawText(TGRI.GoalTeamScore$" Points or "$TGRI.TimeLimit@"Min");
		C.StrLen("Test", XL, YL);
		C.SetPos(0, C.CurY - YL);
	}
}

//-------------------------------------
// DrawFoot
//-------------------------------------
function DrawFoot(canvas C)
{
	local byte Hours, Minutes, Seconds;
	local float XL, YL;
	local PlayerPawn MyPlayer;

    C.bCenter = true;
	C.Font = _FontInfo.GetSmallFont(C.ClipX);

	if (C.ClipX < 1100) C.Font = _FontInfo.GetSmallFont(900);
    if (C.ClipX < 900) C.Font = _FontInfo.GetStaticSmallestFont(C.ClipX);

    C.StrLen("Test", XL, YL);
	C.DrawColor.R = 255;
    C.DrawColor.G = 200;
    C.DrawColor.B = 100;
	MyPlayer = PlayerPawn(Owner);
	C.SetPos(0, C.ClipY - 2 * YL * 1.5);

	if ((Level.NetMode == NM_Standalone) && Level.Game.IsA('DeathMatchPlus'))
	{
        if (DeathMatchPlus(Level.Game).bRatedGame)
            C.DrawText(DeathMatchPlus(Level.Game).RatedGameLadderObj.SkillText@MyPlayer.GameReplicationInfo.GameName@MapTitleString@MTQ$Level.Title$MTQ, true);
		else if (DeathMatchPlus(Level.Game).bNoviceMode)
			C.DrawText(class'ChallengeBotInfo'.default.Skills[Level.Game.Difficulty]@MyPlayer.GameReplicationInfo.GameName@MapTitleString@MTQ$Level.Title$MTQ, true);
		else
			C.DrawText(class'ChallengeBotInfo'.default.Skills[Level.Game.Difficulty + 4]@MyPlayer.GameReplicationInfo.GameName@MapTitleString@MTQ$Level.Title$MTQ, true);
	}
	else
	{
        C.DrawColor.R = 255;
        C.DrawColor.G = 200;
        C.DrawColor.B = 100;
        C.SetPos(0, C.ClipY - 2 * YL * 1.5);
        C.DrawText(MyPlayer.GameReplicationInfo.GameName@MapTitleString@Level.Title, true);
        C.DrawColor.R = 255;
        C.DrawColor.G = 200;
        C.DrawColor.B = 100;
        C.SetPos(0, C.ClipY - 2 * YL);
        C.DrawText(MyPlayer.GameReplicationInfo.ServerName$" - "$GetTime(), true);
	    C.SetPos(0, C.ClipY - YL);
	}

	if (bTimeDown || (MyPlayer.GameReplicationInfo.RemainingTime > 0))
	{
		bTimeDown = true;
		if (MyPlayer.GameReplicationInfo.RemainingTime <= 0)
            C.DrawText(RemainingTimeString@"00:00", true);
		else
		{
			Minutes = MyPlayer.GameReplicationInfo.RemainingTime / 60;
			Seconds = MyPlayer.GameReplicationInfo.RemainingTime % 60;
			C.DrawText(RemainingTimeString@TwoDigitString(Minutes)$":"$TwoDigitString(Seconds), true);
		}
	}
	else
	{
		Seconds = MyPlayer.GameReplicationInfo.ElapsedTime;
		Minutes = Seconds / 60;
		Hours   = Minutes / 60;
		Seconds = Seconds - (Minutes * 60);
		Minutes = Minutes - (Hours * 60);
		C.DrawText(ElapsedTimeString@TwoDigitString(Hours)$":"$TwoDigitString(Minutes)$":"$TwoDigitString(Seconds), true);
	}

	if (MyPlayer.GameReplicationInfo.GameEndedComments != "")
	{
		C.bCenter = true;
		C.StrLen("Test", XL, YL);
		C.SetPos(0, C.ClipY - Min(YL*6, C.ClipY * 0.1));
		C.DrawColor = GreenColor;
		if (Level.NetMode == NM_Standalone)
            C.DrawText(GameEndedString@ContinueString, true);
		else
            C.DrawText(GameEndedString, true);
	}
	else if ((MyPlayer != None) && (MyPlayer.Health <= 0))
	{
		C.bCenter = true;
		C.StrLen("Test", XL, YL);
		C.SetPos(0, C.ClipY - Min( YL * 6, C.ClipY * 0.1 ));
		C.DrawColor = SilverColor;
		C.DrawText(RestartString, true);
	}
	C.bCenter = false;
	C.Font = C.smallfont;
    C.DrawColor.R = 120;
    C.DrawColor.G = 120;
    C.DrawColor.B = 120;
    C.Setpos(C.ClipX - 80, C.ClipY - 20);
    C.DrawText("AutoSS:"@MyCRI.bAutoShot);
}

//-------------------------------------
// GetTime
//-------------------------------------
simulated function string GetTime()
{
   local string amPm, mon, day, min;
   local byte hour;
   local PlayerPawn MyPlayer;

   MyPlayer = PlayerPawn(Owner);

   min = string(MyPlayer.level.minute);

   if (int(min) < 10) min = "0" $ min;

   if (MyPlayer.level.hour >= 12) amPm = "PM";
   else amPm = "AM";

   if (MyPlayer.level.hour > 12) hour = MyPlayer.level.hour - 12;
   else if (MyPlayer.level.hour == 0) hour = 12;
   else hour = MyPlayer.level.hour;

   switch (MyPlayer.level.month)
   {
      case 1: mon = "Jan"; break;
      case 2: mon = "Feb"; break;
      case 3: mon = "Mar"; break;
      case 4: mon = "Apr"; break;
      case 5: mon = "May"; break;
      case 6: mon = "Jun"; break;
      case 7: mon = "Jul"; break;
      case 8: mon = "Aug"; break;
      case 9: mon = "Sep"; break;
      case 10: mon = "Oct"; break;
      case 11: mon = "Nov"; break;
      case 12: mon = "Dec"; break;
   }

   switch (MyPlayer.level.dayOfWeek)
   {
      case 0: day = "Sunday"; break;
      case 1: day = "Monday"; break;
      case 2: day = "Tuesday"; break;
      case 3: day = "Wednesday"; break;
      case 4: day = "Thursday"; break;
      case 5: day = "Friday"; break;
      case 6: day = "Saturday"; break;
   }

   return hour $ ":" $ min @ amPM $ " , " $ day $ ", " $ mon @ MyPlayer.level.day $ ", " $ MyPlayer.level.year;
}
//-------------------------------------
// TwoDigitString
//-------------------------------------
function string TwoDigitString(int i)
{
	if (i < 10) return "0"$i;
	else return string(i);
}

//-------------------------------------
// GetYOffset
//-------------------------------------
function float GetYOffset(Canvas C)
{
    local float XL, YL, YL2, YL3;
    local float buf, div;

    if (C.ClipX > 1100) C.Font =  _FontInfo.GetMediumFont(C.ClipX);
    if (C.ClipX < 1100) C.Font =  _FontInfo.GetStaticBigFont(900);
    if (C.ClipX < 900) C.Font =  _FontInfo.GetStaticSmallFont(1000);

    C.StrLen("TEST",XL,YL);
    C.Font = MySmallFont;
    if (C.ClipX < 700) C.Font = _FontInfo.GetStaticAReallySmallFont(900);
    C.StrLen("TEST", XL, YL2);

    if (C.ClipX > 1100)
    {
        buf = 15;
        div = 4;
    }
    else
    {
        buf = 5;
        div = 2;
    }

    C.StrLen("#",XL,YL3);
    Step = XL;
    return YL + ( YL2 * 1 ) + ( buf * 1.5 ) + div;
}

//-------------------------------------
// DrawSpectators
//-------------------------------------
function DrawSpectators(Canvas C, PlayerReplicationInfo PRI, float x, float y, int cid)
{
    local float XL, YL;

    if (cid > 5) cid = cid - 6;
    C.DrawColor = SpecColor[cid];
    C.Style = ERenderStyle.STY_Normal;
    C.Font = C.smallfont;
    C.SetPos(x, y);
    C.DrawText(PRI.PlayerName, false);
}

//-------------------------------------
// _GetTextureName
//-------------------------------------
function string _GetTextureName(string T)
{
    return caps(mid(T, instr(T, ".") + 1));
}

//-------------------------------------
// MoveToVisible
//-------------------------------------
function MoveToVisible(PlayerReplicationInfo MyPRI, byte MySpot, byte NumPlayers)
{
    local int i;
    local PlayerReplicationInfo SwitchPRI;

    for (i=0; i<NumPlayers; i++)
    {
        if (OrdPRI[i].PlayerName == MyPRI.PlayerName && i > MySpot)
        {
            SwitchPRI = OrdPRI[MySpot];
            OrdPRI[MySpot] = MyPRI;
            OrdPRI[i] = SwitchPRI;
            bPlayerMoved = true;
            break;
        }
    }
}

//-------------------------------------
// defaultproperties
//-------------------------------------
defaultproperties
{
    GreenColor=(R=0,G=255,B=0,A=0),
    WhiteColor=(R=255,G=255,B=255,A=0),
    GoldColor=(R=255,G=255,B=0,A=0),
    BlueColor=(R=5,G=5,B=255,A=0),
    LightCyanColor=(R=128,G=255,B=255,A=0),
    SilverColor=(R=138,G=164,B=166,A=0),
    BronzeColor=(R=203,G=147,B=52,A=0),
    CyanColor=(R=0,G=128,B=255,A=0),
    RedColor=(R=255,G=5,B=5,A=0),
    ShadeColor=(R=70,G=70,B=70,A=0),
    DarkRedColor=(R=0,G=5,B=0,A=0),
    DarkBlueColor=(R=0,G=0,B=5,A=0),
    MapTitleString="in"
    AuthorString="by"
    RestartString="You got pwned.  Hit [Fire] to reSpawn!"
    ContinueString=" Hit [Fire] to continue!"
    GameEndedString="The match has ended."
    ElapsedTimeString="Elapsed Time: "
    RemainingTimeString="Remaining Time: "
    FragGoalString="Frag Limit:"
    TimeLimitString="Time Limit:"
    PlayerString="Player"
    FragsString="Frags"
    DeathsString="Deaths"
    PingString="Ping"
    TimeString="Time"
    LossString="Loss"
    FPHString="FPH"
}
