/*
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
         EUTDeathMessagePlus
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
*/

class EUTDeathMessagePlus extends DeathMessagePlus;

var bool bAerial;

var localized string Killed;

//-------------------------------------
// GetString
//-------------------------------------
static function string GetString(
	optional int i,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject
	)
{
    local string AerialKillMessage;

    if (i > 10 && i != 30)
    {
       AerialKillMessage = static.ParseSwitch(i);
       i = 0;
    }
    else if (i == 30)
    {
       AerialKillMessage = Class<Weapon>(OptionalObject).Default.DeathMessage;
       i = 0;
    }

    switch (i)
	{
		case 0:
			if (RelatedPRI_1 == None)
				return "";
			if (RelatedPRI_1.PlayerName == "")
				return "";
			if (RelatedPRI_2 == None)
				return "";
			if (RelatedPRI_2.PlayerName == "")
				return "";
			if (Class<Weapon>(OptionalObject) == None)
				return "";

            return class'GameInfo'.Static.ParseKillMessage(
            RelatedPRI_1.PlayerName,
            RelatedPRI_2.PlayerName,
			Class<Weapon>(OptionalObject).Default.ItemName,
			AerialKillMessage);
			break;

		case 1:
			if (RelatedPRI_1 == None)
				return "";
			if (RelatedPRI_1.bIsFemale)
				return RelatedPRI_1.PlayerName$class'TournamentGameInfo'.Default.FemaleSuicideMessage;
			else
				return RelatedPRI_1.PlayerName$class'TournamentGameInfo'.Default.MaleSuicideMessage;
			break;

		case 2:
			if (RelatedPRI_1 == None)
				return "";
			return RelatedPRI_1.PlayerName$class'TournamentGameInfo'.Default.FallMessage;
			break;

		case 3:
			if (RelatedPRI_1 == None)
				return "";
			return RelatedPRI_1.PlayerName$class'TournamentGameInfo'.Default.ExplodeMessage;
			break;

		case 4:
			if ( RelatedPRI_1 == None )
				return "";
			return RelatedPRI_1.PlayerName$class'TournamentGameInfo'.Default.DrownedMessage;
			break;

		case 5:
			if (RelatedPRI_1 == None)
				return "";
			return RelatedPRI_1.PlayerName$class'TournamentGameInfo'.Default.BurnedMessage;
			break;

		case 6:
			if (RelatedPRI_1 == None)
				return "";
			return RelatedPRI_1.PlayerName$class'TournamentGameInfo'.Default.CorrodedMessage;
			break;

		case 7:
			if (RelatedPRI_1 == None)
				return "";
			return RelatedPRI_1.PlayerName$class'TournamentGameInfo'.Default.MortarMessage;
			break;

		case 8:
			if (RelatedPRI_1 == None)
				return "";
			if (RelatedPRI_2 == None)
				return "";
			return class'GameInfo'.Static.ParseKillMessage(
				RelatedPRI_1.PlayerName,
				RelatedPRI_2.PlayerName,
				class'Translocator'.Default.ItemName,
				class'Translocator'.Default.DeathMessage
			);
			break;
	}
}

//-------------------------------------
// ClientReceive
//-------------------------------------
static function ClientReceive(
	PlayerPawn MyPlayer,
	optional int i,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject
	)
{
    if (RelatedPRI_1 == MyPlayer.PlayerReplicationInfo)
	{
		if (TournamentPlayer(MyPlayer).myHUD != None)
		{
			TournamentPlayer(MyPlayer).myHUD.LocalizedMessage( Default.ChildMessage, i, RelatedPRI_1, RelatedPRI_2, OptionalObject );
			TournamentPlayer(MyPlayer).myHUD.LocalizedMessage( Default.Class, i, RelatedPRI_1, RelatedPRI_2, OptionalObject );
		}

		if (Default.bIsConsoleMessage)
			TournamentPlayer(MyPlayer).Player.Console.AddString(Static.GetString( i, RelatedPRI_1, RelatedPRI_2, OptionalObject ));


		if ((RelatedPRI_1 != RelatedPRI_2) && (RelatedPRI_2 != None))
		{
			if ((TournamentPlayer(MyPlayer).Level.TimeSeconds - TournamentPlayer(MyPlayer).LastKillTime < 3) && (i != 1))
			{
				TournamentPlayer(MyPlayer).MultiLevel++;
				TournamentPlayer(MyPlayer).ReceiveLocalizedMessage( class'EUTMultiKillMessage', TournamentPlayer(MyPlayer).MultiLevel );

			}
			else
				TournamentPlayer(MyPlayer).MultiLevel = 0;

			TournamentPlayer(MyPlayer).LastKillTime = TournamentPlayer(MyPlayer).Level.TimeSeconds;
		}
		else
			TournamentPlayer(MyPlayer).MultiLevel = 0;

		if (ChallengeHUD(MyPlayer.MyHUD) != None)
			ChallengeHUD(MyPlayer.MyHUD).ScoreTime = TournamentPlayer(MyPlayer).Level.TimeSeconds;
	}
	else if (RelatedPRI_2 == MyPlayer.PlayerReplicationInfo)
	{
		TournamentPlayer(MyPlayer).ReceiveLocalizedMessage( class'VictimMessage', 0, RelatedPRI_1 );
		Super.ClientReceive(MyPlayer, i, RelatedPRI_1, RelatedPRI_2, OptionalObject);
	}
	else
		Super.ClientReceive(MyPlayer, i, RelatedPRI_1, RelatedPRI_2, OptionalObject);
}

//-------------------------------------
// ParseSwitch
//-------------------------------------
static function string ParseSwitch(int i)
{
   switch (i)
   {
        case 11:
            return class'EUTGameReplicationInfo'.default._EnforcerKillMessage; break;

        case 12:
            return class'EUTGameReplicationInfo'.default._BioKillMessage; break;

        case 13:
            return class'EUTGameReplicationInfo'.default._ShockRifleKillMessage; break;

        case 14:
            return class'EUTGameReplicationInfo'.default._PulseGunKillMessage; break;

        case 15:
            return class'EUTGameReplicationInfo'.default._RipperKillMessage; break;

        case 16:
            return class'EUTGameReplicationInfo'.default._MiniGunKillMessage; break;

        case 17:
            return class'EUTGameReplicationInfo'.default._FlakGunKillMessage; break;

        case 18:
            return class'EUTGameReplicationInfo'.default._EightBallKillMessage; break;

        case 19:
            return class'EUTGameReplicationInfo'.default._SniperRifleKillMessage; break;

        case 21:
            return class'EUTGameReplicationInfo'.default._EnforcerKillMessage; break;

        case 22:
            return class'EUTGameReplicationInfo'.default._BioKillMessage; break;

        case 23:
            return class'EUTGameReplicationInfo'.default._ShockRifleKillMessage; break;

        case 24:
            return class'EUTGameReplicationInfo'.default._PulseGunKillMessage; break;

        case 25:
            return class'EUTGameReplicationInfo'.default._RipperKillMessage; break;

        case 26:
            return class'EUTGameReplicationInfo'.default._MiniGunKillMessage; break;

        case 27:
            return class'EUTGameReplicationInfo'.default._FlakGunKillMessage; break;

        case 28:
            return class'EUTGameReplicationInfo'.default._EightBallKillMessage; break;

        case 29:
            return class'EUTGameReplicationInfo'.default._SniperRifleKillMessage; break;

        case 51:
            return class'EUTGameReplicationInfo'.default._AerialKillBioGunMessage; break;

        case 52:
            return class'EUTGameReplicationInfo'.default._AerialKillRipperMessage; break;

        case 53:
            return class'EUTGameReplicationInfo'.default._AerialKillFlakGunMessage; break;

        case 54:
            return class'EUTGameReplicationInfo'.default._AerialKillEightBallMessage; break;

        case 55:
            return class'EUTGameReplicationInfo'.default._AerialKillSniperRifleMessage; break;

        case 56:
            return class'EUTGameReplicationInfo'.default._AerialKillShockRifleMessage; break;

        case 57:
            return class'EUTGameReplicationInfo'.default._AerialKillTranslocatorMessage; break;

        case 58:
            return class'EUTGameReplicationInfo'.default._AerialKillComboMessage; break;

        case 59:
            return class'EUTGameReplicationInfo'.default._AerialKillEnforcerMessage; break;

        case 60:
            return class'EUTGameReplicationInfo'.default._AerialKillPulseGunMessage; break;

        case 61:
            return class'EUTGameReplicationInfo'.default._AerialKillBioGunMessage;  break;

        case 62:
            return class'EUTGameReplicationInfo'.default._AerialKillRipperMessage; break;

        case 63:
            return class'EUTGameReplicationInfo'.default._AerialKillFlakGunMessage; break;

        case 64:
            return class'EUTGameReplicationInfo'.default._AerialKillEightBallMessage; break;

        case 65:
            return class'EUTGameReplicationInfo'.default._AerialKillSniperRifleMessage; break;

        case 66:
            return class'EUTGameReplicationInfo'.default._AerialKillShockRifleMessage; break;

        case 67:
            return class'EUTGameReplicationInfo'.default._AerialKillTranslocatorMessage; break;

        case 68:
            return class'EUTGameReplicationInfo'.default._AerialKillComboMessage; break;

        case 69:
            return class'EUTGameReplicationInfo'.default._AerialKillEnforcerMessage; break;

        case 70:
            return class'EUTGameReplicationInfo'.default._AerialKillPulseGunMessage; break;

        case 71:
            return class'EUTGameReplicationInfo'.default._AerialKillMiniGunMessage; break;

        case 72:
            return class'EUTGameReplicationInfo'.default._AerialKillMiniGunMessage; break;

        case 73:
            return class'EUTGameReplicationInfo'.default._AerialKillPistonMessage; break;

        case 74:
            return class'EUTGameReplicationInfo'.default._AerialKillPistonMessage; break;

        case 75:
            return class'EUTGameReplicationInfo'.default._AerialKillImpactMessage; break;

        case 76:
            return class'EUTGameReplicationInfo'.default._AerialKillImpactMessage; break;

        case 77:
            return class'EUTGameReplicationInfo'.default._AerialKillTransMessage; break;

        case 78:
            return class'EUTGameReplicationInfo'.default._AerialKillTransMessage; break;

    }
}

//-------------------------------------
// defaultproperties
//-------------------------------------
defaultproperties
{
    Killed="was killed by"
}
