/*
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
              EUTDemoEnhancer
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
*/

class EUTDemoEnhancer expands Actor;

//-------------------------------------
// Tick
//------------------------------------
simulated function Tick(float Delta)
{
	local Class<GameInfo> GameClass;
	local Class<ScoreBoard> SB;
	local Class<HUD> HC;
	local DemoRecSpectator DRS;
	local int i;

	foreach AllActors(class'DemoRecSpectator', DRS)
	{
		if (DRS.PlaybackActor != none
        && (DRS.PlaybackGRI != None))
		{
			log("Demo Record Spectator Found",'EUT');
            GameClass = Class<GameInfo>( DynamicLoadObject(DRS.PlaybackGRI.GameClass,Class'Class') );
			SB = None;
			switch (GameClass.Default.ScoreBoardType)
			{
				case Class'UnrealCTFScoreBoard':
                SB = Class'EUTCTFSB';
	            HC = Class'EUTCTFHUD';
	            break;

	            case Class'TeamScoreBoard':
                SB = Class'EUTTDMSB';
	            HC = Class'EUTTDMHUD';
	            break;

	            case Class'EUTCTFSB':
                SB = Class'EUTCTFSB';
	            HC = Class'EUTCTFHUD';
	            break;

	            case Class'EUTTDMSB':
                SB = Class'EUTTDMSB';
	            HC = Class'EUTTDMHUD';
	            break;

	            case class'TournamentScoreBoard':
	            SB = class'EUTDMSB';
	            HC = class'EUTDMHud';
	            break;

	            case class'EUTDMSB':
	            SB = class'EUTDMSB';
	            HC = class'EUTDMHud';
	            break;

            }

			if (SB == None) log("EUT: Failed to Load ScoreBoard for Demo!");

			else if (SB != DRS.PlaybackActor.ScoringType)
			{
				DRS.PlaybackActor.ScoringType = SB;
				if (DRS.PlaybackActor.Scoring != none)
					DRS.PlaybackActor.Scoring.Destroy();

				DRS.PlaybackActor.Scoring = None;
			}

			if (HC == None) HC = Class<HUD>(DynamicLoadObject(string(GameClass.Default.HUDType),Class'Class'));
			if (HC == none) log("EUT: Failed to Load HUD for Demo!");

			else if (HC != DRS.PlaybackActor.HUDType)
			{
				DRS.PlaybackActor.HUDType = HC;
				if(DRS.PlaybackActor.myHUD != none)
					DRS.PlaybackActor.myHUD.Destroy();

				DRS.PlaybackActor.myHUD = None;
            }
            Destroy();
        }
		i++;
		log("Hud class Loaded:"@HC,'EUT');
    }

	if (i == 0)
		Destroy();
}

//-------------------------------------
// defaultproperties
//------------------------------------
defaultproperties
{
    Texture=None
}
