/*
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
            EUTHudHelper
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
*/

class EUTHudHelper expands Info;

var FontInfo _FontInfo;
var PlayerReplicationInfo OrderedPRI[32];
var EUTGameReplicationInfo MyCRI;
var Pawn P;
var font MySmallFont;

var bool bCTF,
    bTDM,
    bDM,
    bCheckKeyBindings,
    bDebugLoad,
    bWeaponFired,
    bScreenShotTaken,
    bShowStats,
    bShowTeamInfo,
    bSetMessageDefaults,
    bCheckForAutoRecorder,
    bDemoLoaded;

var byte StageCount,
    MouseYCount,
    SniperFireAnim0,
    SniperFireAnim1,
    SniperFireAnim2,
    SniperFireAnim3,
    SniperFireAnim4,
    SniperFireAnim5,
    ScreenShotDelay,
    DelayDataClear,
    ScopeMode;

var color YellowColor,
    GreenColor,
    WhiteColor,
    GoldColor,
    BlueColor,
    LightCyanColor,
    SilverColor,
    BronzeColor,
    CyanColor,
    RedColor,
    ShadeColor,
    DarkRedColor,
    DarkBlueColor;

var float WeaponDrawOffset,
    ShotTotal,
    DamageTotal,
    CurrentAccuracy,
    TapTime,
    TapRate;

var texture NewReticle,
    NewScopeReticle;

struct _ShotData
{
    var int Enforcer,
    BioGun,
    ShockRifle,
    PulseGun,
    Ripper,
    MiniGun,
    FlakGun,
    EightBall,
    SniperRifle,
    SuperShockRifle,
    CustomWeapon;
} ;
var _ShotData SD;

struct _Accuracy
{
    var byte Enforcer,
    BioGun,
    ShockRifle,
    PulseGun,
    Ripper,
    MiniGun,
    FlakGun,
    EightBall,
    SniperRifle,
    SuperShockRifle,
    CustomWeapon;
};
var _Accuracy Acc;

struct _ShotCount
{
    var byte Enforcer,
    BioGun,
    ShockRifle,
    PulseGun,
    Ripper,
    MiniGun,
    FlakGun,
    EightBall,
    SniperRifle,
    CustomWeapon;
};
var _ShotCount SC;

struct _AmmoCount
{
    var float Enforcer,
    BioGun,
    ShockRifle,
    PulseGun,
    Ripper,
    MiniGun,
    FlakGun,
    EightBall,
    SniperRifle,
    CustomWeapon;
};
var _AmmoCount AC;

struct _StatInfo
{
    var byte Accuracy;
    var int Effeciency;
};
var _StatInfo StatInfo;

const ReticleSize = 256;
const ReticleOut = 0;


//-------------------------------------
// Destroyed
//-------------------------------------
function Destroyed()
{
	Super.Destroyed();

    if (_FontInfo != none)
		_FontInfo.Destroy();
}

//-------------------------------------
// PostBeginPlay
//-------------------------------------
function PostBeginPlay()
{
	Super.PostBeginPlay();
	_FontInfo = FontInfo(Spawn(Class<Actor>(DynamicLoadObject(class'ChallengeHUD'.default.FontInfoClass, class'Class'))));
    MySmallFont = Font(DynamicLoadObject("EUT_Textures.EUTSmallFont", class'Font'));
}

//-------------------------------------
// RenderInfo
//-------------------------------------
simulated function RenderInfo(Canvas C )
{
	local GameReplicationInfo GRI;

    GRI = PlayerPawn(Owner).GameReplicationInfo;

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
           bCTF = true;
           MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
           break;

        case Class'EUTTDMHud':
            bTDM = true;
            MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
            break;

        case Class'EUTDMHud':
             bDM = true;
             MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
            break;
    }

	if (C.ClipX > 512)
       PreLoadData(C,GRI);
}

//-------------------------------------
// PreLoadData
//-------------------------------------
simulated function PreLoadData(Canvas C, GameReplicationInfo GRI)
{
    local byte i, NumPlayers;
    local PlayerReplicationInfo PRI;
    local PlayerPawn MyPlayer;
    local float X, Y, Loop, YPos, XL, YL;

    MyPlayer = PlayerPawn(Owner);
    NumPlayers = 0;

    for (i = 0; i < ArrayCount(OrderedPRI); i++)
        OrderedPRI[i] = None;

	for (i = 0; i < 32; i++)
    {
        PRI = GRI.PRIArray[i];
        if (PRI != none
        && (PRI.PlayerName != "Player")
        && (PRI.Team == MyPlayer.PlayerReplicationInfo.Team))
        {
            if (!PRI.bIsSpectator || PRI.bWaitingPlayer)
			{
                OrderedPRI[NumPlayers] = PRI;
                NumPlayers++;
                if (NumPlayers == ArrayCount(OrderedPRI)) break;
            }
        }
    }
    SortPlayers(NumPlayers);

    C.Font = _FontInfo.GetSmallFont(C.ClipX);
	C.StrLen("PreLoadData", XL, YL );
    YPos = YL*5 + 8;

    for (i = 0; i < NumPlayers; i++)
    {
       X = 10;
       Y = (YPos) + (GetYOffset(C) * Loop);
       if (i == 0) Y = YPos;
       DrawPlayerData(C, OrderedPRI[i], X, Y);
       Loop += 1;
    }
}

//-------------------------------------
// DrawPlayerData
//-------------------------------------
simulated function DrawPlayerData(Canvas C, PlayerReplicationInfo PRI, float X, float Y)
{
    local float XL, YL, XL2, YL2, XL3, YL3, Buffer;
    local PlayerPawn MyPlayer;
    local string Loc;
    local byte pid;

    MyPlayer = PlayerPawn(Owner);
    pid = PRI.PlayerID;
    C.Style = ERenderStyle.STY_Normal;

    //Location
    if (PRI.Team == MyPlayer.PlayerReplicationInfo.Team)
	{
        if (PRI.PlayerLocation != none) Loc = PRI.PlayerLocation.LocationName;
		else if (PRI.PlayerZone != None) Loc = PRI.PlayerZone.ZoneName;
		else Loc = "";
		if (Loc != "" ) Loc = ""$Loc;
	}

	C.Font = _FontInfo.GetSmallestFont(C.ClipX);

    if (C.ClipX < 1100) C.Font = _FontInfo.GetSmallestFont(900);
    if (C.ClipX < 900) C.Font = MySmallFont;

	C.DrawColor = GoldColor;
    C.StrLen(PRI.PlayerName, XL, YL);
    C.SetPos(X, Y);
    C.DrawText(PRI.PlayerName, false);
    C.StrLen("###########", Buffer, YL2);

    if (bCTF)
    {
        if (PRI.HasFlag != none
        && (!PRI.HasFlag.IsA('EUTReadyFlag')))
        {
            C.DrawColor = GreenColor;
            C.SetPos(X + XL + (Buffer / 9), Y);
            C.DrawText("***Flag Carrier***", false);
        }
    }

    C.DrawColor = GreenColor;
    C.SetPos(X, Y + YL);
    C.DrawText("Location:",false);
    C.DrawColor = CyanColor;
    C.SetPos(X + Buffer, Y + YL);
    C.DrawText(Loc, false);
    C.DrawColor = GreenColor;
    C.SetPos(X, Y + (YL * 2));
    C.DrawText("Health:",false);
    C.DrawColor = WhiteColor;
    C.SetPos(X + Buffer, Y + (YL * 2));

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
        case Class'EUTTDMHud': C.DrawText(MyCRI.HealthAmmount[pid],false); break;
        case Class'EUTDMHud': break;
    }

    C.DrawColor = GreenColor;
    C.SetPos(X, Y + (YL * 3));
    C.DrawText("Armor:",false);
    C.DrawColor = WhiteColor;
    C.SetPos(X + Buffer, Y + (YL * 3));

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
        case Class'EUTTDMHud': C.DrawText(MyCRI.ArmorAmmount[pid],false); break;
        case Class'EUTDMHud': break;
    }
}

//-------------------------------------
// SortPlayers
//-------------------------------------
simulated function SortPlayers(byte N)
{
	local byte I, J, Max;
	local PlayerReplicationInfo TempPRI;

	switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
            for (I = 0; I < N - 1; I++)
            {
                Max = I;
                for (J = I + 1; J < N; J++)
                {
                    if (OrderedPRI[J].HasFlag != none)
        			       Max = J;
                    else if (OrderedPRI[J].Score > OrderedPRI[Max].Score
                    && (OrderedPRI[Max].HasFlag == none))
                        Max = J;
                    else if ((OrderedPRI[J].Score == OrderedPRI[Max].Score)
                    && (OrderedPRI[J].Deaths < OrderedPRI[Max].Deaths)
                    && (OrderedPRI[Max].HasFlag == none))
                        Max = J;
                    else if ((OrderedPRI[J].Score == OrderedPRI[Max].Score)
                    && (OrderedPRI[J].Deaths == OrderedPRI[Max].Deaths)
                    && (OrderedPRI[J].PlayerID < OrderedPRI[Max].Score)
                    && (OrderedPRI[Max].HasFlag == none))
                        Max = J;
                }
                TempPRI = OrderedPRI[Max];
                OrderedPRI[Max] = OrderedPRI[I];
                OrderedPRI[I] = TempPRI;
            }
            break;

        case Class'EUTTDMHud':
            for (I = 0; I < N - 1; I++)
            {
                Max = I;
                for (J = I + 1; J < N; J++)
                {
                    if (OrderedPRI[J].Score > OrderedPRI[Max].Score)
                        Max = J;
                    else if ((OrderedPRI[J].Score == OrderedPRI[Max].Score)
                    && (OrderedPRI[J].Deaths < OrderedPRI[Max].Deaths))
                        Max = J;
                    else if ((OrderedPRI[J].Score == OrderedPRI[Max].Score)
                    && (OrderedPRI[J].Deaths == OrderedPRI[Max].Deaths)
                    && (OrderedPRI[J].PlayerID < OrderedPRI[Max].Score))
                        Max = J;
                }
                TempPRI = OrderedPRI[Max];
                OrderedPRI[Max] = OrderedPRI[I];
                OrderedPRI[I] = TempPRI;
            }
            break;

        case Class'EUTDMHud': break;
    }
}

//-------------------------------------
// GetYOffset
//-------------------------------------
simulated function float GetYOffset(Canvas C)
{
    local float XL, YL, YL2;

    C.Font = _FontInfo.GetSmallestFont(C.ClipX);
    if (C.ClipX < 1100) C.Font = _FontInfo.GetSmallestFont(900);
    if (C.ClipX < 900) C.Font = MySmallFont;
    C.StrLen("TEST", XL, YL);
    return YL * 5;
}

//-------------------------------------
// ParseLoad
//-------------------------------------
simulated final function ParseLoad(Canvas C)
{
    local string Full, Rate, ActorTime, NetTime;
    local int x;
    local float Time, Load, XL, YL;

    Full = PlayerPawn(Owner).Player.Console.MsgText[0];

    if (Instr(Full,"r=") != -1) Rate = Mid(Full, 2, 2);
    if (Instr(Full,"act=") != -1) ActorTime = Mid(Full, Instr(Full,"act=") + 4, 3);
    if (instr(Full,"net=") != -1) NetTime = Mid(Full, instr(Full,"net=") + 4, 3);

    if (Rate != ""
    && (ActorTime != "")
    && (NetTime != ""))
    {
        Time = float(ActorTime) + float(NetTime) + 10.0;
        x = int(Rate);
        Load = (x * Time / 1000) * 100;
        C.Font = _FontInfo.GetStaticMediumFont(C.ClipX);
        C.Style = ERenderStyle.STY_Normal;
        C.DrawColor = RedColor;
        C.StrLen("Load:"@int(Load)@"%", XL, YL);
        C.SetPos(C.ClipX - XL, C.ClipY / 4 + YL);
        C.DrawText("Load:"@int(Load)@"%", false);
    }
}

//-------------------------------------
// DrawBeacon
//-------------------------------------
simulated function DrawBeacon(Canvas C, Pawn P, byte Mode)
{
    local float X, Y, W, H;
    local bool bLineOfSight;
    local vector vPawn;

    if (P == None || (P.PlayerReplicationInfo == none))
        return;

    vPawn = P.Location;
    vPawn.Z += P.CollisionHeight;
    bLineOfSight = WorldToScreen(vPawn, Pawn(Owner), C.ClipX, C.ClipY, X, Y);

    if (bLineOfSight && IsValidCoord(x,C.ClipX) && IsValidCoord(y,C.ClipY))
    {
        switch(P.PlayerReplicationInfo.Team)
        {
            case 0: C.DrawColor = RedColor * 0.333 * 3; break;
            case 1: C.DrawColor = BlueColor * 0.333 * 3; break;
            case 2: C.DrawColor = GreenColor * 0.333 * 3; break;
            case 3: C.DrawColor = GoldColor * 0.333 * 3; break;
            default: C.DrawColor = GreenColor * 0.333 * 3; break;
        }

        C.Font = _FontInfo.GetStaticSmallestFont(C.ClipX);
        C.SetPos(0, 0);

        switch (Mode)
        {
            case 0:
                C.TextSize(P.PlayerReplicationInfo.PlayerName@P.Health , W, H);
                C.SetPos(X - W / 2, Y - (H * 3));
                C.DrawText(P.PlayerReplicationInfo.PlayerName@P.Health, false);
            break;

            case 1:
                C.TextSize(P.PlayerReplicationInfo.PlayerName$" (Leader)" , W, H);
                C.SetPos(X - W / 2, Y - (H * 3));
                C.DrawText(P.PlayerReplicationInfo.PlayerName$" (Leader)", false);
            break;
        }
    }
}
//-------------------------------------
// WorldToScreen
//-------------------------------------
simulated function bool IsValidCoord(float start, float stop)
{
    if (start > 0 && start < stop)
        return true;
    else
        return false;
}

//-------------------------------------
// WorldToScreen
//-------------------------------------
simulated static function bool WorldToScreen( Vector vPawn, Pawn P, float ClipX, float ClipY, out float X, out float Y )
{
    local vector Base, Screen;
    local float Scale;

    Base = P.Location;
    Base.Z += P.BaseEyeHeight;
    Screen = (vPawn - Base) << P.ViewRotation;
    if (Screen.X < 0.01) return false;
    scale = (ClipX / 2) / Tan(P.FovAngle / 2 / 180 * Pi);
    X = Screen.Y / Screen.X * scale + ClipX / 2;
    Y = - Screen.Z / Screen.X * scale + ClipY / 2;
    return true;
}

//-------------------------------------
// NetAdjustment
//-------------------------------------
simulated final function float NetAdjustment(float Base, byte Request)
{
    local float rv;

    switch (Request)
    {
        case 0: return Base; break;
        case 1: return Base * 0.95; break;
        case 2: return Base * 0.90; break;
        case 3: return Base * 0.85; break;
        case 4: return Base * 0.80; break;
        case 5: return Base * 0.75; break;
        case 6: return Base * 0.70; break;
        case 7: return Base * 0.65; break;
        case 8: return Base * 0.60; break;
        case 9: return Base * 0.55; break;
        default: return Base * 0.50; break;
    }
    return rv;
}

//-------------------------------------
// SetMessageDefaults
//-------------------------------------
simulated function SetMessageDefaults(byte Mode)
{
    bSetMessageDefaults = true;

    SetupReticle(0);

    if (!PlayerPawn(Owner).IsA('Spectator'))
    {
        if (PlayerPawn(Owner).DefaultFOV  < 80 || PlayerPawn(Owner).DefaultFOV < 80)
        {
            PlayerPawn(Owner).DefaultFOV = 90;
            PlayerPawn(Owner).DesiredFOV = PlayerPawn(Owner).DefaultFOV;
        }
        else if (PlayerPawn(Owner).DesiredFOV != PlayerPawn(Owner).DefaultFOV
        && (PlayerPawn(Owner).DesiredFOV >= 80 || PlayerPawn(Owner).DefaultFOV >= 80))
        {
            if (PlayerPawn(Owner).DesiredFOV > PlayerPawn(Owner).DefaultFOV)
                PlayerPawn(Owner).DefaultFOV = PlayerPawn(Owner).DesiredFOV;
            else
               PlayerPawn(Owner).DesiredFOV = PlayerPawn(Owner).DefaultFOV;
        }
    }
    else
        PlayerPawn(Owner).ConsoleCommand("fly");

    switch (Mode)
    {
        case 0:
        case 1:
            if (MyCRI == none) MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);

            MyCRI.default._EnforcerKillMessage = MyCRI.EnforcerKillMessage;
            MyCRI.default._BioKillMessage = MyCRI.BioKillMessage;
            MyCRI.default._ShockRifleKillMessage = MyCRI.ShockRifleKillMessage;
            MyCRI.default._PulseGunKillMessage = MyCRI.PulseGunKillMessage;
            MyCRI.default._RipperKillMessage = MyCRI.RipperKillMessage;
            MyCRI.default._MiniGunKillMessage = MyCRI.MiniGunKillMessage;
            MyCRI.default._FlakGunKillMessage = MyCRI.FlakCannonKillMessage;
            MyCRI.default._EightBallKillMessage = MyCRI.RocketLauncherKillMessage;
            MyCRI.default._SniperRifleKillMessage = MyCRI.SniperRifleKillMessage;
            MyCRI.default._CustomeWeaponKillMessage = MyCRI.CustomWeaponKillMessage;
            MyCRI.default._AerialKillBioGunMessage = MyCRI.AerialKillBio;
            MyCRI.default._AerialKillRipperMessage = MyCRI.AerialKillRipper;
            MyCRI.default._AerialKillFlakGunMessage = MyCRI.AerialKillFlak;
            MyCRI.default._AerialKillEightBallMessage = MyCRI.AerialKillRockets;
            MyCRI.default._AerialKillSniperRifleMessage = MyCRI.AerialKillSniper;
            MyCRI.default._AerialKillShockRifleMessage = MyCRI.AerialKillSuper;
            MyCRI.default._AerialKillTranslocatorMessage = MyCRI.AerialKillTrans;
            MyCRI.default._AerialKillComboMessage = MyCRI.AerialKillCombo;
            MyCRI.default._AerialKillEnforcerMessage = MyCRI.AerialKillEnforcer;
            MyCRI.default._AerialKillPulseGunMessage = MyCRI.AerialKillPulse;
            MyCRI.default._AerialKillMiniGunMessage = MyCRI.AerialKillMini;
            MyCRI.default._AerialKillPistonMessage = MyCRI.AerialKillPiston;
            MyCRI.default._AerialKillImpactMessage = MyCRI.ImpactKillMessage;
            MyCRI.default._AerialKillTransMessage = MyCRI.TransKillMessage;
            MyCRI.default._AerialKillCustom = MyCRI.AerialKillCustom;

            if(MyCRI.bUsesSpreeSounds)
        	{
                if(MyCRI.SpreeSound[0] != none) class'KillingSpreeMessage'.default.SpreeSound[0] = MyCRI.SpreeSound[0];
                if(MyCRI.SpreeSound[1] != none) class'KillingSpreeMessage'.default.SpreeSound[1] = MyCRI.SpreeSound[1];
        	    if(MyCRI.SpreeSound[2] != none) class'KillingSpreeMessage'.default.SpreeSound[2] = MyCRI.SpreeSound[2];
        	    if(MyCRI.SpreeSound[3] != none) class'KillingSpreeMessage'.default.SpreeSound[3] = MyCRI.SpreeSound[3];
        	    if(MyCRI.SpreeSound[4] != none) class'KillingSpreeMessage'.default.SpreeSound[4] = MyCRI.SpreeSound[4];

                if(MyCRI.DoubleKillSound != none) class'EUTMultiKillMessage'.default.DoubleKillSound = MyCRI.DoubleKillSound;
                if(MyCRI.MultiKillSound != none) class'EUTMultiKillMessage'.default.MultiKillSound = MyCRI.MultiKillSound;
                if(MyCRI.MegaKillSound != none) class'EUTMultiKillMessage'.default.MegaKillSound = MyCRI.MegaKillSound;
                if(MyCRI.UltraKillSound != none) class'EUTMultiKillMessage'.default.UltraKillSound = MyCRI.UltraKillSound;
                if(MyCRI.MonsterKillSoundF != none) class'EUTMultiKillMessage'.default.MonsterKillSoundF = MyCRI.MonsterKillSoundF;
                if(MyCRI.LudicriousKillSound != none) class'EUTMultiKillMessage'.default.LudicriousKillSound = MyCRI.LudicriousKillSound;
                if(MyCRI.HolyShitKillSound != none) class'EUTMultiKillMessage'.default.HolyShitKillSound = MyCRI.HolyShitKillSound;
                if(MyCRI.OwnageSound != none) class'EUTMultiKillMessage'.default.OwnageSound = MyCRI.OwnageSound;
                if(MyCRI.WhickedSickSound != none) class'EUTMultiKillMessage'.default.WhickedSickSound = MyCRI.WhickedSickSound;

            }

            if(MyCRI.bEnhancedMessages)
            {
                if(MyCRI.RedTeamScoresSound != none) class'EUTTeamGameSounds'.default.RedTeamScoresSound = MyCRI.RedTeamScoresSound;
                if(MyCRI.BlueTeamScoresSound != none) class'EUTTeamGameSounds'.default.BlueTeamScoresSound = MyCRI.BlueTeamScoresSound;
                if(MyCRI.RedTeamTakesTheLeadSound != none) class'EUTTeamGameSounds'.default.RedTeamTakesTheLeadSound = MyCRI.RedTeamTakesTheLeadSound;
                if(MyCRI.BlueTeamTakesTheLeadSound != none) class'EUTTeamGameSounds'.default.BlueTeamTakesTheLeadSound = MyCRI.BlueTeamTakesTheLeadSound;
                if(MyCRI.RedTeamIncreasesThierLeadSound != none) class'EUTTeamGameSounds'.default.RedTeamIncreasesThierLeadSound = MyCRI.RedTeamIncreasesThierLeadSound;
                if(MyCRI.BlueTeamIncreasesThierLeadSound != none) class'EUTTeamGameSounds'.default.BlueTeamIncreasesThierLeadSound = MyCRI.BlueTeamIncreasesThierLeadSound;
                if(MyCRI.RedTeamDominatingSound != none) class'EUTTeamGameSounds'.default.RedTeamDominatingSound = MyCRI.RedTeamDominatingSound;
                if(MyCRI.BlueTeamDominatingSound != none) class'EUTTeamGameSounds'.default.BlueTeamDominatingSound = MyCRI.BlueTeamDominatingSound;
                if(MyCRI.HatTrickSound != none) class'EUTTeamGameSounds'.default.HatTrickSound = MyCRI.HatTrickSound;
                if(MyCRI.DeniedSound != none) class'EUTTeamGameSounds'.default.DeniedSound = MyCRI.DeniedSound;
                if(MyCRI.LastSecondSaveSound != none) class'EUTTeamGameSounds'.default.LastSecondSaveSound = MyCRI.LastSecondSaveSound;
                if(MyCRI.RedTeamIsTheWinnerSound != none) class'EUTTeamGameSounds'.default.RedTeamIsTheWinnerSound = MyCRI.RedTeamIsTheWinnerSound;
                if(MyCRI.BlueTeamIsTheWinnerSound != none) class'EUTTeamGameSounds'.default.BlueTeamIsTheWinnerSound = MyCRI.BlueTeamIsTheWinnerSound;
                if(MyCRI.FlawlessVictorySound != none) class'EUTTeamGameSounds'.default.FlawlessVictorySound = MyCRI.FlawlessVictorySound;

                class'CTFGame'.default.CaptureSound[0] = none;
                class'CTFGame'.default.CaptureSound[1] = none;
                class'CTFGame'.default.CaptureSound[2] = none;
                class'CTFGame'.default.CaptureSound[3] = none;
            }

            if(MyCRI.FlakMonkeySound != none) class'EUTMultiKillMessage'.default.FlakMonkeySound = MyCRI.FlakMonkeySound;
            if(MyCRI.HeadHunterSound != none) class'EUTMultiKillMessage'.default.HeadHunterSound = MyCRI.HeadHunterSound;
            if(MyCRI.ComboWhoreSound != none) class'EUTMultiKillMessage'.default.ComboWhoreSound = MyCRI.ComboWhoreSound;

            if(MyCRI.HitSoundSound != none) class'EUTHitSoundMessage'.default.HitSoundSound = MyCRI.HitSoundSound;
            if(MyCRI.HitSoundFriendlySound != none) class'EUTHitSoundMessage'.default.HitSoundFriendlySound = MyCRI.HitSoundFriendlySound;

            MyCRI.TextureCounter = 0;
            MyCRI.TextureSwitch = 0;
            MyCRI.bClassInitialized = true;
            break;
    }
}

//-------------------------------------
// GetAccuracy
//-------------------------------------
simulated function byte GetAccuracy(int pid, Weapon W)
{
    local int i;
    local byte rv;
    local string WeaponName;

    rv = 0;
    if (W == none || PlayerPawn(Owner) == none) return rv;
    WeaponName = _GetItemName(W);
    if (W.AmmoType == none) return GetLastAccuracy(WeaponName);
    if (MyCRI == none) MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);

    switch (WeaponName)
    {
        case "ZP_SUPERSHOCKRIFLE":
        case "SUPERSHOCKRIFLE":

            if (W.AnimFrame > 0
            && (W.AnimSequence == 'Fire1')
            && (TapRate < W.AnimFrame)
            && (!bWeaponFired))
            {
                SD.SuperShockRifle++;
                TapRate = W.AnimFrame;
                bWeaponFired = true;
            }

            else if (W.AnimFrame > 0
            && (W.AnimSequence == 'Fire1')
            && (W.AnimFrame > TapRate)
            && (bWeaponFired))
                TapRate = W.AnimFrame;

            else if (W.AnimFrame > 0
            && (W.AnimSequence == 'Fire1')
            && (W.AnimFrame < TapRate)
            && (bWeaponFired))
            {
                SD.SuperShockRifle++;
                TapRate = W.AnimFrame;
                bWeaponFired = true;
            }

            else if (W.AnimSequence == 'Still')
            {
                TapRate = 0;
                bWeaponFired = false;
            }

            //Verify against speedstepping this would be faster.
            /*if (W.AnimSequence == 'Fire1' && TapTime + 1.4 < PlayerPawn(Owner).CurrentTimeStamp)
            {
                SD.SuperShockRifle++;
                TapTime = PlayerPawn(Owner).CurrentTimeStamp;
            }*/

            DamageTotal = MyCRI.TotalDamageAmmount[pid];
            ShotTotal = SD.SuperShockRifle;
            CurrentAccuracy = DamageTotal / ShotTotal * 100;

            if (CurrentAccuracy < 0) CurrentAccuracy = 0;

            Acc.SuperShockRifle = CurrentAccuracy;
            return Acc.SuperShockRifle;
            break;

        case "ZP_SNIPERRIFLE":
        case "SNIPERRIFLE":
            i = 0;

            if (W.AmmoType.AmmoAmount > AC.SniperRifle
            && (AC.SniperRifle != 0))
            {
                i = W.AmmoType.AmmoAmount - AC.SniperRifle;
                AC.SniperRifle += i;
                return Acc.SniperRifle;
            }

            if (W.AmmoType.AmmoAmount < AC.SniperRifle
            && (AC.SniperRifle != 0))
                SC.SniperRifle = AC.SniperRifle - W.AmmoType.AmmoAmount;

            AC.SniperRifle = W.AmmoType.AmmoAmount;
            DamageTotal = MyCRI.SniperRifleHitCount[pid];
            ShotTotal = SD.SniperRifle + SC.SniperRifle;
            SD.SniperRifle = ShotTotal;
            CurrentAccuracy = DamageTotal / ShotTotal * 100;

            if (CurrentAccuracy < 0) CurrentAccuracy = 0;

            Acc.SniperRifle = CurrentAccuracy;
            SC.SniperRifle = 0;
            return Acc.SniperRifle;
            break;

        case "ENFORCER":
        case "DOUBLEENFORCER":
        case "ZP_ENFORCER":
            i = 0;

            if (W.AmmoType.AmmoAmount > AC.Enforcer
            && (AC.Enforcer != 0))
            {
                i = W.AmmoType.AmmoAmount - AC.Enforcer;
                AC.Enforcer += i;
                return Acc.Enforcer;
            }

            if (W.AmmoType.AmmoAmount < AC.Enforcer
            && (AC.Enforcer != 0))
                SC.Enforcer = AC.Enforcer - W.AmmoType.AmmoAmount;

            AC.Enforcer = W.AmmoType.AmmoAmount;
            DamageTotal = MyCRI.EnforcerHitCount[pid];
            ShotTotal = SD.Enforcer + SC.Enforcer;
            SD.Enforcer = ShotTotal;
            CurrentAccuracy = DamageTotal / ShotTotal * 100;

            if (CurrentAccuracy < 0) CurrentAccuracy = 0;

            Acc.Enforcer = CurrentAccuracy;
            SC.Enforcer = 0;
            return Acc.Enforcer;
            break;

        case "UT_BIORIFLE":
            i = 0;

            if (W.AmmoType.AmmoAmount > AC.BioGun
            && (AC.BioGun != 0))
            {
                i = W.AmmoType.AmmoAmount - AC.BioGun;
                AC.BioGun += i;
                return Acc.BioGun;
            }

            if (W.AmmoType.AmmoAmount < AC.BioGun
            && (AC.BioGun != 0))
                SC.BioGun = AC.BioGun - W.AmmoType.AmmoAmount;

            AC.BioGun = W.AmmoType.AmmoAmount;
            DamageTotal = MyCRI.BioGunHitCount[pid];
            ShotTotal = SD.BioGun + SC.BioGun;
            SD.BioGun = ShotTotal;
            CurrentAccuracy = DamageTotal / ShotTotal * 100;

            if (CurrentAccuracy < 0) CurrentAccuracy = 0;

            Acc.BioGun = CurrentAccuracy;
            SC.BioGun = 0;
            return Acc.BioGun;
            break;

        case "SHOCKRIFLE":
        case "ZP_SHOCKRIFLE":
            i = 0;

            if (W.AmmoType.AmmoAmount > AC.ShockRifle
            && (AC.ShockRifle != 0))
            {
                 i = W.AmmoType.AmmoAmount - AC.ShockRifle;
                 AC.ShockRifle += i;
                 return Acc.ShockRifle;
            }

            if (W.AmmoType.AmmoAmount < AC.ShockRifle
            && (AC.ShockRifle != 0))
                 SC.ShockRifle = AC.ShockRifle - W.AmmoType.AmmoAmount;

            AC.ShockRifle = W.AmmoType.AmmoAmount;
            DamageTotal = MyCRI.ShockRifleHitCount[pid];
            ShotTotal = SD.ShockRifle + SC.ShockRifle;
            SD.ShockRifle = ShotTotal;
            CurrentAccuracy = DamageTotal / ShotTotal * 100;

            if (CurrentAccuracy < 0) CurrentAccuracy = 0;

            Acc.ShockRifle = CurrentAccuracy;
            SC.ShockRifle = 0;
            return Acc.ShockRifle;
            break;

        case "PULSEGUN":
            i = 0;

            if (W.AmmoType.AmmoAmount > AC.PulseGun
            && (AC.PulseGun != 0))
            {
                 i = W.AmmoType.AmmoAmount - AC.PulseGun;
                 AC.PulseGun += i;
                 return Acc.PulseGun;
            }

            if (W.AmmoType.AmmoAmount < AC.PulseGun
            && (AC.PulseGun != 0))
                 SC.PulseGun = AC.PulseGun - W.AmmoType.AmmoAmount;

            AC.PulseGun = W.AmmoType.AmmoAmount;
            DamageTotal = MyCRI.PulseGunHitCount[pid];
            ShotTotal = SD.PulseGun + SC.PulseGun;
            SD.PulseGun = ShotTotal;
            CurrentAccuracy = DamageTotal / ShotTotal * 100;

            if (CurrentAccuracy < 0) CurrentAccuracy = 0;

            Acc.PulseGun = CurrentAccuracy;
            SC.PulseGun = 0;
            return Acc.PulseGun;
            break;

        case "RIPPER":
            i = 0;

            if (W.AmmoType.AmmoAmount > AC.Ripper
            && (AC.Ripper != 0))
            {
                i = W.AmmoType.AmmoAmount - AC.Ripper;
                AC.Ripper += i;
                return Acc.Ripper;
            }
            if (W.AmmoType.AmmoAmount < AC.Ripper
            && (AC.Ripper != 0))
                SC.Ripper = AC.Ripper - W.AmmoType.AmmoAmount;

            AC.Ripper = W.AmmoType.AmmoAmount;
            DamageTotal = MyCRI.RipperHitCount[pid];
            ShotTotal = SD.Ripper + SC.Ripper;
            SD.Ripper = ShotTotal;
            CurrentAccuracy = DamageTotal / ShotTotal * 100;

            if (CurrentAccuracy < 0) CurrentAccuracy = 0;

            Acc.Ripper = CurrentAccuracy;
            SC.Ripper = 0;
            return Acc.Ripper;
            break;

        case "MINIGUN2":
            i = 0;

            if (W.AmmoType.AmmoAmount > AC.MiniGun
            && (AC.MiniGun != 0))
            {
                i = W.AmmoType.AmmoAmount - AC.MiniGun;
                AC.MiniGun += i;
                return Acc.MiniGun;
            }

            if (W.AmmoType.AmmoAmount < AC.MiniGun
            && (AC.MiniGun != 0))
                SC.MiniGun = AC.MiniGun - W.AmmoType.AmmoAmount;

            AC.MiniGun = W.AmmoType.AmmoAmount;
            DamageTotal = MyCRI.MiniGunHitCount[pid];
            ShotTotal = SD.MiniGun + SC.MiniGun;
            SD.MiniGun = ShotTotal;
            CurrentAccuracy = DamageTotal / ShotTotal * 100;

            if (CurrentAccuracy < 0) CurrentAccuracy = 0;

            Acc.MiniGun = CurrentAccuracy;
            SC.MiniGun = 0;
            return Acc.MiniGun;
            break;

        case "UT_FLAKCANNON":
            i = 0;

            if (W.AmmoType.AmmoAmount > AC.FlakGun
            && (AC.FlakGun != 0))
            {
                i = W.AmmoType.AmmoAmount - AC.FlakGun;
                AC.FlakGun += i;
                return Acc.FlakGun;
            }

            if ( W.AmmoType.AmmoAmount < AC.FlakGun
            && ( AC.FlakGun != 0 ))
                SC.FlakGun = AC.FlakGun - W.AmmoType.AmmoAmount;

            AC.FlakGun = W.AmmoType.AmmoAmount;
            DamageTotal = MyCRI.FlakGunHitCount[pid];
            ShotTotal = SD.FlakGun + SC.FlakGun;
            SD.FlakGun = ShotTotal;
            CurrentAccuracy = DamageTotal / ShotTotal * 100;

            if (CurrentAccuracy < 0) CurrentAccuracy = 0;

            Acc.FlakGun = CurrentAccuracy;
            SC.FlakGun = 0;
            return Acc.FlakGun;
            break;

        case "UT_EIGHTBALL":
            i = 0;

            if (W.AmmoType.AmmoAmount > AC.EightBall
            && (AC.EightBall != 0))
            {
                i = W.AmmoType.AmmoAmount - AC.EightBall;
                AC.EightBall += i;
                return Acc.EightBall;
            }

            if (W.AmmoType.AmmoAmount < AC.EightBall
            && (AC.EightBall != 0))
                SC.EightBall = AC.EightBall - W.AmmoType.AmmoAmount;

            AC.EightBall = W.AmmoType.AmmoAmount;
            DamageTotal = MyCRI.EightBallHitCount[pid];
            ShotTotal = SD.EightBall + SC.EightBall;
            SD.EightBall = ShotTotal;
            CurrentAccuracy = DamageTotal / ShotTotal * 100;

            if (CurrentAccuracy < 0) CurrentAccuracy = 0;

            Acc.EightBall = CurrentAccuracy;
            SC.EightBall = 0;
            return Acc.EightBall;
            break;

         case caps(MyCRI.CustomWeaponName):
            if (MyCRI.bUsesCustomWeapon)
            {
                i = 0;

                if (W.AmmoType.AmmoAmount > AC.CustomWeapon
                && (AC.CustomWeapon != 0))
                {
                    i = W.AmmoType.AmmoAmount - AC.CustomWeapon;
                    AC.CustomWeapon += i;
                    return Acc.CustomWeapon;
                }

                if (W.AmmoType.AmmoAmount < AC.CustomWeapon
                && (AC.CustomWeapon != 0))
                    SC.CustomWeapon = AC.CustomWeapon - W.AmmoType.AmmoAmount;

                AC.CustomWeapon = W.AmmoType.AmmoAmount;
                DamageTotal = MyCRI.CustomWeaponHitCount[pid];
                ShotTotal = SD.CustomWeapon + SC.CustomWeapon;
                SD.CustomWeapon = ShotTotal;
                CurrentAccuracy = DamageTotal / ShotTotal * 100;

                if (CurrentAccuracy < 0) CurrentAccuracy = 0;

                Acc.CustomWeapon = CurrentAccuracy;
                SC.CustomWeapon = 0;
                return Acc.CustomWeapon;
            }
            break;

    }
    return rv;
}

//-------------------------------------
// DrawTeamCount
//-------------------------------------
simulated function DrawTeamCount(
    Canvas C,
    texture TeamBack,
    byte rts,
    byte bts,
    float Scale,
    byte AccuracyOrEffeciency)
{
    local float X, Y;
    local byte CanvasStyle;

	CanvasStyle = C.Style;
	C.Style = ERenderStyle.STY_Translucent;

    switch(AccuracyOrEffeciency)
    {
        case 0:
            Y = C.ClipY - (63.5 + WeaponDrawOffset) * Scale;
            break;
        case 1:
        case 2:
            Y = C.ClipY - (127 + WeaponDrawOffset) * Scale;
            break;

    }
	C.CurX = X;
	C.CurY = Y;

	if (rts != -1)
	{
	    C.DrawColor = RedColor;
	    C.SetPos(X, Y);
	    C.DrawTile(TeamBack, 128.00 * Scale, 64.00 * Scale, 0.00,0.00, 128.00, 64.00);
        C.DrawColor = WhiteColor;
        DrawBigNumber(C, Max(0, rts), X + 32 * Scale, Y + 16 * Scale, Scale, 1);
    }
    if (bts != -1)
	{
	    C.DrawColor = BlueColor;
	    Y = Y - 63.5 * Scale;
	    C.SetPos(X, Y);
	    C.DrawTile(TeamBack, 128.00 * Scale, 64.00 * Scale, 0.00, 0.00, 128.00, 64.00);
        C.DrawColor = WhiteColor;
        DrawBigNumber(C, Max(0, bts), X + 32 * Scale, Y + 16 * Scale, Scale, 1);
    }

    C.Style = CanvasStyle;
}

//-------------------------------------
// DrawAccuracy
//-------------------------------------
simulated function DrawAccuracy(
    Canvas C,
    byte i,
    texture AccuracyBack,
    float Scale,
    color HudColor)
{
	local float X, Y, YX;
    local byte CanvasStyle;

	CanvasStyle = C.Style;
	C.Style = ERenderStyle.STY_Translucent;

	Y = C.ClipY - (63.5 + WeaponDrawOffset) * Scale;
	C.CurX = X;
	C.CurY = Y;
	C.DrawColor = HudColor;

	C.SetPos(X, Y);
    C.DrawTile(AccuracyBack, 128.00 * Scale, 64.00 * Scale, 0.00, 0.00, 128.00, 64.00);
    C.DrawColor = WhiteColor;
    DrawBigNumber(C, Max(0, i), X + 24 * Scale, Y + 16 * Scale, Scale, 1);

    C.Style = CanvasStyle;
}

//-------------------------------------
// DrawEffeciency
//-------------------------------------
simulated function DrawEffeciency(
    Canvas C,
    texture text,
    int eff,
    float Scale,
    color HudColor)
{
	local float X, Y;
    local byte CanvasStyle;

	CanvasStyle = C.Style;
	C.Style = ERenderStyle.STY_Translucent;

	C.Style = Style;
	Y = C.ClipY - (63.5 + WeaponDrawOffset) * Scale;
	C.CurX = X;
	C.CurY = Y;
	C.DrawColor = HudColor;

    C.SetPos(X, Y);
    C.DrawTile(text, 128.00 * Scale, 64.00 * Scale, 0.00, 64.00, 128.00, 64.00);
    C.DrawColor = WhiteColor;
    DrawBigNumber(C, Max(0, eff), X + 24 * Scale, Y + 16 * Scale, Scale, 1);

    C.Style = CanvasStyle;
}

//-------------------------------------
// ResetAmmoCount
//-------------------------------------
simulated final function ResetAmmoCount()
{
    AC.Enforcer = 0;
    AC.BioGun = 0;
    AC.ShockRifle = 0;
    AC.PulseGun = 0;
    AC.Ripper = 0;
    AC.MiniGun = 0;
    AC.FlakGun = 0;
    AC.EightBall = 0;
    AC.SniperRifle = 0;
    AC.CustomWeapon = 0;
}

//-------------------------------------
// ResetScope
//-------------------------------------
simulated function ResetScope(PlayerPawn MyPlayer)
{
    if (MyPlayer != none)
        if (texture'RReticle'.USize == ReticleOut && (MyPlayer.DesiredFOV == MyPlayer.DefaultFOV))
            SetupReticle(0);
}

//-------------------------------------
// DrawReticle
//-------------------------------------
simulated function DrawReticle(
    Canvas C,
    PlayerPawn MyPlayer,
    string s,
    byte i,
    color CrossColor,
    color DotColor)
{
    local float Offset;
    local color CanvasColor;

    if (MyPlayer == none || (MyPlayer.Weapon == None) || (MyCRI == none))
        return;

    if (!PlayerPawn(Owner).IsA('Spectator'))
    {
        if (MyPlayer.DefaultFOV < 90)
        {
            switch(MyCRI.SetFOV)
            {
                case 1:
                    MyPlayer.DefaultFOV = 90;
                    MyPlayer.DesiredFOV = MyPlayer.DefaultFOV;
                    break;
            }
        }
    }

    if (MyPlayer.DesiredFOV == MyPlayer.DefaultFOV)  return;
    if (MyCRI.bLevelSwitch) MyPlayer.DesiredFOV = MyPlayer.DefaultFOV;

    if (i == 4)
    {
        SetupReticle(0);

        CanvasColor = C.DrawColor;
        Offset = C.ClipX / 640;
		C.SetPos(0.5 * C.ClipX - 128 * Offset, 0.5 * C.ClipY - 128 * Offset );
		C.Style = ERenderStyle.STY_Translucent;
		C.DrawColor = GreenColor;
		C.DrawIcon(texture'RReticle', Offset);
		C.DrawColor = CanvasColor;
        return;
    }

    if (i < 4)
    {
        SetupReticle(1);

        if (MyPlayer != none && (MyPlayer.DesiredFOV != MyPlayer.DefaultFOV))
	    {
            if (NewReticle == none)
            {
                ScopeMode = i;
                NewReticle =  texture(DynamicLoadObject(s, class'Texture'));
            }
            if (ScopeMode != i)
            {
                ScopeMode = i;
                NewReticle = texture(DynamicLoadObject(s, class'Texture'));
            }
            Offset = C.ClipX / 640;
		    C.SetPos(0.5 * C.ClipX - 128 * Offset, 0.5 * C.ClipY - 128 * Offset );
		    C.Style = ERenderStyle.STY_Translucent;
		    C.DrawColor = 15 * CrossColor;
		    C.DrawIcon(NewReticle, Offset);
		    C.DrawColor = CanvasColor;
		    return;
	    }
    }

    if(i > 4)
    {
        SetupReticle(1);

        if (MyPlayer != none
        && (MyPlayer.DesiredFOV != MyPlayer.DefaultFOV))
        {
            if (NewScopeReticle == none)
                NewScopeReticle = Texture(DynamicLoadObject(s, class'Texture'));

		    DrawNewScope(C, MyPlayer, CrossColor, DotColor);
		    return;
		}
    }
}


//-------------------------------------
// DrawNewScope
//-------------------------------------
simulated function DrawNewScope (
    Canvas C,
    PlayerPawn MyPlayer,
    color CrossColor,
    color DotColor)
{
    local float Offset, Range, X, Y, X1, Y1, X2, Y2, Y3, Fov;
    local vector HitLocation, HitNormal, StartTrace, EndTrace, xv, yv, zv;
    local float Radi;
    local font CanvasFont;
    local Actor A;

    C.DrawColor = 15 * CrossColor;
    CanvasFont = C.Font;

    X = C.ClipX / 401;
    Y = C.ClipY / 401;
    X1 = C.ClipX / 7;
    Y1 = C.ClipY / 7;
    X2 = C.ClipX / 9;
    Y2 = C.ClipY / 9;
    Y3 = C.ClipY / 1360;
    Fov = 90 - MyPlayer.DesiredFOV;

    if (Level.bHighDetailMode)
    {
        C.Style = ERenderStyle.STY_Modulated;
        C.SetPos(3 * X1 + C.ClipX / 601.5, 3 * Y1 + C.ClipY / 601.5);
        C.DrawTile(NewScopeReticle, X1 - 2 * C.ClipX / 601.5, Y1 - 2 * C.ClipY / 601.5, 220, 220, 0, 0 );
        C.Style = ERenderStyle.STY_Translucent;
    }
    else
        C.Style = ERenderStyle.STY_Translucent;

    C.SetPos(3 * X1, 3 * Y1);
    C.DrawTile(NewScopeReticle, X1, Y1, 0, 0, 256, 193);
    C.SetPos(200 * X, C.ClipY / 229 * (Fov)+ 0.6 * C.ClipY / 28);
    C.DrawTile(NewScopeReticle, X, C.ClipY / 28, 0, 20, 3, 10);
    C.SetPos(200 * X, 15.35 * C.ClipY / 28 + C.ClipY / 229 * MyPlayer.DesiredFOV);
    C.DrawTile(NewScopeReticle, X, C.ClipY / 28, 0, 20, 3, 10);
    C.SetPos(C.ClipX / 229 * (Fov) + 0.6 * C.ClipX / 28, 200 * Y);
    C.DrawTile(NewScopeReticle, C.ClipX / 28, Y, 10, 0, 10, 3);
    C.SetPos(15.35 * C.ClipX / 28 + C.ClipX / 229 * MyPlayer.DesiredFOV, 200 * Y );
    C.DrawTile(NewScopeReticle, C.ClipX / 28, Y, 10, 0, 10, 3);
    C.DrawColor =  DotColor;
    C.Style = ERenderStyle.STY_Normal;
    C.SetPos(199.5 * X, 199.5 * Y);
    C.DrawTile(NewScopeReticle, 2 * X, 2 * Y, 0, 202, 53, 53);
    C.DrawColor = 15 * CrossColor;
    C.Style = ERenderStyle.STY_Translucent;
    C.SetPos(200 * X, 4 * Y2);
    C.DrawTile(NewScopeReticle, X, Y3 * (Fov), 129, 197, 3, 54);
    C.SetPos(4 * X2, 200 * Y);
    C.DrawTile(NewScopeReticle, C.ClipX / 1360 * (Fov), Y, 69, 200, 54, 3);
    C.SetPos(200 * X, 5 * Y2 - Y3 * (Fov));
    C.DrawTile(NewScopeReticle, C.ClipX/401, C.ClipY/1360 * (Fov), 144, 199, 3, 54);
    C.SetPos(5 * X2 - C.ClipX / 1360 * (Fov), 200 * Y);
    C.DrawTile(NewScopeReticle, C.ClipX / 1360 * (Fov), Y, 163, 199, 54, 3);
    GetAxes(Pawn(owner).ViewRotation, xv, yv, zv);

    if ((Pawn(Owner).ViewRotation.Pitch >= 0)
    && (Pawn(Owner).ViewRotation.Pitch <= 18000))
        Radi = float(Pawn(Owner).ViewRotation.Pitch) / float(182) * (Pi / float(180));
    else
        Radi = float(Pawn(Owner).ViewRotation.Pitch - 65535) / float(182) * (Pi / float(180));

    StartTrace = Owner.Location + Pawn(Owner).EyeHeight * zv * cos(Radi);
    MyPlayer.Weapon.AdjustedAim = Pawn(owner).AdjustAim(1000000, StartTrace, 2.75 * MyPlayer.Weapon.AimError, False, False);
    EndTrace = StartTrace + (20000 * vector(MyPlayer.Weapon.AdjustedAim));
    A = Pawn(Owner).TraceShot(HitLocation, HitNormal, EndTrace, StartTrace);
    Range = Vsize(StartTrace - HitLocation) / 48 - 0.25;
    C.SetPos(202 * X - 50, 4 * Y1 + Y);
    C.Font = Font'Botpack.WhiteFont';
    C.DrawColor = DotColor;
    Offset = MyPlayer.DefaultFOV / MyPlayer.DesiredFOV;
    C.DrawText("X"$int(Offset)$"."$int(10 * Offset - 10 * int(Offset)));
    C.SetPos(202 * X, 4 * Y1 + Y);
    C.Font = Font'Botpack.WhiteFont';
    C.DrawText( "R: "$int(Range)$"."$int(10 * RANGE - 10 * int(RANGE))$"");
    C.Font = CanvasFont;
}

//-------------------------------------
// CheckKeyBindings
//-------------------------------------
simulated final function CheckKeyBindings()
{
    local int i;
    local string k;
    local string a, f;
    local bool bFound;
    local PlayerPawn PP;

    if (PlayerPawn(Owner) == none) return;

    bCheckKeyBindings = true;
    PP = PlayerPawn(Owner);
    MouseYCount = 0;

    for (i = 0; i < 255; i++)
    {
        k = PP.ConsoleCommand("KEYNAME "$i);
        if (k != "")
        {
            a = PP.ConsoleCommand("KEYBINDING "$k );

            if (a ~= "ShowStats") bFound = true;

            f = caps(a);

            if (instr(f,"AMOUSEY") != -1)
            {
                MouseYCount++;

                if (instr(f,"SPEED=") != -1)
                {
                    f = Mid(f, instr(f,"SPEED=") + 6);

                    if (MyCRI != none)
                        MyCRI.MouseYSetting = float(f);
                    else
                    {
                        MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
                        MyCRI.MouseYSetting = float(f);
                    }
                }
            }
        }
    }
    if (!bFound)
    {
        PP.ConsoleCommand("Set Input F3 ShowStats");
        PP.ClientMessage("ShowStats bound to F3");
    }
}

//-------------------------------------
// DrawDigit
//-------------------------------------
simulated function DrawDigit(
    Canvas C,
    int i,
    int x,
    float up,
    out byte bMin)
{
	if (bMin == 1)
	{
        C.CurX -= x;
		C.DrawTile(Texture'BotPack.HudElements1', up * 25, 64 * up, 0, 64, 25.0, 64.0);
		bMin= 0;
	}
	if (i == 1) C.CurX -= 0.625 * x;
	else C.CurX -= 0.25 * x;
	C.DrawTile(Texture'BotPack.HudElements1', up * 25, 64 * up, i * 25, 0, 25.0, 64.0);
	C.CurX += 7 * up;
}

//-------------------------------------
// DrawBigNumber
//-------------------------------------
simulated function DrawBigNumber(
    Canvas C,
    int val,
    int X,
    int Y,
    float Scale,
    optional float sf)
{
	local int i, max, step;
	local float _Scale;
	local byte bMin;

	if (sf != 0) _Scale = Scale * sf;
	else _Scale = Scale;

	C.CurX = X;
	C.CurY = Y;
	step = 16 * _Scale;
	if (val < 0) bMin = 1;
	max = FMin(9999, Abs(val));

	if (max >= 1000)
	{
		C.CurX -= step;
		i = 0.001 * max;
		DrawDigit(C, i, step, _Scale, bMin);
		max = max - 1000 * i;
		i = 0.01 * max;
		DrawDigit(C, i, step, _Scale, bMin);
		max = max - 100 * i;
	}
	else if (max >= 100)
	{
		i = 0.01 * max;
		DrawDigit(C, i, step, _Scale, bMin);
		max = max - 100 * i;
	}
	else C.CurX += step;

	if (max >= 10)
	{
		i = 0.1 * max;
		DrawDigit(C, i, step, _Scale, bMin);
		max = max - 10 * i;
	}
	else if (i > 0) DrawDigit(C, 0, step, _Scale, bMin);
	else C.CurX += step;

	DrawDigit(C, max, step, _Scale, bMin);
}

//-------------------------------------
// _GetItemName
//-------------------------------------
simulated function string _GetItemName(Weapon W)
{
    return caps(mid(string(W.Class), instr(string(W.Class), ".") + 1));
}

//-------------------------------------
// GetLastAccuracy
//-------------------------------------
simulated function byte GetLastAccuracy(string s)
{
    local byte rv;

    switch (s)
    {
        case "ZP_SUPERSHOCKRIFLE":
        case "SUPERSHOCKRIFLE":
           return Acc.SuperShockRifle;
           break;

        case "ZP_SNIPERRIFLE":
        case "SNIPERRIFLE":
            return Acc.SniperRifle;
            break;

        case "ENFORCER":
        case "DOUBLEENFORCER":
        case "ZP_ENFORCER":
            return Acc.Enforcer;
            break;

        case "UT_BIORIFLE":
            return Acc.BioGun;
            break;

        case "SHOCKRIFLE":
        case "ZP_SHOCKRIFLE":
            return Acc.ShockRifle;
            break;

        case "PULSEGUN":
            return Acc.PulseGun;
            break;

        case "RIPPER":
            return Acc.Ripper;
            break;

        case "MINIGUN2":
            return Acc.MiniGun;
            break;

        case "UT_FLAKCANNON":
            return Acc.FlakGun;
            break;

        case "UT_EIGHTBALL":
            return Acc.EightBall;
            break;
    }
    return rv;
}

//-------------------------------------
// FixPhysics
//-------------------------------------
simulated function FixPhysics(PlayerPawn MyPlayer)
{
    if (MyPlayer != none && (MyPlayer.Physics == PHYS_Walking))
    {
        if (MyPlayer.DodgeDir == DODGE_Active)
            MyPlayer.DodgeDir = DODGE_Done;
    }
}

//-------------------------------------
// CheckForAutoRecorder
//-------------------------------------
simulated final function CheckForAutoRecorder(PlayerPawn MyPlayer, byte i)
{
    local string s;

    bCheckForAutoRecorder = true;

    if (!MyPlayer.bClientDemoNetFunc)
        return;

    switch (i)
    {
        case -1:
        case 0:
            break;

        case 1:
            bDemoLoaded = true;
            s = LogDate()$"-"$MyPlayer.Level.Title;
            s = SterilizeString(s);
            MyPlayer.ConsoleCommand("demorec \""$s$"\"");
            break;

        case 2:
            bDemoLoaded = true;
            s = MyPlayer.Level.Title;
            s = SterilizeString(s);
            MyPlayer.ConsoleCommand("demorec \""$s$"\"");
            break;

        default:
            break;
    }
}

//-------------------------------------
// StopDemo
//-------------------------------------
simulated final function StopDemo(PlayerPawn MyPlayer)
{
    if (!bDemoLoaded && MyPlayer.bClientDemoNetFunc)
        return;

    MyPlayer.ConsoleCommand("stopdemo");
}

//-------------------------------------
// LogDate
//-------------------------------------
simulated function string LogDate()
{
	local string d, t;

	d = Level.Year$"-"$PrePad(Level.Month,"0",2)$"-"$PrePad(Level.Day,"0",2);
	t = PrePad(Level.Hour,"0",2)$":"$PrePad(Level.Minute,"0",2)$"."$PrePad(Level.Second,"0",2);
	return d@t;
}

//-------------------------------------
// PrePad
//-------------------------------------
simulated function string PrePad(coerce string rv, string p, int i)
{
	while (Len(rv) < i) rv = p$rv;
	return rv;
}

//-------------------------------------
// SterilizeString
//-------------------------------------
simulated function string SterilizeString(string s)
{
   local string rv;
   local int i;

	rv = "";

	for (i = 0; i < Len(s); i++)
	{
		if (InStr("\/*?:<>|"$Chr(34), Mid(s, i, 1)) != -1)
			rv = rv $ "_";
		else
			rv = rv $ Mid(s, i, 1);
	}
    return rv;
}

//-------------------------------------
// GetTime
//-------------------------------------
simulated function string GetTime(GameReplicationInfo GRI)
{
	local int Min, Sec;
	local string s;

	Min = GRI.RemainingTime;
	if (Min == 0) Min = MyCRI.RealTotalGameTime;
	Sec = Min % 60;
	Min = Min / 60;
	if (Min < 10) s = s$"0"$string(Min);
	else s = s$string(Min);
	if (Sec < 10) s = s$"0"$string(Sec);
    else s = s$string(Sec);

    return s;
}

//-------------------------------------
// GetTimeDigit 15 x 27  >> 4
//-------------------------------------
simulated function GetTimeDigit(string Dig, out float X, out float Y)
{
    switch (int(Dig))
    {
        case 0: X = 0;      Y = 128; break;
        case 1: X = 32;     Y = 128; break;
        case 2: X = 64;     Y = 128; break;
        case 3: X = 96;     Y = 128; break;
        case 4: X = 128;    Y = 128; break;
        case 5: X = 160;    Y = 128; break;
        case 6: X = 192;    Y = 128; break;
        case 7: X = 224;    Y = 128; break;
        case 8: X = 0;      Y = 192; break;
        case 9: X = 32;     Y = 192; break;
    }
}

//-------------------------------------
// SetupReticle
//-------------------------------------
simulated final function SetupReticle(byte i)
{
    switch(i)
    {
        case 0:
            texture'RReticle'.USize = ReticleSize;
            texture'RReticle'.VSize = ReticleSize;
            break;

        case 1:
            texture'RReticle'.USize = ReticleOut;
            texture'RReticle'.VSize = ReticleOut;
            break;
    }
}

//-------------------------------------
// ResetWeaponData
//-------------------------------------
simulated final function ResetWeaponData()
{
    SniperFireAnim0 = 0;
    SniperFireAnim1 = 0;
    SniperFireAnim2 = 0;
    SniperFireAnim3 = 0;
    SniperFireAnim4 = 0;
    SniperFireAnim5 = 0;
    AC.Enforcer = 0;
    AC.BioGun = 0;
    AC.ShockRifle = 0;
    AC.PulseGun = 0;
    AC.Ripper = 0;
    AC.MiniGun = 0;
    AC.FlakGun = 0;
    AC.EightBall = 0;
    AC.SniperRifle = 0;
    AC.CustomWeapon = 0;
    ShotTotal = 0;
    DamageTotal = 0;
    CurrentAccuracy = 0;
    SD.Enforcer = 0;
    SD.BioGun = 0;
    SD.ShockRifle = 0;
    SD.PulseGun = 0;
    SD.Ripper = 0;
    SD.MiniGun = 0;
    SD.FlakGun = 0;
    SD.EightBall = 0;
    SD.SniperRifle = 0;
    SD.SuperShockRifle = 0;
    SD.CustomWeapon = 0;
    Acc.Enforcer = 0;
    Acc.BioGun = 0;
    Acc.ShockRifle = 0;
    Acc.PulseGun = 0;
    Acc.Ripper = 0;
    Acc.MiniGun = 0;
    Acc.FlakGun = 0;
    Acc.EightBall = 0;
    Acc.SniperRifle = 0;
    Acc.SuperShockRifle = 0;
    Acc.CustomWeapon = 0;
    SC.Enforcer = 0;
    SC.BioGun = 0;
    SC.ShockRifle = 0;
    SC.PulseGun = 0;
    SC.Ripper = 0;
    SC.MiniGun = 0;
    SC.FlakGun = 0;
    SC.EightBall = 0;
    SC.SniperRifle = 0;
    SC.CustomWeapon = 0;
}

simulated final function bool IsUdemoSpectator(PlayerPawn P)
{
    if ( P != none
    && (!P.bCollideActors)
    && ( P.GetStateName() == 'CheatFlying')
    && ( caps(mid(string(P.Class), instr(string(P.Class), ".") + 1)) == "DEMOPLAYBACKSPEC"))
        return true;
    else
        return false;
}

//-------------------------------------
// defaultproperties
//-------------------------------------
defaultproperties
{
    YellowColor=(R=255,G=200,B=100,A=0),
    GreenColor=(R=20,G=255,B=20,A=0),
    WhiteColor=(R=255,G=255,B=255,A=0),
    GoldColor=(R=255,G=255,B=0,A=0),
    BlueColor=(R=0,G=0,B=255,A=0),
    LightCyanColor=(R=128,G=255,B=255,A=0),
    SilverColor=(R=138,G=164,B=166,A=0),
    BronzeColor=(R=203,G=147,B=52,A=0),
    CyanColor=(R=0,G=128,B=255,A=0),
    RedColor=(R=255,G=0,B=0,A=0),
    ShadeColor=(R=70,G=70,B=70,A=0),
    DarkRedColor=(R=5,G=0,B=0,A=0),
    DarkBlueColor=(R=0,G=0,B=5,A=0),
}
