/*
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
            EUTMultiKillMessage
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
*/

class EUTMultiKillMessage extends LocalMessagePlus;

var(Messages)	localized string 	DoubleKillString;
var(Messages)	localized string 	TripleKillString;
var(Messages)	localized string 	MultiKillString;
var(Messages)	localized string 	UltraKillString;
var(Messages)	localized string 	MonsterKillString;
var(Messages)	localized string 	MegaKillString;
var(Messages)	localized string 	LudcriousKillString;
var(Messages)	localized string 	HolyShitKillString;
var(Messages)	localized string 	AerialKillString;
var(Messages)	localized string 	EndRampageString;
var(Messages)	localized string 	EndDominatingString;
var(Messages)	localized string 	EndUnStoppableString;
var(Messages)	localized string 	EndGodlikeString;
var(Messages)	localized string 	EndOwnageString;
var(Messages)   localized string    EndKillingSpreeString;
var(Messages)	localized string 	EndRampageString2;
var(Messages)	localized string 	EndDominatingString2;
var(Messages)	localized string 	EndUnStoppableString2;
var(Messages)	localized string 	EndGodlikeString2;
var(Messages)	localized string 	EndOwnageString2;
var(Messages)   localized string    EndKillingSpreeString2;

var sound DoubleKillSound,
    MultiKillSound,
    MegaKillSound,
    UltraKillSound,
    MonsterKillSoundF,
    LudicriousKillSound,
    HolyShitKillSound,
    OwnageSound,
    FlakMonkeySound,
    HeadHunterSound,
    ComboWhoreSound,
    WhickedSickSound;


//-------------------------------------
// GetOffset
//-------------------------------------
static function float GetOffset(int i, float YL, float ClipY )
{
    if (i <= 19)
       return (Default.YPos/768.0) * ClipY + YL;

    if (i == 20)
        return ClipY - YL*4 - 0.0833*ClipY;

	if (i > 20)
	   return (Default.YPos/768.0) * ClipY;
}

//-------------------------------------
// GetFontSize
//-------------------------------------
static function int GetFontSize(int i)
{
	return Default.FontSize;
}

//-------------------------------------
// GetString
//-------------------------------------
static function string GetString(
	optional int i,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject)
{
    switch (i)
	{
        case 1: return Default.DoubleKillString; break;
		case 2: return Default.MultiKillString; break;
		case 3: return Default.MegaKillString; break;
		case 4: return Default.UltraKillString; break;
		case 5: return Default.MonsterKillString; break;
		case 6: return Default.LudcriousKillString; break;
		case 7:
		case 8:
		case 9:
		case 10:
		case 11:
		case 12:
		case 13:
		case 14:
		case 15:
		case 16:
		case 17:
		case 18:
		case 19: return Default.HolyShitKillString; break;
		case 20: return Default.AerialKillString; break;
        case 21: return Default.EndRampageString; break;
        case 22: return Default.EndDominatingString; break;
        case 23: return Default.EndUnStoppableString; break;
        case 24: return Default.EndGodlikeString; break;
        case 25: return Default.EndOwnageString; break;
        case 26: return Default.EndKillingSpreeString2; break;

	}
	return "";
}

//-------------------------------------
// ClientReceive
//-------------------------------------
static simulated function ClientReceive(
	PlayerPawn MyPlayer,
	optional int i,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject
	)
{
	Super.ClientReceive(MyPlayer, i, RelatedPRI_1, RelatedPRI_2, OptionalObject);

    switch (i)
	{
		case 1: TournamentPlayer(MyPlayer).ClientPlaySound(Default.DoubleKillSound,,true); break;
		case 2: TournamentPlayer(MyPlayer).ClientPlaySound(Default.MultiKillSound,,true); break;
		case 3: TournamentPlayer(MyPlayer).ClientPlaySound(Default.MegaKillSound,,true); break;
		case 4: TournamentPlayer(MyPlayer).ClientPlaySound(Default.UltraKillSound,,true); break;
		case 5: TournamentPlayer(MyPlayer).ClientPlaySound(Default.MonsterKillSoundF,,true); break;
		case 6: TournamentPlayer(MyPlayer).ClientPlaySound(Default.LudicriousKillSound,,true); break;
		case 7:
		case 8:
		case 9:
		case 10:
		case 11:
		case 12:
		case 13:
		case 14:
		case 15:
		case 16:
		case 17:
		case 18:
		case 19: TournamentPlayer(MyPlayer).ClientPlaySound(Default.HolyShitKillSound,,true); break;
        case 20: TournamentPlayer(MyPlayer).ClientPlaySound(Default.OwnageSound,true,true); break;
        case 101: TournamentPlayer(MyPlayer).ClientPlaySound(Default.FlakMonkeySound,,true); break;
        case 102: TournamentPlayer(MyPlayer).ClientPlaySound(Default.HeadHunterSound,true,true); break;
        case 103: TournamentPlayer(MyPlayer).ClientPlaySound(Default.ComboWhoreSound,true,true); break;
        case 104: TournamentPlayer(MyPlayer).ClientPlaySound(Default.WhickedSickSound,,true); break;
	}
}

//-------------------------------------
// GetBroadCastString
//-------------------------------------
static function string GetBroadCastString(
	optional int i,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject
	)
{
    switch (i)
	{
		case 1: return RelatedPRI_1.PlayerName@"Had A"@Default.DoubleKillString; break;
		case 2: return RelatedPRI_1.PlayerName@"Had A"@Default.MultiKillString; break;
		case 3: return RelatedPRI_1.PlayerName@"Had A"@Default.MegaKillString; break;
		case 4: return RelatedPRI_1.PlayerName@"Had A"@Default.UltraKillString; break;
		case 5: return RelatedPRI_1.PlayerName@"Had A"@Default.MonsterKillString; break;
		case 6: return RelatedPRI_1.PlayerName@"Had A"@Default.LudcriousKillString; break;
        case 7:
		case 8:
		case 9:
		case 10:
		case 11:
		case 12:
		case 13:
		case 14:
		case 15:
		case 16:
		case 17:
		case 18:
		case 19: return RelatedPRI_1.PlayerName@"Had A"@Default.HolyShitKillString; break;
        case 20: return RelatedPRI_1.PlayerName@"Had A"@Default.AerialKillString; break;
        case 21:
            if (RelatedPRI_2.PlayerName == RelatedPRI_1.PlayerName)
               return RelatedPRI_1.PlayerName@Default.EndRampageString2;
            else
               return RelatedPRI_2.PlayerName@Default.EndRampageString@RelatedPRI_1.PlayerName;
            break;
        case 22:
            if (RelatedPRI_2.PlayerName == RelatedPRI_1.PlayerName)
               return RelatedPRI_1.PlayerName@Default.EndDominatingString2;
            else
               return RelatedPRI_2.PlayerName@Default.EndDominatingString@RelatedPRI_1.PlayerName;
            break;
        case 23:
            if (RelatedPRI_2.PlayerName == RelatedPRI_1.PlayerName)
               return RelatedPRI_1.PlayerName@Default.EndUnStoppableString2;
            else
               return RelatedPRI_2.PlayerName@Default.EndUnStoppableString@RelatedPRI_1.PlayerName;
            break;
        case 24:
            if (RelatedPRI_2.PlayerName == RelatedPRI_1.PlayerName)
               return RelatedPRI_1.PlayerName@Default.EndGodlikeString2;
            else
               return RelatedPRI_2.PlayerName@Default.EndGodlikeString@RelatedPRI_1.PlayerName;
            break;
        case 25:
            if( RelatedPRI_2.PlayerName == RelatedPRI_1.PlayerName)
               return RelatedPRI_1.PlayerName@Default.EndOwnageString2;
            else
               return RelatedPRI_2.PlayerName@Default.EndOwnageString@RelatedPRI_1.PlayerName;
            break;
        case 26:
            if (RelatedPRI_2.PlayerName == RelatedPRI_1.PlayerName)
               return RelatedPRI_1.PlayerName@Default.EndKillingSpreeString2;
            else
               return RelatedPRI_2.PlayerName@Default.EndKillingSpreeString@RelatedPRI_1.PlayerName;
            break;
	}
}

//-------------------------------------
// defaultproperties
//-------------------------------------
defaultproperties
{
    DoubleKillString="Double Kill!"
    TripleKillString="Triple Kill!"
    MultiKillString="Multi Kill!"
    UltraKillString="ULTRA KILL!!"
    MonsterKillString="M O N S T E R  K I L L !!!"
    MegaKillString="MEGA KILL!!"
    LudcriousKillString="L U D I C R O U S K I L L!!!"
    HolyShitKillString="H O L Y  S H I T !"
    AerialKillString="AERIAL KILL!!"
    EndRampageString="'s Rampage Spree was ended by"
    EndDominatingString="'s Dominating Spree was ended by"
    EndUnStoppableString="'s UnStoppable Spree was ended by"
    EndGodlikeString="'s Godlike Spree was ended by"
    EndOwnageString="'s Ownage Spree was ended by"
    EndKillingSpreeString="'s Killing Spree was ended by"
    EndRampageString2=" was l337 and ended his own Rempage Spree"
    EndDominatingString2=" was l337 and ended his own Dominating Spree"
    EndUnStoppableString2=" was l337 and ended his own UnStoppable Spree"
    EndGodlikeString2=" was l337 and ended his own Godlike Spree"
    EndOwnageString2=" was l337 and ended his own Ownage Spree"
    EndKillingSpreeString2=" was l337 and ended his own Killing Spree"
    DoubleKillSound=Sound'EUT_Sounds.EUT.Double_Kill'
    MultiKillSound=Sound'Announcer.(All).multikill'
    UltraKillSound=Sound'Announcer.(All).ultrakill'
    MonsterKillSoundF=Sound'EUT_Sounds.EUT.MonsterKill_F'
    LudicriousKillSound=Sound'EUT_Sounds.EUT.LudicrousKill'
    HolyShitKillSound=Sound'EUT_Sounds.EUT.HolyShit_F'
    OwnageSound=Sound'EUT_Sounds.EUT.Ownage'
    FontSize=1
    bIsSpecial=True
    bIsUnique=True
    bFadeMessage=True
    DrawColor=(R=255,G=0,B=0,A=0),
    YPos=196.00
    bCenter=True
}
