/*
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
              EUTMutator
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
*/

class EUTMutator extends Mutator
config (EUTServer);

var DeathMatchPlus DMP;
var Decoration ReadyFlag;

var EUTMutatorHelper EMH;
var SmartCTFGame MyCTF;
var EUTTeamGamePlus MyTGP;
var EUTDeathMatchPlus MyDM;
var EUTGameLog gLog;
var EUTGameReplicationInfo MyCRI;
var Class<ServerInfo> MyServerInfo;

var int PlayerNetspeed[40], PlayerHeld[40];
var PlayerPawn PlayerList[40];
var EUTClientReplication PlayerRIList[40];
var vector PlayerVectorList[40];
var float PlayerLoginTime[40];

var string VersionStr,
    ThisVer;

var bool bCTF,
    bTDM,
    bDM,
    bCheckDefaults,
    bAutoTaunts,
    bReport,
    bRecordTourney,
    bDemoRequests,
    bKickMinY,
    bLogMods,
    bKickSpeedHack,
    bLogStarted,
    bNoFlockPawns;

var float MinY;

var globalconfig bool bPauseJoin;
var globalconfig float ClientLoginDelay;
var globalconfig string LogFolder;
var globalconfig string IllegalMods[100];
var globalconfig string AllowedMods[10];

const MaxArray = 40;
const SpecCounter = 10;
const MenuItem = ".EUTLockedMenuItem";
const SoFunny = "obj dependencies package=S_Swat";
const StillLaughing = "Dependencies of s_SWAT";
const OglLoadBias = "get OpenGLDrv.OpenGLRenderDevice lodbias" ;
const BotChair = "BotPack.Chair";
const Mousey = "get engine.input mousey";

//-------------------------------------
// PreBeginPlay
//-------------------------------------
function PreBeginPlay()
{
    local Class<ScoreBoard> sb;

    DMP = DeathMatchPlus(Level.Game);

	if (DMP == None) return;

	switch (DMP.HUDType)
	{
	    case Class'ChallengeCTFHUD': DMP.HUDType = Class'EUTCTFHud'; break;
	    case Class'ChallengeTeamHUD': DMP.HUDType = Class'EUTTDMHud'; break;
	    case class'ChallengeHud': DMP.HudType = class'EUTDMHud'; break;
	}

    Switch(Level.Game.Default.ScoreBoardType)
	{
       case Class'UnrealCTFScoreBoard': sb = Class'EUTCTFSB'; break;
       case Class'TeamScoreBoard': sb = Class'EUTTDMSB'; break;
       case class'TournamentScoreBoard': sb = class'EUTDMSB'; break;
       case Class'EUTCTFSB': sb = Class'EUTCTFSB'; break;
       case Class'EUTTDMSB': sb = Class'EUTTDMSB'; break;
       case Class'EUTDMSB': sb = Class'EUTDMSB'; break;
	}

	if (sb == None)
		log("Failed to load EUT ScoreBoard!"@Level.Game.ScoreBoardType,'EUTWarning');
	else
	{
		Level.Game.Default.ScoreBoardType = sb;
		Level.Game.ScoreBoardType = sb;
		log("ScoreBoard Loaded:"@sb,'EUT');
		log("Hud class Loaded :"@DMP.HudType,'EUT');
	}

    MyServerInfo = Class<ChallengeHUD>(DMP.HUDType).Default.ServerInfoClass;
    EMH = Level.Spawn(Class'EUTMutatorHelper');

    if (EMH != None)
    {
        EMH.MyMut = self;
        EMH.SetGameInfo();
    }
}

//-------------------------------------
// PostBeginPlay
//-------------------------------------
function PostBeginPlay()
{
    local ScrollingMessageTexture SMT;

    Super.PostBeginPlay();

    MyLog("*******************************************");
	MyLog("");
	MyLog("     ********************     ");
	MyLog("     *      "$VersionStr$"   *     ");
	MyLog("     *    Release "$ThisVer$"    *     ");
	MyLog("     ********************     ");
	MyLog("");
	MyLog("*******************************************");
	MyLog("");
	MyLog("Version ............................ "$VersionStr);
	MyLog("Version #............................"$ThisVer);

	if (bCTF) EMH.LogStartup(0);
    if (bTDM) EMH.LogStartup(1);
    if (bDM) EMH.LogStartup(2);

	Level.Game.RegisterMessageMutator(self);

	if (MyCRI == none) MyCRI = EUTGameReplicationInfo(Level.Game.GameReplicationInfo);

	foreach Level.AllActors(class'ScrollingMessageTexture', SMT)
	{
        if(SMT != none)
        {
            MyCRI.Scrollers[MyCRI.ScrollersCount] = SMT;
            MyCRI.ScrollersCount++;
        }
	}
}

//-------------------------------------
// Spawned
//-------------------------------------
simulated event Spawned()
{
	if (Level.NetMode == NM_Client)
		Spawn(Class'EUTDemoEnhancer');
}

//-------------------------------------
// Destroyed
//-------------------------------------
event Destroyed()
{
	Super.Destroyed();

    if (gLog!= None)
	{
		gLog.StopLog();
		gLog.Destroy();
		gLog = None;
	}
}
//-------------------------------------
// MyLog
//-------------------------------------
function MyLog(coerce string s)
{
    local Pawn P;

    if (bReport)
    {
        for (P = Level.PawnList; P != None; P = P.NextPawn)
            if (P.IsA('MessagingSpectator') )
                P.ClientMessage("[EUT]"@s, '');
	}
	Log(s,'EUT');
}

//-------------------------------------
// GameLog
//-------------------------------------
function GameLog(string s)
{
    local Pawn P;

	if (LogFolder != "")
	{
        if (gLog == none)
        {
            gLog = Spawn(class'EUTGameLog');
            gLog.LogFolder = LogFolder;
            gLog.StartLog();
        }
        else if (s != "****************************************")
        {
            gLog.LogEventString(s);
            gLog.FileFlush();
        }
	}

	if (bReport)
	{
	   for (P = Level.PawnList; P != None; P = P.NextPawn)
		  if (P.IsA('MessagingSpectator'))
			  P.ClientMessage("[EUT]"@s, '');
    }

	Log(s,'EUT');
}

//-------------------------------------
// Tick
//-------------------------------------
function Tick(float DeltaTime)
{
    local Pawn P;
	local int a, i;
	local EUTClientReplication CRI;
	local Inventory Inv;


    if (DMP == None)
        DMP = DeathMatchPlus(Level.Game);

    if (Level.Game.bGameEnded || Level.NextSwitchCountdown < 0.5)
	{
		if (gLog != None)
		{
            gLog.StopLog();
		    gLog.Destroy();
		    gLog = None;
		}
		if(MyCRI != none)
		    MyCRI.bLevelSwitch = true;
	}

    for (a = 0; a < MaxArray; a++)
	{
		P = PlayerList[a];
		CRI = PlayerRIList[a];

		if (((P == None) || (P.bDeleteMe)) && (CRI != None))
		{
			PlayerList[a] = None;
			PlayerRIList[a].Destroy();
			PlayerRIList[a] = None;
			PlayerHeld[a] = 0;
			PlayerVectorList[a] = vect(0,0,0);
			PlayerLoginTime[a] = 0;
			P.Destroy();
			P = None;
		}

		if (P != None && bPauseJoin && PlayerHeld[a] < 2 && !P.IsA('Spectator') && !MyCRI.bTournament)
		{
            if (PlayerLoginTime[a] > Level.TimeSeconds)
		    {
                if (PlayerHeld[a] == 0)
                {
                    PlayerList[a].Weapon = None;
                    PlayerList[a].SelectedItem = None;
				    for (Inv = PlayerList[a].Inventory; Inv != None; Inv = Inv.Inventory)
					   Inv.Destroy();

				    PlayerList[a].bHidden = true;
				    PlayerList[a].SetPhysics(PHYS_None);
				    PlayerList[a].SetCollision(false,false,false);
				    PlayerVectorList[a] = PlayerList[a].Location;
				    PlayerHeld[a] = 1;
				    P.Mesh = P.default.Mesh;
				    PlayerList[a].Health = 0;
				}
				else
				{
				    if (MyCRI != none && P.PlayerReplicationInfo != none)
                        MyCRI.PlayWaitMessage[P.PlayerReplicationInfo.PlayerID] = 1;
				    PlayerList[a].SetLocation(PlayerVectorList[a]);
				}
		    }
		    else if (MyCRI.bMatchStarted)
		    {
                PlayerHeld[a] = 2;
                PlayerList[a].SetPhysics(PHYS_Walking);
				PlayerList[a].Health = 0;
				Level.Game.RestartPlayer(PlayerList[a]);
				if (MyCRI != none && P.PlayerReplicationInfo != none)
                    MyCRI.PlayWaitMessage[P.PlayerReplicationInfo.PlayerID] = 0;
		    }
		    else if (!MyCRI.bMatchStarted)
		    {
		        PlayerList[a].Weapon = None;
                PlayerList[a].SelectedItem = None;
				for (Inv = PlayerList[a].Inventory; Inv != None; Inv = Inv.Inventory)
					Inv.Destroy();

				PlayerList[a].bHidden = true;
				PlayerList[a].SetPhysics(PHYS_None);
				PlayerList[a].SetCollision(false,false,false);
				PlayerList[a].Health = 0;
		    }
		}
    }

	for (P = Level.PawnList; P != None; P = P.NextPawn)
    {
        if (P.Isa('FlockPawn') && bNoFlockPawns)
        {
           Log(EMH.LogDate()@"Auto Destroying FlockPawn:"@P,'EUT');
           P.Destroy();
        }
        if (P.IsA('PlayerPawn')
        && (EMH.FindIndexPI(P) != -1))
		   EMH.VerifyHudType(P);


        if ((P.IsA('PlayerPawn'))
        && (NetConnection(PlayerPawn(P).Player) != none)
        && (!P.IsA('MessagingSpectator'))
        && (EMH.FindIndexPI(P) == -1))
		{
            a = 0;
			while ((a < MaxArray) && (PlayerList[a] != None))
			  a++;

			PlayerList[a] = PlayerPawn(P);
			PlayerHeld[a] = 0;

			CRI = Spawn(class'EUTClientReplication', P,, P.Location);
			if (CRI == None)
			    EMH.BaseLog(PlayerPawn(P), 2, "");

			else
			{
                if (!P.IsA('Spectator'))
                    EMH.BaseLog(PlayerPawn(P), 0, "");

                if (P.IsA('Spectator'))
			    {
			        CRI.bSPECTATOR = true;
			        EMH.BaseLog(PlayerPawn(P), 1, "");
                }

                PlayerRIList[a] = CRI;
				PlayerNetspeed[a] = 0;
				PlayerLoginTime[a] = Level.TimeSeconds + ClientLoginDelay;
				CRI.bCheckTweaks = bCheckDefaults;
				CRI.SpecCounter = SpecCounter;
				CRI.MouseSetting = Mousey;
				CRI.LockedMenu = MenuItem;
	            CRI.Stitches = SoFunny;
                CRI.Floor = StillLaughing;
                CRI.LodBias = OglLoadBias;
                CRI.VersString = VersionStr;
                CRI.ThisVer = ThisVer;
                CRI.bAutoTaunts = bAutoTaunts;

                for (i = 0; i < 10; i++)
				   CRI.AllowedMods[i] = AllowedMods[i];

	            CRI.BotChair = BotChair;
	            CRI.bTDM = bTDM;
	            CRI.bCTF = bCTF;
	            CRI.bDM = bDM;
	            CRI.MyMut = self;

	            if (P.PlayerReplicationInfo.PlayerID > 32)
	               EMH.SetNewPlayerId(P);
			}
		}
	}
}

//-------------------------------------
// LogModItems
//-------------------------------------
function bool LogModItems(PlayerPawn MyPlayer, string Mods)
{
    local int z, i;
    local string s, v;

    if (MyPlayer == None) return false;
    if (bLogMods) EMH.BaseLog(MyPlayer,4,Mods);
    z = instr(Mods,".");

   	if (z != -1)
    {
       s = left(Mods, 250);
       z = instr(Mods, ".");
       s = mid(s, z + 1);
       z = instr(s,".");
       v = right(s, 250);

       for (i = 0;  i < 100; i++)
       {
           if (len(IllegalMods[i]) == 0) continue;
           if (IllegalMods[i] ~= v)
           {
               EMH.LogInfraction(MyPlayer, 1, "IM", v);
               return true;
           }
       }
    }
}

//-------------------------------------
// ValidateFace
//-------------------------------------
function ValidateFace(PlayerPawn MyPlayer, string Face)
{
    if (MyPlayer == None) return;

    if (instr(Face, ".") != -1 )
    {
       Face = mid(Face, instr(Face, ".") + 1);
       if (caps(Face) == "IVAN" )
          EMH.LogInfraction(MyPlayer, 2, "IV", Face);
    }
}

//-------------------------------------
// LogInfraction
//-------------------------------------
function LogInfraction(PlayerPawn MyPlayer, byte Offense, string Code, string Opt)
{
    if (MyPlayer == None) return;
    EMH.LogInfraction(MyPlayer, Offense, Code, Opt);
}

//-------------------------------------
// sLogPass
//-------------------------------------
function sLogPass(PlayerPawn MyPlayer, byte v, string s)
{
    if (MyPlayer == None) return;
    EMH.BaseLog(MyPlayer, v, s);
}

//-------------------------------------
// SendTime
//-------------------------------------
function SendTime(PlayerPawn MyPlayer)
{
   if (MyPlayer == None) return;
   PlayerRIList[EMH.FindIndexPRI(MyPlayer)].ServerTime = Level.TimeSeconds;
}

//-------------------------------------
// VerifySpectator
//-------------------------------------
function VerifySpectator(PlayerPawn MyPlayer)
{
   if (MyPlayer == None) return;
   if ( !MyPlayer.IsA('Spectator') )
        EMH.LogInfraction(MyPlayer, 12, "SP", "");
}

//-------------------------------------
// RecieveGameData
//-------------------------------------
function RecieveGameData(
    PlayerPawn MyPlayer,
    byte Mode,
    byte hs,
    byte ea,
    byte ba,
    byte sa,
    byte pa,
    byte ra,
    byte ma,
    byte fa,
    byte roa,
    byte sna,
    byte ia,
    byte ca,
    byte mc,
    float mmy)
{
    local private int pid;

    if (MyCRI == none) MyCRI = EUTGameReplicationInfo(Level.Game.GameReplicationInfo);
    if (MyPlayer == none || (MyCRI == none)) return;
    if (MyPlayer.PlayerReplicationInfo == none) return;

    pid = MyPlayer.PlayerReplicationInfo.PlayerID;

    if (mc > 1) EMH.LogInfraction(MyPlayer, 13, "YM", string(mc));

    switch (Mode)
    {
        case 1:
        case 2:
        case 3:
            MyCRI.ClientHitSound[pid] = hs;
            if (mmy < MinY && bKickMinY) EMH.LogInfraction(MyPlayer, 13, "MV", string(mmy));
            MyCRI.PlayerAccuracy1[pid].Enforcer = ea;
            MyCRI.PlayerAccuracy1[pid].BioGun = ba;
            MyCRI.PlayerAccuracy1[pid].ShockRifle = sa;
            MyCRI.PlayerAccuracy2[pid].MiniGun = ma;
            MyCRI.PlayerAccuracy2[pid].PulseGun = pa;
            MyCRI.PlayerAccuracy2[pid].Ripper = ra;
            MyCRI.PlayerAccuracy3[pid].EightBall = roa;
            MyCRI.PlayerAccuracy3[pid].FlakCannon = fa;
            MyCRI.PlayerAccuracy3[pid].SniperRifle = sna;
            MyCRI.PlayerAccuracy3[pid].InstaGib = ia;
            MyCRI.PlayerAccuracy4[pid].CustomWeapon = ca;
            break;
    }
}

//-------------------------------------
// Mutate
//-------------------------------------
function Mutate(string ms, PlayerPawn sender)
{
    local string filename;
    local string date;

    Super.Mutate(ms, sender);

    date = EMH.LogDate();

    if (Left(ms, 10) ~= "SERVERDEMO")
	{
	    if (Level.bDemoRecording)
        {
	        sender.ClientMessage("DemoRecording already in session");
	        return;
	    }
	    if(!bDemoRequests)
        {
            sender.ClientMessage("DemoRecording Requests Turned Off");
            return;
        }
        if (EMH.IsLevelActive()
        && (!Level.bDemoRecording)
        && (bDemoRequests))
        {
            filename = Mid(ms, 11);
            filename = date$filename;
            filename = EMH.SterilizeString(filename);
            Level.ConsoleCommand("demorec \""$filename$"\"");
            MyLog("DemoRec: DemoRec initiated by:"$sender.PlayerReplicationInfo.PlayerName);
            sender.ClientMessage("Demorecording Initiated");
		}
    }
}

//-------------------------------------
// Timer
//-------------------------------------
function Timer()
{
	local Pawn P;
    local string date;

    date = EMH.LogDate();

    if (ReadyFlag != None)
	{
		if (Level.Game.IsA('DeathMatchPlus'))
		{
			if (DMP.CountDown > 0  &&  DMP.bTournament)
			{
				for (P = Level.PawnList; P != None; P = P.NextPawn)
				{
 					 if (P.IsA('PlayerPawn')
                     && (!P.IsA('Spectator'))
                     && (PlayerPawn(P).bReadyToPlay)
                     && (P.PlayerReplicationInfo.HasFlag == None))
				          P.PlayerReplicationInfo.HasFlag = ReadyFlag;
				}
			}
			else
			{
				for (P = Level.PawnList; P != None; P = P.NextPawn)
					P.PlayerReplicationInfo.HasFlag = None;

				if (ReadyFlag != None) ReadyFlag.Destroy();

				ReadyFlag = None;
				SetTimer(0, False);

				if (bRecordTourney && !Level.bDemoRecording)
				{
				    Level.ConsoleCommand("demorec \""$date$"-"$Level.Title$"\"");
                    MyLog("DemoRec: DemoRec initiated by: auto Recorder");
                }
			}
		}
	}
}


//-------------------------------------
// MutatorBroadcastLocalizedMessage
//-------------------------------------
function bool MutatorBroadcastLocalizedMessage( Actor Sender, Pawn Receiver, out class<LocalMessage> Message, out optional int Switch, out optional PlayerReplicationInfo RelatedPRI_1, out optional PlayerReplicationInfo RelatedPRI_2, out optional Object OptionalObject )
{
	if (bCTF && (MyCTF != none) && (MyCTF.bNoDroppedFlags))
	{
        if (Message == Class'CTFMessage' && Switch == 2)
    	{
            if (Receiver.PlayerReplicationInfo != none)
            {
                if (RelatedPRI_1.PlayerName == Receiver.PlayerReplicationInfo.PlayerName)
                {
                    if (RelatedPRI_1.HasFlag != none)
                    {
                        MyCTF.FlagToReturn = CTFFlag(RelatedPRI_1.HasFlag);
                        MyCTF.FlagDropper = Receiver;
                    }
                }
            }
    	}
    }

    if ( NextMessageMutator != None )
		return NextMessageMutator.MutatorBroadcastLocalizedMessage( Sender, Receiver, Message, Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject );
	else
		return true;
}

//-------------------------------------
// defaultproperties
//-------------------------------------
defaultproperties
{
    VersionStr="EUT"
    ThisVer="Source"
}
