/*
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
             EUTMutatorHelper
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
*/

class EUTMutatorHelper extends Info;

var EUTMutator MyMut;

var ListItem iMutators;
var ListItem eMutators;

const MaxArray = 40;

//-------------------------------------
// SetGameInfo
//-------------------------------------
function SetGameInfo()
{
    MyMut.bCTF = false;
    MyMut.bTDM = false;
    MyMut.bDM = false;

    if (Level.Game.IsA('SmartCTFGame'))
    {
         MyMut.bCTF = true;
         MyMut.MyCTF = SmartCTFGame(level.Game);
         if (MyMut.MyCTF.bTournament)
	     {
		     CreateTournamentFlag();
		     MyMut.Timer();
		     MyMut.SetTimer(0.333, True);
	     }
	     return;
    }
    if (Level.Game.IsA('EUTTeamGamePlus')
    && (!Level.Game.IsA('CTFGame')))
    {
         MyMut.bTDM = true;
         MyMut.MyTGP = EUTTeamGamePlus(level.game);
         if (MyMut.MyTGP.bTournament)
	     {
		      CreateTournamentFlag();
		      MyMut.Timer();
		      MyMut.SetTimer(0.333, True);
	     }
	     return;
    }
    if (Level.Game.IsA('EUTDeathMatchPlus')
    && (!Level.Game.IsA('CTFGame'))
    && (!Level.Game.IsA('TeamGamePlus')))
    {
         MyMut.bDM = true;
         MyMut.MyDM = EUTDeathMatchPlus(level.game);
         if (MyMut.MyDM.bTournament)
	     {
		      CreateTournamentFlag();
		      MyMut.Timer();
		      MyMut.SetTimer(0.333, True);
	     }
	     return;
    }
    if (!MyMut.bCTF && !MyMut.bTDM && !MyMut.bDM)
        CheckRestart();
}

//-------------------------------------
// CheckRestart
//-------------------------------------
function CheckRestart()
{
    if (Level.Game.IsA('CTFGame')
    && (!Level.Game.IsA('SmartCTFGame')))
    {
         LoadMutators();
         Level.ServerTravel(Left(string(Level), InStr(string(Level), "."))$".unr"$"?game="$"EUTSource.SmartCTFGame"$"?mutator="$UsedMutators(),false);
         Log("Level Restart to Authorized CTF Gametype",'EUTWarning');
         return;
    }
    if (Level.Game.IsA('TeamGamePlus')
    && (!Level.Game.IsA('CTFGame'))
    && (!Level.Game.IsA('SmartCTFGame'))
    && (!Level.Game.IsA('EUTTeamGamePlus')))
    {
         LoadMutators();
         Level.ServerTravel(Left(string(Level), InStr(string(Level), "."))$".unr"$"?game="$"EUTSource.EUTTeamGamePlus"$"?mutator="$UsedMutators(),false);
         Log("Level Restart to Authorized TDM Gametype",'EUTWarning');
         return;
    }
    if (Level.Game.IsA('DeathMatchPlus')
    && (!Level.Game.IsA('SmartCTFGame'))
    && (!Level.Game.IsA('EUTTeamGamePlus'))
    && (!Level.Game.IsA('EUTDeathMatchPlus')))
    {
         LoadMutators();
         Level.ServerTravel(Left(string(Level), InStr(string(Level), "."))$".unr"$"?game="$"EUTSource.EUTDeathMatchPlus"$"?mutator="$UsedMutators(),false);
         Log("Level Restart to Authorized DM Gametype",'EUTWarning');
         return;
    }
}

//-------------------------------------
// CreateTournamentFlag
//-------------------------------------
final function CreateTournamentFlag()
{
	local Actor A;

	MyMut.ReadyFlag = Spawn(class'EUTReadyFlag');
	if (MyMut.ReadyFlag != None) return;

	foreach AllActors(class'Actor', A)
	{
		MyMut.ReadyFlag = Spawn(class'EUTReadyFlag', None,, A.Location);
		if (MyMut.ReadyFlag != None) return;
	}
}

//-------------------------------------
// LoadMutators
//-------------------------------------
function LoadMutators()
{
	local int z;
	local string next, desc;
	local ListItem Item;
	local Mutator M;
	local byte i;

	eMutators = None;
	Level.GetNextIntDesc("Engine.Mutator", 0, next, desc);

	while((next != "") && (z < 250))
	{
		Item = new(None) class'ListItem';
		i = InStr(desc, ",");

		if (i == -1) Item.Tag = desc;
		else Item.Tag = Left(desc, i);

		Item.Data = next;

		if (eMutators == None) eMutators = Item;
		else eMutators.AddSortedElement(eMutators, Item);

		z++;
		Level.GetNextIntDesc("Engine.Mutator", z, next, desc);
	}

	iMutators = None;

	for (M = Level.Game.BaseMutator.NextMutator; M != None; M = M.NextMutator)
    {
		Item = eMutators.DeleteElement(eMutators, String(M.Class));

		if (Item != None)
        {
			if (iMutators == None) iMutators = Item;
			else iMutators.AddElement(Item);
		}
		else
			Log("Unknown Mutator in use: "@String(M.Class),'EUTWarning');
	}
}

//-------------------------------------
// UsedMutators
//-------------------------------------
function String UsedMutators()
{
	local ListItem Item;
	local string rv;

	if (iMutators == None) return "";
	rv = iMutators.Data;

	for (Item = iMutators.Next; Item != None; Item = Item.Next)
		rv = rv$","$Item.Data;

	return rv;
}

//-------------------------------------
// LogStartup
//-------------------------------------
function LogStartup(byte Mode)
{
    switch (Mode)
    {
        case 0:
            MyMut.MyCRI = EUTGameReplicationInfo(Level.Game.GameReplicationInfo);
            MyMut.MyLog("Check Defaults/Tweaking.............."$MyMut.MyCTF.default.bCheckDefaults);
    	    MyMut.MyLog("Log/Check Mod Items.................."$MyMut.MyCTF.default.bLogMods);
    	    MyMut.MyLog("EnhancedSprees ......................"$MyMut.MyCTF.default.bEnhancedSprees);
    	    MyMut.MyLog("EnhancedMessages....................."$MyMut.MyCTF.default.bEnhancedMessages);
    	    MyMut.MyLog("EnhancedDeathMessages................"$MyMut.MyCTF.default.bEnhancedDeathMessages);
    	    MyMut.MyLog("ShowIPS.............................."$MyMut.MyCTF.default.bShowIPS);
    	    MyMut.MyLog("HitSounds...... ....................."$MyMut.MyCTF.default.bHitSounds);
    	    MyMut.MyLog("Demo Requests........................"$MyMut.MyCTF.default.bDemoRequest);
    	    MyMut.MyLog("AnnouncerLevel......................."$MyMut.MyCTF.default.AnnouncerLevel);
    	    MyMut.MyLog("Max Trace............................"$MyMut.MyCTF.default.TraceDistance);
    	    MyMut.MyLog("Team Beacons........................."$MyMut.MyCTF.default.bTeamBeacon);
    	    MyMut.MyLog("Min Mouse Y.........................."$MyMut.MyCTF.default.MinY);
    	    MyMut.MyLog("Kick Speed Hack......................"$MyMut.MyCTF.default.bKickSpeedHack);
    	    MyMut.MyLog("Report Messages......................"$MyMut.MyCTF.default.bReport);
    	    MyMut.MyLog("Auto Taunts.........................."$MyMut.MyCTF.default.bAutoTaunts);
    	    MyMut.MyLog("AntiTimer............................"$MyMut.MyCTF.default.bAntiTimer);
    	    MyMut.MyLog("Stat Link............................"$MyMut.MyCTF.default.bStatLink);
    	    MyMut.MyLog("Auto Record Tourney.................."$MyMut.MyCTF.default.bAlwaysRecordTourney);
    	    MyMut.MyLog("Kick MinY............................"$MyMut.MyCTF.default.bKickMinY);
    	    MyMut.MyLog("No Overtime.........................."$MyMut.MyCTF.default.bNoOverTime);
    	    MyMut.MyLog("IpToCountry.........................."$MyMut.MyCTF.default.bIpToCountry);
    	    MyMut.MyLog("bUsesCustomWeapon...................."$MyMut.MyCTF.default.bUsesCustomWeapon);
    	    MyMut.MyLog("bNoFlockPawns........................"$MyMut.MyCTF.default.bNoFlockPawns);
    	    MyMut.MyLog("bNoDroppedFlags......................"$MyMut.MyCTF.default.bNoDroppedFlags);
    	    MyMut.MyLog("bPauseJoin..........................."$MyMut.default.bPauseJoin);
    	    MyMut.MyLog("");
    	    MyMut.MyLog("CTF.....:"$MyMut.bCTF);
	        MyMut.MyLog("TDM.....:"$MyMut.bTDM);
	        MyMut.MyLog("DM......:"$MyMut.bDM);
	        MyMut.MyLog("*******************************************");
    	    AssignGameBools(Mode);
            break;

        case 1:
            MyMut.MyCRI = EUTGameReplicationInfo(Level.Game.GameReplicationInfo);
            MyMut.MyLog("Check Defaults/Tweaking.............."$MyMut.MyTGP.default.bCheckDefaults);
    	    MyMut.MyLog("Log/Check Mod Items.................."$MyMut.MyTGP.default.bLogMods);
    	    MyMut.MyLog("EnhancedSprees ......................"$MyMut.MyTGP.default.bEnhancedSprees);
    	    MyMut.MyLog("EnhancedMessages....................."$MyMut.MyTGP.default.bEnhancedMessages);
    	    MyMut.MyLog("ShowIPS.............................."$MyMut.MyTGP.default.bShowIPS);
    	    MyMut.MyLog("HitSoundSounds ......................"$MyMut.MyTGP.default.bHitSounds);
    	    MyMut.MyLog("Demo Requests........................"$MyMut.MyTGP.default.bDemoRequest);
    	    MyMut.MyLog("AnnouncerLevel ......................"$MyMut.MyTGP.default.AnnouncerLevel);
    	    MyMut.MyLog("Max Trace............................"$MyMut.MyTGP.default.TraceDistance);
    	    MyMut.MyLog("Team Beacons........................."$MyMut.MyTGP.default.bTeamBeacon);
    	    MyMut.MyLog("Min Mouse Y.........................."$MyMut.MyTGP.default.MinY);
    	    MyMut.MyLog("Kick Speed Hack......................"$MyMut.MyTGP.default.bKickSpeedHack);
    	    MyMut.MyLog("Report Messages......................"$MyMut.MyTGP.default.bReport);
    	    MyMut.MyLog("Auto Taunts.........................."$MyMut.MyTGP.default.bAutoTaunts);
            MyMut.MyLog("AntiTimer............................"$MyMut.MyTGP.default.bAntiTimer);
            MyMut.MyLog("Stat Link............................"$MyMut.MyTGP.default.bStatLink);
    	    MyMut.MyLog("Auto Record Tourney.................."$MyMut.MyTGP.default.bAlwaysRecordTourney);
    	    MyMut.MyLog("Kick MinY............................"$MyMut.MyTGP.default.bKickMinY);
    	    MyMut.MyLog("No Overtime.........................."$MyMut.MyTGP.default.bNoOverTime);
    	    MyMut.MyLog("IpToCountry.........................."$MyMut.MyTGP.default.bIpToCountry);
    	    MyMut.MyLog("bUsesCustomWeapon...................."$MyMut.MyTGP.default.bUsesCustomWeapon);
    	    MyMut.MyLog("bSuddenDeathOverTime................."$MyMut.MyTGP.default.bSuddenDeathOverTime);
    	    MyMut.MyLog("bNoFlockPawns........................"$MyMut.MyTGP.default.bNoFlockPawns);
    	    MyMut.MyLog("bPauseJoin..........................."$MyMut.default.bPauseJoin);
    	    MyMut.MyLog("");
    	    MyMut.MyLog("CTF.....:"$MyMut.bCTF);
	        MyMut.MyLog("TDM.....:"$MyMut.bTDM);
	        MyMut.MyLog("DM......:"$MyMut.bDM);
	        MyMut.MyLog("*******************************************");
    	    AssignGameBools(Mode);
            break;

        case 2:
            MyMut.MyCRI = EUTGameReplicationInfo(Level.Game.GameReplicationInfo);
            MyMut.MyLog("Check Defaults/Tweaking.............."$MyMut.MyDM.default.bCheckDefaults);
	        MyMut.MyLog("Log/Check Mod Items.................."$MyMut.MyDM.default.bLogMods);
    	    MyMut.MyLog("EnhancedSprees ......................"$MyMut.MyDM.default.bEnhancedSprees);
    	    MyMut.MyLog("EnhancedMessages....................."$MyMut.MyDM.default.bEnhancedMessages);
    	    MyMut.MyLog("ShowIPS.............................."$MyMut.MyDM.default.bShowIPS);
    	    MyMut.MyLog("HitSoundSounds ......................"$MyMut.MyDM.default.bHitSounds);
    	    MyMut.MyLog("Demo Requests........................"$MyMut.MyDM.default.bDemoRequest);
    	    MyMut.MyLog("AnnouncerLevel ......................"$MyMut.MyDM.default.AnnouncerLevel);
    	    MyMut.MyLog("Max Trace............................"$MyMut.MyDM.default.TraceDistance);
    	    MyMut.MyLog("Team Beacons........................."$MyMut.MyDM.default.bLeaderBeacon);
    	    MyMut.MyLog("Min Mouse Y.........................."$MyMut.MyDM.default.MinY);
    	    MyMut.MyLog("Kick Speed Hack......................"$MyMut.MyDM.default.bKickSpeedHack);
    	    MyMut.MyLog("Report Messages......................"$MyMut.MyDM.default.bReport);
    	    MyMut.MyLog("Auto Taunts.........................."$MyMut.MyDM.default.bAutoTaunts);
    	    MyMut.MyLog("AntiTimer............................"$MyMut.MyDM.default.bAntiTimer);
    	    MyMut.MyLog("Stat Link............................"$MyMut.MyDM.default.bStatLink);
    	    MyMut.MyLog("Auto Record Tourney.................."$MyMut.MyDM.default.bAlwaysRecordTourney);
    	    MyMut.MyLog("Kick MinY............................"$MyMut.MyDM.default.bKickMinY);
    	    MyMut.MyLog("No Overtime.........................."$MyMut.MyDM.default.bNoOverTime);
    	    MyMut.MyLog("IpToCountry.........................."$MyMut.MyDM.default.bIpToCountry);
    	    MyMut.MyLog("bUsesCustomWeapon...................."$MyMut.MyDM.default.bUsesCustomWeapon);
    	    MyMut.MyLog("bNoFlockPawns........................"$MyMut.MyDM.default.bNoFlockPawns);
    	    MyMut.MyLog("bPauseJoin..........................."$MyMut.default.bPauseJoin);
    	    MyMut.MyLog("");
    	    MyMut.MyLog("CTF.....:"$MyMut.bCTF);
	        MyMut.MyLog("TDM.....:"$MyMut.bTDM);
	        MyMut.MyLog("DM......:"$MyMut.bDM);
	        MyMut.MyLog("*******************************************");
    	    AssignGameBools(Mode);
            break;
    }
}

//-------------------------------------
// AssignGameBools
//-------------------------------------
function AssignGameBools(byte Mode)
{
    switch (Mode)
    {
        case 0:
            MyMut.bCheckDefaults = MyMut.MyCTF.default.bCheckDefaults;
    	    MyMut.bAutoTaunts = MyMut.MyCTF.default.bAutoTaunts;
    	    MyMut.bReport = MyMut.MyCTF.default.bReport;
    	    MyMut.bRecordTourney = MyMut.MyCTF.default.bAlwaysRecordTourney;
    	    MyMut.bDemoRequests = MyMut.MyCTF.default.bDemoRequest;
    	    MyMut.bKickMinY = MyMut.MyCTF.default.bKickMinY;
    	    MyMut.bLogMods = MyMut.MyCTF.default.bLogMods;
    	    MyMut.bKickSpeedHack = MyMut.MyCTF.Default.bKickSpeedHack;
    	    MyMut.MinY = MyMut.MyCTF.default.MinY;
    	    MyMut.bNoFlockPawns = MyMut.MyCTF.default.bNoFlockPawns;
            break;
        case 1:
            MyMut.bCheckDefaults = MyMut.MyTGP.default.bCheckDefaults;
    	    MyMut.bAutoTaunts = MyMut.MyTGP.default.bAutoTaunts;
    	    MyMut.bReport = MyMut.MyTGP.default.bReport;
    	    MyMut.bRecordTourney = MyMut.MyTGP.default.bAlwaysRecordTourney;
    	    MyMut.bDemoRequests = MyMut.MyTGP.default.bDemoRequest;
    	    MyMut.bKickMinY = MyMut.MyTGP.default.bKickMinY;
    	    MyMut.bLogMods = MyMut.MyTGP.default.bLogMods;
    	    MyMut.bKickSpeedHack = MyMut.MyTGP.Default.bKickSpeedHack;
    	    MyMut.MinY = MyMut.MyTGP.default.MinY;
    	    MyMut.bNoFlockPawns = MyMut.MyTGP.default.bNoFlockPawns;
            break;
        case 2:
            MyMut.bCheckDefaults =  MyMut.MyDM.default.bCheckDefaults;
	        MyMut.bAutoTaunts =  MyMut.MyDM.default.bAutoTaunts;
	        MyMut.bReport =  MyMut.MyDM.default.bReport;
	        MyMut.bRecordTourney =  MyMut.MyDM.default.bAlwaysRecordTourney;
	        MyMut.bDemoRequests =  MyMut.MyDM.default.bDemoRequest;
	        MyMut.bKickMinY =  MyMut.MyDM.default.bKickMinY;
	        MyMut.bLogMods =  MyMut.MyDM.default.bLogMods;
	        MyMut.bKickSpeedHack =  MyMut.MyDM.Default.bKickSpeedHack;
	        MyMut.MinY = MyMut.MyDM.default.MinY;
    	    MyMut.bNoFlockPawns = MyMut.MyDM.default.bNoFlockPawns;
            break;
    }
}

//-------------------------------------
// GetClientIP
//-------------------------------------
function string GetClientIP(PlayerPawn MyPlayer)
{
    local string rv;

    rv = MyPlayer.GetPlayerNetworkAddress();
    if (Instr(rv,":") != -1) rv = Left(rv, InStr(rv,":"));
    return rv;
}

//-------------------------------------
// FindIndexPI
//-------------------------------------
function int FindIndexPI(Pawn p)
{
	local int i;

	for (i = 0; i < MaxArray; i++)
		if ((MyMut.PlayerList[i] != None) && (MyMut.PlayerList[i] == p))
			return i;

	return -1;
}

//-------------------------------------
// FindIndexPRI
//-------------------------------------
function int FindIndexPRI(PlayerPawn MyPlayer)
{
    local int i;

    for (i = 0; i < MaxArray; i++)
		if (( MyMut.PlayerList[i] != None) && (MyMut.PlayerList[i] == MyPlayer))
			return i;

	return -1;
}

//-------------------------------------
// SetNewPlayerId
//-------------------------------------
final function SetNewPlayerId(Pawn P)
{
    local Pawn NP;
    local int ID[40];
    local int i;

    for (NP = Level.PawnList; NP != None; NP = NP.NextPawn )
        ID[NP.PlayerReplicationInfo.PlayerID] = 1;

    for (i = 0; i < 32; i++)
    {
        if (ID[i] == 0)
        {
            P.PlayerReplicationInfo.PlayerID = i;
            Level.Game.AddDefaultInventory(P);
            break;
        }
    }
}

//-------------------------------------
// IsLevelActive
//-------------------------------------
function bool IsLevelActive()
{
    if ( Level.Game.IsA('DeathMatchPlus') )
		if ( MyMut.DMP.bGameEnded )
			return false;

	return true;
}

//-------------------------------------
// LogDate
//-------------------------------------
function string LogDate()
{
	local string d, t;

	d = Level.Year$"-"$PrePad(Level.Month,"0",2)$"-"$PrePad(Level.Day,"0",2);
	t = PrePad(Level.Hour,"0",2)$":"$PrePad(Level.Minute,"0",2)$"."$PrePad(Level.Second,"0",2);
	return d@t;
}

//-------------------------------------
// PrePad
//-------------------------------------
function string PrePad(coerce string rv, string p, int i)
{
	while (Len(rv) < i) rv = p$rv;
	return rv;
}

//-------------------------------------
// SterilizeString
//-------------------------------------
function string SterilizeString(string s)
{
   local string rv;
   local int i;

	rv = "";

	for (i = 0; i < Len(s); i++)
	{
		if (InStr("\/*?:<>|"$Chr(34), Mid(s, i, 1)) != -1)
			rv = rv $ "_";
		else
			rv = rv $ Mid(s, i, 1);
	}
    return rv;
}

//-------------------------------------
// VerifyHudType
//-------------------------------------
function VerifyHudType(Pawn P)
{
    if (MyMut.bCTF)
	{
        MyMut.MyCRI = EUTGameReplicationInfo(Level.Game.GameReplicationInfo);
        if (PlayerPawn(P).HUDType != Class'EUTCTFHud')
		    LogInfraction(PlayerPawn(P), 0, "BH", "");
		else if (PlayerPawn(P).ScoringType != Class'EUTCTFSB')
            LogInfraction(PlayerPawn(P), 0, "BSB", "");
		return;
    }
    if (MyMut.bTDM)
	{
        MyMut.MyCRI = EUTGameReplicationInfo(Level.Game.GameReplicationInfo);
        if (PlayerPawn(P).HUDType != Class'EUTTDMHud')
		    LogInfraction(PlayerPawn(P), 0, "BH", "");
		else if (PlayerPawn(P).ScoringType != Class'EUTTDMSB')
            LogInfraction(PlayerPawn(P), 0, "BSB", "");
		return;
    }
    if (MyMut.bDM)
	{
        MyMut.MyCRI = EUTGameReplicationInfo(Level.Game.GameReplicationInfo);
        if (PlayerPawn(P).HUDType != Class'EUTDMHud')
		    LogInfraction(PlayerPawn(P), 0, "BH", "");
		else if (PlayerPawn(P).ScoringType != Class'EUTDMSB')
            LogInfraction(PlayerPawn(P), 0, "BSB", "");
		return;
    }
}

//-------------------------------------
// LogInfraction
//-------------------------------------
function LogInfraction(PlayerPawn MyPlayer, byte Offense, string Code, string Opt)
{
    local string PlayerName;
    local string PlayerIP;

    if (MyPlayer == None) return;

    if (MyPlayer.PlayerReplicationInfo != none)
    {
        PlayerName = MyPlayer.PlayerReplicationInfo.PlayerName;
        PlayerIP = GetClientIP(MyPlayer);
    }

    if (Len(Code) > 255 || Len(Opt) > 255)
    {
        opt = string(Offense);
        Offense = 99;
    }

    switch (Offense)
    {
        case 0://Illegal Hud Detected
        case 1://Illegal Mod Menu Item Detected
        case 2://Illagal Face Texture Detected
        case 3://Client Changed MouseLook Settings
        case 4://Client Has Illegal Tweaks
        case 5://Client Has Illegal Tweaks
        case 6://Client Has Illegal Tweaks
        case 7://Client Has Illegal Tweaks
        case 8://Client Changed MouseLook Settings
            MyMut.GameLog("****************************************");
            MyMut.GameLog(logdate()@"[EUT CHEAT] - "$Code$" - "$Opt@PlayerName@"[IP]"@PlayerIP);
            MyMut.GameLog("****************************************");
            NotifyPlayer(MyPlayer,Offense,Code,Opt);
            break;

        case 9://Client Time Exceded Server Time + 20
            if ( !MyMut.bKickSpeedHack )
                return;
            else
            {
                MyMut.GameLog("****************************************");
                MyMut.GameLog(logdate()@"[EUT CHEAT] - "$Code$" - "$Opt@PlayerName@"[IP]"@PlayerIP);
                MyMut.GameLog("****************************************");
                NotifyPlayer(MyPlayer,Offense,Code,Opt);
            }

        case 10://Illegal Hook
        case 11://Illegal LodBias Settings
        case 12://Illegal Spectator
        case 13://Illagal MouseY Settings
            MyMut.GameLog("****************************************");
            MyMut.GameLog(logdate()@"[EUT CHEAT] - "$Code$" - "$Opt@PlayerName@"[IP]"@PlayerIP);
            MyMut.GameLog("****************************************");
            NotifyPlayer(MyPlayer,Offense,Code,Opt);
            break;

        case 99://Bad Info
            MyMut.GameLog("****************************************");
            MyMut.GameLog(logdate()@"[EUT CHEAT] - "$"BI"$" - "$Opt@PlayerName@"[IP]"@PlayerIP);
            MyMut.GameLog("****************************************");
            NotifyPlayer(MyPlayer,Offense,Code,Opt);
            break;

    }
}

//-------------------------------------
// NotifyPlayer
//-------------------------------------
function NotifyPlayer(PlayerPawn MyPlayer, byte Offense, string Code, string Opt)
{
    if (MyPlayer == None) return;

    MyMut.PlayerRIList[FindIndexPRI(MyPlayer)].OpenConsole();
    MyPlayer.ClientMessage("****************************************");

    switch (Offense)
    {
         case 0:
            MyPlayer.ClientMessage("Illegal Hud Detected -"$Code$"-");
            break;
        case 1:
            MyPlayer.ClientMessage("Illegal Mod Menu Item Detected -"$Code$"-"@Opt);
            break;
        case 2:
            MyPlayer.ClientMessage("Illagal Face Texture Detected -"@Opt$"-");
            break;
        case 3:
            MyPlayer.ClientMessage("MouseY Settings Changed "$Code$"-");
            break;
        case 4:
            MyPlayer.ClientMessage("Illegal Tweaks Detected -"$Code$"-");
            break;
        case 5:
            MyPlayer.ClientMessage("Illegal Tweaks Detected -"$Code$"-");
            break;
        case 6:
            MyPlayer.ClientMessage("Illegal Tweaks Detected -"$Code$"-");
            break;
        case 7:
            MyPlayer.ClientMessage("Illegal Tweaks Detected -"$Code$"-");
            break;
        case 8:
            MyPlayer.ClientMessage("Mouse Input Settings Changed "$Code$"-");
            break;
        case 9:
            MyPlayer.ClientMessage("Illegal Time Variation between Client and Server "$Code$"-");
            break;
        case 10:
            MyPlayer.ClientMessage("Illegal Hook Detected "$Code$"-");
            break;
        case 11:
            MyPlayer.ClientMessage("Illegal LodBias Settings "$Code$"-");
            break;
        case 12:
            MyPlayer.ClientMessage("Illegal Spectator "$Code$"-");
            break;
        case 13:
            MyPlayer.ClientMessage("Illegal Mouse Y Settings "$Code$"-");
            break;
        case 99:
            MyPlayer.ClientMessage("Illegal Info Sent "$Code$"-");
            break;
    }

    MyPlayer.ClientMessage("If You Feel This was In Error Contact The Server Administrator"@Level.Game.GameReplicationInfo.AdminEmail);
    MyPlayer.ClientMessage(MyMut.VersionStr$MyMut.ThisVer);
    MyPlayer.ClientMessage("****************************************");
    KickPlayer(MyPlayer);
}

//-------------------------------------
// BaseLog
//-------------------------------------
function BaseLog(PlayerPawn MyPlayer, byte Code, string Opt)
{
    local string PlayerName;
    local string PlayerIP;

    if (MyPlayer == None) return;

    if (MyPlayer.PlayerReplicationInfo != none)
    {
        PlayerName = MyPlayer.PlayerReplicationInfo.PlayerName;
        PlayerIP = GetClientIP(MyPlayer);
    }

    if (Len(Opt) > 255)
    {
        opt = string(Code);
        Code = 99;
    }

    switch (Code)
    {
        case 0:
            MyMut.MyLog(LogDate()@PlayerName$"....Client Connected"@"[IP]"@PlayerIP);
            break;

        case 1:
            MyMut.MyLog(LogDate()@PlayerName$"....Spectator Connected"@"[IP]"@PlayerIP);
            break;

        case 2:
            MyMut.MyLog(LogDate()@PlayerName@"[ERROR]: CRI == None"@"[IP]"@PlayerIP);
            break;

        case 3:
            MyMut.MyLog(LogDate()@"Auto Destroying FlockPawn:"@MyPlayer);
            break;

        case 4:
            MyMut.MyLog(logdate()@PlayerName@"[IP]"@PlayerIP@"[MMI]"@Opt);
            break;

        case 5:
            MyMut.MyLog(logdate()@PlayerName@"[IP]"@PlayerIP@"[Client MouseY]"@Opt);
            break;

        case 6:
            MyMut.MyLog(logdate()@PlayerName@"[IP]"@PlayerIP@"[Client MouseX]"@Opt);
            break;

        case 99:
            MyMut.MyLog(logdate()@PlayerName@"[IP]"@PlayerIP@"[BI]"@opt);
            KickPlayer(MyPlayer);
            break;
    }
}

//-------------------------------------
// KickPlayer
//-------------------------------------
function KickPlayer(PlayerPawn MyPlayer)
{
    if (MyPlayer == None) return;
    MyPlayer.Destroy();
}

//-------------------------------------
// defaultproperties
//-------------------------------------
defaultproperties
{
}
