/*
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
              EUTServerInfo
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
*/

class EUTServerInfo expands ServerInfoTeam;

var EUTGameReplicationInfo MyCRI;
var PlayerReplicationInfo RedPRI[32];
var PlayerReplicationInfo BluePRI[32];
var PlayerReplicationInfo Ordered[32];
var FontInfo _FontInfo;

var bool bCTF, bTDM, bDM;

var color ShadeColor,
    RedColor,
    BlueColor,
    GreenColor,
    GoldColor,
    WhiteColor,
    GrayColor,
    CyanColor,
    BronzeColor;

var float FloatingY,
    RankLine,
    ScoresLine,
    KillsLine,
    DeathsLine,
    EffLine,
    CapsLine,
    AssistLine,
    CoversLine,
    GrabsLine,
    SavesLine,
    DeniedLine,
    SealsLine,
    FKillsLine,
    IpLine,
    AccLine;

var localized string ServerInfoText,
    ContactInfoText,
    NameText,
    AdminText,
    EMailText,
    UnknownText,
    MOTD,
    ServerStatsText,
    FragsLoggedText,
    GamesHostedText,
    VictimsText,
    GameStatsText,
    GameTypeText,
    PlayersText,
    FragsText,
    TopPlayersText,
    BestNameText,
    BestFPHText,
    BestRecordSetText,
    BotText,
    FlagsCapturedText,
    TotalGrabsText,
    TotalSealsText,
    TotalAssistsText,
    TotalCoversText,
    TotalFlagKillsText,
    TotalDeniedText,
    TotalSavesText,
    PlayerStatsText,
    BestPlayersText[3];

var string ServerName;

var texture BoxFill;

//-------------------------------------
// Destroyed
//-------------------------------------
function Destroyed()
{
	Super.Destroyed();
	if (_FontInfo != none)
		_FontInfo.Destroy();
}

//-------------------------------------
// PostBeginPlay
//-------------------------------------
function PostBeginPlay()
{
	Super.PostBeginPlay();
	_FontInfo = FontInfo(Spawn(Class<Actor>(DynamicLoadObject(class'ChallengeHUD'.default.FontInfoClass, class'Class'))));
    LoadTextures();

}

//-------------------------------------
// LoadTextures
//-------------------------------------
final function LoadTextures()
{
    BoxFill = Texture(DynamicLoadObject("EUT_Textures.EUT_Fill", class'Texture'));
    bCTF = false;
    bTDM = false;
    bDM = false;
}

//-------------------------------------
// RenderInfo
//-------------------------------------
function RenderInfo(canvas C)
{
	local GameReplicationInfo GRI;

    GRI = PlayerPawn(Owner).GameReplicationInfo;

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
            bCTF = true;
            MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
            PlayerStatsText = "SmartCTF Stats Plus";
            break;

        case Class'EUTTDMHud':
            bTDM = true;
            MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
            PlayerStatsText = "EUTTeamGame Stats Plus";
            break;

        case Class'EUTDMHud':
            bDM = true;
            MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
            PlayerStatsText = "EUTDeathMatch Stats Plus";
            break;
    }

	DrawTitle(C);

	if (C.ClipX > 512)
	{
		ServerName = GRI.ServerName;
        DrawShadedBack(C);
        DrawContactInfos(C, GRI, true);
		DrawServerStats(C, GRI);
		DrawCurrentStats(C, GRI);
		DrawGameStats(C, GRI);
	}
    else DrawContactInfos(C, GRI, false);
}

//-------------------------------------
// DrawTitle
//-------------------------------------
function DrawTitle(canvas C)
{
	local float XL, YL;

	C.Font = _FontInfo.GetHugeFont(C.ClipX);
	C.DrawColor = GrayColor;
	C.StrLen(ServerInfoText, XL, YL);
	C.SetPos((C.ClipX - XL) / 2, YL);
	C.DrawText(ServerInfoText, true);
}

//-------------------------------------
// DrawShadedBack
//-------------------------------------
function DrawShadedBack(Canvas C)
{
    C.DrawColor = ShadeColor;
    C.Style = ERenderStyle.STY_Modulated;
    C.SetPos(0,0);
    C.DrawRect(BoxFill, C.ClipX, C.ClipY);
    C.Style = ERenderStyle.STY_Normal;
}

//-------------------------------------
// DrawMotd
//-------------------------------------
function DrawMotd( canvas C, GameReplicationInfo GRI )
{
}

//-------------------------------------
// DrawGameStats
//-------------------------------------
function DrawGameStats( canvas C, GameReplicationInfo GRI )
{
	local float XL, YL, XL2, YL2, Y, X;
	local TournamentGameReplicationInfo TGRI;
	local byte i, NumBots;

	TGRI = TournamentGameReplicationInfo(GRI);

	C.DrawColor = GrayColor;
	C.Font = _FontInfo.GetBigFont(C.ClipX);
	C.StrLen("####", XL, YL);
	X = C.ClipX / 8;
	Y = (C.ClipY / 8) * 2 + (YL + 1);
    C.SetPos(X, (C.ClipY / 8) * 2 );
	C.DrawText(GameStatsText, True);

	C.DrawColor = CyanColor;
	C.Font = _FontInfo.GetSmallFont( C.ClipX );
	C.StrLen("########", XL2, YL2);
	YL2 = YL2 + 1;

	C.SetPos(X, Y);
	C.DrawText(GameTypeText, True);

	C.DrawColor = WhiteColor;
	C.SetPos(X + XL2, Y);
	C.DrawText(GRI.GameName, True);

	C.DrawColor = CyanColor;
	C.SetPos(X, Y + YL2);
	C.DrawText(PlayersText, True);

	C.DrawColor = WhiteColor;
	C.SetPos(X + XL2, Y + YL2);

	for (i = 0; i < 32; i++)
		if ((GRI.PRIArray[i] != None)
        && (GRI.PRIArray[i].bIsABot))
			NumBots++;

	C.DrawText(GRI.NumPlayers$"   ["$NumBots@BotText$"]", True);

	if (PlayerPawn(Owner).HudType == Class'EUTDMHud')
	{
	   C.StrLen("##############", XL2, YL2);

       C.DrawColor = CyanColor;
	   C.SetPos(X, Y + (YL2*2));
	   C.DrawText("Best FPH #1:", True);

	   C.DrawColor = WhiteColor;
	   C.SetPos(X + XL2, Y + (YL2*2));
	   C.DrawText(TGRI.BestPlayers[0]$" "$TGRI.BestFPHs[0]$" "$TGRI.BestRecordDate[0], True);

	   C.DrawColor = CyanColor;
	   C.SetPos(X, Y + (YL2*3));
	   C.DrawText("Best FPH #2:", True);

	   C.DrawColor = WhiteColor;
	   C.SetPos(X + XL2, Y + (YL2*3));
	   C.DrawText(TGRI.BestPlayers[1]$" "$TGRI.BestFPHs[1]$" "$TGRI.BestRecordDate[1], True);

	   C.DrawColor = CyanColor;
	   C.SetPos(X, Y + (YL2*4));
	   C.DrawText("Best FPH #3:", True);

	   C.DrawColor = WhiteColor;
	   C.SetPos(X + XL2, Y + (YL2*4));
	   C.DrawText(TGRI.BestPlayers[2]$" "$TGRI.BestFPHs[2]$" "$TGRI.BestRecordDate[2], True);

	}
}

//-------------------------------------
// DrawLeaderBoards
//-------------------------------------
function DrawLeaderBoards( canvas C, GameReplicationInfo GRI )
{
}

//-------------------------------------
// DrawContactInfos
//-------------------------------------
function DrawContactInfos( canvas C, GameReplicationInfo GRI, bool bShort)
{
	local float XL, YL, XL2, YL2, Y, X, ServerNameStart, ServerNameMax, ServerNameY, ServerNameX;

	C.DrawColor = GrayColor;
	C.Font = _FontInfo.GetBigFont(C.ClipX);
	C.StrLen( "####", XL, YL );
	C.SetPos(C.ClipX / 8, (C.ClipY / 8));
	C.DrawText(ContactInfoText, True);

	C.DrawColor = CyanColor;
	C.Font = _FontInfo.GetSmallFont(C.ClipX);
	C.StrLen("########", XL2, YL2);
	YL2 = YL2 + 1;

	if (bShort)
	{
        X = C.ClipX / 8;
    	Y = (C.ClipY / 8) + (YL + 1);
	}
	else
	{
	    X = C.ClipX / 4;
    	Y = (C.ClipY / 4) + (YL + 1);
	}

	C.StrLen(ServerName, ServerNameX, ServerNameY);
    ServerNameMax = (C.ClipX / 8) * 5 - 2;
    ServerNameStart = X + XL2;

    if(ServerNameX > ServerNameMax - ServerNameStart)
    {
        while(ServerNameX > ServerNameMax - ServerNameStart)
        {
            ServerName = Left(ServerName,Len(ServerName)-1);
            C.StrLen(ServerName, ServerNameX, ServerNameY);
        }
    }
    else
        ServerName = GRI.ServerName;

    C.SetPos(X,Y);
	C.DrawText(NameText, True);

	C.DrawColor = WhiteColor;
    C.SetPos(X + XL2, Y);
	C.DrawText(ServerName, True);

	C.DrawColor = CyanColor;
    C.SetPos(X, Y + YL2);
	C.DrawText(AdminText, True);

    C.DrawColor = WhiteColor;
    C.SetPos(X + XL2, Y + YL2);
	if (GRI.AdminName != "") C.DrawText(GRI.AdminName, True);
	else C.DrawText(UnknownText, True);

	C.DrawColor = CyanColor;
    C.SetPos(X, Y + (YL2*2));
	C.DrawText(EMailText, True);

	C.DrawColor = WhiteColor;
    C.SetPos(X + XL2, Y + (YL2*2));
	if (GRI.AdminEmail != "") C.DrawText(GRI.AdminEmail, True);
	else C.DrawText(UnknownText, True);
}

//-------------------------------------
// DrawServerStats
//-------------------------------------
function DrawServerStats( canvas C, GameReplicationInfo GRI )
{
	local float XL, YL, XL2, YL2, Y, X;
	local TournamentGameReplicationInfo TGRI;

	TGRI = TournamentGameReplicationInfo(GRI);

	C.DrawColor = GrayColor;
	C.Font = _FontInfo.GetBigFont(C.ClipX);
	C.StrLen("####", XL, YL);

	X = (C.ClipX / 8) * 5;
	Y = (C.ClipY / 8) + (YL + 1);

    C.SetPos(X, C.ClipY / 8);
	C.DrawText( ServerStatsText, True);

	C.DrawColor = CyanColor;
    C.Font = _FontInfo.GetSmallFont(C.ClipX);
	C.StrLen("###############", XL2, YL2);

	C.SetPos(X, Y);
	C.DrawText(GamesHostedText, True);

	C.DrawColor = WhiteColor;
	C.SetPos(X + XL2, Y);
	C.DrawText(TGRI.TotalGames, True);

	YL2 = YL2 + 1;
    C.DrawColor = CyanColor;

	switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
            C.SetPos(X, Y + YL2);
            C.DrawText(FlagsCapturedText, True);
            C.SetPos(X, Y + (YL2*2));
            C.DrawText(TotalGrabsText, True);
            C.SetPos(X, Y + (YL2*3));
            C.DrawText(TotalAssistsText, True);
            C.SetPos(X, Y + (YL2*4));
            C.DrawText(TotalCoversText, True);
            C.SetPos(X, Y + (YL2*5));
            C.DrawText(TotalSealsText, True);
            C.SetPos(X, Y + (YL2*6));
            C.DrawText(TotalFlagKillsText, True);
            C.SetPos(X, Y + (YL2*7));
            C.DrawText(TotalDeniedText, True);
            C.SetPos(X, Y + (YL2*8));
            C.DrawText(TotalSavesText, True);
            C.SetPos(X, Y + (YL2*9));
            C.DrawText(BestPlayersText[0], True);
            C.SetPos(X, Y + (YL2*10));
            C.DrawText(BestPlayersText[1], True);
            C.SetPos(X, Y + (YL2*11));
            C.DrawText(BestPlayersText[2], True);

            C.DrawColor = WhiteColor;
            C.SetPos(X + XL2, Y + YL2);
            C.DrawText(TGRI.TotalFlags, True);
            C.SetPos(X + XL2, Y + (YL2*2));
            C.DrawText(MyCRI.SmartStats.FlagGrabs, True);
            C.SetPos(X + XL2, Y + (YL2*3));
            C.DrawText(MyCRI.SmartStats.FlagAssists, True);
            C.SetPos(X + XL2, Y + (YL2*4));
            C.DrawText(MyCRI.SmartStats.FlagCovers, True);
            C.SetPos(X + XL2, Y + (YL2*5));
            C.DrawText(MyCRI.SmartStats.BaseSeals, True);
            C.SetPos(X + XL2, Y + (YL2*6));
            C.DrawText(MyCRI.SmartStats.FlagKills, True);
            C.SetPos(X + XL2, Y + (YL2*7));
            C.DrawText(MyCRI.SmartStats.FlagDenied, True);
            C.SetPos(X + XL2, Y + (YL2*8));
            C.DrawText(MyCRI.SmartStats.FlagSaves, True);
            C.SetPos(X + XL2, Y + (YL2*9));
            C.DrawText(MyCRI.BestPlayers[2]$" "$MyCRI.BestRanking[2], True);
            C.SetPos(X + XL2, Y + (YL2*10));
            C.DrawText(MyCRI.BestPlayers[1]$" "$MyCRI.BestRanking[1], True);
            C.SetPos(X + XL2, Y + (YL2*11));
            C.DrawText(MyCRI.BestPlayers[0]$" "$MyCRI.BestRanking[0], True);
            FloatingY = Y + (YL2*13);
            break;

        case Class'EUTTDMHud':
            C.SetPos(X, Y + YL2);
            C.DrawText(FragsText, True);
            C.SetPos(X, Y + (YL2*2));
            C.DrawText(VictimsText, True);
            C.SetPos(X, Y + (YL2*3));
            C.DrawText(BestPlayersText[0], True);
            C.SetPos(X, Y + (YL2*4));
            C.DrawText(BestPlayersText[1], True);
            C.SetPos(X, Y + (YL2*5));
            C.DrawText(BestPlayersText[2], True);

            C.DrawColor = WhiteColor;
            C.SetPos(X + XL2, Y + YL2);
            C.DrawText(TGRI.TotalFrags, True);
            C.SetPos(X + XL2, Y + (YL2*2));
            C.DrawText(TGRI.TotalDeaths, True);
            C.SetPos(X + XL2, Y + (YL2*3));
            C.DrawText(MyCRI.BestTDMPlayers[2]$" "$MyCRI.BestTDMRanking[2], True);
            C.SetPos(X + XL2, Y + (YL2*4));
            C.DrawText(MyCRI.BestTDMPlayers[1]$" "$MyCRI.BestTDMRanking[1], True);
            C.SetPos(X + XL2, Y + (YL2*5));
            C.DrawText(MyCRI.BestTDMPlayers[0]$" "$MyCRI.BestTDMRanking[0], True);
            FloatingY = Y + (YL2*13);
            break;

        case Class'EUTDMHud':
            C.SetPos(X, Y + YL2);
            C.DrawText(FragsText, True);
            C.SetPos(X, Y + (YL2*2));
            C.DrawText(VictimsText, True);
            C.SetPos(X, Y + (YL2*3));
            C.DrawText(BestPlayersText[0], True);
            C.SetPos(X, Y + (YL2*4));
            C.DrawText(BestPlayersText[1], True);
            C.SetPos(X, Y + (YL2*5));
            C.DrawText(BestPlayersText[2], True);

            C.DrawColor = WhiteColor;
            C.SetPos(X + XL2, Y + YL2);
            C.DrawText(TGRI.TotalFrags, True);
            C.SetPos(X + XL2, Y + (YL2*2));
            C.DrawText(TGRI.TotalDeaths, True);
            C.SetPos(X + XL2, Y + (YL2*3));
            C.DrawText(MyCRI.BestDMPlayers[2]$" "$MyCRI.BestDMRanking[2], True);
            C.SetPos(X + XL2, Y + (YL2*4));
            C.DrawText(MyCRI.BestDMPlayers[1]$" "$MyCRI.BestDMRanking[1], True);
            C.SetPos(X + XL2, Y + (YL2*5));
            C.DrawText(MyCRI.BestDMPlayers[0]$" "$MyCRI.BestDMRanking[0], True);
            FloatingY = Y + (YL2*13);
            break;
    }
}

//-------------------------------------
// DrawCurrentStats
//-------------------------------------
function DrawCurrentStats(Canvas C, GameReplicationInfo GRI)
{
    local float XL, YL, Y, X, Start;
	local TournamentGameReplicationInfo TGRI;
	local byte i, NumRed, NumBlue, Total;
	local PlayerReplicationInfo PRI;

    C.DrawColor = GrayColor;
	C.Font = _FontInfo.GetBigFont( C.ClipX );
	C.StrLen( PlayerStatsText, XL, YL );
	C.SetPos( (C.ClipX - XL) / 2, FloatingY);
	C.DrawText( PlayerStatsText, True);
	C.DrawColor.R = 0;
	C.DrawColor.G = 255;
	C.DrawColor.B = 50;

    if (C.ClipX > 800) C.Font = _FontInfo.GetSmallFont( C.ClipX );
    else C.Font = _FontInfo.GetSmallestFont( C.ClipX );

    C.StrLen("12345678901234567890", XL, YL);
    X = C.ClipX / 8;
    Y = FloatingY + (YL * 2);
    C.SetPos(X, Y);
	C.DrawText("Player",True);
    C.SetPos(X + (XL + 7), Y);
    C.DrawText("Ranking",True);
    RankLine = X + (XL + 7);
    C.StrLen("Ranking", XL, YL);
	C.SetPos(RankLine + (XL + 7), Y);
    C.DrawText("Score",True);
    ScoresLine = RankLine + (XL + 7);
    C.StrLen("Score", XL, YL);
	C.SetPos(ScoresLine + (XL + 7), Y);
    C.DrawText("Kills",True);
    KillsLine = ScoresLine + (XL + 7);
    C.StrLen("Kills", XL, YL);
	C.SetPos(KillsLine + (XL + 7), Y);
    C.DrawText("Deaths",True);
    DeathsLine = KillsLine + (XL + 7);
    C.StrLen("Deaths", XL, YL);
	C.SetPos(DeathsLine + (XL + 7), Y);
    C.DrawText(" Eff ",True);
    EffLine = DeathsLine + (XL + 7);
    C.StrLen(" Eff ", XL, YL);
	C.SetPos(EffLine + (XL + 7), Y);
    C.DrawText("Acc",True);
    AccLine = EffLine + (XL + 7);

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
           C.StrLen("###", XL, YL);
    	   C.SetPos(AccLine + (XL + 7), Y);
           C.DrawText("Cps",True);
           CapsLine = AccLine + (XL + 7);
    	   C.SetPos(CapsLine + (XL + 7), Y);
           C.DrawText("Ass",True);
           AssistLine = CapsLine + (XL + 7);
    	   C.SetPos(AssistLine + (XL + 7), Y);
           C.DrawText("Cov",True);
           CoversLine = AssistLine + (XL + 7);
    	   C.SetPos(CoversLine + (XL + 7), Y);
           C.DrawText("Gbs",True);
           GrabsLine = CoversLine + (XL + 7);
    	   C.SetPos(GrabsLine + (XL + 7), Y);
           C.DrawText("Svs",True);
           SavesLine = GrabsLine + (XL + 7);
    	   C.SetPos(SavesLine + (XL + 7), Y);
           C.DrawText("Den",True);
           DeniedLine = SavesLine + (XL + 7);
    	   C.SetPos(DeniedLine + (XL + 7), Y);
           C.DrawText("Sls",True);
           SealsLine = DeniedLine + (XL + 7);
    	   C.SetPos(SealsLine + (XL + 7), Y);
           C.DrawText("Fkl",True);
           FKillsLine = SealsLine + (XL + 7);
    	   C.SetPos(FKillsLine + (XL + 7), Y);
           C.DrawText("IP Address     ",True);
           IpLine = FKillsLine + (XL + 7);
           break;

        case Class'EUTTDMHud':
        case Class'EUTDMHud':
           C.StrLen("###", XL, YL);
    	   C.SetPos(AccLine + (XL + 7), Y);
           C.DrawText("---",True);
           CapsLine = AccLine + (XL + 7);
    	   C.SetPos(CapsLine + (XL + 7), Y);
           C.DrawText("---",True);
           AssistLine = CapsLine + (XL + 7);
    	   C.SetPos(AssistLine + (XL + 7), Y);
           C.DrawText("---",True);
           CoversLine = AssistLine + (XL + 7);
    	   C.SetPos(CoversLine + (XL + 7), Y);
           C.DrawText("---",True);
           GrabsLine = CoversLine + (XL + 7);
    	   C.SetPos(GrabsLine + (XL + 7), Y);
           C.DrawText("---",True);
           SavesLine = GrabsLine + (XL + 7);
    	   C.SetPos(SavesLine + (XL + 7), Y);
           C.DrawText("---",True);
           DeniedLine = SavesLine + (XL + 7);
    	   C.SetPos(DeniedLine + (XL + 7), Y);
           C.DrawText("---",True);
           SealsLine = DeniedLine + (XL + 7);
    	   C.SetPos(SealsLine + (XL + 7), Y);
           C.DrawText("---",True);
           FKillsLine = SealsLine + (XL + 7);
    	   C.SetPos(FKillsLine + (XL + 7), Y);
           C.DrawText("IP Address     ",True);
           IpLine = FKillsLine + (XL + 7);
           break;
    }

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
        case Class'EUTTDMHud':
           for (i = 0; i < ArrayCount(RedPRI); i++)
    		  RedPRI[i] = None;

    	   for (i = 0; i < 32; i++)
           {
              PRI = GRI.PRIArray[i];
              if (PRI != none
              && (PRI.PlayerName != "Player")
              && (PRI.Team == 0))
              {
                 if (!PRI.bIsSpectator || PRI.bWaitingPlayer)
    			 {
                    RedPRI[NumRed] = PRI;
                    NumRed++;
                    if (NumRed == ArrayCount(RedPRI)) break;
                 }
              }
           }
           SortScoresRed(NumRed);

           for (i = 0; i < ArrayCount(BluePRI); i++)
    		  BluePRI[i] = None;

    	   for (i = 0; i < 32; i ++)
           {
               PRI = GRI.PRIArray[i];
               if (PRI != none
               && (PRI.PlayerName != "Player")
               && (PRI.Team == 1))
               {
                  if (!PRI.bIsSpectator || PRI.bWaitingPlayer)
    			  {
                     BluePRI[NumBlue] = PRI;
                     NumBlue++;
                     if (NumBlue == ArrayCount(BluePRI)) break;
                  }
               }
           }
           SortScoresBlue(NumBlue);

           C.StrLen( "TEST", XL, YL );
           Start = FloatingY + (YL * 4);
           Y = Start;

           for (i = 0; i < NumRed; i++)
    	   {
    	       Y = Start + i * YL;
               DrawData(C, RedPRI[i], Y);
    	   }

    	   Start = FloatingY + (YL * 5) + (YL * NumRed);

    	   for (i = 0; i < NumBlue; i++)
    	   {
    	       Y = Start + i * YL;
               DrawData(C, BluePRI[i], Y);
    	   }
           break;

        case Class'EUTDMHud':
           for (i = 0; i < ArrayCount(Ordered); i++)
    		  Ordered[i] = None;

    	   for (i = 0; i < 32; i++)
           {
              PRI = GRI.PRIArray[i];
              if (PRI != none
              && (PRI.PlayerName != "Player"))
              {
                  if (!PRI.bIsSpectator || PRI.bWaitingPlayer)
    			  {
                      Ordered[Total] = PRI;
                      Total++;
                      if (Total == ArrayCount(Ordered))
                         break;
                  }
              }
           }
           SortScores(Total);

           Start = FloatingY + (YL * 4);

           for (i = 0; i < Total; i++)
    	   {
    	       Y = Start + i * YL;
               DrawData(C, Ordered[i], Y);
    	   }
           break;
    }
}

//-------------------------------------
// DrawData
//-------------------------------------
function DrawData(Canvas C, PlayerReplicationInfo PRI, float Y)
{
    local float XL, YL, XL2, YL2, X;
	local bool bLocal;
	local PlayerPawn MyPlayer;
	local int eff;
	local byte i;

	MyPlayer = PlayerPawn(Owner);
	bLocal = (PRI.PlayerName == MyPlayer.PlayerReplicationInfo.PlayerName);

	if (C.ClipX > 800) C.Font = _FontInfo.GetSmallFont( C.ClipX );
    else C.Font = _FontInfo.GetSmallestFont( C.ClipX );

    if (bCTF) i = 0;
    else i = 1;

    eff = GetEffeciency( PRI.PlayerID, i );

    switch (PRI.Team)
    {
        case 0: C.DrawColor = RedColor; break;
        case 1: C.DrawColor = BlueColor; break;
        case 2: C.DrawColor = GreenColor; break;
        case 3: C.DrawColor = GoldColor; break;
        case 255: C.DrawColor = BronzeColor; break;
    }

	if (bLocal) C.DrawColor = WhiteColor;

	C.SetPos(C.ClipX/8, Y);
	C.DrawText(PRI.PlayerName, False);
	C.SetPos(RankLine, Y);

	switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
        case Class'EUTTDMHud':
        case Class'EUTDMHud':
            C.DrawText(MyCRI.CurrentRanking[PRI.PlayerID], False);
            break;
    }

	C.SetPos(ScoresLine, Y);
	C.DrawText(int(PRI.Score), False);
	C.SetPos(KillsLine, Y);

	switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
            C.DrawText(MyCRI.TotalKills[PRI.PlayerID], False);
            C.SetPos(DeathsLine, Y);
            C.DrawText(MyCRI.TotalDeaths[PRI.PlayerID], False);
            C.SetPos(EffLine, Y);
	        C.DrawText(eff, False);
	        C.SetPos(AccLine, Y);
	        C.DrawText(MyCRI.CurrentTotalAccuracy[PRI.PlayerID], False);
	        C.SetPos(CapsLine, Y);
	        C.DrawText(MyCRI.IStats1[PRI.PlayerID].FlagCaps, False);
	        C.SetPos(AssistLine, Y);
	        C.DrawText(MyCRI.IStats1[PRI.PlayerID].FlagAssists, False);
	        C.SetPos(CoversLine, Y);
	        C.DrawText(MyCRI.IStats3[PRI.PlayerID].FlagCovers, False);
	        C.SetPos(GrabsLine, Y);
	        C.DrawText(MyCRI.IStats1[PRI.PlayerID].FlagGrabs, False);
	        C.SetPos(SavesLine, Y);
	        C.DrawText(MyCRI.IStats2[PRI.PlayerID].FlagSaves, False);
	        C.SetPos(DeniedLine, Y);
	        C.DrawText(MyCRI.IStats2[PRI.PlayerID].FlagsDenied, False);
	        C.SetPos(SealsLine, Y);
	        C.DrawText(MyCRI.IStats1[PRI.PlayerID].BaseSeals, False);
	        C.SetPos(FKillsLine, Y);
	        C.DrawText(MyCRI.IStats2[PRI.PlayerID].FlagKills, False);
	        if (MyCRI.bShowIPS)
    	    {
               C.SetPos(IpLine, Y);
               C.DrawText(MyCRI.StoredPlayerIP[PRI.PlayerID], False);
            }
            else
    	    {
               C.SetPos(IpLine, Y);
               C.DrawText("Disabled", False);
            }
            break;

        case Class'EUTTDMHud':
        case Class'EUTDMHud':
            C.DrawText(MyCRI.TotalKills[PRI.PlayerID], False);
            C.SetPos(DeathsLine, Y);
            C.DrawText(MyCRI.TotalDeaths[PRI.PlayerID], False);
            C.SetPos(EffLine, Y);
	        C.DrawText(eff, False);
	        C.SetPos(AccLine, Y);
	        C.DrawText(MyCRI.CurrentTotalAccuracy[PRI.PlayerID], False);
	        C.SetPos(CapsLine, Y);
	        C.DrawText(MyCRI.IStats1[PRI.PlayerID].FlagAssists, False);
	        C.SetPos(CoversLine, Y);
	        if (MyCRI.bShowIPS)
    	    {
               C.SetPos(IpLine, Y);
               C.DrawText(MyCRI.StoredPlayerIP[PRI.PlayerID], False);
            }
            else
    	    {
               C.SetPos(IpLine, Y);
               C.DrawText("Disabled", False);
            }
            break;
    }
}

//-------------------------------------
// GetEffeciency
//-------------------------------------
function int GetEffeciency( int pid, byte i )
{
    local int rv;

    switch (i)
    {
        case 0:
        case 1:
            rv = Clamp(int((float(MyCRI.TotalKills[pid]) /
            float(MyCRI.TotalKills[pid] + MyCRI.TotalDeaths[pid])) * 100), 0, 100);
            break;
    }

    return rv;
}

//-------------------------------------
// SortScoresRed
//-------------------------------------
function SortScoresRed(int N)
{
	local int I, J, Max;
	local PlayerReplicationInfo TempPRI;

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
            for (I = 0; I < N - 1; I++)
            {
                Max = I;
                for (J = I + 1; J < N; J++)
                {
                    if (MyCRI.CurrentRanking[RedPRI[j].PlayerID] > MyCRI.CurrentRanking[RedPRI[Max].PlayerID])
                        Max = J;
                    else if ((MyCRI.CurrentRanking[RedPRI[j].PlayerID] == MyCRI.CurrentRanking[RedPRI[Max].PlayerID])
                    && (RedPRI[J].Deaths < RedPRI[Max].Deaths))
    				    Max = J;
    			    else if ((RedPRI[J].Score == RedPRI[Max].Score)
                    && (RedPRI[J].Deaths == RedPRI[Max].Deaths)
                    && (RedPRI[J].PlayerID < RedPRI[Max].Score))
    				    Max = J;
    		    }
    		    TempPRI = RedPRI[Max];
    		    RedPRI[Max] = RedPRI[I];
    		    RedPRI[I] = TempPRI;
    	    }
            break;

        case Class'EUTTDMHud':
            for (I = 0; I < N - 1; I++)
    	    {
                Max = I;
                for (J = I + 1; J < N; J++)
    		    {
                    if (MyCRI.CurrentRanking[RedPRI[j].PlayerID] > MyCRI.CurrentRanking[RedPRI[Max].PlayerID])
                        Max = J;
    			    else if ((MyCRI.CurrentRanking[RedPRI[j].PlayerID] == MyCRI.CurrentRanking[RedPRI[Max].PlayerID])
                    && (RedPRI[J].Deaths < RedPRI[Max].Deaths))
    				    Max = J;
    			    else if ((RedPRI[J].Score == RedPRI[Max].Score)
                    && (RedPRI[J].Deaths == RedPRI[Max].Deaths)
                    && (RedPRI[J].PlayerID < RedPRI[Max].Score))
    				    Max = J;
    		    }
    		    TempPRI = RedPRI[Max];
    		    RedPRI[Max] = RedPRI[I];
    		    RedPRI[I] = TempPRI;
    	    }
            break;

        case Class'EUTDMHud': break;
    }
}

//-------------------------------------
// SortScoresBlue
//-------------------------------------
function SortScoresBlue(int N)
{
	local int I, J, Max;
	local PlayerReplicationInfo TempPRI;

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
           for (I = 0; I < N - 1; I++)
    	   {
    		   Max = I;
               for (J = I + 1; J < N; J++)
    		   {
                  if (MyCRI.CurrentRanking[BluePRI[j].PlayerID] > MyCRI.CurrentRanking[BluePRI[Max].PlayerID])
    				 Max = J;
    			  else if ((MyCRI.CurrentRanking[BluePRI[j].PlayerID] == MyCRI.CurrentRanking[BluePRI[Max].PlayerID])
                  && (BluePRI[J].Deaths < BluePRI[Max].Deaths))
    				 Max = J;
    			  else if ((BluePRI[J].Score == BluePRI[Max].Score)
                  && (BluePRI[J].Deaths == BluePRI[Max].Deaths)
                  && (BluePRI[J].PlayerID < BluePRI[Max].Score))
    				 Max = J;
    		   }
    		   TempPRI = BluePRI[Max];
    		   BluePRI[Max] = BluePRI[I];
    		   BluePRI[I] = TempPRI;
    	   }
           break;

        case Class'EUTTDMHud':
           for (I = 0; I < N - 1; I++)
    	   {
    		   Max = I;
               for (J = I + 1; J < N; J++)
    		   {
                  if (MyCRI.CurrentRanking[BluePRI[j].PlayerID] > MyCRI.CurrentRanking[BluePRI[Max].PlayerID])
    				 Max = J;
    			  else if ((MyCRI.CurrentRanking[BluePRI[j].PlayerID] == MyCRI.CurrentRanking[BluePRI[Max].PlayerID])
                  && (BluePRI[J].Deaths < BluePRI[Max].Deaths))
    				 Max = J;
    			  else if ((BluePRI[J].Score == BluePRI[Max].Score)
                  && (BluePRI[J].Deaths == BluePRI[Max].Deaths)
                  && (BluePRI[J].PlayerID < BluePRI[Max].Score))
    				 Max = J;
    		   }
    		   TempPRI = BluePRI[Max];
    		   BluePRI[Max] = BluePRI[I];
    		   BluePRI[I] = TempPRI;
    	   }
    	   break;

        case Class'EUTDMHud':  break;
    }
}

//-------------------------------------
// SortScores
//-------------------------------------
function SortScores(int N)
{
	local int I, J, Max;
	local PlayerReplicationInfo TempPRI;

    if (bDM)
    {
        for (I = 0; I < N - 1; I++)
	    {
            Max = I;
            for (J = I + 1; J < N; J++)
		    {
                if (MyCRI.CurrentRanking[Ordered[j].PlayerID] > MyCRI.CurrentRanking[Ordered[Max].PlayerID])
				    Max = J;
			    else if ((MyCRI.CurrentRanking[Ordered[j].PlayerID] == MyCRI.CurrentRanking[Ordered[Max].PlayerID])
                && (Ordered[J].Deaths < Ordered[Max].Deaths))
				    Max = J;
			    else if ((Ordered[J].Score == Ordered[Max].Score)
                && (Ordered[J].Deaths == Ordered[Max].Deaths)
                && (Ordered[J].PlayerID < Ordered[Max].Score))
				    Max = J;
		    }
		    TempPRI = Ordered[Max];
		    Ordered[Max] = Ordered[I];
		    Ordered[I] = TempPRI;
	    }
    }
}

//-------------------------------------
// defaultproperties
//-------------------------------------
defaultproperties
{
    RedColor=(R=255,G=5,B=5,A=0),
    BlueColor=(R=5,G=5,B=255,A=0),
    GreenColor=(R=0,G=255,B=0,A=0),
    GoldColor=(R=255,G=255,B=0,A=0),
    WhiteColor=(R=255,G=255,B=255,A=0),
    GrayColor=(R=255,G=200,B=100,A=0),
    CyanColor=(R=0,G=128,B=255,A=0),
    BronzeColor=(R=203,G=147,B=52,A=0),
    ServerInfoText="Server Info"
    ContactInfoText="Contact Info"
    NameText="Name:"
    AdminText="Admin:"
    EMailText="EMail:"
    UnknownText="Unknown"
    MOTD="Message of the Day"
    ServerStatsText="Server Stats"
    FragsLoggedText="Frags Logged:"
    GamesHostedText="Games Hosted:"
    VictimsText="Lives Claimed:"
    GameStatsText="Game Stats"
    GameTypeText="Game:"
    PlayersText="Players:"
    FragsText="Total Frags:"
    TopPlayersText="Top Players [Frags per Hour]"
    BestNameText="Name"
    BestFPHText="Best FPH"
    BestRecordSetText="Record Set"
    BotText="Bots"
    FlagsCapturedText="Flags Captured:"
    TotalGrabsText="Total Flag Grabs:"
    TotalSealsText="Total Flag Seals:"
    TotalAssistsText="Total Flag Assists:"
    TotalCoversText="Total Flag Covers:"
    TotalFlagKillsText="Total Flag Kills:"
    TotalDeniedText="Total Flag Denials:"
    TotalSavesText="Total Flag Saves:"
    PlayerStatsText="SmartCTF Stats Plus"
    BestPlayersText(0)="Best Rank #1:"
    BestPlayersText(1)="Best Rank #2:"
    BestPlayersText(2)="Best Rank #3:"
}
