class EUTStatInfo expands Info;

var EUTGameReplicationInfo MyCRI;
var PlayerReplicationInfo RedPRI[32];
var PlayerReplicationInfo BluePRI[32];
var PlayerReplicationInfo RedPRI2[32];
var PlayerReplicationInfo BluePRI2[32];
var PlayerReplicationInfo OrderedPRI[32];
var PlayerReplicationInfo OrderedPRI2[32];
var FontInfo _FontInfo;

var bool bCTF,
    bTDM,
    bDM;

var color YellowColor,
    GreenColor,
    WhiteColor,
    GoldColor,
    BlueColor,
    LightCyanColor,
    SilverColor,
    BronzeColor,
    CyanColor,
    RedColor,
    ShadeColor,
    DarkRedColor,
    DarkBlueColor;

var float FloatingY,
    FloatingY2,
    ScaleOffset,
    SpacerOffset,
    AvgLine,
    EnforcerLine,
    BioLine,
    ShockRifleLine,
    PulseGunLine,
    RipperLine,
    MiniGunLine,
    FlakGunLine,
    EightBallLine,
    SniperLine,
    TotalsLine,
    UltraKillLine,
    MonsterKillLine,
    LudKillLine,
    HolyShitLine,
    KillingSpreeLine,
    RampageLine,
    DominatingLine,
    UnStoppableLine,
    GodlikeLine,
    OwnageLine,
    CoversLine,
    SealsLine,
    HeadHunterLine,
    FlakMonkeyLine,
    ComboWhoreLine;

var texture BaseFill, EUTHeadShots;

var localized string StatInfoText,
    PlayerStatsText,
    SpreesText;

//-------------------------------------
// Destroyed
//-------------------------------------
function Destroyed()
{
	Super.Destroyed();
    if (_FontInfo != none)
        _FontInfo.Destroy();
}

//-------------------------------------
// PostBeginPlay
//-------------------------------------
function PostBeginPlay()
{
	Super.PostBeginPlay();
	_FontInfo = FontInfo(Spawn(Class<Actor>(DynamicLoadObject(class'ChallengeHUD'.default.FontInfoClass, class'Class'))));
    BaseFill = Texture(DynamicLoadObject("EUT_Textures.EUT_Fill", class'Texture'));
    EUTHeadShots = Texture(DynamicLoadObject("EUT_Textures.EUT_HeadShots", class'Texture'));
}

//-------------------------------------
// RenderInfo
//-------------------------------------
function RenderInfo( canvas C )
{
	local GameReplicationInfo GRI;

    GRI = PlayerPawn(Owner).GameReplicationInfo;

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
           bCTF = true;
           MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
           break;

        case Class'EUTTDMHud':
            bTDM = true;
            MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
            break;

        case Class'EUTDMHud':
            bDM = true;
            MyCRI = EUTGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
            break;
    }

	if (C.ClipX > 512)
	{
        C.DrawColor = ShadeColor;
        C.Style = ERenderStyle.STY_Modulated;
        C.SetPos(0,0);
        C.DrawRect(BaseFill, C.ClipX, C.ClipY);
        C.Style = ERenderStyle.STY_Normal;
        DrawPlayerStats(C, GRI);
        DrawPlayerSprees(C, GRI);
	}
}

//-------------------------------------
// DrawPlayerStats
//-------------------------------------
function DrawPlayerStats(Canvas C, GameReplicationInfo GRI)
{
    local float XL, YL, ScaleOffset, SpacerOffset, X, Y, Start, Start2, Y2;
	local TournamentGameReplicationInfo TGRI;
	local byte i, NumRed, NumBlue, Total;
	local PlayerReplicationInfo PRI;

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
        case Class'EUTTDMHud':
            for (i = 0; i < ArrayCount(RedPRI); i++)
                RedPRI[i] = None;

    	    for (i = 0; i < 32; i++)
            {
                PRI = GRI.PRIArray[i];
                if (PRI != none
                && (PRI.PlayerName != "Player")
                && (PRI.Team == 0))
                {
                    if (!PRI.bIsSpectator || PRI.bWaitingPlayer)
    			    {
                        RedPRI[NumRed] = PRI;
                        NumRed++;
                        if (NumRed == ArrayCount(RedPRI)) break;
                    }
               }
            }
            SortScoresRed(NumRed);

            for (i = 0; i < ArrayCount(BluePRI); i++)
                BluePRI[i] = None;

    	    for (i = 0; i < 32; i++)
            {
                PRI = GRI.PRIArray[i];
                if (PRI != none
                && (PRI.PlayerName != "Player")
                && (PRI.Team == 1))
                {
                    if (!PRI.bIsSpectator || PRI.bWaitingPlayer)
    			    {
                        BluePRI[NumBlue] = PRI;
                        NumBlue++;
                        if (NumBlue == ArrayCount(BluePRI)) break;
                    }
                }
            }
            SortScoresBlue(NumBlue);
            break;

        case Class'EUTDMHud':
            for (i = 0; i < ArrayCount(OrderedPRI); i++)
                OrderedPRI[i] = None;

            for (i = 0; i < 32; i++)
            {
                PRI = GRI.PRIArray[i];
                if (PRI != none
                && (PRI.PlayerName != "Player"))
                {
                    if ( !PRI.bIsSpectator || PRI.bWaitingPlayer )
    			    {
                        OrderedPRI[Total] = PRI;
                        Total++;
                        if (Total == ArrayCount(OrderedPRI)) break;
                    }
                }
            }
            SortScores(Total);
            break;
    }

    if (C.ClipX < 600)
	{
	   ScaleOffset = 0.15;
	   SpacerOffset = 10;
    }
	else if (C.ClipX > 600 && (C.ClipX < 760))
    {
       ScaleOffset = 0.22;
       SpacerOffset = 10;
    }
    else if (C.Clipx > 760 && (C.ClipX < 900))
    {
       ScaleOffset = 0.25;
       SpacerOffset = 10;
    }
    else if (C.ClipX > 900 && (C.ClipX < 1200))
    {
       ScaleOffset = 0.30;
       SpacerOffset = 25;
    }
    else
    {
       ScaleOffset = 0.50;
       SpacerOffset = 40;
    }

    C.DrawColor = YellowColor;
	C.Font = _FontInfo.GetBigFont( C.ClipX);
	C.StrLen(PlayerStatsText, XL, YL);
	C.SetPos((C.ClipX - XL) / 2, 0 + YL * 2);
	C.DrawText(PlayerStatsText, True);
	C.DrawColor = GreenColor;
	FloatingY = YL * 3;

    if (C.ClipX > 800) C.Font = _FontInfo.GetSmallFont(C.ClipX);
    else C.Font = _FontInfo.GetSmallestFont(C.ClipX);

    C.StrLen("12345678901234567890", XL, YL);

	X = C.ClipX / 8;
	Y = FloatingY + (YL * 2);
    C.SetPos(X, Y);
	C.DrawText("Player", True);
    C.SetPos(X + (XL + 7), Y);
    C.DrawText("AVG ", True);
    AvgLine = C.ClipX / 8 + (XL + SpacerOffset);
    C.Style = ERenderStyle.STY_Translucent;
    C.StrLen("### ", XL, YL);
	C.SetPos(AvgLine + (XL + 7), Y);
	C.DrawIcon(texture'BotPack.IconAutom',ScaleOffset);
    EnforcerLine = AvgLine + (XL + SpacerOffset);
	C.SetPos(EnforcerLine + (XL + 7), Y);
    C.DrawIcon(texture'BotPack.IconBio',ScaleOffset);
    BioLine = EnforcerLine + (XL + SpacerOffset);
	C.SetPos(BioLine + (XL + 7), Y);
    C.DrawIcon(texture'BotPack.IconASMD',ScaleOffset);
    ShockRifleLine = BioLine + (XL + SpacerOffset);
	C.SetPos(ShockRifleLine + (XL + 7), Y);
    C.DrawIcon(texture'BotPack.IconPulse',ScaleOffset);
    PulseGunLine = ShockRifleLine + (XL + SpacerOffset);
	C.SetPos(PulseGunLine + (XL + 7), Y);
    C.DrawIcon(texture'BotPack.IconRazor',ScaleOffset);
    RipperLine = PulseGunLine + (XL + SpacerOffset);
	C.SetPos(RipperLine + (XL + 7), Y);
    C.DrawIcon(texture'BotPack.IconMini',ScaleOffset);
    MiniGunLine = RipperLine + (XL + SpacerOffset);
	C.SetPos(MiniGunLine + (XL + 7), Y);
    C.DrawIcon(texture'BotPack.IconFlak',ScaleOffset);
    FlakGunLine = MiniGunLine + (XL + SpacerOffset);
	C.SetPos(FlakGunLine + (XL + 7), Y);
    C.DrawIcon(texture'BotPack.Icon8ball',ScaleOffset);
    EightBallLine = FlakGunLine + (XL + SpacerOffset);
	C.SetPos(EightBallLine + (XL + 7), Y);

	switch (MyCRI.TextureSwitch)
	{
	   case 0: C.DrawIcon(texture'BotPack.IconRifle',ScaleOffset); break;
	   case 1: C.DrawIcon(EUTHeadShots,ScaleOffset); break;
	}

    SniperLine = EightBallLine + (XL + SpacerOffset);
    C.Style = ERenderStyle.STY_Normal;
    C.StrLen("TEST", XL, YL );
    Start = FloatingY + (YL * 5);
    Y = Start;

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
        case Class'EUTTDMHud':
           for (i = 0; i < NumRed; i++)
    	   {
    	       Y = Start + i * YL;
               DrawInfo(C, RedPRI[i], Y);
    	   }
    	   Start = FloatingY + (YL * 5) + (YL * NumRed);
    	   for (i = 0; i < NumBlue; i++)
    	   {
    	       Y = Start + i * YL;
               DrawInfo(C, BluePRI[i], Y);
    	   }
           break;

        case Class'EUTDMHud':
           Start = FloatingY + (YL * 5);
           for (i = 0; i < Total; i++)
    	   {
    	       Y = Start + i * YL;
               DrawInfo(C, OrderedPRI[i], Y);
    	   }
           break;
    }
}

//-------------------------------------
// DrawInfo
//-------------------------------------
function DrawInfo(Canvas C, PlayerReplicationInfo PRI, float Y)
{
    local float XL, YL, XL2, YL2, X;
	local bool bLocal, bZP;
	local PlayerPawn MyPlayer;
	local byte EAcc, Shock, SniperHeadShotAcc;
	local int pid;
	local float Acc;

	MyPlayer = PlayerPawn(Owner);
	bZp = false;
	bLocal = (PRI.PlayerName == MyPlayer.PlayerReplicationInfo.PlayerName);
	pid = PRI.PlayerID;

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
        case Class'EUTTDMHud':
        case Class'EUTDMHud':
           EAcc = MyCRI.PlayerAccuracy3[pid].InstaGib;
           if(EAcc != 0) bZp = true;
        break;
    }

    if (MyCRI.HeadHunterCount[pid] < 1)
        Acc = float(MyCRI.HeadShotsCount[pid]) / float(MyCRI.TotalKills[pid]) * 100;
    else
        Acc = float(MyCRI.HeadShotsCount[pid] + (MyCRI.HeadHunterCount[pid] * 31)) / float(MyCRI.TotalKills[pid]) * 100;

    if(Acc < 0) Acc = 0;
    SniperHeadShotAcc = byte(Acc);

	if (C.ClipX > 800) C.Font = _FontInfo.GetSmallFont( C.ClipX );
    else C.Font = _FontInfo.GetSmallestFont(C.ClipX);

	switch (PRI.Team)
    {
        case 0: C.DrawColor = RedColor; break;
        case 1: C.DrawColor = BlueColor; break;
        case 2: C.DrawColor = GreenColor; break;
        case 3: C.DrawColor = GoldColor; break;
        case 255: C.DrawColor = BronzeColor; break;
    }

	if (bLocal) C.DrawColor = WhiteColor;

	C.SetPos(C.ClipX/8, Y);
	C.DrawText(PRI.PlayerName, False);
	C.SetPos(AvgLine, Y);

	switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
        case Class'EUTTDMHud':
        case Class'EUTDMHud':
           C.DrawText(MyCRI.CurrentTotalAccuracy[pid]$" %", False);
           C.SetPos(EnforcerLine, Y);
           C.DrawText(MyCRI.PlayerAccuracy1[pid].Enforcer$" %", False);
           C.SetPos(BioLine, Y);
           C.DrawText(MyCRI.PlayerAccuracy1[pid].BioGun$" %", False);
           if (!bZP)
           {
               C.SetPos(ShockRifleLine, Y);
               C.DrawText(MyCRI.PlayerAccuracy1[pid].ShockRifle$" %", False);
           }
           else
           {
               C.SetPos(ShockRifleLine, Y);
	           C.DrawText(EAcc$" %", False);
           }
           C.SetPos(PulseGunLine, Y);
           C.DrawText(MyCRI.PlayerAccuracy2[pid].PulseGun$" %", False);
           C.SetPos(RipperLine, Y);
           C.DrawText(MyCRI.PlayerAccuracy2[pid].Ripper$" %", False);
           C.SetPos(MiniGunLine, Y);
           C.DrawText(MyCRI.PlayerAccuracy2[pid].MiniGun$" %", False);
           C.SetPos(FlakGunLine, Y);
           C.DrawText(MyCRI.PlayerAccuracy3[pid].FlakCannon$" %", False);
           C.SetPos(EightBallLine, Y);
           C.DrawText(MyCRI.PlayerAccuracy3[pid].EightBall$" %", False);
           C.SetPos(SniperLine, Y);

           if (!MyCRI.bUsesCustomWeapon)
           {
                switch (MyCRI.TextureSwitch)
            	{
            	   case 0: C.DrawText(MyCRI.PlayerAccuracy3[pid].SniperRifle$" %", False); break;
            	   case 1: C.DrawText(SniperHeadShotAcc$" %", False); break;
            	}
           }
           else
           {
                switch (MyCRI.TextureSwitch)
            	{
            	   case 0: C.DrawText(MyCRI.PlayerAccuracy4[pid].CustomWeapon$" %", False); break;
            	   case 1: C.DrawText(SniperHeadShotAcc$" %", False); break;
            	}
           }

           break;
    }
	FloatingY2 = Y + 30;
}

//-------------------------------------
// DrawPlayerSprees
//-------------------------------------
function DrawPlayerSprees(Canvas C, GameReplicationInfo GRI)
{
    local float XL, YL, ScaleOffset, SpacerOffset, Y, Start, Start2, Y2;
	local TournamentGameReplicationInfo TGRI;
	local byte i, NumRed, NumBlue, Total;
	local PlayerReplicationInfo PRI;

    C.DrawColor = YellowColor;

    if (C.ClipX < 600)
	{
	   ScaleOffset = 0.15;
	   SpacerOffset = 10;
    }
	else if (C.ClipX > 600 && (C.ClipX < 760))
    {
       ScaleOffset = 0.22;
       SpacerOffset = 10;
    }
    else if (C.Clipx > 760 && (C.ClipX < 900))
    {
       ScaleOffset = 0.25;
       SpacerOffset = 10;
    }
    else if (C.ClipX > 900 && (C.ClipX < 1200))
    {
       ScaleOffset = 0.30;
       SpacerOffset = 25;
    }
    else
    {
       ScaleOffset = 0.50;
       SpacerOffset = 40;
    }

	C.Font = _FontInfo.GetBigFont( C.ClipX);
	C.StrLen(SpreesText, XL, YL);
	C.SetPos((C.ClipX - XL) / 2, FloatingY2);
	C.DrawText(SpreesText, True);
	C.DrawColor.R = 0;
	C.DrawColor.G = 255;
	C.DrawColor.B = 50;

    if (C.ClipX > 800) C.Font = _FontInfo.GetSmallFont(C.ClipX);
    else C.Font = _FontInfo.GetSmallestFont(C.ClipX);

    C.StrLen("12345678901234567890", XL, YL);
	C.SetPos(C.ClipX / 8, FloatingY2 + (YL * 2));
	C.DrawText("Player", True);
    C.SetPos(C.ClipX / 8 + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("Total", True);
    TotalsLine = C.ClipX / 8 + (XL + 7);
    C.StrLen("Total", XL, YL);
	C.SetPos(TotalsLine + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("Ult", True);
    UltraKillLine = TotalsLine + (XL + 7);
    C.StrLen("###", XL, YL);
	C.SetPos(UltraKillLine + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("Mon", True);
    MonsterKillLine = UltraKillLine + (XL + 7);
	C.SetPos(MonsterKillLine + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("Lud", True);
    LudKillLine = MonsterKillLine + (XL + 7);
	C.SetPos(LudKillLine + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("HoS", True);
    HolyShitLine = LudKillLine + (XL + 7);
	C.SetPos(HolyShitLine + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("KSp", True);
    KillingSpreeLine = HolyShitLine + (XL + 7);
	C.SetPos(KillingSpreeLine + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("Ram", True);
    RampageLine = KillingSpreeLine + (XL + 7);
	C.SetPos(RampageLine + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("Dom", True);
    DominatingLine = RampageLine + (XL + 7);
	C.SetPos(DominatingLine + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("Uns", True);
    UnStoppableLine = DominatingLine + (XL + 7);
	C.SetPos(UnStoppableLine + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("God", True);
    GodlikeLine = UnStoppableLine + (XL + 7);
	C.SetPos(GodlikeLine + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("WkS", True);
    OwnageLine = GodlikeLine + (XL + 7);
	C.SetPos(OwnageLine + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("Cov", True);
    CoversLine = OwnageLine + (XL + 7);
	C.SetPos(CoversLine + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("Sls", True);
    SealsLine = CoversLine + (XL + 7);
    C.SetPos(SealsLine + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("CoW", true);
    ComboWhoreLine = SealsLine + (XL + 7);
    C.SetPos(ComboWhoreLine + (XL + 7), FloatingY2 + (YL * 2));
    C.DrawText("FkM", true);
    FlakMonkeyLine = ComboWhoreLine + (XL + 7);
    C.SetPos(FlakMonkeyLine + (XL + 7), FloatingY2 + (YL * 2));
    switch (MyCRI.TextureSwitch)
	{
	   case 0: C.DrawText("HdH", true); break;
	   case 1: C.DrawText("HsT", true); break;
	}
    //C.DrawText("HdH", true);
    HeadHunterLine = FlakMonkeyLine + (XL + 7);

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
        case Class'EUTTDMHud':
           for (i = 0; i < ArrayCount(RedPRI2); i++)
    		   RedPRI2[i] = None;

    	   for (i = 0; i < 32; i++)
           {
               PRI = GRI.PRIArray[i];
               if (PRI != none
               && (PRI.PlayerName != "Player")
               && (PRI.Team == 0))
               {
                   if (!PRI.bIsSpectator || PRI.bWaitingPlayer)
    			   {
                       RedPRI2[NumRed] = PRI;
                       NumRed++;
                       if (NumRed == ArrayCount(RedPRI2)) break;
                   }
               }
           }
           SortScoresRed2(NumRed);

           for (i = 0; i < ArrayCount(BluePRI2); i++)
    		   BluePRI2[i] = None;

    	   for (i = 0; i < 32; i++)
           {
               PRI = GRI.PRIArray[i];
               if (PRI != none
               && (PRI.PlayerName != "Player")
               && (PRI.Team == 1))
               {
                   if (!PRI.bIsSpectator || PRI.bWaitingPlayer)
    			   {
                       BluePRI2[NumBlue] = PRI;
                       NumBlue++;
                       if (NumBlue == ArrayCount(BluePRI2)) break;
                   }
               }
           }
           SortScoresBlue2(NumBlue);
           C.StrLen( "TEST", XL, YL );
           Start = FloatingY2 + (YL * 5);
           Y = Start;

           for (i = 0; i < NumRed; i++)
    	   {
    	       Y = Start + i * YL;
               DrawSprees(C, RedPRI2[i], Y);
    	   }
    	   Start = FloatingY2 + (YL * 5) + (YL * NumRed);

    	   for (i = 0; i < NumBlue; i++)
    	   {
    	       Y = Start + i * YL;
               DrawSprees(C, BluePRI2[i], Y);
    	   }
           break;

        case Class'EUTDMHud':
           for (i = 0; i < ArrayCount(OrderedPRI2); i++)
    		   OrderedPRI2[i] = None;

    	   for (i = 0; i < 32; i++)
           {
               PRI = GRI.PRIArray[i];
               if (PRI != none
               && (PRI.PlayerName != "Player"))
               {
                   if (!PRI.bIsSpectator || PRI.bWaitingPlayer)
    			   {
                       OrderedPRI2[Total] = PRI;
                       Total++;
                       if (Total == ArrayCount(OrderedPRI2)) break;
                   }
               }
           }
           SortScores2(Total);
           C.StrLen( "TEST", XL, YL );
           Start = FloatingY2 + (YL * 5);
           Y = Start;
           Start = FloatingY2 + (YL * 5);

           for (i = 0; i < Total; i++)
    	   {
    	       Y = Start + i * YL;
               DrawSprees(C, OrderedPRI2[i], Y);
    	   }
           break;
    }
}

//-------------------------------------
// DrawSprees
//-------------------------------------
function DrawSprees(Canvas C, PlayerReplicationInfo PRI, float Y)
{
    local float XL, YL, XL2, YL2;
	local bool bLocal;
	local PlayerPawn MyPlayer;
    local byte Total;
    local int pid;

	MyPlayer = PlayerPawn(Owner);
    bLocal = (PRI.PlayerName == MyPlayer.PlayerReplicationInfo.PlayerName);
    pid = PRI.PlayerID;

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
           Total = MyCRI.KillingSpree[pid].UltraKills +
	          MyCRI.KillingSpree[pid].MonsterKills +
	          MyCRI.KillingSpree[pid].LudicriousKills +
	          MyCRI.KillingSpree[pid].HolyShitKills +
	          MyCRI.MultiKills1[pid].KillingSpree +
	          MyCRI.MultiKills1[pid].Rampage +
	          MyCRI.MultiKills1[pid].Dominating +
	          MyCRI.MultiKills2[pid].UnStoppable +
	          MyCRI.MultiKills2[pid].Godlike +
	          MyCRI.MultiKills2[pid].Ownage +
	          MyCRI.CoversSpreeCount[pid] +
	          MyCRI.SealsSpreeCount[pid];
           break;

        case Class'EUTTDMHud':
        case Class'EUTDMHud':
           Total = MyCRI.KillingSpree[pid].UltraKills +
	          MyCRI.KillingSpree[pid].MonsterKills +
	          MyCRI.KillingSpree[pid].LudicriousKills +
	          MyCRI.KillingSpree[pid].HolyShitKills +
	          MyCRI.MultiKills1[pid].KillingSpree +
	          MyCRI.MultiKills1[pid].Rampage +
	          MyCRI.MultiKills1[pid].Dominating +
	          MyCRI.MultiKills2[pid].UnStoppable +
	          MyCRI.MultiKills2[pid].Godlike +
	          MyCRI.MultiKills2[pid].Ownage;
           break;
    }

	if (C.ClipX > 800) C.Font = _FontInfo.GetSmallFont( C.ClipX );
    else C.Font = _FontInfo.GetSmallestFont( C.ClipX );

	switch (PRI.Team)
    {
        case 0: C.DrawColor = RedColor; break;
        case 1: C.DrawColor = BlueColor; break;
        case 2: C.DrawColor = GreenColor; break;
        case 3: C.DrawColor = GoldColor; break;
        case 255: C.DrawColor = BronzeColor; break;
    }

	if (bLocal) C.DrawColor = WhiteColor;


	C.SetPos(C.ClipX / 8, Y);
	C.DrawText(PRI.PlayerName, False);
	C.SetPos(TotalsLine, Y);
	C.DrawText(Total, False);
	C.SetPos(UltraKillLine, Y);

	switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
           C.DrawText(MyCRI.KillingSpree[pid].UltraKills, False);
           C.SetPos(MonsterKillLine, Y);
	       C.DrawText(MyCRI.KillingSpree[pid].MonsterKills, False);
	       C.SetPos(LudKillLine, Y);
	       C.DrawText(MyCRI.KillingSpree[pid].LudicriousKills, False);
	       C.SetPos(HolyShitLine, Y);
	       C.DrawText(MyCRI.KillingSpree[pid].HolyShitKills, False);
	       C.SetPos(KillingSpreeLine, Y);
	       C.DrawText(MyCRI.MultiKills1[pid].KillingSpree, False);
	       C.SetPos(RampageLine, Y);
	       C.DrawText(MyCRI.MultiKills1[pid].Rampage, False);
	       C.SetPos(DominatingLine, Y);
	       C.DrawText(MyCRI.MultiKills1[pid].Dominating, False);
	       C.SetPos(UnStoppableLine, Y);
	       C.DrawText(MyCRI.MultiKills2[pid].UnStoppable, False);
	       C.SetPos(GodlikeLine, Y);
	       C.DrawText(MyCRI.MultiKills2[pid].Godlike, False);
	       C.SetPos(OwnageLine, Y);
	       C.DrawText(MyCRI.MultiKills2[pid].Ownage, False);
	       C.SetPos(CoversLine, Y);
	       C.DrawText(MyCRI.CoversSpreeCount[pid], False);
	       C.SetPos(SealsLine, Y);
	       C.DrawText(MyCRI.SealsSpreeCount[pid], False);
	       C.SetPos(ComboWhoreLine, Y);
	       C.DrawText(MyCRI.ComboWhoreCount[pid], False);
	       C.SetPos(FlakMonkeyLine, Y);
	       C.DrawText(MyCRI.FlakMonkeyCount[pid], False);
	       C.SetPos(HeadHunterLine, Y);
	       switch (MyCRI.TextureSwitch)
	       {
	            case 0: C.DrawText(MyCRI.HeadHunterCount[pid], False); break;
	            case 1:
                    if (MyCRI.HeadHunterCount[pid] < 1)
                        C.DrawText(MyCRI.HeadShotsCount[pid], False);
                    else
                        C.DrawText(MyCRI.HeadHunterCount[pid] * 31 + MyCRI.HeadShotsCount[pid], False);
                break;
	       }
           break;

        case Class'EUTTDMHud':
        case Class'EUTDMHud':
           C.DrawText(MyCRI.KillingSpree[pid].UltraKills, False);
           C.SetPos(MonsterKillLine, Y);
           C.DrawText(MyCRI.KillingSpree[pid].MonsterKills, False);
           C.SetPos(LudKillLine, Y);
           C.DrawText(MyCRI.KillingSpree[pid].LudicriousKills, False);
           C.SetPos(HolyShitLine, Y);
           C.DrawText(MyCRI.KillingSpree[pid].HolyShitKills, False);
           C.SetPos(KillingSpreeLine, Y);
           C.DrawText(MyCRI.MultiKills1[pid].KillingSpree, False);
           C.SetPos(RampageLine, Y);
           C.DrawText(MyCRI.MultiKills1[pid].Rampage, False);
           C.SetPos(DominatingLine, Y);
           C.DrawText(MyCRI.MultiKills1[pid].Dominating, False);
           C.SetPos(UnStoppableLine, Y);
           C.DrawText(MyCRI.MultiKills2[pid].UnStoppable, False);
           C.SetPos(GodlikeLine, Y);
           C.DrawText(MyCRI.MultiKills2[pid].Godlike, False);
           C.SetPos(OwnageLine, Y);
           C.DrawText(MyCRI.MultiKills2[pid].Ownage, False);
           C.SetPos(CoversLine, Y);
           C.DrawText("0", False);
           C.SetPos(SealsLine, Y);
           C.DrawText("0", False);
           C.SetPos(ComboWhoreLine, Y);
           C.DrawText(MyCRI.ComboWhoreCount[pid], False);
           C.SetPos(FlakMonkeyLine, Y);
           C.DrawText(MyCRI.FlakMonkeyCount[pid], False);
           C.SetPos(HeadHunterLine, Y);
           switch (MyCRI.TextureSwitch)
	       {
	           case 0: C.DrawText(MyCRI.HeadHunterCount[pid], False); break;
	           case 1:
                    if (MyCRI.HeadHunterCount[pid] < 1)
                        C.DrawText(MyCRI.HeadShotsCount[pid], False);
                    else
                        C.DrawText(MyCRI.HeadHunterCount[pid] * 31 + MyCRI.HeadShotsCount[pid], False);
                break;
	       }
           break;

    }
}

//-------------------------------------
// SortScoresRed
//-------------------------------------
function SortScoresRed(int N)
{
	local int I, J, Max;
	local PlayerReplicationInfo TempPRI;

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
           for (I = 0; I < N - 1; I++)
    	   {
    		   Max = I;
               for (J = I + 1; J < N; J++)
    		   {
                  if(MyCRI.CurrentTotalAccuracy[RedPRI[j].PlayerID] > MyCRI.CurrentTotalAccuracy[RedPRI[Max].PlayerID])
    				  Max = J;
    			  else if((MyCRI.CurrentTotalAccuracy[RedPRI[j].PlayerID] == MyCRI.CurrentTotalAccuracy[RedPRI[Max].PlayerID])
                  &&(RedPRI[J].Deaths < RedPRI[Max].Deaths))
    				  Max = J;
    			  else if((RedPRI[J].Score == RedPRI[Max].Score)
                  &&(RedPRI[J].Deaths == RedPRI[Max].Deaths)
                  &&(RedPRI[J].PlayerID < RedPRI[Max].Score))
    				  Max = J;
    		   }
               TempPRI = RedPRI[Max];
    		   RedPRI[Max] = RedPRI[I];
    		   RedPRI[I] = TempPRI;
    	   }
           break;

        case Class'EUTTDMHud':
           for (I = 0; I < N - 1; I++)
    	   {
    		   Max = I;
               for (J = I + 1; J < N; J++)
    		   {
                  if(MyCRI.CurrentTotalAccuracy[RedPRI[j].PlayerID] > MyCRI.CurrentTotalAccuracy[RedPRI[Max].PlayerID])
    				  Max = J;
    			  else if((MyCRI.CurrentTotalAccuracy[RedPRI[j].PlayerID] == MyCRI.CurrentTotalAccuracy[RedPRI[Max].PlayerID])
                  &&(RedPRI[J].Deaths < RedPRI[Max].Deaths))
    				  Max = J;
    			  else if((RedPRI[J].Score == RedPRI[Max].Score)
                  &&(RedPRI[J].Deaths == RedPRI[Max].Deaths)
                  &&(RedPRI[J].PlayerID < RedPRI[Max].Score))
    				  Max = J;
    		   }
               TempPRI = RedPRI[Max];
    		   RedPRI[Max] = RedPRI[I];
    		   RedPRI[I] = TempPRI;
    	   }
            break;

        case Class'EUTDMHud': break;
    }
}

//-------------------------------------
// SortScoresBlue
//-------------------------------------
function SortScoresBlue(int N)
{
	local int I, J, Max;
	local PlayerReplicationInfo TempPRI;

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
           for (I = 0; I < N - 1; I++)
    	   {
                Max = I;
                for (J = I + 1; J < N; J++)
        		{
                    if(MyCRI.CurrentTotalAccuracy[BluePRI[j].PlayerID] > MyCRI.CurrentTotalAccuracy[BluePRI[Max].PlayerID])
            			Max = J;
            		else if((MyCRI.CurrentTotalAccuracy[BluePRI[j].PlayerID] == MyCRI.CurrentTotalAccuracy[BluePRI[Max].PlayerID])
                    &&(BluePRI[J].Deaths < BluePRI[Max].Deaths))
            			Max = J;
            		else if((BluePRI[J].Score == BluePRI[Max].Score)
                    &&(BluePRI[J].Deaths == BluePRI[Max].Deaths)
                    &&(BluePRI[J].PlayerID < BluePRI[Max].Score))
            			Max = J;
        		}
                TempPRI = BluePRI[Max];
        		BluePRI[Max] = BluePRI[I];
        		BluePRI[I] = TempPRI;
    	   }
           break;

        case Class'EUTTDMHud':
           for (I = 0; I < N - 1; I++)
    	   {
                Max = I;
                for (J = I + 1; J < N; J++)
        		{
                    if(MyCRI.CurrentTotalAccuracy[BluePRI[j].PlayerID] > MyCRI.CurrentTotalAccuracy[BluePRI[Max].PlayerID])
            			Max = J;
            		else if((MyCRI.CurrentTotalAccuracy[BluePRI[j].PlayerID] == MyCRI.CurrentTotalAccuracy[BluePRI[Max].PlayerID])
                    &&(BluePRI[J].Deaths < BluePRI[Max].Deaths))
            			Max = J;
            		else if((BluePRI[J].Score == BluePRI[Max].Score)
                    &&(BluePRI[J].Deaths == BluePRI[Max].Deaths)
                    &&(BluePRI[J].PlayerID < BluePRI[Max].Score))
            			Max = J;
        		}
                TempPRI = BluePRI[Max];
        		BluePRI[Max] = BluePRI[I];
        		BluePRI[I] = TempPRI;
    	   }
           break;

        case Class'EUTDMHud': break;
    }
}

//-------------------------------------
// SortScores
//-------------------------------------
function SortScores(int N)
{
	local int I, J, Max;
	local PlayerReplicationInfo TempPRI;

    if (bDM)
	{
        for (I = 0; I < N - 1; I++)
	    {
            Max = I;
            for (J = I + 1; J < N; J++)
		    {
                if(MyCRI.CurrentTotalAccuracy[OrderedPRI[j].PlayerID] > MyCRI.CurrentTotalAccuracy[OrderedPRI[Max].PlayerID])
                    Max = J;
			    else if((MyCRI.CurrentTotalAccuracy[OrderedPRI[j].PlayerID] == MyCRI.CurrentTotalAccuracy[OrderedPRI[Max].PlayerID])
                &&(OrderedPRI[J].Deaths < OrderedPRI[Max].Deaths))
				    Max = J;
			    else if((OrderedPRI[J].Score == OrderedPRI[Max].Score)
                &&(OrderedPRI[J].Deaths == OrderedPRI[Max].Deaths)
                &&(OrderedPRI[J].PlayerID < OrderedPRI[Max].Score))
				    Max = J;
		    }
            TempPRI = OrderedPRI[Max];
		    OrderedPRI[Max] = OrderedPRI[I];
		    OrderedPRI[I] = TempPRI;
	    }
    }
}

//-------------------------------------
// SortScoresRed2
//-------------------------------------
function SortScoresRed2(int N)
{
	local int I, J, Max;
	local PlayerReplicationInfo TempPRI;

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
           for (I = 0; I < N - 1; I++)
    	   {
                Max = I;
                for (J = I + 1; J < N; J++)
        		{
                    if(MyCRI.KillingSpree[RedPRI2[j].PlayerID].UltraKills +
                        MyCRI.KillingSpree[RedPRI2[j].PlayerID].MonsterKills +
                        MyCRI.KillingSpree[RedPRI2[j].PlayerID].LudicriousKills +
                        MyCRI.KillingSpree[RedPRI2[j].PlayerID].HolyShitKills  >
                        MyCRI.KillingSpree[RedPRI2[Max].PlayerID].UltraKills +
                        MyCRI.KillingSpree[RedPRI2[Max].PlayerID].MonsterKills +
                        MyCRI.KillingSpree[RedPRI2[Max].PlayerID].LudicriousKills +
                        MyCRI.KillingSpree[RedPRI2[Max].PlayerID].HolyShitKills)
            			Max = J;
            		else if((MyCRI.CurrentTotalAccuracy[RedPRI2[j].PlayerID] == MyCRI.CurrentTotalAccuracy[RedPRI2[Max].PlayerID])
                    &&(RedPRI2[J].Deaths < RedPRI2[Max].Deaths))
            			Max = J;
            		else if((RedPRI2[J].Score == RedPRI2[Max].Score)
                    &&(RedPRI2[J].Deaths == RedPRI2[Max].Deaths)
                    &&(RedPRI2[J].PlayerID < RedPRI2[Max].Score))
            			Max = J;
        		}
                TempPRI = RedPRI2[Max];
        		RedPRI2[Max] = RedPRI2[I];
        		RedPRI2[I] = TempPRI;
    	   }
           break;

        case Class'EUTTDMHud':
           for (I = 0; I < N - 1; I++)
    	   {
        		Max = I;
                for ( J = I + 1; J < N; J++ )
        		{
                    if(MyCRI.KillingSpree[RedPRI2[j].PlayerID].UltraKills +
                        MyCRI.KillingSpree[RedPRI2[j].PlayerID].MonsterKills +
                        MyCRI.KillingSpree[RedPRI2[j].PlayerID].LudicriousKills +
                        MyCRI.KillingSpree[RedPRI2[j].PlayerID].HolyShitKills  >
                        MyCRI.KillingSpree[RedPRI2[Max].PlayerID].UltraKills +
                        MyCRI.KillingSpree[RedPRI2[Max].PlayerID].MonsterKills +
                        MyCRI.KillingSpree[RedPRI2[Max].PlayerID].LudicriousKills +
                        MyCRI.KillingSpree[RedPRI2[Max].PlayerID].HolyShitKills)
            			Max = J;
            		else if((MyCRI.CurrentTotalAccuracy[RedPRI2[j].PlayerID] == MyCRI.CurrentTotalAccuracy[RedPRI2[Max].PlayerID])
                    &&(RedPRI2[J].Deaths < RedPRI2[Max].Deaths))
            			Max = J;
            		else if((RedPRI2[J].Score == RedPRI2[Max].Score)
                    &&(RedPRI2[J].Deaths == RedPRI2[Max].Deaths)
                    &&(RedPRI2[J].PlayerID < RedPRI2[Max].Score))
            			Max = J;
        		}
                TempPRI = RedPRI2[Max];
        		RedPRI2[Max] = RedPRI2[I];
        		RedPRI2[I] = TempPRI;
    	   }
           break;

        case Class'EUTDMHud': break;
    }
}

//-------------------------------------
// SortScoresBlue2
//-------------------------------------
function SortScoresBlue2(int N)
{
	local int I, J, Max;
	local PlayerReplicationInfo TempPRI;

    switch (PlayerPawn(Owner).HudType)
    {
        case Class'EUTCTFHud':
           for (I = 0; I < N - 1; I++)
    	   {
                Max = I;
                for (J = I + 1; J < N; J++)
        		{
                    if(MyCRI.KillingSpree[BluePRI2[j].PlayerID].UltraKills +
                        MyCRI.KillingSpree[BluePRI2[j].PlayerID].MonsterKills +
                        MyCRI.KillingSpree[BluePRI2[j].PlayerID].LudicriousKills +
                        MyCRI.KillingSpree[BluePRI2[j].PlayerID].HolyShitKills  >
                        MyCRI.KillingSpree[BluePRI2[Max].PlayerID].UltraKills +
                        MyCRI.KillingSpree[BluePRI2[Max].PlayerID].MonsterKills +
                        MyCRI.KillingSpree[BluePRI2[Max].PlayerID].LudicriousKills +
                        MyCRI.KillingSpree[BluePRI2[Max].PlayerID].HolyShitKills)
            			Max = J;
            		else if((MyCRI.CurrentTotalAccuracy[BluePRI2[j].PlayerID] == MyCRI.CurrentTotalAccuracy[BluePRI2[Max].PlayerID])
                    &&(BluePRI2[J].Deaths < BluePRI2[Max].Deaths))
            			Max = J;
            		else if((BluePRI2[J].Score == BluePRI2[Max].Score)
                    &&(BluePRI2[J].Deaths == BluePRI2[Max].Deaths)
                    &&(BluePRI2[J].PlayerID < BluePRI2[Max].Score))
            			Max = J;
        		}
                TempPRI = BluePRI2[Max];
        		BluePRI2[Max] = BluePRI2[I];
        		BluePRI2[I] = TempPRI;
    	   }
           break;

        case Class'EUTTDMHud':
           for (I = 0; I < N - 1; I++)
    	   {
                Max = I;
                for (J = I + 1; J < N; J++)
        		{
                    if(MyCRI.KillingSpree[BluePRI2[j].PlayerID].UltraKills +
                        MyCRI.KillingSpree[BluePRI2[j].PlayerID].MonsterKills +
                        MyCRI.KillingSpree[BluePRI2[j].PlayerID].LudicriousKills +
                        MyCRI.KillingSpree[BluePRI2[j].PlayerID].HolyShitKills  >
                        MyCRI.KillingSpree[BluePRI2[Max].PlayerID].UltraKills +
                        MyCRI.KillingSpree[BluePRI2[Max].PlayerID].MonsterKills +
                        MyCRI.KillingSpree[BluePRI2[Max].PlayerID].LudicriousKills +
                        MyCRI.KillingSpree[BluePRI2[Max].PlayerID].HolyShitKills)
            			Max = J;
            		else if((MyCRI.CurrentTotalAccuracy[BluePRI2[j].PlayerID] == MyCRI.CurrentTotalAccuracy[BluePRI2[Max].PlayerID])
                    &&(BluePRI2[J].Deaths < BluePRI2[Max].Deaths))
            			Max = J;
            		else if((BluePRI2[J].Score == BluePRI2[Max].Score)
                    &&(BluePRI2[J].Deaths == BluePRI2[Max].Deaths)
                    &&(BluePRI2[J].PlayerID < BluePRI2[Max].Score))
            			Max = J;
        		}
                TempPRI = BluePRI2[Max];
        		BluePRI2[Max] = BluePRI2[I];
        		BluePRI2[I] = TempPRI;
    	   }
            break;

        case Class'EUTDMHud': break;
    }
}

//-------------------------------------
// SortScores2
//-------------------------------------
function SortScores2(int N)
{
	local int I, J, Max;
	local PlayerReplicationInfo TempPRI;

    if (bDM)
	{
        for (I = 0; I < N - 1; I++)
	    {
            Max = I;
            for (J = I + 1; J < N; J++)
    		{
                if (MyCRI.KillingSpree[OrderedPRI2[j].PlayerID].UltraKills +
                    MyCRI.KillingSpree[OrderedPRI2[j].PlayerID].MonsterKills +
                    MyCRI.KillingSpree[OrderedPRI2[j].PlayerID].LudicriousKills +
                    MyCRI.KillingSpree[OrderedPRI2[j].PlayerID].HolyShitKills  >
                    MyCRI.KillingSpree[OrderedPRI2[Max].PlayerID].UltraKills +
                    MyCRI.KillingSpree[OrderedPRI2[Max].PlayerID].MonsterKills +
                    MyCRI.KillingSpree[OrderedPRI2[Max].PlayerID].LudicriousKills +
                    MyCRI.KillingSpree[OrderedPRI2[Max].PlayerID].HolyShitKills)
        			Max = J;
        		else if((MyCRI.CurrentTotalAccuracy[OrderedPRI2[j].PlayerID] == MyCRI.CurrentTotalAccuracy[OrderedPRI2[Max].PlayerID])
                &&(OrderedPRI2[J].Deaths < OrderedPRI2[Max].Deaths))
        			Max = J;
        		else if((OrderedPRI2[J].Score == OrderedPRI2[Max].Score)
                &&(OrderedPRI2[J].Deaths == OrderedPRI2[Max].Deaths)
                &&(OrderedPRI2[J].PlayerID < OrderedPRI2[Max].Score))
        			Max = J;
    		}
            TempPRI = OrderedPRI2[Max];
    		OrderedPRI2[Max] = OrderedPRI2[I];
    		OrderedPRI2[I] = TempPRI;
	    }
	}
}

//-------------------------------------
// defaultproperties
//-------------------------------------
defaultproperties
{
    YellowColor=(R=255,G=200,B=100,A=0),
    GreenColor=(R=0,G=255,B=0,A=0),
    WhiteColor=(R=255,G=255,B=255,A=0),
    GoldColor=(R=255,G=255,B=0,A=0),
    BlueColor=(R=0,G=0,B=255,A=0),
    LightCyanColor=(R=128,G=255,B=255,A=0),
    SilverColor=(R=138,G=164,B=166,A=0),
    BronzeColor=(R=203,G=147,B=52,A=0),
    CyanColor=(R=0,G=128,B=255,A=0),
    RedColor=(R=255,G=0,B=0,A=0),
    ShadeColor=(R=70,G=70,B=70,A=0),
    DarkRedColor=(R=5,G=0,B=0,A=0),
    DarkBlueColor=(R=0,G=0,B=5,A=0),
    StatInfoText="Enhanced Statistics"
    PlayerStatsText="Accuracy Stats:"
    SpreesText="Spree and Multi Stats:"
}
