/*
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
              EUTTeamGamePlus
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
*/
class EUTTeamGamePlus extends TeamGamePlus
	config;

#exec OBJ LOAD FILE=..\Sounds\EUT_Sounds.uax

var EUTGameReplicationInfo MyCRI;
var UTStatsLink StatLink;

var class<EUTEndStats> _EndStatsClass;

var ZoneInfo Z;
var LowGrav lg;
var Actor IpToCountry;

var bool bExpandSpree, bAltOvertime;

var byte AKMS[40], FlakKills[40], ComboKills[40], WarheadCount, ExpandedSpreeSwitch;

var int BestTDMRanking[3], LowGravityAerialKillAdjuster;

var string BestTDMPlayers[3];

var vector WarheadLocation[20];

struct _MultiKills
{
    var float MultiTime;
    var byte MultiLevel;
};
var _MultiKills MultiKills[40];


struct _WeaponDamage
{
    var int Enforcer,
    BioGun,
    ShockRifle,
    Ripper,
    MiniGun,
    PulseGun,
    FlakGun,
    EightBall,
    SniperRifle,
    SuperShockRifle,
    CustomWeapon;
};
var _WeaponDamage WeaponDamage[40];

struct _SplashKills
{
    var float FlakTime;
    var Pawn LastHit;
};
var _SplashKills SplashKills[40];

var() config bool bEnhancedSprees;
var() config bool bEnhancedMessages;
var() config bool bShowIPS;
var() config bool bLogMods;
var() config bool bCheckDefaults;
var() config bool bHitSounds;
var() config bool bDemoRequest;
var() config bool bKickSpeedHack;
var() config bool bReport;
var() config bool bAntiTimer;
var() config bool bTeamBeacon;
var() config bool bAutoTaunts;
var() config bool bEnhancedDeathMessages;
var() config bool bScoreBoardEff;
var() config bool bStatLink;
var() config bool bAlwaysRecordTourney;
var() config bool bKickMinY;
var() config bool bNoOverTime;
var() config bool bIpToCountry;
var() config bool bUsesCustomWeapon;
var() config bool bSuddenDeathOverTime;
var() config bool bNoFlockPawns;

var() config byte AnnouncerLevel;
var() config byte SetFOV;

var() config int TraceDistance;

var() config float MinY;

var() config string TransKillMessage;
var() config string ImpactKillMessage;
var() config string EnforcerKillMessage;
var() config string BioKillMessage;
var() config string ShockRifleKillMessage;
var() config string PulseGunKillMessage;
var() config string RipperKillMessage;
var() config string MiniGunKillMessage;
var() config string FlakCannonKillMessage;
var() config string RocketLauncherKillMessage;
var() config string SniperRifleKillMessage;
var() config string CustomWeaponKillMessage;
var() config string AerialKillBio;
var() config string AerialKillRipper;
var() config string AerialKillFlak;
var() config string AerialKillRockets;
var() config string AerialKillSniper;
var() config string AerialKillSuper;
var() config string AerialKillTrans;
var() config string AerialKillCombo;
var() config string AerialKillEnforcer;
var() config string AerialKillPulse;
var() config string AerialKillMini;
var() config string AerialKillPiston;
var() config string AerialKillCustom;
var() config string SoundPackage;
var() config string RedTeamName, BlueTeamName;
var() config string CustomWeaponName;
var() config string IpToCountryTexturePackage;
var() config string MessageOfTheDay;

var sound DeniedSound;
var sound FlakMonkeySound;
var sound HeadHunterSound;
var sound ComboWhoreSound;
var sound KillingSpreeSound;
var sound RampageSound;
var sound DominatingSound;
var sound UnStoppableSound;
var sound GodlikeSound;
var sound WhickedSickSound;
var sound RedTeamIsTheWinnerSound;
var sound BlueTeamIsTheWinnerSound;
var sound FlawlessVictorySound;
var sound LastSecondSaveSound;
var sound RedTeamScoresSound;
var sound RedTeamTakesTheLeadSound;
var sound RedTeamIncreasesThierLeadSound;
var sound RedTeamDominatingSound;
var sound BlueTeamScoresSound;
var sound BlueTeamTakesTheLeadSound;
var sound BlueTeamIncreasesThierLeadSound;
var sound BlueTeamDominatingSound;
var sound HatTrickSound;
var sound HitSoundSound;
var sound HitSoundFriendlySound;
var sound DoubleKillSound;
var sound MultiKillSound;
var sound MegaKillSound;
var sound UltraKillSound;
var sound MonsterKillSoundF;
var sound LudicriousKillSound;
var sound HolyShitKillSound;
var sound OwnageSound;

const MaxArray = 40;
const MaxTries = 21;

//-------------------------------------
// PreLogin
//-------------------------------------
event PreLogin
(
	string Options,
	string Address,
	out string Error,
	out string FailCode
)
{
	local string Face, Pad, PlayerName;
	local bool bCheckFace;

    bCheckFace = ParseFace(Options, Address, Face, Pad, PlayerName);

    if (Face == "FailedParse")
    {
        Error = "FAILEDPARSE";
        FailCode = "Your Client Failed to Parse at Prelogin Correctly";
        log("Client Failed PreLogin with a Failure to Parse Options"@Pad,'EUT');
        Super.PreLogin(Options, Address, Error, FailCode);
    }
    else if (bCheckFace)
    {
        Error = "ILLEGALFACE";
        FailCode = "Ivan is not an authorized Face";
        log("Client Attempted to PreLogin with Face"@Face@"--"@PlayerName@Pad,'EUT');
    }
    else
        Super.PreLogin(Options, Address, Error, FailCode);
}

//-------------------------------------
// ParseFace
//-------------------------------------
function bool ParseFace(string Options, string Address, out string Face, out string Pad, out string PlayerName)
{
    local string s;

    if (Instr(Address,":") != -1) Pad = Left(Address, InStr(Address,":"));
    else Pad = Address;

    Options = Caps(Options);

    if (Instr(Options, "NAME=") != -1)
    {
        s = Mid(Options, instr(Options, "NAME=") + 5);
        if (instr(s, "?") != -1) PlayerName = left(s, instr(s,"?"));
        else PlayerName = "FailedParse";
    }
    else PlayerName = "FailedParse";

    if(InStr(Options, "FACE=") != -1)
    {
        s = Mid(Options, instr(Options, "FACE=") + 5);
        if (instr(s, "?") != -1)
        {
            Face = left(s, instr(s,"?"));
            if (instr(Face, ".") != -1)
                Face = mid(Face, instr(Face, ".") + 1);
            else Face = "FailedParse";
        }
        else Face = "FailedParse";
    }
    else Face = "FailedParse";

    if (Face == "IVAN")
        return true;

    return False;
}


//-------------------------------------
// PostBeginPlay
//-------------------------------------
function PostBeginPlay()
{
    local int i;
    local Warheadlauncher  WL;
    local Actor A;

    super(TeamGamePlus).PostBeginPlay();

    PreCacheSounds();
    ResetVars();

    if (bEnhancedSprees)
    {
        DeathMessageClass = Class'EUTDeathMessagePlus';
        MyCRI.bUsesSpreeSounds = true;

        class'EUTMultiKillMessage'.default.DoubleKillSound = DoubleKillSound;
        class'EUTMultiKillMessage'.default.MultiKillSound = MultiKillSound;
        class'EUTMultiKillMessage'.default.MegaKillSound = MegaKillSound;
        class'EUTMultiKillMessage'.default.UltraKillSound = UltraKillSound;
        class'EUTMultiKillMessage'.default.MonsterKillSoundF = MonsterKillSoundF;
        class'EUTMultiKillMessage'.default.LudicriousKillSound = LudicriousKillSound;
        class'EUTMultiKillMessage'.default.HolyShitKillSound = HolyShitKillSound;
        class'EUTMultiKillMessage'.default.OwnageSound = OwnageSound;

        MyCRI.DoubleKillSound = DoubleKillSound;
        MyCRI.MultiKillSound = MultiKillSound;
        MyCRI.MegaKillSound = MegaKillSound;
        MyCRI.UltraKillSound = UltraKillSound;
        MyCRI.MonsterKillSoundF = MonsterKillSoundF;
        MyCRI.LudicriousKillSound = LudicriousKillSound;
        MyCRI.HolyShitKillSound = HolyShitKillSound;
        MyCRI.OwnageSound = OwnageSound;
        MyCRI.WhickedSickSound = WhickedSickSound;

        class'KillingSpreeMessage'.default.SpreeSound[0] =  KillingSpreeSound;
	    class'KillingSpreeMessage'.default.SpreeSound[1] =  RampageSound;
	    class'KillingSpreeMessage'.default.SpreeSound[2] =  DominatingSound;
	    class'KillingSpreeMessage'.default.SpreeSound[3] =  UnStoppableSound;
	    class'KillingSpreeMessage'.default.SpreeSound[4] =  GodlikeSound;

	    MyCRI.SpreeSound[0] = KillingSpreeSound;
	    MyCRI.SpreeSound[1] = RampageSound;
	    MyCRI.SpreeSound[2] = DominatingSound;
	    MyCRI.SpreeSound[3] = UnStoppableSound;
	    MyCRI.SpreeSound[4] = GodlikeSound;
    }
    else DeathMessageClass=Class'DeathMessagePlus';

    if (bEnhancedMessages)
    {
        MyCRI.RedTeamScoresSound = RedTeamScoresSound;
        MyCRI.BlueTeamScoresSound = BlueTeamScoresSound;
        MyCRI.RedTeamTakesTheLeadSound = RedTeamTakesTheLeadSound;
        MyCRI.BlueTeamTakesTheLeadSound = BlueTeamTakesTheLeadSound;
        MyCRI.RedTeamIncreasesThierLeadSound = RedTeamIncreasesThierLeadSound;
        MyCRI.BlueTeamIncreasesThierLeadSound = BlueTeamIncreasesThierLeadSound;
        MyCRI.RedTeamDominatingSound = RedTeamDominatingSound;
        MyCRI.BlueTeamDominatingSound = BlueTeamDominatingSound;
        MyCRI.DeniedSound = DeniedSound;
        MyCRI.RedTeamIsTheWinnerSound = RedTeamIsTheWinnerSound;
        MyCRI.BlueTeamIsTheWinnerSound = BlueTeamIsTheWinnerSound;
        MyCRI.FlawlessVictorySound = FlawlessVictorySound;
        MyCRI.LastSecondSaveSound = LastSecondSaveSound;
        MyCRI.HatTrickSound = HatTrickSound;
    }

    MyCRI.FlakMonkeySound = FlakMonkeySound;
    MyCRI.HeadHunterSound = HeadHunterSound;
    MyCRI.ComboWhoreSound = ComboWhoreSound;
    MyCRI.HitSoundSound = HitSoundSound;
    MyCRI.HitSoundFriendlySound = HitSoundFriendlySound;

    if (Level.NetMode == NM_Client)
		Spawn(Class'EUTDemoEnhancer');

    i = 0;
    WarheadCount = 0;
    foreach level.allactors(class'Warheadlauncher', WL)
    {
        if (i < 20)
        {
            WarheadLocation[i] =  WL.location;
            i++;
            WarheadCount++;
        }
    }

    LowGravityAerialKillAdjuster = 1;
    foreach Level.AllActors(class'LowGrav',lg)
       if (lg != none)
          LowGravityAerialKillAdjuster = 2.5;

    if (bStatLink)
    {
        StatLink = Spawn(Class'UTStatsLink');
        if (StatLink != none)
        {
            Log("TDM Stat Link Created:"@StatLink,'EUT');
            InitializeLogging();
        }
    }
    else
        GameName = "EUT Tournament Team Game";

    if (bIpToCountry)
    {
        foreach AllActors(class'Actor', A, 'IpToCountry')
        {
            IpToCountry = A;
		    break;
		}
    }
}

//-------------------------------------
// PreCacheSounds
//-------------------------------------
function PreCacheSounds()
{
    DeniedSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Denied",class'sound',true));
    if(DeniedSound == none)
        DeniedSound = sound'EUT_Sounds.Denied';

    HeadHunterSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_HeadHunter",class'sound',true));
    if(HeadHunterSound == none)
        HeadHunterSound = sound'EUT_Sounds.HeadHunter';

    FlakMonkeySound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_FlackMonkey",class'sound',true));
    if(FlakMonkeySound == none)
        FlakMonkeySound = sound'EUT_Sounds.FlackMonkey';

    ComboWhoreSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_ComboWhore",class'sound',true));
    if(ComboWhoreSound == none)
        ComboWhoreSound = sound'EUT_Sounds.ComboWhore';

    KillingSpreeSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_KillingSpree",class'sound',true));
    if(KillingSpreeSound == none)
        KillingSpreeSound = sound'EUT_Sounds.Killing_Spree';

    RampageSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Rampage",class'sound',true));
    if(RampageSound == none)
        RampageSound = sound'EUT_Sounds.Rampage';

    DominatingSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Dominating",class'sound',true));
    if(DominatingSound == none)
        DominatingSound = sound'EUT_Sounds.Dominating';

    UnStoppableSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_UnStoppable",class'sound',true));
    if(UnStoppableSound == none)
        UnStoppableSound = sound'EUT_Sounds.UnStoppable';

    GodlikeSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Godlike",class'sound',true));
    if(GodlikeSound == none)
        GodlikeSound = sound'EUT_Sounds.Godlike';

    WhickedSickSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_WhickedSick",class'sound',true));
    if(WhickedSickSound == none)
        WhickedSickSound = sound'EUT_Sounds.WhickedSick';

    RedTeamIsTheWinnerSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_red_team_is_the_winner",class'sound',true));
    if(RedTeamIsTheWinnerSound == none)
        RedTeamIsTheWinnerSound = sound'EUT_Sounds.red_team_is_the_winner';

    FlawlessVictorySound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Flawless_victory",class'sound',true));
    if(FlawlessVictorySound == none)
        FlawlessVictorySound = sound'EUT_Sounds.Flawless_victory';

    BlueTeamIsTheWinnerSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_blue_team_is_the_winner",class'sound',true));
    if(BlueTeamIsTheWinnerSound == none)
        BlueTeamIsTheWinnerSound = sound'EUT_Sounds.blue_team_is_the_winner';

    LastSecondSaveSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Last_Second_Save",class'sound',true));
    if(LastSecondSaveSound == none)
        LastSecondSaveSound = sound'EUT_Sounds.Last_Second_Save';

    RedTeamScoresSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Red_Team_Scores",class'sound',true));
    if(RedTeamScoresSound == none)
        RedTeamScoresSound = sound'EUT_Sounds.Red_Team_Scores';

    RedTeamTakesTheLeadSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Red_Team_takes_lead",class'sound',true));
    if(RedTeamTakesTheLeadSound == none)
        RedTeamTakesTheLeadSound = sound'EUT_Sounds.Red_Team_takes_lead';

   RedTeamIncreasesThierLeadSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Red_Team_increases_their_lead",class'sound',true));
   if(RedTeamIncreasesThierLeadSound == none)
      RedTeamIncreasesThierLeadSound = sound'EUT_Sounds.Red_Team_increases_their_lead';

    RedTeamDominatingSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_red_team_Dominating",class'sound',true));
    if(RedTeamDominatingSound == none)
        RedTeamDominatingSound = sound'EUT_Sounds.red_team_Dominating';

    BlueTeamScoresSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Blue_Team_Scores",class'sound',true));
    if(BlueTeamScoresSound == none)
        BlueTeamScoresSound = sound'EUT_Sounds.Blue_Team_Scores';

    BlueTeamTakesTheLeadSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Blue_Team_takes_the_lead",class'sound',true));
    if(BlueTeamTakesTheLeadSound == none)
        BlueTeamTakesTheLeadSound = sound'EUT_Sounds.Blue_Team_takes_the_lead';

    BlueTeamIncreasesThierLeadSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Blue_Team_increases_their_lead",class'sound',true));
    if(BlueTeamIncreasesThierLeadSound == none)
        BlueTeamIncreasesThierLeadSound = sound'EUT_Sounds.Blue_Team_increases_their_lead';

    BlueTeamDominatingSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_blue_team_Dominating",class'sound',true));
    if(BlueTeamDominatingSound == none)
        BlueTeamDominatingSound = sound'EUT_Sounds.blue_team_Dominating';

    HatTrickSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_HatTrick",class'sound',true));
    if(HatTrickSound == none)
        HatTrickSound = sound'EUT_Sounds.HatTrick';

    HitSoundSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_HitSound",class'sound',true));
    if(HitSoundSound == none)
        HitSoundSound = sound'EUT_Sounds.HitSound';

    HitSoundFriendlySound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_HitSound_F",class'sound',true));
    if(HitSoundFriendlySound == none)
        HitSoundFriendlySound =sound'EUT_Sounds.HitSound_F';

    DoubleKillSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Double_Kill",class'sound',true));
    if(DoubleKillSound == none)
        DoubleKillSound = sound'EUT_Sounds.Double_Kill';

    MultiKillSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_MultiKill",class'sound',true));
    if(MultiKillSound == none)
        MultiKillSound = sound'EUT_Sounds.MultiKill';

    MegaKillSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_megakill",class'sound',true));
    if(MegaKillSound == none)
        MegaKillSound = sound'EUT_Sounds.megakill';

    UltraKillSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_UltraKill",class'sound',true));
    if(UltraKillSound == none)
        UltraKillSound = sound'EUT_Sounds.UltraKill';

    MonsterKillSoundF = sound(DynamicLoadObject(SoundPackage$"."$"Alt_MonsterKill_F",class'sound',true));
    if(MonsterKillSoundF == none)
        MonsterKillSoundF = sound'EUT_Sounds.MonsterKill_F';

    LudicriousKillSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_LudicrousKill",class'sound',true));
    if(LudicriousKillSound == none)
        LudicriousKillSound = sound'EUT_Sounds.LudicrousKill';

    HolyShitKillSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_HolyShit_F",class'sound',true));
    if(HolyShitKillSound == none)
        HolyShitKillSound = sound'EUT_Sounds.HolyShit_F';

    OwnageSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Ownage",class'sound',true));
    if(OwnageSound == none)
        OwnageSound = sound'EUT_Sounds.Ownage';
}

//-------------------------------------
// ResetVars
//-------------------------------------
function ResetVars()
{
    local int i;

    MyCRI = EUTGameReplicationInfo(GameReplicationInfo);
    MyCRI.RedTeamName = RedTeamName;
    MyCRI.BlueTeamName = BlueTeamName;
    MyCRI.bShowIPS = bShowIPS;
	MyCRI.TraceDistance = TraceDistance;
	MyCRI.bTeamBeacon = bTeamBeacon;
	MyCRI.bIpToCountry = bIpToCountry;
    MyCRI.TransKillMessage = TransKillMessage;
    MyCRI.ImpactKillMessage = ImpactKillMessage;
    MyCRI.EnforcerKillMessage = EnforcerKillMessage;
    MyCRI.BioKillMessage = BioKillMessage;
    MyCRI.ShockRifleKillMessage = ShockRifleKillMessage;
    MyCRI.PulseGunKillMessage = PulseGunKillMessage;
    MyCRI.RipperKillMessage = RipperKillMessage;
    MyCRI.MiniGunKillMessage = MiniGunKillMessage;
    MyCRI.FlakCannonKillMessage = FlakCannonKillMessage;
    MyCRI.RocketLauncherKillMessage = RocketLauncherKillMessage;
    MyCRI.SniperRifleKillMessage = SniperRifleKillMessage;
    MyCRI.AerialKillBio = AerialKillBio;
    MyCRI.AerialKillRipper = AerialKillRipper;
    MyCRI.AerialKillFlak = AerialKillFlak;
    MyCRI.AerialKillRockets = AerialKillRockets;
    MyCRI.AerialKillSniper = AerialKillSniper;
    MyCRI.AerialKillSuper = AerialKillSuper;
    MyCRI.AerialKillTrans = AerialKillTrans;
    MyCRI.AerialKillCombo = AerialKillCombo;
    MyCRI.AerialKillEnforcer = AerialKillEnforcer;
    MyCRI.AerialKillPulse = AerialKillPulse;
    MyCRI.AerialKillMini = AerialKillMini;
    MyCRI.AerialKillPiston = AerialKillPiston;
    MyCRI.bScoreBoardEff = bScoreBoardEff;
    MyCRI.IpToCountryTexturePackage = IpToCountryTexturePackage;
    MyCRI.CustomWeaponName = CustomWeaponName;
    MyCRI.bUsesCustomWeapon = bUsesCustomWeapon;
    MyCRI.CustomWeaponKillMessage = CustomWeaponKillMessage;
    MyCRI.AerialKillCustom = AerialKillCustom;
    MyCRI.SetFOV = SetFOV;
    MyCRI.bEnhancedMessages = bEnhancedMessages;
    MyCRI.bTournament= bTournament;
    MyCRI.MessageOfTheDay = MessageOfTheDay;

    for (i = 0; i < MaxArray; i++)
    {
        MyCRI.TotalDamageAmmount[i] = 0;
        MyCRI.ClientHitSound[i] = 0;
        MyCRI.EnforcerHitCount[i] = 0;
        MyCRI.BioGunHitCount[i] = 0;
        MyCRI.ShockRifleHitCount[i] = 0;
        MyCRI.PulseGunHitCount[i] = 0;
        MyCRI.RipperHitCount[i] = 0;
        MyCRI.MiniGunHitCount[i] = 0;
        MyCRI.FlakGunHitCount[i] = 0;
        MyCRI.EightBallHitCount[i] = 0;
        MyCRI.SniperRifleHitCount[i] = 0;
        MyCRI.SuperShockRifleHitCount[i] = 0;
        MyCRI.ArmorAmmount[i] = 0;
        MyCRI.TotalKills[i] = 0;
  	    MyCRI.TotalDeaths[i] = 0;
    	MyCRI.StoredPlayerIP[i] = "";
        MyCRI.IPCTexture[i] = "";
        MyCRI.ClientIdentified[i] = 0;
	    MyCRI.HealthAmmount[i] = 0;
	    MyCRI.MultiKills1[i].KillingSpree = 0;
        MyCRI.MultiKills1[i].Rampage = 0;
        MyCRI.MultiKills1[i].Dominating = 0;
        MyCRI.MultiKills2[i].UnStoppable = 0;
        MyCRI.MultiKills2[i].Godlike = 0;
        MyCRI.MultiKills2[i].Ownage = 0;
        MyCRI.PlayerAccuracy1[i].Enforcer = 0;
        MyCRI.PlayerAccuracy1[i].BioGun = 0;
        MyCRI.PlayerAccuracy1[i].ShockRifle = 0;
        MyCRI.PlayerAccuracy2[i].PulseGun = 0;
        MyCRI.PlayerAccuracy2[i].Ripper = 0;
        MyCRI.PlayerAccuracy2[i].MiniGun = 0;
        MyCRI.PlayerAccuracy3[i].FlakCannon = 0;
        MyCRI.PlayerAccuracy3[i].EightBall = 0;
        MyCRI.PlayerAccuracy3[i].SniperRifle = 0;
        MyCRI.PlayerAccuracy3[i].InstaGib = 0;
        FlakKills[i] = 0;
        ComboKills[i] = 0;
        MyCRI.HeadHunterCount[i] = 0;
        MyCRI.ComboWhoreCount[i] = 0;
        MyCRI.FlakMonkeyCount[i] = 0;
        MyCRI.HeadShotsCount[i] = 0;
        MultiKills[i].MultiLevel = 0;
 	    MultiKills[i].MultiTime = 0;
        MyCRI.KillingSpree[i].UltraKills = 0;
        MyCRI.KillingSpree[i].MonsterKills = 0;
        MyCRI.KillingSpree[i].LudicriousKills = 0;
        MyCRI.KillingSpree[i].HolyShitKills = 0;
        MyCRI.CurrentTotalAccuracy[i] = 0;
        MyCRI.CurrentRanking[i] = 0;
        WeaponDamage[i].Enforcer = 0;
        WeaponDamage[i].BioGun = 0;
        WeaponDamage[i].ShockRifle = 0;
        WeaponDamage[i].PulseGun = 0;
        WeaponDamage[i].Ripper = 0;
        WeaponDamage[i].MiniGun = 0;
        WeaponDamage[i].FlakGun = 0;
        WeaponDamage[i].EightBall = 0;
        WeaponDamage[i].SniperRifle = 0;
        WeaponDamage[i].SuperShockRifle = 0;
        AKMS[i] = 0;
        MyCRI.CustomWeaponHitCount[i] = 0;
        WeaponDamage[i].CustomWeapon = 0;
        MyCRI.PlayerAccuracy4[i].CustomWeapon = 0;
        SplashKills[i].FlakTime = 0;
        SplashKills[i].LastHit = none;
    }
}

//-------------------------------------
// InitializeLogging
//-------------------------------------
function InitializeLogging()
{
    local Mutator Mut;

    StatLink.bWorld = False;
	StatLink.StartLog();
	StatLink.LogStandardInfo();
	StatLink.LogServerInfo();
    StatLink.LogMapParameters();

    for (Mut = Level.Game.BaseMutator; Mut != None; Mut = Mut.NextMutator)
        StatLink.AddMutator(Mut);

    StatLink.LogMutatorList();
    Level.Game.LogGameParameters(StatLink);
	Level.Game.LocalLog = StatLink;
	Level.Game.LocalLogFileName = StatLink.GetLogFileName();
}

//-------------------------------------
// InitGameReplicationInfo
//-------------------------------------
function InitGameReplicationInfo()
{
	Super.InitGameReplicationInfo();
    ResetVars();
}

//-------------------------------------
// Logout
//-------------------------------------
function Logout(Pawn P)
{
	local int pid;

	pid = P.PlayerReplicationInfo.PlayerID;
    MyCRI = EUTGameReplicationInfo(GameReplicationInfo);

    super(TeamGamePlus).Logout(P);

    MyCRI.TotalDamageAmmount[pid] = 0;
	MyCRI.ClientHitSound[pid] = 0;
	MyCRI.EnforcerHitCount[pid] = 0;
    MyCRI.BioGunHitCount[pid] = 0;
    MyCRI.ShockRifleHitCount[pid] = 0;
    MyCRI.PulseGunHitCount[pid] = 0;
    MyCRI.RipperHitCount[pid] = 0;
    MyCRI.MiniGunHitCount[pid] = 0;
    MyCRI.FlakGunHitCount[pid] = 0;
    MyCRI.EightBallHitCount[pid] = 0;
    MyCRI.SniperRifleHitCount[pid] = 0;
    MyCRI.SuperShockRifleHitCount[pid] = 0;
    MyCRI.ArmorAmmount[pid] = 0;
    MyCRI.TotalKills[pid] = 0;
    MyCRI.TotalDeaths[pid] = 0;
    MyCRI.StoredPlayerIP[pid] = "";
    MyCRI.IPCTexture[pid] = "";
    MyCRI.ClientIdentified[pid] = 0;
    MyCRI.HealthAmmount[pid] = 0;
    MyCRI.MultiKills1[pid].KillingSpree = 0;
    MyCRI.MultiKills1[pid].Rampage = 0;
    MyCRI.MultiKills1[pid].Dominating = 0;
    MyCRI.MultiKills2[pid].UnStoppable = 0;
    MyCRI.MultiKills2[pid].Godlike = 0;
    MyCRI.MultiKills2[pid].Ownage = 0;
    MyCRI.PlayerAccuracy1[pid].Enforcer = 0;
    MyCRI.PlayerAccuracy1[pid].BioGun = 0;
    MyCRI.PlayerAccuracy1[pid].ShockRifle = 0;
    MyCRI.PlayerAccuracy2[pid].PulseGun = 0;
    MyCRI.PlayerAccuracy2[pid].Ripper = 0;
    MyCRI.PlayerAccuracy2[pid].MiniGun = 0;
    MyCRI.PlayerAccuracy3[pid].FlakCannon = 0;
    MyCRI.PlayerAccuracy3[pid].EightBall = 0;
    MyCRI.PlayerAccuracy3[pid].SniperRifle = 0;
    MyCRI.PlayerAccuracy3[pid].InstaGib = 0;
    FlakKills[pid] = 0;
    ComboKills[pid] = 0;
    MyCRI.HeadHunterCount[pid] = 0;
    MyCRI.ComboWhoreCount[pid] = 0;
    MyCRI.FlakMonkeyCount[pid] = 0;
    MyCRI.HeadShotsCount[pid] = 0;
    MultiKills[pid].MultiLevel = 0;
    MultiKills[pid].MultiTime = 0;
    MyCRI.KillingSpree[pid].UltraKills = 0;
    MyCRI.KillingSpree[pid].MonsterKills = 0;
    MyCRI.KillingSpree[pid].LudicriousKills = 0;
    MyCRI.KillingSpree[pid].HolyShitKills = 0;
    MyCRI.CurrentTotalAccuracy[pid] = 0;
    MyCRI.CurrentRanking[pid] = 0;
    WeaponDamage[pid].Enforcer = 0;
    WeaponDamage[pid].BioGun = 0;
    WeaponDamage[pid].ShockRifle = 0;
    WeaponDamage[pid].PulseGun = 0;
    WeaponDamage[pid].Ripper = 0;
    WeaponDamage[pid].MiniGun = 0;
    WeaponDamage[pid].FlakGun = 0;
    WeaponDamage[pid].EightBall = 0;
    WeaponDamage[pid].SniperRifle = 0;
    WeaponDamage[pid].SuperShockRifle = 0;
    AKMS[pid] = 0;
    MyCRI.CustomWeaponHitCount[pid] = 0;
    WeaponDamage[pid].CustomWeapon = 0;
    MyCRI.PlayerAccuracy4[pid].CustomWeapon = 0;
    SplashKills[pid].FlakTime = 0;
    SplashKills[pid].LastHit = none;
}

//-------------------------------------
// StartMatch
//-------------------------------------
function StartMatch()
{
    Super.StartMatch();
    log("Match Started");
    if (bTournament) { ResetVars(); MyCRI.bWarmupSwitch = true; }
    MyCRI.bMatchStarted = true;
}

//-------------------------------------
// InitGame
//-------------------------------------
event InitGame(string S, out string E)
{
	Super.InitGame(S, E);
	MaxTeams = Min(MaxTeams, MaxAllowedTeams);
}

//-------------------------------------
// Killed
//-------------------------------------
function Killed(Pawn Killer, Pawn Victim, name DamageType)
{
    local int kid, oid;

    if (Killer == none)
    {
        if (DamageType == 'Suicided'
        || (DamageType == 'Fell')
        || (DamageType == 'Burned')
        || (DamageType == 'Drowned')
        || (DamageType == ''))
        {
            super(DeathMatchPlus).Killed(Killer, Victim, DamageType);
            return;
        }
    }

    if (Killer != none && (Victim != none))
    {
        if (Killer != Victim)
        {
            if ((DamageType == 'FlakDeath') || (DamageType == 'shredded'))
            {
                kid = Killer.PlayerReplicationInfo.PlayerID;
                oid = Victim.PlayerReplicationInfo.PlayerID;
                FlakKills[kid]++;

                if (FlakKills[kid] == 30)
                {
                    FlakKills[kid] = 0;
                    if (Level.Game.LocalLog != None)
                        level.game.localLog.logSpecialEvent("flak_monkey", kid, oid);

                    PlayerPawn(Killer).ReceiveLocalizedMessage( class'EUTHudMessages', 15);
                    BroadCastMessage(Killer.PlayerReplicationInfo.PlayerName$" Is A FlakMonkey!!!!",false);
                    MyCRI.FlakMonkeyCount[kid]++;

                    if (CanPlaySound(Killer))
                        TournamentPlayer(PlayerPawn(Killer)).ReceiveLocalizedMessage( class'EUTMultiKillMessage', 101);

                }
            }
            if (DamageType == 'Decapitated')
            {
                kid = Killer.PlayerReplicationInfo.PlayerID;
                oid = Victim.PlayerReplicationInfo.PlayerID;
                MyCRI.HeadShotsCount[kid]++;

                if (MyCRI.HeadShotsCount[kid] > 30)
	            {
                    if (Level.Game.LocalLog != None)
                        level.game.localLog.logSpecialEvent("head_hunter", kid, oid);

                    PlayerPawn(Killer).ReceiveLocalizedMessage( class'EUTHudMessages', 9 );
                    MyCRI.HeadShotsCount[kid] = 0;
                    BroadCastMessage(Killer.PlayerReplicationInfo.PlayerName$" Is A HeadHunter!!!!",false);
                    MyCRI.HeadHunterCount[kid]++;

                    if (CanPlaySound(Killer))
                        TournamentPlayer(PlayerPawn(Killer)).ReceiveLocalizedMessage( class'EUTMultiKillMessage', 102);
                }
            }
        }
        if (Killer != none
        && (Killer.Weapon != none)
        && (Killer.IsA('PlayerPawn'))
        && (!Killer.Weapon.IsA('SuperShockRifle'))
        && (_GetItemName(Killer.Weapon) != "ZP_SUPERSHOCKRIFLE"))
        {
            if (DamageType == 'Jolted')
            {
                if (Victim.health < -50)
                {
                    ComboKills[kid]++;
                    kid = Killer.PlayerReplicationInfo.PlayerID;
                    oid = Victim.PlayerReplicationInfo.PlayerID;

                    if (ComboKills[kid] == 30)
                    {
                        ComboKills[kid] = 0;
                        if (Level.Game.LocalLog != None)
                            level.game.localLog.logSpecialEvent("combo_whore", kid, oid);

                        PlayerPawn(Killer).ReceiveLocalizedMessage( class'EUTHudMessages', 16);
                        BroadCastMessage(Killer.PlayerReplicationInfo.PlayerName$" Is A ComboWhore!!!!",false);
                        MyCRI.ComboWhoreCount[kid]++;

                        if (CanPlaySound(Killer))
                            TournamentPlayer(PlayerPawn(Killer)).ReceiveLocalizedMessage( class'EUTMultiKillMessage', 103);

                    }
                }
            }
        }
    }
    if (Victim != none && (Killer != none))
        ProcessExtendedSprees(Victim.Spree);

   super(DeathMatchPlus).Killed(Killer, Victim, DamageType);
}

//-------------------------------------
// ProcessExtendedSprees
//-------------------------------------
function ProcessExtendedSprees(int i)
{
    switch(i)
    {
        case 0: break;
        case 1: break;
        case 2: break;
        case 3: break;
        case 4: break;
        case 5:
        case 6:
        case 7:
        case 8:
        case 9: bExpandSpree = true; ExpandedSpreeSwitch = 6; break;
        case 10:
        case 11:
        case 12:
        case 13:
        case 14: bExpandSpree = true; ExpandedSpreeSwitch = 1; break;
        case 15:
        case 16:
        case 17:
        case 18:
        case 19: bExpandSpree = true; ExpandedSpreeSwitch = 2; break;
        case 20:
        case 21:
        case 22:
        case 23:
        case 24: bExpandSpree = true; ExpandedSpreeSwitch = 3; break;
        case 25:
        case 26:
        case 27:
        case 28:
        case 29: bExpandSpree = true; ExpandedSpreeSwitch = 4; break;
        case 30: break;
    }
    if (i > 29)
    {
        bExpandSpree = true;
        ExpandedSpreeSwitch = 5;
    }
}

//-------------------------------------
// ScoreKill
//-------------------------------------
function ScoreKill(Pawn Killer, Pawn Victim)
{
    local int kid, oid;

    if ((Killer == Victim) || (Killer == None))
        Victim.PlayerReplicationInfo.Score -= 1;

	if (Killer != none
    && (Victim != none)
    && (Killer != Victim))
	{
        Killer.killCount++;
        kid = Killer.PlayerReplicationInfo.PlayerID;
        oid = Victim.PlayerReplicationInfo.PlayerID;
        MultiKills[oid].MultiLevel = 0;

		if (Level.TimeSeconds - MultiKills[kid].MultiTime < 3)
        {
            ProcessMultiKills(kid);
            if (MultiKills[kid].MultiLevel >= AnnouncerLevel && (bEnhancedSprees))
                BroadcastMessage(class'EUTMultiKillMessage'.static.GetBroadCastString(MultiKills[kid].MultiLevel, Killer.PlayerReplicationInfo,None,None),false,'EUTEvent');
        }
        if (Level.TimeSeconds - MultiKills[kid].MultiTime > 3)
            MultiKills[kid].MultiLevel = 0;

        MultiKills[kid].MultiTime = Level.TimeSeconds;

        if (Killer.bIsPlayer
        && (Victim.bIsPlayer)
        && (Killer.PlayerReplicationInfo.Team != Victim.PlayerReplicationInfo.Team))
            Killer.PlayerReplicationInfo.Score += 1;
	}

	if (bAltScoring
    && (Killer != Victim)
    && (Killer != None)
    && (Victim.bIsPlayer))
        Victim.PlayerReplicationInfo.Score -= 1;

	Victim.DieCount++;
	BaseMutator.ScoreKill(Killer, Victim);

	if (!bScoreTeamKills)
        return;

	if (Victim.bIsPlayer && ((Killer == None) || Killer.bIsPlayer))
	{
		if ((Killer == Victim) || (Killer == None))
			Teams[Victim.PlayerReplicationInfo.Team].Score -= 1;
		else if ( Killer.PlayerReplicationInfo.Team != Victim.PlayerReplicationInfo.Team )
			Teams[Killer.PlayerReplicationInfo.Team].Score += 1;
		else if (FriendlyFireScale > 0)
		{
			Teams[Victim.PlayerReplicationInfo.Team].Score -= 1;
			Killer.PlayerReplicationInfo.Score -= 1;
		}
	}

    if ((bOverTime || (GoalTeamScore > 0))
    && (Killer != none
    && (Killer.bIsPlayer)
	&& (Teams[killer.PlayerReplicationInfo.Team].Score >= GoalTeamScore)))
		EndGame("teamscorelimit");

	if (!bNoOverTime
	&& (bSuddenDeathOverTime)
	&& (RemainingTime <= 0)
	&& (!bAltOverTime)
	&& (Teams[0].Score != Teams[1].Score))
	   AltEndGame("SuddenDeath");
}

//-------------------------------------
// ProcessMultiKills
//-------------------------------------
function ProcessMultiKills(int pid)
{
    MultiKills[pid].MultiLevel++;

    switch (MultiKills[pid].MultiLevel)
    {
        case 0:
        case 1:
        case 2: break;
        case 3:
            if (Level.Game.LocalLog != None)
                Level.Game.LocalLog.LogSpecialEvent(Level.Game.LocalLog.GetTimeStamp()$Chr(9)$"spree"$chr(9)$"spree_meg"$chr(9)$pid);
            break;
        case 4: MyCRI.KillingSpree[pid].UltraKills++; break;
        case 5: MyCRI.KillingSpree[pid].MonsterKills++; break;
        case 6:
            MyCRI.KillingSpree[pid].LudicriousKills++;
            if (Level.Game.LocalLog != None)
                Level.Game.LocalLog.LogSpecialEvent(Level.Game.LocalLog.GetTimeStamp()$Chr(9)$"spree"$chr(9)$"spree_lud"$chr(9)$pid);
            break;
        case 7:
        case 8:
        case 9:
        case 10:
        case 11:
        case 12:
        case 13:
        case 14:
        case 15:
        case 16:
        case 17:
        case 18:
            MyCRI.KillingSpree[pid].HolyShitKills++;
            if (Level.Game.LocalLog != None)
                Level.Game.LocalLog.LogSpecialEvent(Level.Game.LocalLog.GetTimeStamp()$Chr(9)$"spree"$chr(9)$"spree_hs"$chr(9)$pid);
            break;
        case 19:
            MyCRI.KillingSpree[pid].HolyShitKills++;
            if (Level.Game.LocalLog != None)
                Level.Game.LocalLog.LogSpecialEvent(Level.Game.LocalLog.GetTimeStamp()$Chr(9)$"spree"$chr(9)$"spree_hs"$chr(9)$pid);
            MultiKills[pid].MultiLevel = 0;
            break;
    }
}

//-------------------------------------
// SetEndCams
//-------------------------------------
function bool SetEndCams(string Reason)
{
	local TeamInfo BestTeam;
	local int i;
	local Pawn P, BestP;
	local PlayerPawn PP;

	// find individual winner
	for (P = Level.PawnList; P != None; P = P.nextPawn)
		if (P.bIsPlayer && ((BestP == None) || (P.PlayerReplicationInfo.Score > BestP.PlayerReplicationInfo.Score)))
			BestP = P;

	// find winner
	BestTeam = Teams[0];
	for (i = 1; i < MaxTeams; i++)
		if (Teams[i].Score > BestTeam.Score)
			BestTeam = Teams[i];

	for (i = 0; i < MaxTeams; i++)
	{
		if ((BestTeam.TeamIndex != i) && (BestTeam.Score == Teams[i].Score))
		{
			BroadcastLocalizedMessage(DMMessageClass, 0);
			return false;
		}
	}

	GameReplicationInfo.GameEndedComments = TeamPrefix@BestTeam.TeamName@GameEndedMessage;

	EndTime = Level.TimeSeconds + 3.0;
	for (P = Level.PawnList; P != None; P = P.nextPawn)
	{
		CalculateRanking(P);
        PP = PlayerPawn(P);
		if (PP != None)
		{
			if (!bTutorialGame && (!bEnhancedMessages))
				PlayWinMessage(PP, (PP.PlayerReplicationInfo.Team == BestTeam.TeamIndex));

			if (!bTutorialGame && (bEnhancedMessages))
			{
				if (CanPlaySound(P))
				{
				   if (Teams[0].Score > Teams[1].Score)
				      TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 11);

	               if (Teams[1].Score > Teams[0].Score)
				      TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds',12);

                }
            }
			PP.bBehindView = true;
			if (PP == BestP) PP.ViewTarget = None;
			else PP.ViewTarget = BestP;
			PP.ClientGameEnded();
		}
		P.GotoState('GameEnded');
	}
	CalcEndStats();
	return true;
}

//-------------------------------------
// ReduceDamage
//-------------------------------------
function int ReduceDamage(int DamageAmmount, name DamageType, Pawn Injured, Pawn Instigator)
{
    if (Injured != none && (!Injured.bIsPlayer))
          return Super(TeamGamePlus).ReduceDamage(DamageAmmount, DamageType, Injured, Instigator);

    if ((Instigator != None)
    && (Injured.PlayerReplicationInfo.Team != Instigator.PlayerReplicationInfo.Team)
    && Injured.IsA('Bot')
    && ((Injured.health < 35)
    || (Injured.PlayerReplicationInfo.HasFlag != None)))
        Bot(Injured).SendTeamMessage(None, 'Other', 4, 15);

    if (Instigator != None && Injured != None)
    {
        If (Injured.PlayerReplicationInfo != None && Instigator.PlayerReplicationInfo != None)
        {
            if (Injured.PlayerReplicationInfo.Team != Instigator.PlayerReplicationInfo.Team)
            {
                MyCRI.TotalDamageAmmount[Instigator.PlayerReplicationInfo.PlayerID]++;
                if (Instigator.Weapon != none)
                    CalculateDamage(Instigator, Injured, DamageType, DamageAmmount);

	            if (MyCRI.ClientHitSound[Instigator.PlayerReplicationInfo.PlayerID] == 1
                && (bHitSounds))
	                TournamentPlayer(PlayerPawn(Instigator)).ReceiveLocalizedMessage( class'EUTHitSoundMessage', 0);

	            return Super(TeamGamePlus).ReduceDamage(DamageAmmount, DamageType, Injured, Instigator);
            }

            if (Injured.PlayerReplicationInfo.Team == Instigator.PlayerReplicationInfo.Team
            && (MyCRI.ClientHitSound[Instigator.PlayerReplicationInfo.PlayerID] == 1)
            && (Instigator != Injured)
            && (bHitSounds))
                TournamentPlayer(PlayerPawn(Instigator)).ReceiveLocalizedMessage( class'EUTHitSoundMessage', 1);
        }
    }

	return Super(TeamGamePlus).ReduceDamage(DamageAmmount, DamageType, Injured, Instigator);
}

//-------------------------------------
// Timer
//-------------------------------------
function Timer()
{
	local Pawn P;
	local string IP, S;
	local int pid;
	local Inventory Inv;

    if (NumSpectators < MaxSpectators) MyCRI.bCanSpectate = true;
    else MyCRI.bCanSpectate = false;

    for (P = Level.PawnList; P != None; P = P.NextPawn)
	{
        if (P.PlayerReplicationInfo != none)
        {
            pid = P.PlayerReplicationInfo.PlayerID;

            if (P.PlayerReplicationInfo.Team == 0 && (MyCRI.Teams[0].Size == 0))
                AddToTeam(0,P);
            if (P.PlayerReplicationInfo.Team == 1 && (MyCRI.Teams[1].Size == 0))
                AddToTeam(1,P);
        }

        if (P.IsA('Bot') || P.IsA('PlayerPawn'))
	    {
            if (P.PlayerReplicationInfo != none && (P.PlayerReplicationInfo.PlayerName != "Player"))
            {
                MyCRI.ClientPing[pid] = P.PlayerReplicationInfo.Ping;
                MyCRI.TotalKills[pid] = P.KillCount;
                MyCRI.TotalDeaths[pid] = P.DieCount;

                if(!P.IsA('Bot'))
                {
                    if (MyCRI.StoredPlayerIP[pid] == "")
                    {
                        IP = PlayerPawn(P).GetPlayerNetworkAddress();
                        IP = Left(IP,InStr(IP,":"));
                        MyCRI.StoredPlayerIP[pid] = IP;
                    }

                    if (MyCRI.StoredPlayerIP[pid] != ""
                    && (bIpToCountry)
                    && (IpToCountry != none)
                    && (MyCRI.ClientIdentified[pid] < MaxTries))
                    {
                        S = IpToCountry.GetItemName(MyCRI.StoredPlayerIP[pid]);

                        if(caps(S) == "!DISABLED")
                        {
                            MyCRI.IPCTexture[pid] = "";
                            MyCRI.ClientIdentified[pid] = MaxTries;
                        }
                        else if(Left(S, 1) != "!")
                        {
                            MyCRI.IPCTexture[pid] = SelElem(S, 5);
                            if (MyCRI.IPCTexture[pid] == "")
                            {
                                MyCRI.IPCTexture[pid] = "";
                                MyCRI.ClientIdentified[pid] = MaxTries;
                            }
                            else
                                MyCRI.ClientIdentified[pid] = MaxTries;
                        }
                        MyCRI.ClientIdentified[pid]++;
                    }
                }
                CalculateRanking(P);

                if (P.Health >= 0)
                    MyCRI.HealthAmmount[pid] = P.Health;
                else
                    MyCRI.HealthAmmount[pid] = 0;

                MyCRI.ArmorAmmount[pid] = 0;
                for (Inv = P.Inventory; Inv != None; Inv = Inv.Inventory)
	               if (Inv.bIsAnArmor)
	                   MyCRI.ArmorAmmount[pid] += Inv.Charge;
            }
        }
    }
    if (RemainingTime <= 0
    && (!bAltOvertime)
    && (bNoOverTime))
        AltEndGame("timelimit");

    super(DeathMatchPlus).Timer();
}

//-------------------------------------
//   SelElem
//-------------------------------------
static final function string SelElem(string s, int e)
{
	local int i;

	while (e-->1) s = Mid(s, InStr(s,":") + 1);
	i = InStr(s, ":");
	if (i != -1) s = Left(s, i);
    return s;
}

//-------------------------------------
// NotifySpree
//-------------------------------------
function NotifySpree(Pawn Other, int i)
{
	local Pawn P;
	local int oid;

    oid = Other.PlayerReplicationInfo.PlayerID;

    if (i != 5
	&& (i != 10)
	&& (i != 15)
	&& (i != 20)
	&& (i != 25)
	&& (i != 30))
	   return;

    switch (i)
    {
        case 5:
           i = 0;
		   MyCRI.MultiKills1[oid].KillingSpree++;
           break;
        case 10:
           i = 1;
		   MyCRI.MultiKills1[oid].Rampage++;
           break;
        case 15:
           i = 2;
		   MyCRI.MultiKills1[oid].Dominating++;
           break;
        case 20:
           i = 3;
		   MyCRI.MultiKills2[oid].UnStoppable++;
           break;
        case 25:
           i = 4;
	       MyCRI.MultiKills2[oid].Godlike++;
           break;
        case 30:
           i = 5;
		   MyCRI.MultiKills2[oid].Ownage++;
		   Other.Spree = 0;
		   if (Level.Game.LocalLog != None)
		        Level.Game.LocalLog.LogSpecialEvent(Level.Game.LocalLog.GetTimeStamp()$Chr(9)$"spree"$chr(9)$"spree_wks"$chr(9)$oid);

           break;
    }

    for (P = Level.PawnList; P != None; P = P.NextPawn)
	{
		if (P.IsA('TournamentPlayer'))
			P.ReceiveLocalizedMessage( class'KillingSpreeMessage', i, Other.PlayerReplicationInfo );

        if (CanPlaySound(P) && (i == 5) && (bEnhancedSprees))
        {
            BroadcastLocalizedMessage(class'EUTHudMessages', i, Other.PlayerReplicationInfo, None, None);
			TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTMultiKillMessage', 104);
		}
    }
}

//-------------------------------------
// CalculateAccuracy
//-------------------------------------
function CalculateAccuracy(Pawn P)
{
     local int pid;
     local int f, t;

     if (P.PlayerReplicationInfo == none ||(P.PlayerReplicationInfo.PlayerName == "Player"))
        return;

     pid = P.PlayerReplicationInfo.PlayerID;
     f = 0;

     t =
     MyCRI.PlayerAccuracy1[pid].Enforcer +
     MyCRI.PlayerAccuracy1[pid].BioGun +
     MyCRI.PlayerAccuracy1[pid].ShockRifle +
     MyCRI.PlayerAccuracy2[pid].MiniGun +
     MyCRI.PlayerAccuracy2[pid].PulseGun +
     MyCRI.PlayerAccuracy2[pid].Ripper +
     MyCRI.PlayerAccuracy3[pid].EightBall +
     MyCRI.PlayerAccuracy3[pid].FlakCannon +
     MyCRI.PlayerAccuracy3[pid].SniperRifle +
     MyCRI.PlayerAccuracy3[pid].InstaGib +
     MyCRI.PlayerAccuracy4[pid].CustomWeapon;

     if (MyCRI.PlayerAccuracy1[pid].Enforcer != 0) f++;
     if (MyCRI.PlayerAccuracy1[pid].BioGun != 0) f++;
     if (MyCRI.PlayerAccuracy1[pid].ShockRifle != 0) f++;
     if (MyCRI.PlayerAccuracy2[pid].MiniGun != 0) f++;
     if (MyCRI.PlayerAccuracy2[pid].PulseGun != 0) f++;
     if (MyCRI.PlayerAccuracy2[pid].Ripper != 0) f++;
     if (MyCRI.PlayerAccuracy3[pid].EightBall != 0) f++;
     if (MyCRI.PlayerAccuracy3[pid].FlakCannon != 0) f++;
     if (MyCRI.PlayerAccuracy3[pid].SniperRifle != 0) f++;
     if (MyCRI.PlayerAccuracy3[pid].InstaGib != 0) f++;
     if (MyCRI.PlayerAccuracy4[pid].CustomWeapon != 0) f++;

     MyCRI.CurrentTotalAccuracy[pid] = t/f;
}

//-------------------------------------
//   PickupQuery
//-------------------------------------
function bool PickupQuery(Pawn Other, Inventory Inv)
{
	local byte x;
    local int st, at, rt, it, kt, mt, bt, i;
    local string s;

    s = caps(mid(string(Inv.Class), instr(string(Inv.Class), ".") + 1));

    if (!bAntiTimer)
    {
        if (bCheckDefaults)
        {
            switch (s)
            {
                case "UT_SHIELDBELT": Inv.DrawScale = 1.0; break;
                case "UDAMAGE": Inv.DrawScale = 1.0; break;
                case "WARHEADLAUNCHER": Inv.DrawScale = 1.0; break;
                case "UT_INVISIBILITY": Inv.DrawScale = 1.0; break;
                case "HEALTHPACK": Inv.DrawScale = 1.0; break;
                case "ARMOR2": Inv.DrawScale = 1.0; break;
                case "UT_JUMPBOOTS": Inv.DrawScale = 1.0; break;
            }
        }
        if (BaseMutator.HandlePickupQuery(Other, Inv, x)) return ( x == 1 );
        if ( Other.Inventory == none ) return true;
	    else return !Other.Inventory.HandlePickupQuery(Inv);
    }

    st = rand(30) + 55;
    at = rand(40) + 100;
    rt = st;
    it = at;
    kt = rand(40) + 100;
    mt = rand(20) + 20;
    bt = mt;

    switch (s)
    {
        case "UT_SHIELDBELT": Inv.ReSpawnTime = st; Inv.DrawScale = 1.0; break;
        case "UDAMAGE": Inv.ReSpawnTime = at; Inv.DrawScale = 1.0; break;

        case "WARHEADLAUNCHER":
            for (i = 0; i < WarheadCount; i++)
            {
                if (Inv.location == WarheadLocation[i])
                {
                    Inv.ReSpawnTime = rt;
                    Inv.DrawScale = 1.0;
                    break;
                }
            }
            break;

        case "UT_INVISIBILITY": Inv.ReSpawnTime = it; Inv.DrawScale = 1.0; break;
        case "HEALTHPACK": Inv.ReSpawnTime = kt; Inv.DrawScale = 1.0; break;
        case "ARMOR2": Inv.ReSpawnTime = mt; Inv.DrawScale = 1.0; break;
        case "UT_JUMPBOOTS": Inv.ReSpawnTime = bt; Inv.DrawScale = 1.0; break;
    }

    if (BaseMutator.HandlePickupQuery(Other, Inv, x)) return (x == 1);
	if (Other.Inventory == none) return true;
	else return !Other.Inventory.HandlePickupQuery(Inv);
}

//-------------------------------------
// GetRules
//-------------------------------------
function string GetRules()
{
	local string ResultSet;
	ResultSet = super(TeamGamePlus).GetRules();

	ResultSet = ResultSet$"\\bEnhancedSprees\\"$bEnhancedSprees;
	ResultSet = ResultSet$"\\bEnhancedMessages\\"$bEnhancedMessages;
	ResultSet = ResultSet$"\\bShowIPS\\"$bShowIPS;
	ResultSet = ResultSet$"\\bLogMods\\"$bLogMods;
	ResultSet = ResultSet$"\\bCheckDefaults\\"$bCheckDefaults;
	ResultSet = ResultSet$"\\HitSoundSounds\\"$bHitSounds;
	ResultSet = ResultSet$"\\DemoRequest\\"$bDemoRequest;
	ResultSet = ResultSet$"\\AnnouncerLevel\\"$AnnouncerLevel;
	ResultSet = ResultSet$"\\RedTeamName\\"$RedTeamName;
	ResultSet = ResultSet$"\\BlueTeamName\\"$BlueTeamName;
	//Log("GetRules: "$ResultSet,'Rules');
	return ResultSet;
}

//-------------------------------------
// LogGameParameters
//-------------------------------------
function LogGameParameters(StatLog _StatLog)
{
	local bool bTemp;

    if (_StatLog == None)
    {
        GameName = "EUT Tournament Team Game";
        return;
    }
    GameName = "Tournament Team Game";
	bTemp = bCoopWeaponMode;
	if (Level.Netmode != NM_Standalone) bCoopWeaponMode = bMultiWeaponStay;
	super(TeamGamePlus).LogGameParameters(_StatLog);
	bCoopWeaponMode = bTemp;

    _StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"bEnhancedSprees"$Chr(9)$bEnhancedSprees);
	_StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"bEnhancedMessages"$Chr(9)$bEnhancedMessages);
    _StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"bHitSounds"$Chr(9)$bHitSounds);
    _StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"bDemoRequest"$Chr(9)$bDemoRequest);
	_StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"BlueTeamName"$Chr(9)$BlueTeamName);
	_StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"RedTeamName"$Chr(9)$RedTeamName);
	GameName = "EUT Tournament Team Game";
}

//-------------------------------------
// CalculateRanking
//-------------------------------------
function CalculateRanking(Pawn P)
{
    local int pid;

    if (P.PlayerReplicationInfo == none ||(P.PlayerReplicationInfo.PlayerName == "Player"))
        return;

    pid = P.PlayerReplicationInfo.PlayerID;

    MyCRI.CurrentRanking[pid] = 1000
    + (Clamp(int((float(MyCRI.TotalKills[pid]) / float(MyCRI.TotalKills[pid] + MyCRI.TotalDeaths[pid])) * 100), 0, 100) * 10)
    + (MyCRI.CurrentTotalAccuracy[pid] * 10)
    + (P.PlayerReplicationInfo.Score * 50)
    + (MyCRI.MultiKills1[pid].KillingSpree * 100)
    + (MyCRI.MultiKills1[pid].Rampage * 100)
    + (MyCRI.MultiKills1[pid].Dominating * 100)
    + (MyCRI.HeadHunterCount[pid] * 100)
    + (MyCRI.KillingSpree[pid].UltraKills * 10)
    + (MyCRI.KillingSpree[pid].MonsterKills * 10)
    + (MyCRI.KillingSpree[pid].LudicriousKills * 10)
    + (MyCRI.KillingSpree[pid].HolyShitKills * 10);

    CalculateAccuracy(P);
}

//-------------------------------------
// CalcEndStats
//-------------------------------------
function CalcEndStats()
{
	local int i;
	local PlayerReplicationInfo PRI;
	local Pawn P;
	local int pid;

    Log("!!!!!!!!!!!!!!! CALC END STATS");

	for (i = 0; i < 3; i++)
	{
		BestTDMRanking[i] = _EndStatsClass.Default.BestTDMRanking[i];
		BestTDMPlayers[i] = _EndStatsClass.Default.BestTDMPlayers[i];
	}

    for (i = 0; i < 32; i++)
	{
	    if (GameReplicationInfo.PRIArray[i] != None)
		{
            PRI = GameReplicationInfo.PRIArray[i];
            TotalFrags += PRI.Score;
			TotalDeaths += PRI.Deaths;
            if (Caps(PRI.PlayerName) != "PLAYER")
		      EmptyBestTDMSlot(MyCRI.CurrentRanking[PRI.PlayerID], PRI.PlayerName);
        }
    }
	for (i = 0; i < 3; i++)
    {
		_EndStatsClass.Default.BestTDMPlayers[i] = BestTDMPlayers[i];
		_EndStatsClass.Default.BestTDMRanking[i] = BestTDMRanking[i];
	}

	EndStatsClass.Default.TotalFrags = TotalFrags + EndStatsClass.Default.TotalFrags;
	EndStatsClass.Default.TotalDeaths = TotalDeaths + EndStatsClass.Default.TotalDeaths;
	EndStatsClass.Default.TotalGames++;
	EndStatsClass.Static.StaticSaveConfig();
	_EndStatsClass.Static.StaticSaveConfig();

    for (P = Level.PawnList; P != None; P = P.NextPawn)
	{
        if ( P.IsA('Bot') || P.IsA('PlayerPawn') )
	    {
            if ( P.PlayerReplicationInfo != none
            && ( P.PlayerReplicationInfo.PlayerName != "Player" ))
            {
                pid = P.PlayerReplicationInfo.PlayerID;
                if ( Level.Game.LocalLog != None
                && ( bStatLink ))
                {
                    Level.Game.LocalLog.LogSpecialEvent("stat_player", "accuracy", pid, string(MyCRI.CurrentTotalAccuracy[pid]));
                    //Weapon Specific Accuracy
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Enforcer",pid, string(MyCRI.PlayerAccuracy1[pid].Enforcer));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","GES Bio Rifle",pid, string(MyCRI.PlayerAccuracy1[pid].BioGun));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Shock Rifle",pid, string(MyCRI.PlayerAccuracy1[pid].ShockRifle));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Ripper",pid, string(MyCRI.PlayerAccuracy2[pid].Ripper));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Pulse Gun",pid, string(MyCRI.PlayerAccuracy2[pid].PulseGun));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Minigun",pid, string(MyCRI.PlayerAccuracy2[pid].MiniGun));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Flak Cannon",pid, string(MyCRI.PlayerAccuracy3[pid].FlakCannon));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Rocket Launcher",pid, string(MyCRI.PlayerAccuracy3[pid].EightBall));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Sniper Rifle",pid, string(MyCRI.PlayerAccuracy3[pid].SniperRifle));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Enhanced Shock Rifle",pid, string(MyCRI.PlayerAccuracy3[pid].InstaGib));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Custom Weapon",pid,string(MyCRI.PlayerAccuracy4[pid].CustomWeapon));
                    //Weapon Hit Count
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Enforcer",pid, string(MyCRI.EnforcerHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","GES Bio Rifle",pid, string(MyCRI.BioGunHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Shock Rifle",pid, string(MyCRI.ShockRifleHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Ripper",pid, string(MyCRI.RipperHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Pulse Gun",pid, string(MyCRI.PulseGunHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Minigun",pid, string(MyCRI.MiniGunHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Flak Cannon",pid, string(MyCRI.FlakGunHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Rocket Launcher",pid, string(MyCRI.EightBallHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Sniper Rifle",pid, string(MyCRI.SniperRifleHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Enhanced Shock Rifle",pid, string(MyCRI.SuperShockRifleHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Custom Weapon",pid, string(MyCRI.CustomWeaponHitCount[pid]));
                    //Weapon Damage
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Enforcer",pid, string(WeaponDamage[pid].Enforcer));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","GES Bio Rifle",pid, string(WeaponDamage[pid].BioGun));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Shock Rifle",pid, string(WeaponDamage[pid].ShockRifle));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Ripper",pid, string(WeaponDamage[pid].Ripper));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Pulse Gun",pid, string(WeaponDamage[pid].PulseGun));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Minigun",pid, string(WeaponDamage[pid].MiniGun));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Flak Cannon",pid, string(WeaponDamage[pid].FlakGun));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Rocket Launcher",pid, string(WeaponDamage[pid].EightBall));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Sniper Rifle",pid, string(WeaponDamage[pid].SniperRifle));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Enhanced Shock Rifle",pid, string(WeaponDamage[pid].SuperShockRifle));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Custom Weapon",pid, string(WeaponDamage[pid].CustomWeapon));
                    //Weapon Shot Count
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Enforcer",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy1[pid].Enforcer,MyCRI.EnforcerHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","GES Bio Rifle",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy1[pid].BioGun,MyCRI.BioGunHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Shock Rifle",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy1[pid].ShockRifle,MyCRI.ShockRifleHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Ripper",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy2[pid].Ripper,MyCRI.RipperHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Pulse Gun",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy2[pid].PulseGun,MyCRI.PulseGunHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Minigun",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy2[pid].MiniGun,MyCRI.MiniGunHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Flak Cannon",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy3[pid].FlakCannon,MyCRI.FlakGunHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Rocket Launcher",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy3[pid].EightBall,MyCRI.EightBallHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Sniper Rifle",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy3[pid].SniperRifle,MyCRI.SniperRifleHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Enhanced Shock Rifle",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy3[pid].InstaGib,MyCRI.SuperShockRifleHitCount[pid])));
                     Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Custom Weapon",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy4[pid].CustomWeapon,MyCRI.CustomWeaponHitCount[pid])));
                }
            }
        }
    }
}

//-------------------------------------
// CalculateShotCount
//-------------------------------------
function int CalculateShotCount(float acc, int i)
{
   acc = acc/100;
   return i / acc;
}

//-------------------------------------
// EmptyBestTDMSlot
//------------------------------------
function EmptyBestTDMSlot(int Rank, string PlayerName)
{
	if (Rank > BestTDMRanking[2])
	{
	   BestTDMRanking[0] = BestTDMRanking[1];
	   BestTDMPlayers[0] = BestTDMPlayers[1];
	   BestTDMRanking[1] = BestTDMRanking[2];
	   BestTDMPlayers[1] = BestTDMPlayers[2];
       BestTDMRanking[2] = Rank;
	   BestTDMPlayers[2] = PlayerName;
       return;
	}
	else if (Rank > BestTDMRanking[1])
	{
	   BestTDMRanking[0] = BestTDMRanking[1];
	   BestTDMPlayers[0] = BestTDMPlayers[1];
       BestTDMRanking[1] = Rank;
	   BestTDMPlayers[1] = PlayerName;
       return;
	}
	else if (Rank > BestTDMRanking[0])
	{
	   BestTDMRanking[0] = Rank;
	   BestTDMPlayers[0] = PlayerName;
       return;
	}
}

//-------------------------------------
//   CalculateDamage
//-------------------------------------
function CalculateDamage(Pawn Killer, Pawn Victim, name DamageType, int DamageAmmount)
{
    local int kid, vid;
    local byte i;
    local int health;
    local string s;

    if (Killer == none || (Victim == none) || (bGameEnded)) return;

    if (Killer.PlayerReplicationInfo == none
    || (Victim.PlayerReplicationInfo == none)
    || (Killer.Weapon == none))
       return;

    kid = Killer.PlayerReplicationInfo.PlayerID;
    vid = Victim.PlayerReplicationInfo.PlayerID;
    i = 0;
    health = Victim.Health + MyCRI.ArmorAmmount[vid];
    s = _GetItemName(Killer.Weapon);

    switch (s)
    {
        case "ENFORCER":
        case "DOUBLEENFORCER":
        case "ZP_ENFORCER":
            MyCRI.EnforcerHitCount[kid]++;
            WeaponDamage[kid].Enforcer = WeaponDamage[kid].Enforcer + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            if (DamageType == 'Shot')
            {
                if (Victim.Physics == PHYS_Falling
                && (DamageKills(health, DamageAmmount)
                && (CheckZ(Victim))))
                {
                    i = 1;
                    ParseNotification(Killer, Victim, 'Enf', i);
                    return;
                }
            }
            break;

        case "UT_BIORIFLE":
            MyCRI.BioGunHitCount[kid]++;
            WeaponDamage[kid].BioGun = WeaponDamage[kid].BioGun + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            if (DamageType == 'Corroded')
            {
                if (Victim.Physics == PHYS_Falling
                && (DamageKills(health, DamageAmmount)
                && (CheckZ(Victim))))
                {
                    i = 1;
                    ParseNotification(Killer, Victim, 'Bio', i);
                    return;
                }
            }
            break;

        case "SHOCKRIFLE":
            MyCRI.ShockRifleHitCount[kid]++;
            WeaponDamage[kid].ShockRifle = WeaponDamage[kid].ShockRifle + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            if (DamageType == 'Jolted')
            {
                if (health - DamageAmmount < -100)
                {
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Combo', i);
                        return;
                    }
                }
            }
            break;

        case "SUPERSHOCKRIFLE":
        case "ZP_SHOCKRIFLE":
        case "ZP_SUPERSHOCKRIFLE":
            MyCRI.SuperShockRifleHitCount[kid]++;
            WeaponDamage[kid].SuperShockRifle = WeaponDamage[kid].SuperShockRifle + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            if (Victim.Physics == PHYS_Falling
            && (DamageKills(health, DamageAmmount)
            && (CheckZ(Victim))))
            {
                i = 1;
                ParseNotification(Killer, Victim, 'SuperShock', i);
                return;
            }
            break;

        case "PULSEGUN":
            MyCRI.PulseGunHitCount[kid]++;
            WeaponDamage[kid].PulseGun = WeaponDamage[kid].PulseGun + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            switch (DamageType)
            {
                case 'Pulsed':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Pulse', i);
                        return;
                    }
                    break;

                case 'zapped':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Pulse', i);
                        return;
                    }
                    break;
            }
            break;
        case "RIPPER":
            MyCRI.RipperHitCount[kid]++;
            WeaponDamage[kid].Ripper = WeaponDamage[kid].Ripper + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            switch (DamageType)
            {
                case 'RipperAltDeath':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Ripper', i);
                        return;
                    }
                    break;

                case 'shredded':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Ripper', i);
                        return;
                    }
                    break;

                case 'Decapitated':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Ripper', i);
                        return;
                    }
                    break;
            }
            break;

        case "MINIGUN2":
            MyCRI.MiniGunHitCount[kid]++;
            WeaponDamage[kid].MiniGun = WeaponDamage[kid].MiniGun + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            if (DamageType == 'shot')
            {
                if (Victim.Physics == PHYS_Falling
                && (DamageKills(health, DamageAmmount)
                && (CheckZ(Victim))))
                {
                    i = 1;
                    ParseNotification(Killer, Victim, 'Mini', i);
                    return;
                }
            }
            break;
        case "UT_FLAKCANNON":

            if (Level.TimeSeconds - SplashKills[kid].FlakTime > 1)
            {
                MyCRI.FlakGunHitCount[kid]++;
                WeaponDamage[kid].FlakGun = WeaponDamage[kid].FlakGun + DamageAmmount;
                SplashKills[kid].FlakTime = Level.TimeSeconds;
                SplashKills[kid].LastHit = Victim;
            }
            else if (SplashKills[kid].LastHit != Victim && Level.TimeSeconds - SplashKills[kid].FlakTime < 1)
            {
                MyCRI.FlakGunHitCount[kid]++;
                WeaponDamage[kid].FlakGun = WeaponDamage[kid].FlakGun + DamageAmmount;
                SplashKills[kid].FlakTime = Level.TimeSeconds;
                SplashKills[kid].LastHit = Victim;
            }
            if (!bEnhancedDeathMessages) return;

            switch (DamageType)
            {
                case 'shredded':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Flak', i);
                        return;
                    }
                    break;

                case 'FlakDeath':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Flak', i);
                        return;
                    }
                    break;
            }
            break;

        case "UT_EIGHTBALL":
            MyCRI.EightBallHitCount[kid]++;
            WeaponDamage[kid].EightBall = WeaponDamage[kid].EightBall + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            switch (DamageType)
            {
                case 'GrenadeDeath':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Rockets', i);
                        return;
                    }
                    break;

                case 'RocketDeath':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Rockets', i);
                        return;
                    }
                    break;
            }
            break;

        case "SNIPERRIFLE":
        case "ZP_SNIPERRIFLE":
            MyCRI.SniperRifleHitCount[kid]++;
            WeaponDamage[kid].SniperRifle = WeaponDamage[kid].SniperRifle + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            switch (DamageType)
            {
                case 'shot':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Sniper', i);
                        return;
                    }
                    break;

                case 'Decapitated':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Sniper', i);
                        return;
                    }
                    break;
            }
            break;

        case "IMPACTHAMMER":
            if (!bEnhancedDeathMessages) return;

            if (DamageType == 'Impact')
            {
                if (Victim.Physics == PHYS_Falling
                && (DamageKills(health, DamageAmmount)
                && (CheckZ(Victim))))
                {
                    i = 1;
                    ParseNotification(Killer, Victim, 'Impact', i);
                    return;
                }
            }
            break;

        case "TRANSLOCATOR":
            if (!bEnhancedDeathMessages) return;

            if (DamageType == 'Gibbed')
            {
                if (Victim.Physics == PHYS_Falling
                && (DamageKills(health, DamageAmmount)
                && (CheckZ(Victim))))
                {
                    i = 1;
                    ParseNotification(Killer, Victim, 'Trans', i);
                    return;
                }
            }
            break;

        case CustomWeaponName:
            if (bUsesCustomWeapon)
            {
                MyCRI.CustomWeaponHitCount[kid]++;
                WeaponDamage[kid].CustomWeapon = WeaponDamage[kid].CustomWeapon + DamageAmmount;

                if (!bEnhancedDeathMessages) return;

                switch (DamageType)
                {
                    case 'shot':
                        if (Victim.Physics == PHYS_Falling
                        && (DamageKills(health, DamageAmmount)
                        && (CheckZ(Victim))))
                        {
                            i = 1;
                            ParseNotification(Killer, Victim, 'Sniper', i);
                            return;
                        }
                        break;

                    case 'Decapitated':
                        if (Victim.Physics == PHYS_Falling
                        && (DamageKills(health, DamageAmmount)
                        && (CheckZ(Victim))))
                        {
                            i = 1;
                            ParseNotification(Killer, Victim, 'Sniper', i);
                            return;
                        }
                        break;
                }
            }
            break;
    }
}

//-------------------------------------
//   DamageKills
//-------------------------------------
function bool DamageKills(int x, int i)
{
   if (x <= i) return true;
   else return false;
}

//-------------------------------------
//   CheckZ
//-------------------------------------
function bool CheckZ(Pawn P)
{
    local vector X;

    X.X = P.Location.X;
    X.Y = P.Location.Y;
    X.Z = P.Location.Z + (-150 * LowGravityAerialKillAdjuster);

    if (FastTrace(X,P.Location))
       return true;
    else
       return false;
}

//-------------------------------------
//   ParseNotification
//-------------------------------------
function ParseNotification(Pawn Killer, Pawn Victim, name DamageInstigator, byte i)
{
    if (Killer == none || (Victim == none) || (i == 0))
        return;

    if (Killer.IsA('Bot')) return;

    if (i == 1)
    {
        if (DamageInstigator == 'bio'
        || (DamageInstigator == 'Ripper')
        || (DamageInstigator == 'Flak')
        || (DamageInstigator == 'Rockets')
        || (DamageInstigator == 'Sniper')
        || (DamageInstigator == 'SuperShock')
        || (DamageInstigator == 'Trans')
        || (DamageInstigator == 'Combo')
        || (DamageInstigator == 'Enf')
        || (DamageInstigator == 'Pulse')
        || (DamageInstigator == 'Mini')
        || (DamageInstigator == 'Piston')
        || (DamageInstigator == 'Impact'))
        {
            if(CanPlaySound(Killer))
                TournamentPlayer(PlayerPawn(Killer)).ReceiveLocalizedMessage(class'EUTMultiKillMessage', 20);

            AKMS[Killer.PlayerReplicationInfo.PlayerID] = 1;
            BroadcastRegularDeathMessage(Killer, Victim, DamageInstigator);
            return;
        }
    }
}

//-------------------------------------
//   BroadcastRegularDeathMessage
//-------------------------------------
function BroadcastRegularDeathMessage(Pawn Killer, Pawn Other, name DamageType)
{
    local int i;
    local string s;
    local bool b;

    if (Killer == none || (Other == none)) return;

    if (Killer.PlayerReplicationInfo == none
    || (Other.PlayerReplicationInfo == none)
    || (Killer.Weapon == none))
       return;

    if (bEnhancedDeathMessages)
    {
        if (EUTDamageType(DamageType))
        {
            switch (DamageType)
            {
               case 'bio':
                  i = 61;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Ripper':
                  i = 62;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Flak':
                  i = 63;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Rockets':
                  i = 64;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Sniper':
                  i = 65;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'SuperShock':
                  i = 66;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Trans':
                  i = 67;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Combo':
                  i = 68;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Enf':
                  i = 69;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Pulse':
                  i = 70;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Mini':
                  i = 72;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Impact':
                  i = 74;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
            }
        }
        if (!EUTDamageType(DamageType))
        {
            if (AKMS[Killer.PlayerReplicationInfo.PlayerID] == 1)
            {
               AKMS[Killer.PlayerReplicationInfo.PlayerID] = 0;
               return;
            }

            switch (_GetItemName(Killer.Weapon))
            {
                case "ENFORCER":
                case "DOUBLEENFORCER":
                case "ZP_ENFORCER":
                    i = 21;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "UT_BIORIFLE":
                    i = 22;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "SHOCKRIFLE":
                case "SUPERSHOCKRIFLE":
                case "ZP_SHOCKRIFLE":
                case "ZP_SUPERSHOCKRIFLE":
                    i = 23;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "PULSEGUN":
                    i = 24;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "RIPPER":
                    i = 25;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "MINIGUN2":
                    i = 26;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "UT_FLAKCANNON":
                    i = 27;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "UT_EIGHTBALL":
                    i = 28;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "SNIPERRIFLE":
                case "ZP_SNIPERRIFLE":
                    i = 29;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "IMPACTHAMMER":
                    i = 76;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "TRANSLOCATOR":
                    i = 78;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
            }
        }
    }
    if (!bEnhancedDeathMessages && (!b))
        BroadcastLocalizedMessage(DeathMessageClass, 30, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);

}

//-------------------------------------
//   EUTDamageType
//-------------------------------------
function bool EUTDamageType(name DamageType)
{
   if (DamageType == 'bio'
   || (DamageType == 'Ripper' )
   || (DamageType == 'Flak' )
   || (DamageType == 'Rockets' )
   || (DamageType == 'Sniper' )
   || (DamageType == 'SuperShock' )
   || (DamageType == 'Trans' )
   || (DamageType == 'Combo' )
   || (DamageType == 'Enf' )
   || (DamageType == 'Pulse' )
   || (DamageType == 'Mini' )
   || (DamageType == 'Impact' ))
      return true;
   else
      return false;
}

//-------------------------------------
//   EndSpree
//-------------------------------------
function EndSpree(Pawn Killer, Pawn Other)
{
	local Pawn P;

	if (Other != none)
        if (!Other.bIsPlayer)
		    return;

	for (P = Level.PawnList; P != None; P = P.NextPawn)
    {
        if (P.IsA('TournamentPlayer'))
        {
            if (!bExpandSpree)
            {
                if ((Killer == None) || !Killer.bIsPlayer)
                {
                    TournamentPlayer(P).EndSpree(None, Other.PlayerReplicationInfo);
                    return;
                }
                else
                {
                    TournamentPlayer(P).EndSpree(Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo);
                    return;
                }
            }
            if (bExpandSpree)
            {
                if ((Killer == None) || !Killer.bIsPlayer)
                {
                    TournamentPlayer(P).EndSpree(None, Other.PlayerReplicationInfo);
                    return;
                }
                else
                {
                    TournamentPlayer(P).EndSpree(Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo);

                    switch (ExpandedSpreeSwitch)
                    {
                          case 1:
                              ExpandedSpreeSwitch = 0;
                              bExpandSpree = false;
                              BroadcastMessage(class'EUTMultiKillMessage'.static.GetBroadCastString(21, Killer.PlayerReplicationInfo,Other.PlayerReplicationInfo,None));
                              break;
                          case 2:
                              ExpandedSpreeSwitch = 0;
                              bExpandSpree = false;
                              BroadcastMessage(class'EUTMultiKillMessage'.static.GetBroadCastString(22, Killer.PlayerReplicationInfo,Other.PlayerReplicationInfo,None));
                              break;
                          case 3:
                              ExpandedSpreeSwitch = 0;
                              bExpandSpree = false;
                              BroadcastMessage(class'EUTMultiKillMessage'.static.GetBroadCastString(23, Killer.PlayerReplicationInfo,Other.PlayerReplicationInfo,None));
                              break;
                          case 4:
                              ExpandedSpreeSwitch = 0;
                              bExpandSpree = false;
                              BroadcastMessage(class'EUTMultiKillMessage'.static.GetBroadCastString(24, Killer.PlayerReplicationInfo,Other.PlayerReplicationInfo,None));
                              break;
                          case 5:
                              ExpandedSpreeSwitch = 0;
                              bExpandSpree = false;
                              BroadcastMessage(class'EUTMultiKillMessage'.static.GetBroadCastString(25, Killer.PlayerReplicationInfo,Other.PlayerReplicationInfo,None));
                              break;
                          case 6:
                              ExpandedSpreeSwitch = 0;
                              bExpandSpree = false;
                              BroadcastMessage(class'EUTMultiKillMessage'.static.GetBroadCastString(26, Killer.PlayerReplicationInfo,Other.PlayerReplicationInfo,None));
                              break;
                          default:
                            break;
                    }
                }
            }
        }
	}
}

//-------------------------------------
//   AltEndGame
//-------------------------------------
function AltEndGame(string Reason)
{
	local actor A;

	AltSetEndCams(Reason);

	bGameEnded = true;
	bAltOvertime = true;

	foreach AllActors(class'Actor', A, 'EndGame')
		A.trigger(self, none);

	if (LocalLog != None)
	{
		LocalLog.LogGameEnd(Reason);
		LocalLog.StopLog();

		if (bBatchLocal)
			LocalLog.ExecuteSilentLogBatcher();

		LocalLog.Destroy();
		LocalLog = None;
	}
	if (WorldLog != None)
	{
		WorldLog.LogGameEnd(Reason);
		WorldLog.StopLog();
		WorldLog.ExecuteWorldLogBatcher();
		WorldLog.Destroy();
		WorldLog = None;
	}
}

//-------------------------------------
//   AltSetEndCams
//-------------------------------------
function bool AltSetEndCams(string Reason)
{
	local TeamInfo BestTeam;
	local int i;
	local Pawn P, BestP;
	local PlayerPawn PP;
	local string EndGameNotify;

	BestTeam = Teams[0];
	for (i = 1; i < MaxTeams; i++)
	{
		if (Teams[i].Score > BestTeam.Score)
		{
			BestTeam = Teams[i];
            if(Reason == "SuddenDeath")
                EndGameNotify = TeamPrefix@BestTeam.TeamName@"Won The Match In Sudden Death";
            EndGameNotify = TeamPrefix@BestTeam.TeamName@GameEndedMessage;
        }
    }

    for (P = Level.PawnList; P != None; P = P.nextPawn)
	{
        if (P.PlayerReplicationInfo != none)
        {
            if (P.bIsPlayer
            && (P.PlayerReplicationInfo.Team == BestTeam.TeamIndex))
            {
                if (P.PlayerReplicationInfo.Score > BestP.PlayerReplicationInfo.Score)
                    BestP = P;
                else if (P.PlayerReplicationInfo.Score == BestP.PlayerReplicationInfo.Score
                && (MyCRI.CurrentRanking[P.PlayerReplicationInfo.PlayerID] > MyCRI.CurrentRanking[BestP.PlayerReplicationInfo.PlayerID]))
                    BestP = P;
            }
        }

	}

	if (BestP == none)
	{
	   for (P = Level.PawnList; P != None; P = P.nextPawn)
	   {
            if (P.PlayerReplicationInfo != none)
                if (P.bIsPlayer && (( BestP == None) || (P.PlayerReplicationInfo.Score > BestP.PlayerReplicationInfo.Score)))
			         BestP = P;
	   }
	}

    if (BestTeam == none)
    {
	    i = Rand(2);
        BestTeam = Teams[i];
	    EndGameNotify = "Match Ended for Time Limit!";
    }

	GameReplicationInfo.GameEndedComments = EndGameNotify;

	EndTime = Level.TimeSeconds + 3.0;
	for (P = Level.PawnList; P != None; P = P.nextPawn)
	{
		CalculateRanking(P);
        PP = PlayerPawn(P);
		if (PP != None)
		{
			if (!bTutorialGame && (!bEnhancedMessages))
                PlayWinMessage(PP, (PP.PlayerReplicationInfo.Team == BestTeam.TeamIndex));

			if (!bTutorialGame && (bEnhancedMessages))
			{
				if (CanPlaySound(P))
				{
				   if (Teams[0].Score > Teams[1].Score)
				      TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 11);

	               if (Teams[1].Score > Teams[0].Score)
				      TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 12);
                }
            }
			PP.bBehindView = true;
			if (PP == BestP) PP.ViewTarget = None;
			else PP.ViewTarget = BestP;
			PP.ClientGameEnded();
		}
		P.GotoState('GameEnded');
	}
	CalcEndStats();
	return true;
}

//-------------------------------------
//    CanPlaySound
//-------------------------------------
function bool CanPlaySound( Pawn P )
{
    if (P.IsA('PlayerPawn')
    && (P.IsA('TournamentPlayer')))
        return true;
    else return false;
}

//-------------------------------------
// _GetItemName
//-------------------------------------
function string _GetItemName(Weapon W)
{
    return caps(mid(string(W.Class), instr(string(W.Class), ".") + 1));
}

//-------------------------------------
//   defaultproperties
//-------------------------------------
defaultproperties
{
    _EndStatsClass=Class'EUTEndStats'
    bEnhancedSprees=True
    bEnhancedMessages=True
    bShowIPS=True
    bLogMods=True
    bCheckDefaults=True
    bHitSounds=True
    bReport=True
    bAntiTimer=True
    bNoFlockPawns=True
    AnnouncerLevel=2
    TraceDistance=3500
    TransKillMessage="%k telefragged %o!"
    ImpactKillMessage="%o got smeared by %k's piston."
    EnforcerKillMessage="%k riddled %o full of holes with the %w."
    BioKillMessage="%o drank a glass of %k's dripping green load."
    ShockRifleKillMessage="%k inflicted mortal damage upon %o with the %w."
    PulseGunKillMessage="%o ate %k's burning plasma death."
    RipperKillMessage="%k ripped a chunk of meat out of %o with the %w."
    MiniGunKillMessage="%k's %w turned %o into a leaky piece of meat."
    FlakCannonKillMessage="%o was ripped to shreds by %k's %w."
    RocketLauncherKillMessage="%o was smacked down by %k's %w."
    SniperRifleKillMessage="%k put a bullet through %o's head."
    AerialKillBio="%k smacked %o out of the air with his %w."
    AerialKillRipper="%k smacked %o out of the air with his %w."
    AerialKillFlak="%k smacked %o out of the air with his %w."
    AerialKillRockets="%k smacked %o out of the air with his %w."
    AerialKillSniper="%k smacked %o out of the air with his %w."
    AerialKillSuper="%k smacked %o out of the air with his %w."
    AerialKillTrans="%k smacked %o out of the air with his %w."
    AerialKillCombo="%k smacked %o out of the air with his %w."
    AerialKillEnforcer="%k smacked %o out of the air with his %w."
    AerialKillPulse="%k smacked %o out of the air with his %w."
    AerialKillMini="%k smacked %o out of the air with his %w."
    AerialKillPiston="%k smacked %o out of the air with his %w."
    SoundPackage="EUT_Sounds"
    RedTeamName="Red Team"
    BlueTeamName="Blue Team"
    GameReplicationInfoClass=Class'EUTGameReplicationInfo'
}
