/*
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
              SmartCTFGame
<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>
*/
class SmartCTFGame extends CTFGame
	config;

#exec OBJ LOAD FILE=..\Sounds\EUT_Sounds.uax

var EUTGameReplicationInfo MyCRI;
var UTStatsLink StatLink;
var Actor IpToCountry;

var class<EUTEndStats> _EndStatsClass;

var Pawn FlagDropper;
var Pawn FlagGrabs[40];
var Pawn FlagAssists[40];
var CTFFlag RedFlag, BlueFlag, FlagToReturn;
var LowGrav lg;

var bool bAltOvertime, bExpandSpree;

var byte AKMS[40], FlakKills[40], ComboKills[40], WarheadCount, ExpandedSpreeSwitch;

var int NumFlagGrabs[40], BestRanking[3], LowGravityAerialKillAdjuster;

var sound _CaptureSound[4];
var sound _ReturnSound;
var sound DeniedSound;
var sound FlakMonkeySound;
var sound HeadHunterSound;
var sound ComboWhoreSound;
var sound KillingSpreeSound;
var sound RampageSound;
var sound DominatingSound;
var sound UnStoppableSound;
var sound GodlikeSound;
var sound WhickedSickSound;
var sound RedTeamIsTheWinnerSound;
var sound FlawlessVictorySound;
var sound BlueTeamIsTheWinnerSound;
var sound LastSecondSaveSound;
var sound RedTeamScoresSound;
var sound RedTeamTakesTheLeadSound;
var sound RedTeamIncreasesThierLeadSound;
var sound RedTeamDominatingSound;
var sound BlueTeamScoresSound;
var sound BlueTeamTakesTheLeadSound;
var sound BlueTeamIncreasesThierLeadSound;
var sound BlueTeamDominatingSound;
var sound HatTrickSound;
var sound HitSoundSound;
var sound HitSoundFriendlySound;
var sound DoubleKillSound;
var sound MultiKillSound;
var sound MegaKillSound;
var sound UltraKillSound;
var sound MonsterKillSoundF;
var sound LudicriousKillSound;
var sound HolyShitKillSound;
var sound OwnageSound;

var string BestPlayers[3];

var vector WarheadLocation[20];

var() config bool bEnhancedSprees;
var() config bool bEnhancedMessages;
var() config bool bShowIPS;
var() config bool bLogMods;
var() config bool bCheckDefaults;
var() config bool bHitSounds;
var() config bool bDemoRequest;
var() config bool bKickSpeedHack;
var() config bool bReport;
var() config bool bScoreBoardEff;
var() config bool bAutoTaunts;
var() config bool bEnhancedDeathMessages;
var() config bool bAntiTimer;
var() config bool bTeamBeacon;
var() config bool bStatLink;
var() config bool bAlwaysRecordTourney;
var() config bool bKickMinY;
var() config bool bNoOverTime;
var() config bool bIpToCountry;
var() config bool bUsesCustomWeapon;
var() config bool bNoFlockPawns;
var() config bool bNoDroppedFlags;

var() config byte FlagCap;
var() config byte AssistsBonus;
var() config byte FlagKill;
var() config byte CoversBonus;
var() config byte SealsBonus;
var() config byte DeniedBonus;
var() config byte SavesBonus;
var() config byte AnnouncerLevel;
var() config byte SetFOV;

var() config float MinY;
var() config float FlagSaveDistance;
var() config float FlagDeniedDistance;
var() config float FlagCoverVisibleDistance;
var() config float FlagCoverHiddenDistance;

var() config int TraceDistance;

var() config string TransKillMessage;
var() config string ImpactKillMessage;
var() config string EnforcerKillMessage;
var() config string BioKillMessage;
var() config string ShockRifleKillMessage;
var() config string PulseGunKillMessage;
var() config string RipperKillMessage;
var() config string MiniGunKillMessage;
var() config string FlakCannonKillMessage;
var() config string RocketLauncherKillMessage;
var() config string SniperRifleKillMessage;
var() config string CustomWeaponKillMessage;
var() config string AerialKillBio;
var() config string AerialKillRipper;
var() config string AerialKillFlak;
var() config string AerialKillRockets;
var() config string AerialKillSniper;
var() config string AerialKillSuper;
var() config string AerialKillTrans;
var() config string AerialKillCombo;
var() config string AerialKillEnforcer;
var() config string AerialKillPulse;
var() config string AerialKillMini;
var() config string AerialKillPiston;
var() config string AerialKillCustom;

var() config string RedTeamName, BlueTeamName;
var() config string SoundPackage;
var() config string CustomWeaponName;
var() config string IpToCountryTexturePackage;
var() config string MessageOfTheDay;

struct _WeaponDamage
{
    var int Enforcer,
    BioGun,
    ShockRifle,
    Ripper,
    MiniGun,
    PulseGun,
    FlakGun,
    EightBall,
    SniperRifle,
    SuperShockRifle,
    CustomWeapon;
};
var _WeaponDamage WeaponDamage[40];

struct _MultiKills
{
    var float MultiTime;
    var byte MultiLevel;
};
var _MultiKills MultiKills[40];

struct _SplashKills
{
    var float FlakTime;
    var Pawn LastHit;
};
var _SplashKills SplashKills[40];

const MaxArray = 40;
const MaxTries = 21;

//-------------------------------------
// PreLogin
//-------------------------------------
event PreLogin
(
	string Options,
	string Address,
	out string Error,
	out string FailCode
)
{
	local string Face, Pad, PlayerName;
	local bool bCheckFace;

    bCheckFace = ParseFace(Options, Address, Face, Pad, PlayerName);

    if (Face == "FailedParse")
    {
        Error = "FAILEDPARSE";
        FailCode = "Your Client Failed to Parse at Prelogin Correctly";
        log("Client Failed PreLogin with a Failure to Parse Options"@Pad,'EUT');
        Super.PreLogin(Options, Address, Error, FailCode);
    }
    else if (bCheckFace)
    {
        Error = "ILLEGALFACE";
        FailCode = "Ivan is not an authorized Face";
        log("Client Attempted to PreLogin with Face"@Face@"--"@PlayerName@Pad,'EUT');
    }
    else
        Super.PreLogin(Options, Address, Error, FailCode);
}

//-------------------------------------
// ParseFace
//-------------------------------------
function bool ParseFace(string Options, string Address, out string Face, out string Pad, out string PlayerName)
{
    local string s;

    if (Instr(Address,":") != -1) Pad = Left(Address, InStr(Address,":"));
    else Pad = Address;

    Options = Caps(Options);

    if (Instr(Options, "NAME=") != -1)
    {
        s = Mid(Options, instr(Options, "NAME=") + 5);
        if (instr(s, "?") != -1) PlayerName = left(s, instr(s,"?"));
        else PlayerName = "FailedParse";
    }
    else PlayerName = "FailedParse";

    if(InStr(Options, "FACE=") != -1)
    {
        s = Mid(Options, instr(Options, "FACE=") + 5);
        if (instr(s, "?") != -1)
        {
            Face = left(s, instr(s,"?"));
            if (instr(Face, ".") != -1)
                Face = mid(Face, instr(Face, ".") + 1);
            else Face = "FailedParse";
        }
        else Face = "FailedParse";
    }
    else Face = "FailedParse";

    if (Face == "IVAN")
        return true;

    return False;
}

//-------------------------------------
// PostBeginPlay
//-------------------------------------
function PostBeginPlay()
{
    local int i;
    local Warheadlauncher  WL;
    local Actor A;

    super(TeamGamePlus).PostBeginPlay();

    PreCacheSounds();
    ResetVars();

    if (bEnhancedSprees)
    {
        DeathMessageClass = Class'EUTDeathMessagePlus';
        MyCRI.bUsesSpreeSounds = true;

        class'EUTMultiKillMessage'.default.DoubleKillSound = DoubleKillSound;
        class'EUTMultiKillMessage'.default.MultiKillSound = MultiKillSound;
        class'EUTMultiKillMessage'.default.MegaKillSound = MegaKillSound;
        class'EUTMultiKillMessage'.default.UltraKillSound = UltraKillSound;
        class'EUTMultiKillMessage'.default.MonsterKillSoundF = MonsterKillSoundF;
        class'EUTMultiKillMessage'.default.LudicriousKillSound = LudicriousKillSound;
        class'EUTMultiKillMessage'.default.HolyShitKillSound = HolyShitKillSound;
        class'EUTMultiKillMessage'.default.OwnageSound = OwnageSound;

        MyCRI.DoubleKillSound = DoubleKillSound;
        MyCRI.MultiKillSound = MultiKillSound;
        MyCRI.MegaKillSound = MegaKillSound;
        MyCRI.UltraKillSound = UltraKillSound;
        MyCRI.MonsterKillSoundF = MonsterKillSoundF;
        MyCRI.LudicriousKillSound = LudicriousKillSound;
        MyCRI.HolyShitKillSound = HolyShitKillSound;
        MyCRI.OwnageSound = OwnageSound;
        MyCRI.WhickedSickSound = WhickedSickSound;

        class'KillingSpreeMessage'.default.SpreeSound[0] =  KillingSpreeSound;
	    class'KillingSpreeMessage'.default.SpreeSound[1] =  RampageSound;
	    class'KillingSpreeMessage'.default.SpreeSound[2] =  DominatingSound;
	    class'KillingSpreeMessage'.default.SpreeSound[3] =  UnStoppableSound;
	    class'KillingSpreeMessage'.default.SpreeSound[4] =  GodlikeSound;

	    MyCRI.SpreeSound[0] = KillingSpreeSound;
	    MyCRI.SpreeSound[1] = RampageSound;
	    MyCRI.SpreeSound[2] = DominatingSound;
	    MyCRI.SpreeSound[3] = UnStoppableSound;
	    MyCRI.SpreeSound[4] = GodlikeSound;
    }
    else DeathMessageClass=Class'DeathMessagePlus';

    if (bEnhancedMessages)
    {
        MyCRI.RedTeamScoresSound = RedTeamScoresSound;
        MyCRI.BlueTeamScoresSound = BlueTeamScoresSound;
        MyCRI.RedTeamTakesTheLeadSound = RedTeamTakesTheLeadSound;
        MyCRI.BlueTeamTakesTheLeadSound = BlueTeamTakesTheLeadSound;
        MyCRI.RedTeamIncreasesThierLeadSound = RedTeamIncreasesThierLeadSound;
        MyCRI.BlueTeamIncreasesThierLeadSound = BlueTeamIncreasesThierLeadSound;
        MyCRI.RedTeamDominatingSound = RedTeamDominatingSound;
        MyCRI.BlueTeamDominatingSound = BlueTeamDominatingSound;
        MyCRI.DeniedSound = DeniedSound;
        MyCRI.RedTeamIsTheWinnerSound = RedTeamIsTheWinnerSound;
        MyCRI.BlueTeamIsTheWinnerSound = BlueTeamIsTheWinnerSound;
        MyCRI.FlawlessVictorySound = FlawlessVictorySound;
        MyCRI.LastSecondSaveSound = LastSecondSaveSound;
        MyCRI.HatTrickSound = HatTrickSound;
    }

    MyCRI.FlakMonkeySound = FlakMonkeySound;
    MyCRI.HeadHunterSound = HeadHunterSound;
    MyCRI.ComboWhoreSound = ComboWhoreSound;
    MyCRI.HitSoundSound = HitSoundSound;
    MyCRI.HitSoundFriendlySound = HitSoundFriendlySound;

    if (Level.NetMode == NM_Client)
		Spawn(Class'EUTDemoEnhancer');

    i = 0;
    WarheadCount = 0;
    foreach level.allactors(class'Warheadlauncher', WL)
    {
        if (i < 20)
        {
            WarheadLocation[i] =  WL.location;
            i++;
            WarheadCount++;
        }
    }

    LowGravityAerialKillAdjuster = 1;
    foreach Level.AllActors(class'LowGrav',lg)
       if (lg != none)
          LowGravityAerialKillAdjuster = 2.5;

    if (bStatLink)
    {
        StatLink = Spawn(Class'UTStatsLink');
        if (StatLink != none)
        {
            Log("CTF Stat Link Created:"@StatLink,'EUT');
            InitializeLogging();
        }
    }
    else
        GameName = "Smart Capture the Flag";

    if (bIpToCountry)
    {
        foreach AllActors(class'Actor', A, 'IpToCountry')
        {
            IpToCountry = A;
		    log("IpToCountry Located"@IpToCountry,'EUT');
            break;
		}
    }
}

//-------------------------------------
// PreCacheSounds
//-------------------------------------
function PreCacheSounds()
{
    DeniedSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Denied",class'sound',true));
    if(DeniedSound == none)
        DeniedSound = sound'EUT_Sounds.Denied';

    HeadHunterSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_HeadHunter",class'sound',true));
    if(HeadHunterSound == none)
        HeadHunterSound = sound'EUT_Sounds.HeadHunter';

    FlakMonkeySound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_FlackMonkey",class'sound',true));
    if(FlakMonkeySound == none)
        FlakMonkeySound = sound'EUT_Sounds.FlackMonkey';

    ComboWhoreSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_ComboWhore",class'sound',true));
    if(ComboWhoreSound == none)
        ComboWhoreSound = sound'EUT_Sounds.ComboWhore';

    KillingSpreeSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_KillingSpree",class'sound',true));
    if(KillingSpreeSound == none)
        KillingSpreeSound = sound'EUT_Sounds.Killing_Spree';

    RampageSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Rampage",class'sound',true));
    if(RampageSound == none)
        RampageSound = sound'EUT_Sounds.Rampage';

    DominatingSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Dominating",class'sound',true));
    if(DominatingSound == none)
        DominatingSound = sound'EUT_Sounds.Dominating';

    UnStoppableSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_UnStoppable",class'sound',true));
    if(UnStoppableSound == none)
        UnStoppableSound = sound'EUT_Sounds.UnStoppable';

    GodlikeSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Godlike",class'sound',true));
    if(GodlikeSound == none)
        GodlikeSound = sound'EUT_Sounds.Godlike';

    WhickedSickSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_WhickedSick",class'sound',true));
    if(WhickedSickSound == none)
        WhickedSickSound = sound'EUT_Sounds.WhickedSick';

    RedTeamIsTheWinnerSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_red_team_is_the_winner",class'sound',true));
    if(RedTeamIsTheWinnerSound == none)
        RedTeamIsTheWinnerSound = sound'EUT_Sounds.red_team_is_the_winner';

    FlawlessVictorySound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Flawless_victory",class'sound',true));
    if(FlawlessVictorySound == none)
        FlawlessVictorySound = sound'EUT_Sounds.Flawless_victory';

    BlueTeamIsTheWinnerSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_blue_team_is_the_winner",class'sound',true));
    if(BlueTeamIsTheWinnerSound == none)
        BlueTeamIsTheWinnerSound = sound'EUT_Sounds.blue_team_is_the_winner';

    LastSecondSaveSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Last_Second_Save",class'sound',true));
    if(LastSecondSaveSound == none)
        LastSecondSaveSound = sound'EUT_Sounds.Last_Second_Save';

    RedTeamScoresSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Red_Team_Scores",class'sound',true));
    if(RedTeamScoresSound == none)
        RedTeamScoresSound = sound'EUT_Sounds.Red_Team_Scores';

    RedTeamTakesTheLeadSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Red_Team_takes_lead",class'sound',true));
    if(RedTeamTakesTheLeadSound == none)
        RedTeamTakesTheLeadSound = sound'EUT_Sounds.Red_Team_takes_lead';

    RedTeamIncreasesThierLeadSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Red_Team_increases_their_lead",class'sound',true));
    if(RedTeamIncreasesThierLeadSound == none)
        RedTeamIncreasesThierLeadSound = sound'EUT_Sounds.Red_Team_increases_their_lead';

    RedTeamDominatingSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_red_team_Dominating",class'sound',true));
    if(RedTeamDominatingSound == none)
        RedTeamDominatingSound = sound'EUT_Sounds.red_team_Dominating';

    BlueTeamScoresSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Blue_Team_Scores",class'sound',true));
    if(BlueTeamScoresSound == none)
        BlueTeamScoresSound = sound'EUT_Sounds.Blue_Team_Scores';

    BlueTeamTakesTheLeadSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Blue_Team_takes_the_lead",class'sound',true));
    if(BlueTeamTakesTheLeadSound == none)
        BlueTeamTakesTheLeadSound = sound'EUT_Sounds.Blue_Team_takes_the_lead';

    BlueTeamIncreasesThierLeadSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Blue_Team_increases_their_lead",class'sound',true));
    if(BlueTeamIncreasesThierLeadSound == none)
        BlueTeamIncreasesThierLeadSound = sound'EUT_Sounds.Blue_Team_increases_their_lead';

    BlueTeamDominatingSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_blue_team_Dominating",class'sound',true));
    if(BlueTeamDominatingSound == none)
        BlueTeamDominatingSound = sound'EUT_Sounds.blue_team_Dominating';

    HatTrickSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_HatTrick",class'sound',true));
    if(HatTrickSound == none)
        HatTrickSound = sound'EUT_Sounds.HatTrick';

    HitSoundSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_HitSound",class'sound',true));
    if(HitSoundSound == none)
        HitSoundSound = sound'EUT_Sounds.HitSound';

    HitSoundFriendlySound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_HitSound_F",class'sound',true));
    if(HitSoundFriendlySound == none)
        HitSoundFriendlySound =sound'EUT_Sounds.HitSound_F';

    DoubleKillSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Double_Kill",class'sound',true));
    if(DoubleKillSound == none)
        DoubleKillSound = sound'EUT_Sounds.Double_Kill';

    MultiKillSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_MultiKill",class'sound',true));
    if(MultiKillSound == none)
        MultiKillSound = sound'EUT_Sounds.MultiKill';

    MegaKillSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_megakill",class'sound',true));
    if(MegaKillSound == none)
        MegaKillSound = sound'EUT_Sounds.megakill';

    UltraKillSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_UltraKill",class'sound',true));
    if(UltraKillSound == none)
        UltraKillSound = sound'EUT_Sounds.UltraKill';

    MonsterKillSoundF = sound(DynamicLoadObject(SoundPackage$"."$"Alt_MonsterKill_F",class'sound',true));
    if(MonsterKillSoundF == none)
        MonsterKillSoundF = sound'EUT_Sounds.MonsterKill_F';

    LudicriousKillSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_LudicrousKill",class'sound',true));
    if(LudicriousKillSound == none)
        LudicriousKillSound = sound'EUT_Sounds.LudicrousKill';

    HolyShitKillSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_HolyShit_F",class'sound',true));
    if(HolyShitKillSound == none)
        HolyShitKillSound = sound'EUT_Sounds.HolyShit_F';

    OwnageSound = sound(DynamicLoadObject(SoundPackage$"."$"Alt_Ownage",class'sound',true));
    if(OwnageSound == none)
        OwnageSound = sound'EUT_Sounds.Ownage';

}

//-------------------------------------
// ResetVars
//-------------------------------------
function ResetVars()
{
    local int i;

    MyCRI = EUTGameReplicationInfo(GameReplicationInfo);
    MyCRI.RedTeamName = RedTeamName;
    MyCRI.BlueTeamName = BlueTeamName;
    MyCRI.bShowIPS = bShowIPS;
	MyCRI.TraceDistance = TraceDistance;
	MyCRI.bTeamBeacon = bTeamBeacon;
	MyCRI.bIpToCountry = bIpToCountry;
    RedFlag = MyCRI.FlagList[0];
    BlueFlag = MyCRI.FlagList[1];
    MyCRI.TransKillMessage = TransKillMessage;
    MyCRI.ImpactKillMessage = ImpactKillMessage;
    MyCRI.EnforcerKillMessage = EnforcerKillMessage;
    MyCRI.BioKillMessage = BioKillMessage;
    MyCRI.ShockRifleKillMessage = ShockRifleKillMessage;
    MyCRI.PulseGunKillMessage = PulseGunKillMessage;
    MyCRI.RipperKillMessage = RipperKillMessage;
    MyCRI.MiniGunKillMessage = MiniGunKillMessage;
    MyCRI.FlakCannonKillMessage = FlakCannonKillMessage;
    MyCRI.RocketLauncherKillMessage = RocketLauncherKillMessage;
    MyCRI.SniperRifleKillMessage = SniperRifleKillMessage;
    MyCRI.AerialKillBio = AerialKillBio;
    MyCRI.AerialKillRipper = AerialKillRipper;
    MyCRI.AerialKillFlak = AerialKillFlak;
    MyCRI.AerialKillRockets = AerialKillRockets;
    MyCRI.AerialKillSniper = AerialKillSniper;
    MyCRI.AerialKillSuper = AerialKillSuper;
    MyCRI.AerialKillTrans = AerialKillTrans;
    MyCRI.AerialKillCombo = AerialKillCombo;
    MyCRI.AerialKillEnforcer = AerialKillEnforcer;
    MyCRI.AerialKillPulse = AerialKillPulse;
    MyCRI.AerialKillMini = AerialKillMini;
    MyCRI.AerialKillPiston = AerialKillPiston;
    MyCRI.bScoreBoardEff = bScoreBoardEff;
    MyCRI.IpToCountryTexturePackage = IpToCountryTexturePackage;
    MyCRI.CustomWeaponName = CustomWeaponName;
    MyCRI.bUsesCustomWeapon = bUsesCustomWeapon;
    MyCRI.CustomWeaponKillMessage = CustomWeaponKillMessage;
    MyCRI.AerialKillCustom = AerialKillCustom;
    MyCRI.SetFOV = SetFOV;
    MyCRI.bEnhancedMessages = bEnhancedMessages;
    MyCRI.bTournament= bTournament;
    MyCRI.MessageOfTheDay = MessageOfTheDay;

    for (i = 0; i < MaxArray; i++)
    {
        MyCRI.IStats1[i].FlagCaps = 0;
        MyCRI.IStats1[i].FlagGrabs = 0;
        MyCRI.IStats1[i].BaseSeals = 0;
        MyCRI.IStats1[i].FlagAssists = 0;
        MyCRI.IStats3[i].FlagCovers = 0;
        MyCRI.IStats2[i].FlagKills = 0;
        MyCRI.SealsSpreeCount[i] = 0;
        MyCRI.CoversSpreeCount[i] = 0;
        MyCRI.TotalDamageAmmount[i] = 0;
        MyCRI.IStats2[i].FlagsDenied = 0;
        MyCRI.IStats2[i].FlagSaves = 0;
        MyCRI.HeadShotsCount[i] = 0;
        MyCRI.TotalKills[i] = 0;
        MyCRI.TotalDeaths[i] = 0;
        MyCRI.CurrentRanking[i] = 0;
        MyCRI.CurrentTotalAccuracy[i] = 0;
        MyCRI.ClientHitSound[i] = 0;
        MultiKills[i].MultiLevel = 0;
        MultiKills[i].MultiTime = 0;
        NumFlagGrabs[i] = 0;
        MyCRI.IStats2[i].GameSaves = 0;
        MyCRI.StoredPlayerIP[i] = "";
        MyCRI.IPCTexture[i] = "";
        MyCRI.ClientIdentified[i] = 0;
        FlagGrabs[i] = none;
        FlagAssists[i] = none;
        MyCRI.EnforcerHitCount[i] = 0;
        MyCRI.BioGunHitCount[i] = 0;
        MyCRI.ShockRifleHitCount[i] = 0;
        MyCRI.PulseGunHitCount[i] = 0;
        MyCRI.RipperHitCount[i] = 0;
        MyCRI.MiniGunHitCount[i] = 0;
        MyCRI.FlakGunHitCount[i] = 0;
        MyCRI.EightBallHitCount[i] = 0;
        MyCRI.SniperRifleHitCount[i] = 0;
        MyCRI.SuperShockRifleHitCount[i] = 0;
        MyCRI.PlayerAccuracy1[i].Enforcer = 0;
        MyCRI.PlayerAccuracy1[i].BioGun = 0;
        MyCRI.PlayerAccuracy1[i].ShockRifle = 0;
        MyCRI.PlayerAccuracy2[i].PulseGun = 0;
        MyCRI.PlayerAccuracy2[i].Ripper = 0;
        MyCRI.PlayerAccuracy2[i].MiniGun = 0;
        MyCRI.PlayerAccuracy3[i].FlakCannon = 0;
        MyCRI.PlayerAccuracy3[i].EightBall = 0;
        MyCRI.PlayerAccuracy3[i].SniperRifle = 0;
        MyCRI.PlayerAccuracy3[i].InstaGib = 0;
        MyCRI.KillingSpree[i].UltraKills = 0;
        MyCRI.KillingSpree[i].MonsterKills = 0;
        MyCRI.KillingSpree[i].LudicriousKills = 0;
        MyCRI.KillingSpree[i].HolyShitKills = 0;
        MyCRI.MultiKills1[i].KillingSpree = 0;
        MyCRI.MultiKills1[i].Rampage = 0;
        MyCRI.MultiKills1[i].Dominating = 0;
        MyCRI.MultiKills2[i].UnStoppable = 0;
        MyCRI.MultiKills2[i].Godlike = 0;
        MyCRI.MultiKills2[i].Ownage = 0;
        MyCRI.HeadHunterCount[i] = 0;
        MyCRI.ComboWhoreCount[i] = 0;
        MyCRI.FlakMonkeyCount[i] = 0;
        FlakKills[i] = 0;
        ComboKills[i] = 0;
        MyCRI.ArmorAmmount[i] = 0;
        MyCRI.HealthAmmount[i] = 0;
        WeaponDamage[i].Enforcer = 0;
        WeaponDamage[i].BioGun = 0;
        WeaponDamage[i].ShockRifle = 0;
        WeaponDamage[i].PulseGun = 0;
        WeaponDamage[i].Ripper = 0;
        WeaponDamage[i].MiniGun = 0;
        WeaponDamage[i].FlakGun = 0;
        WeaponDamage[i].EightBall = 0;
        WeaponDamage[i].SniperRifle = 0;
        WeaponDamage[i].SuperShockRifle = 0;
        AKMS[i] = 0;
        MyCRI.CustomWeaponHitCount[i] = 0;
        WeaponDamage[i].CustomWeapon = 0;
        MyCRI.PlayerAccuracy4[i].CustomWeapon = 0;
        SplashKills[i].FlakTime = 0;
        SplashKills[i].LastHit = none;
    }
}

//-------------------------------------
// InitializeLogging
//-------------------------------------
function InitializeLogging()
{
    local Mutator M;

    StatLink.bWorld = False;
	StatLink.StartLog();
	StatLink.LogStandardInfo();
	StatLink.LogServerInfo();
    StatLink.LogMapParameters();

     for (M = Level.Game.BaseMutator; M != None; M = M.NextMutator)
         StatLink.AddMutator(M);

    StatLink.LogMutatorList();
    Level.Game.LogGameParameters(StatLink);
	Level.Game.LocalLog = StatLink;
	Level.Game.LocalLogFileName = StatLink.GetLogFileName();
}

//-------------------------------------
// InitGameReplicationInfo
//-------------------------------------
function InitGameReplicationInfo()
{
	Super.InitGameReplicationInfo();
    ResetVars();
}

//-------------------------------------
// StartMatch
//-------------------------------------
function StartMatch()
{
    Super.StartMatch();
    log("Match Started");
    if (bTournament) { ResetVars(); MyCRI.bWarmupSwitch = true; }
    MyCRI.bMatchStarted = true;
}

//-------------------------------------
// Logout
//-------------------------------------
function Logout(Pawn P)
{
	local int pid;

	pid = P.PlayerReplicationInfo.PlayerID;
    MyCRI = EUTGameReplicationInfo(GameReplicationInfo);

    if (P.PlayerReplicationInfo.HasFlag != none && (!P.PlayerReplicationInfo.HasFlag.IsA('EUTReadyFlag')))
		CTFFlag(P.PlayerReplicationInfo.HasFlag).Drop(0.5 * P.Velocity);

	super(TeamGamePlus).Logout(P);

	MyCRI.IStats1[pid].FlagCaps = 0;
	MyCRI.IStats1[pid].FlagGrabs = 0;
	MyCRI.IStats1[pid].BaseSeals = 0;
	MyCRI.IStats1[pid].FlagAssists = 0;
	MyCRI.IStats3[pid].FlagCovers = 0;
	MyCRI.IStats2[pid].FlagKills = 0;
	MyCRI.SealsSpreeCount[pid] = 0;
	MyCRI.CoversSpreeCount[pid] = 0;
	MyCRI.TotalDamageAmmount[pid] = 0;
	MyCRI.IStats2[pid].FlagsDenied = 0;
	MyCRI.IStats2[pid].FlagSaves = 0;
	MyCRI.HeadShotsCount[pid] = 0;
	MyCRI.TotalKills[pid] = 0;
	MyCRI.TotalDeaths[pid] = 0;
	MyCRI.CurrentRanking[pid] = 0;
	MyCRI.CurrentTotalAccuracy[pid] = 0;
	MyCRI.ClientHitSound[pid] = 0;
	MultiKills[pid].MultiLevel = 0;
    MultiKills[pid].MultiTime = 0;
	MyCRI.StoredPlayerIP[pid] = "";
    MyCRI.IPCTexture[pid] = "";
    MyCRI.ClientIdentified[pid] = 0;
	NumFlagGrabs[pid] = 0;
	MyCRI.IStats2[pid].GameSaves = 0;
    FlagGrabs[pid] = none;
    FlagAssists[pid] = none;
    MyCRI.EnforcerHitCount[pid] = 0;
    MyCRI.BioGunHitCount[pid] = 0;
    MyCRI.ShockRifleHitCount[pid] = 0;
    MyCRI.PulseGunHitCount[pid] = 0;
    MyCRI.RipperHitCount[pid] = 0;
    MyCRI.MiniGunHitCount[pid] = 0;
    MyCRI.FlakGunHitCount[pid] = 0;
    MyCRI.EightBallHitCount[pid] = 0;
    MyCRI.SniperRifleHitCount[pid] = 0;
    MyCRI.SuperShockRifleHitCount[pid] = 0;
    MyCRI.PlayerAccuracy1[pid].Enforcer = 0;
    MyCRI.PlayerAccuracy1[pid].BioGun = 0;
    MyCRI.PlayerAccuracy1[pid].ShockRifle = 0;
    MyCRI.PlayerAccuracy2[pid].PulseGun = 0;
    MyCRI.PlayerAccuracy2[pid].Ripper = 0;
    MyCRI.PlayerAccuracy2[pid].MiniGun = 0;
    MyCRI.PlayerAccuracy3[pid].FlakCannon = 0;
    MyCRI.PlayerAccuracy3[pid].EightBall = 0;
    MyCRI.PlayerAccuracy3[pid].SniperRifle = 0;
    MyCRI.PlayerAccuracy3[pid].InstaGib = 0;
    MyCRI.KillingSpree[pid].UltraKills = 0;
    MyCRI.KillingSpree[pid].MonsterKills = 0;
    MyCRI.KillingSpree[pid].LudicriousKills = 0;
    MyCRI.KillingSpree[pid].HolyShitKills = 0;
    MyCRI.MultiKills1[pid].KillingSpree = 0;
    MyCRI.MultiKills1[pid].Rampage = 0;
    MyCRI.MultiKills1[pid].Dominating = 0;
    MyCRI.MultiKills2[pid].UnStoppable = 0;
    MyCRI.MultiKills2[pid].Godlike = 0;
    MyCRI.MultiKills2[pid].Ownage = 0;
    MyCRI.HeadHunterCount[pid] = 0;
    MyCRI.ComboWhoreCount[pid] = 0;
    MyCRI.FlakMonkeyCount[pid] = 0;
    FlakKills[pid] = 0;
    ComboKills[pid] = 0;
    MyCRI.ArmorAmmount[pid] = 0;
    MyCRI.HealthAmmount[pid] = 0;
    WeaponDamage[pid].Enforcer = 0;
    WeaponDamage[pid].BioGun = 0;
    WeaponDamage[pid].ShockRifle = 0;
    WeaponDamage[pid].PulseGun = 0;
    WeaponDamage[pid].Ripper = 0;
    WeaponDamage[pid].MiniGun = 0;
    WeaponDamage[pid].FlakGun = 0;
    WeaponDamage[pid].EightBall = 0;
    WeaponDamage[pid].SniperRifle = 0;
    WeaponDamage[pid].SuperShockRifle = 0;
    AKMS[pid] = 0;
    MyCRI.CustomWeaponHitCount[pid] = 0;
    WeaponDamage[pid].CustomWeapon = 0;
    MyCRI.PlayerAccuracy4[pid].CustomWeapon = 0;
    SplashKills[pid].FlakTime = 0;
    SplashKills[pid].LastHit = none;
}

//-------------------------------------
// InitGame
//-------------------------------------
event InitGame(string O, out string E)
{
	super(TeamGamePlus).InitGame(O, E);
	if (bRatedGame) GoalTeamScore = 5;
	FragLimit = 0;
	SetGameSpeed(GameSpeed);
}

//-------------------------------------
// Killed
//-------------------------------------
function Killed( Pawn Killer, Pawn Other, name DamageType)
{
	local int next, i;
	local bool bAutoTaunt;
	local Pawn P;
	local int kid, oid;

    if (Killer == none)
    {
        if (DamageType == 'Suicided'
        || (DamageType == 'Fell')
        || (DamageType == 'Burned')
        || (DamageType == 'Drowned')
        || (DamageType == ''))
        {
            super(CTFGame).Killed(Killer, Other,  DamageType);
            return;
        }
    }

    if (Other.bIsPlayer
    && (Other.PlayerReplicationInfo.HasFlag != None)
    && (!Other.PlayerReplicationInfo.HasFlag.IsA('EUTReadyFlag')))
	{
		if (Killer != None)
		{
            if (Killer.bIsPlayer
            && (Other.bIsPlayer)
            && (Killer.PlayerReplicationInfo.Team != Other.PlayerReplicationInfo.Team))
		    {
                kid = Killer.PlayerReplicationInfo.PlayerID;
                oid = Other.PlayerReplicationInfo.PlayerID;
                Killer.PlayerReplicationInfo.Score += FlagKill;
                MyCRI.IStats2[kid].FlagKills++;
                _EndStatsClass.Default.TotalFlagKills++;
                bAutoTaunt = ((TournamentPlayer(Killer) != None) && TournamentPlayer(Killer).bAutoTaunt);

                if (Other.PlayerReplicationInfo.Team == 0 && (RedFlag.bHome))
                {
                    if (FlagSpread(Other.Location, RedFlag.Location) < FlagDeniedDistance)
                    {
                        Killer.PlayerReplicationInfo.Score += DeniedBonus;
                        Killer.ClientMessage("You Denied the Red Team!");

                        if (Level.Game.LocalLog != None)
                            level.game.localLog.logSpecialEvent("flag_denied", kid, oid);

                        MyCRI.IStats2[kid].FlagsDenied++;
                        _EndStatsClass.Default.TotalDenied++;

                        if (bEnhancedMessages)
                           for ( P = Level.PawnList;  P != None;  P = P.NextPawn)
			                  if (CanPlaySound(P))
			                     TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 9);

			            BroadcastLocalizedMessage(class'EUTHudMessages',6,Killer.PlayerReplicationInfo,None,None);
                    }
                }

                if (Other.PlayerReplicationInfo.Team == 1 && (BlueFlag.bHome ))
                {
                    if (FlagSpread(Other.Location, BlueFlag.Location) < FlagDeniedDistance)
                    {
                        Killer.PlayerReplicationInfo.Score += DeniedBonus;
                        Killer.ClientMessage("You Denied the Blue Team!");

                        if (Level.Game.LocalLog != None)
                           level.game.localLog.logSpecialEvent("flag_denied", kid, oid);

                        MyCRI.IStats2[kid].FlagsDenied++;
                        _EndStatsClass.Default.TotalDenied++;

                        if (bEnhancedMessages)
                           for ( P = Level.PawnList;  P != None;  P = P.NextPawn)
    		                    if (CanPlaySound(P))
                                    TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 9);

                        BroadcastLocalizedMessage(class'EUTHudMessages',6,Killer.PlayerReplicationInfo,None,None);
                    }
                }
            }

            if (Bot(Killer) != None || (bAutoTaunt))
            {
                next = Rand(class<ChallengeVoicePack>(Killer.PlayerReplicationInfo.VoiceType).Default.NumTaunts);

                for (i = 0; i < 4; i++)
                {
                    if (next == LastTaunt[i])
                        next = Rand(class<ChallengeVoicePack>(Killer.PlayerReplicationInfo.VoiceType).Default.NumTaunts);

                    if (i > 0)
                        LastTaunt[i-1] = LastTaunt[i];

                }
                LastTaunt[3] = next;
                Killer.SendGlobalMessage(None, 'AUTOTAUNT', next, 5);
			}
		}
		CTFFlag(Other.PlayerReplicationInfo.HasFlag).Drop(0.5 * Other.Velocity);
	}

    if (Killer != Other && (Killer != none))
    {
        kid = Killer.PlayerReplicationInfo.PlayerID;
        oid = Other.PlayerReplicationInfo.PlayerID;

        if ((DamageType == 'FlakDeath') || (DamageType == 'shredded'))
        {
            FlakKills[kid]++;
            if (FlakKills[kid] == 30)
            {
                FlakKills[kid] = 0;
                if (Level.Game.LocalLog != None)
                    level.game.localLog.logSpecialEvent("flak_monkey", kid, oid);

                PlayerPawn(Killer).ReceiveLocalizedMessage( class'EUTHudMessages', 15);
                BroadCastMessage(Killer.PlayerReplicationInfo.PlayerName$" Is A FlakMonkey!!!!",false);
                MyCRI.FlakMonkeyCount[kid]++;
                if (CanPlaySound(Killer))
                    TournamentPlayer(PlayerPawn(Killer)).ReceiveLocalizedMessage( class'EUTMultiKillMessage', 101);

            }
        }
        if (DamageType == 'Decapitated')
        {
            kid = Killer.PlayerReplicationInfo.PlayerID;
            oid = Other.PlayerReplicationInfo.PlayerID;
            MyCRI.HeadShotsCount[kid]++;

            if (MyCRI.HeadShotsCount[kid] > 30)
            {
                if (Level.Game.LocalLog != None)
                    level.game.localLog.logSpecialEvent("head_hunter", kid, oid);

                PlayerPawn(Killer).ReceiveLocalizedMessage( class'EUTHudMessages', 9 );
                MyCRI.HeadShotsCount[kid] = 0;
                BroadCastMessage(Killer.PlayerReplicationInfo.PlayerName$" Is A HeadHunter!!!!",false);
                MyCRI.HeadHunterCount[kid]++;
                if (CanPlaySound(Killer))
                    TournamentPlayer(PlayerPawn(Killer)).ReceiveLocalizedMessage( class'EUTMultiKillMessage', 102);

            }
        }
    }

    if (Killer != none
    && (Killer.Weapon != none)
    && (Killer.IsA('PlayerPawn'))
    && (!Killer.Weapon.IsA('SuperShockRifle'))
    && (_GetItemName(Killer.Weapon) != "ZP_SUPERSHOCKRIFLE"))
    {
        if (DamageType == 'Jolted')
        {
            if (Other.health < -50)
            {
                kid = Killer.PlayerReplicationInfo.PlayerID;
                oid = Other.PlayerReplicationInfo.PlayerID;
                ComboKills[kid]++;

                if (ComboKills[kid] == 30)
                {
                    ComboKills[kid] = 0;
                    if (Level.Game.LocalLog != None)
                        level.game.localLog.logSpecialEvent("combo_whore", kid, oid);

                    PlayerPawn(Killer).ReceiveLocalizedMessage( class'EUTHudMessages', 16);
                    BroadCastMessage(Killer.PlayerReplicationInfo.PlayerName$" Is A ComboWhore!!!!",false);
                    MyCRI.ComboWhoreCount[kid]++;
                    if (CanPlaySound(Killer))
                        TournamentPlayer(PlayerPawn(Killer)).ReceiveLocalizedMessage( class'EUTMultiKillMessage', 103);

                }
            }
        }
    }

    if (Other != none && (Killer != none))
       ProcessExtendedSprees(Other.Spree);

	super(TeamGamePlus).Killed(Killer, Other, DamageType);
}

//-------------------------------------
// ProcessExtendedSprees
//-------------------------------------
function ProcessExtendedSprees(int i)
{
    switch(i)
    {
        case 0: break;
        case 1: break;
        case 2: break;
        case 3: break;
        case 4: break;
        case 5:
        case 6:
        case 7:
        case 8:
        case 9: bExpandSpree = true; ExpandedSpreeSwitch = 6; break;
        case 10:
        case 11:
        case 12:
        case 13:
        case 14: bExpandSpree = true; ExpandedSpreeSwitch = 1; break;
        case 15:
        case 16:
        case 17:
        case 18:
        case 19: bExpandSpree = true; ExpandedSpreeSwitch = 2; break;
        case 20:
        case 21:
        case 22:
        case 23:
        case 24: bExpandSpree = true; ExpandedSpreeSwitch = 3; break;
        case 25:
        case 26:
        case 27:
        case 28:
        case 29: bExpandSpree = true; ExpandedSpreeSwitch = 4; break;
        case 30: break;
    }
    if (i > 29)
    {
        bExpandSpree = true;
        ExpandedSpreeSwitch = 5;
    }
}

//-------------------------------------
// ScoreKill
//-------------------------------------
function ScoreKill(Pawn Killer, Pawn Other)
{
    local string KillerZone, FlagZone;
    local int kid, oid;

	if ((Killer == Other) || (Killer == None))
        Other.PlayerReplicationInfo.Score -= 1;

	if (Killer != none && (Other != none) && (Killer != Other))
	{
        Killer.KillCount++;
        kid = Killer.PlayerReplicationInfo.PlayerID;
        oid = Other.PlayerReplicationInfo.PlayerID;
        MultiKills[oid].MultiLevel = 0;

        if (Level.TimeSeconds - MultiKills[kid].MultiTime < 3)
        {
            ProcessMultiKills(kid);
            if (MultiKills[kid].MultiLevel >= AnnouncerLevel && (bEnhancedSprees))
                BroadcastMessage(class'EUTMultiKillMessage'.static.GetBroadCastString(MultiKills[kid].MultiLevel, Killer.PlayerReplicationInfo,None,None),false,'EUTEvent');

        }
        if (Level.TimeSeconds - MultiKills[kid].MultiTime > 3)
            MultiKills[kid].MultiLevel = 0;

        MultiKills[kid].MultiTime = Level.TimeSeconds;

        if (Killer.bIsPlayer && (Other.bIsPlayer) && (Killer.PlayerReplicationInfo.Team != Other.PlayerReplicationInfo.Team))
        {
            Killer.PlayerReplicationInfo.Score += 1;

            if (Killer.PlayerReplicationInfo.Team == 0 && (Killer.PlayerReplicationInfo.HasFlag == none ))
            {
                if (!BlueFlag.bHome && (BlueFlag.Holder != none))
                {
                    if ( Other.LineOfSightTo(BlueFlag.Holder)
                    && ( FlagSpread(Killer.location, BlueFlag.Holder.Location) < FlagCoverVisibleDistance ))
                    {
                        MyCRI.IStats3[kid].FlagCovers++;
                        MyCRI.CoversSpreeCount[kid]++;
                        _EndStatsClass.Default.TotalCovers++;
                        if (Level.Game.LocalLog != None)
                            Level.Game.LocalLog.logSpecialEvent("flag_cover", kid, oid);

                        Killer.PlayerReplicationInfo.Score += CoversBonus;
                        if (MyCRI.CoversSpreeCount[kid] == 3)
                            BroadcastLocalizedMessage(class'EUTHudMessages',12,Killer.PlayerReplicationInfo,None,None);
                        else if(MyCRI.CoversSpreeCount[kid] == 4)
                            BroadcastLocalizedMessage(class'EUTHudMessages',11,Killer.PlayerReplicationInfo,None,None);
                        else BroadcastLocalizedMessage(class'EUTHudMessages',10,Killer.PlayerReplicationInfo,None,None);
                    }
                    if (!Other.LineOfSightTo(BlueFlag.Holder)
                    && (FlagSpread(Killer.location, BlueFlag.Holder.Location) < FlagCoverHiddenDistance))
                    {
                        MyCRI.IStats3[kid].FlagCovers++;
                        MyCRI.CoversSpreeCount[kid]++;
                        _EndStatsClass.Default.TotalCovers++;
                        if (Level.Game.LocalLog != None)
                            Level.Game.LocalLog.logSpecialEvent("flag_cover", kid, oid);

                        Killer.PlayerReplicationInfo.Score += CoversBonus;
                        if (MyCRI.CoversSpreeCount[kid] == 3)
                            BroadcastLocalizedMessage(class'EUTHudMessages',12,Killer.PlayerReplicationInfo,None,None);
                        else if (MyCRI.CoversSpreeCount[kid] == 4)
                            BroadcastLocalizedMessage(class'EUTHudMessages',11,Killer.PlayerReplicationInfo,None,None);
                        else BroadcastLocalizedMessage(class'EUTHudMessages',10,Killer.PlayerReplicationInfo,None,None);
                    }
                    if (Other.PlayerReplicationInfo.PlayerZone != none && (RedFlag.bHome))
                    {
                        KillerZone = caps(Other.PlayerReplicationInfo.PlayerZone.ZoneName);
                        FlagZone = caps(BlueFlag.Holder.PlayerReplicationInfo.PlayerZone.ZoneName);
                        if (instr(KillerZone,"RED") != -1 && (instr(FlagZone,"RED") != -1))
                        {
                            MyCRI.IStats1[kid].BaseSeals++;
                            MyCRI.SealsSpreeCount[kid]++;
                            _EndStatsClass.Default.TotalSeals++;
                            if (Level.Game.LocalLog != None)
                                Level.Game.LocalLog.logSpecialEvent("flag_seal", kid, oid);
                            Killer.PlayerReplicationInfo.Score += SealsBonus;
                            if (MyCRI.SealsSpreeCount[kid] == 2)
                                BroadcastLocalizedMessage(class'EUTHudMessages',13,Killer.PlayerReplicationInfo,None,None);

                        }
                    }
                }
            }
            if (Killer.PlayerReplicationInfo.Team == 1
            && (Killer.PlayerReplicationInfo.HasFlag == none))
            {
                if (!RedFlag.bHome && (RedFlag.Holder != none))
                {
                    if (Other.LineOfSightTo(RedFlag.Holder)
                    && (FlagSpread(Killer.location, RedFlag.Holder.Location) < FlagCoverVisibleDistance))
                    {
                        MyCRI.IStats3[kid].FlagCovers++;
                        MyCRI.CoversSpreeCount[kid]++;
                        _EndStatsClass.Default.TotalCovers++;
                        if (Level.Game.LocalLog != None)
                            Level.Game.LocalLog.logSpecialEvent("flag_cover", kid, oid);
                        Killer.PlayerReplicationInfo.Score += CoversBonus;
                        if(MyCRI.CoversSpreeCount[kid] == 3)
                            BroadcastLocalizedMessage(class'EUTHudMessages',12,Killer.PlayerReplicationInfo,None,None);
                        else if(MyCRI.CoversSpreeCount[kid] == 4)
                            BroadcastLocalizedMessage(class'EUTHudMessages',11,Killer.PlayerReplicationInfo,None,None);
                        else BroadcastLocalizedMessage(class'EUTHudMessages',10,Killer.PlayerReplicationInfo,None,None);
                    }
                    if (!Other.LineOfSightTo(RedFlag.Holder)
                    && (FlagSpread(Killer.location, RedFlag.Holder.Location) < FlagCoverHiddenDistance))
                    {
                        MyCRI.IStats3[kid].FlagCovers++;
                        MyCRI.CoversSpreeCount[kid]++;
                        _EndStatsClass.Default.TotalCovers++;
                        if (Level.Game.LocalLog != None)
                            level.game.localLog.logSpecialEvent("flag_cover", kid, oid);
                        Killer.PlayerReplicationInfo.Score += CoversBonus;
                        if (MyCRI.CoversSpreeCount[kid] == 3)
                            BroadcastLocalizedMessage(class'EUTHudMessages',12,Killer.PlayerReplicationInfo,None,None);
                        else if(MyCRI.CoversSpreeCount[kid] == 4)
                            BroadcastLocalizedMessage(class'EUTHudMessages',11,Killer.PlayerReplicationInfo,None,None);
                        else BroadcastLocalizedMessage(class'EUTHudMessages',10,Killer.PlayerReplicationInfo,None,None);
                    }
                    if (Other.PlayerReplicationInfo.PlayerZone != none && (BlueFlag.bHome))
                    {
                        KillerZone = caps(Other.PlayerReplicationInfo.PlayerZone.ZoneName);
                        FlagZone = caps(RedFlag.Holder.PlayerReplicationInfo.PlayerZone.ZoneName);

                        if (instr(KillerZone,"BLUE") != -1 && (instr(FlagZone,"BLUE") != -1))
                        {
                            MyCRI.IStats1[kid].BaseSeals++;
                            MyCRI.SealsSpreeCount[kid]++;
                            _EndStatsClass.Default.TotalSeals++;
                            if (Level.Game.LocalLog != None)
                                Level.Game.LocalLog.logSpecialEvent("flag_seal", kid, oid);

                            Killer.PlayerReplicationInfo.Score += SealsBonus;
                            if (MyCRI.SealsSpreeCount[kid] == 2)
                                BroadcastLocalizedMessage(class'EUTHudMessages',13,Killer.PlayerReplicationInfo,None,None);
                        }
                    }
                }
            }
        }
	}
    if (Other != none
    && (Other.PlayerReplicationInfo != none)
    && (MyCRI.SealsSpreeCount[oid] != 0))
        MyCRI.SealsSpreeCount[oid] = 0;

    if (Other != none
    && (Other.PlayerReplicationInfo != none)
    && (MyCRI.CoversSpreeCount[oid] != 0))
        MyCRI.CoversSpreeCount[oid] = 0;

    if (bAltScoring
    && (Killer != Other)
    && (Killer != None)
    && (Other.bIsPlayer))
        Other.PlayerReplicationInfo.Score -= 1;

    Other.DieCount++;
    BaseMutator.ScoreKill(Killer, Other);
}

//-------------------------------------
// ProcessMultiKills
//-------------------------------------
function ProcessMultiKills(int pid)
{
    MultiKills[pid].MultiLevel++;

    switch (MultiKills[pid].MultiLevel)
    {
        case 0: break;
        case 1: break;
        case 2: break;
        case 3:
            if (Level.Game.LocalLog != None)
                Level.Game.LocalLog.LogSpecialEvent(Level.Game.LocalLog.GetTimeStamp()$Chr(9)$"spree"$chr(9)$"spree_meg"$chr(9)$pid);
            break;
        case 4: MyCRI.KillingSpree[pid].UltraKills++; break;
        case 5: MyCRI.KillingSpree[pid].MonsterKills++; break;
        case 6:
            MyCRI.KillingSpree[pid].LudicriousKills++;
            if (Level.Game.LocalLog != None)
                Level.Game.LocalLog.LogSpecialEvent(Level.Game.LocalLog.GetTimeStamp()$Chr(9)$"spree"$chr(9)$"spree_lud"$chr(9)$pid);
            break;
        case 7:
        case 8:
        case 9:
        case 10:
        case 11:
        case 12:
        case 13:
        case 14:
        case 15:
        case 16:
        case 17:
        case 18:
            MyCRI.KillingSpree[pid].HolyShitKills++;
            if (Level.Game.LocalLog != None)
                Level.Game.LocalLog.LogSpecialEvent(Level.Game.LocalLog.GetTimeStamp()$Chr(9)$"spree"$chr(9)$"spree_hs"$chr(9)$pid);
            break;
        case 19:
            MyCRI.KillingSpree[pid].HolyShitKills++;
            if (Level.Game.LocalLog != None)
                Level.Game.LocalLog.LogSpecialEvent(Level.Game.LocalLog.GetTimeStamp()$Chr(9)$"spree"$chr(9)$"spree_hs"$chr(9)$pid);
            MultiKills[pid].MultiLevel = 0;
            break;
    }
}

//-------------------------------------
// NotifySpree
//-------------------------------------
function NotifySpree(Pawn Other, int i)
{
	local Pawn P;
	local int oid;

    oid = Other.PlayerReplicationInfo.PlayerID;

    if (i != 5
	&& (i != 10)
	&& (i != 15)
	&& (i != 20)
	&& (i != 25)
	&& (i != 30))
	   return;

    switch (i)
    {
        case 5:
           i = 0;
		   MyCRI.MultiKills1[oid].KillingSpree++;
           break;
        case 10:
           i = 1;
		   MyCRI.MultiKills1[oid].Rampage++;
           break;
        case 15:
           i = 2;
		   MyCRI.MultiKills1[oid].Dominating++;
           break;
        case 20:
           i = 3;
		   MyCRI.MultiKills2[oid].UnStoppable++;
           break;
        case 25:
           i = 4;
	       MyCRI.MultiKills2[oid].Godlike++;
           break;
        case 30:
           i = 5;
		   MyCRI.MultiKills2[oid].Ownage++;
		   Other.Spree = 0;
		   if (Level.Game.LocalLog != None)
		        Level.Game.LocalLog.LogSpecialEvent(Level.Game.LocalLog.GetTimeStamp()$Chr(9)$"spree"$chr(9)$"spree_wks"$chr(9)$oid);
           break;
    }

    for (P = Level.PawnList; P != None; P = P.NextPawn)
	{
		if (P.IsA('TournamentPlayer'))
			P.ReceiveLocalizedMessage( class'KillingSpreeMessage', i, Other.PlayerReplicationInfo );

        if (CanPlaySound(P) && (i == 5) && (bEnhancedSprees))
        {
            BroadcastLocalizedMessage(class'EUTHudMessages', i, Other.PlayerReplicationInfo, None, None);
			TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTMultiKillMessage', 104);
		}
    }
}

//-------------------------------------
//  FlagSpread
//-------------------------------------
function float FlagSpread(vector v, vector w)
{
  local vector z;
  z = v - w;
  return Vsize(z);
}

//-------------------------------------
//  SetEndCams
//-------------------------------------
function bool SetEndCams(string Reason)
{
	local TeamInfo BestTeam;
	local FlagBase BestBase;
	local CTFFlag BestFlag;
	local Pawn P;
	local int i;
	local PlayerPawn PP;

	for (i = 0; i < MaxTeams; i++)
	   if ((BestTeam == None) || (BestTeam.Score < Teams[i].Score))
			BestTeam = Teams[i];

    for (i = 0; i < MaxTeams; i++)
    {
		if ((BestTeam.TeamIndex != i) && (BestTeam.Score == Teams[i].Score))
		{
            BroadcastLocalizedMessage(DMMessageClass, 0);
			return false;
		}
    }

    foreach AllActors(class'CTFFlag', BestFlag)
		if (BestFlag.Team == BestTeam.TeamIndex)
			break;

	BestBase = BestFlag.HomeBase;
	GameReplicationInfo.GameEndedComments = TeamPrefix@BestTeam.TeamName@GameEndedMessage;

	EndTime = Level.TimeSeconds + 3.0;
	for (P = Level.PawnList; P != None; P = P.nextPawn)
	{
		CalculateRanking(P);
        P.GotoState('GameEnded');
		PP = PlayerPawn(P);
		if (PP != None)
		{
			PP.bBehindView = true;
			PP.ViewTarget = BestBase;
			PP.ClientGameEnded();

			if (!bTutorialGame && (!bEnhancedMessages))
				PlayWinMessage(PP, (PP.PlayerReplicationInfo.Team == BestTeam.TeamIndex));

            if (!bTutorialGame && (bEnhancedMessages))
			{
				if (CanPlaySound(P))
				{
				   if (Teams[0].Score > Teams[1].Score && (Teams[1].Score != 0))
				      TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 11);

                   else if (Teams[0].Score > Teams[1].Score && (Teams[1].Score == 0))
				      TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 13);

                   else if (Teams[1].Score > Teams[0].Score && (Teams[0].Score != 0))
				      TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 12);

                   else if (Teams[1].Score > Teams[0].Score && (Teams[0].Score == 0))
				      TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 13);

                }
            }
		}
	}
	BestBase.bHidden = false;
	BestFlag.bHidden = true;
	CalcEndStats();
	return true;
}

//-------------------------------------
//  CalcEndStats
//-------------------------------------
function CalcEndStats()
{
	local int i;
	local PlayerReplicationInfo PRI;
	local Pawn P;
	local int pid;

    Log("!!!!!!!!!!!!!!! CALC END STATS");

	for (i = 0; i < 3; i++)
	{
		BestRanking[i] = _EndStatsClass.Default.BestRanking[i];
		BestPlayers[i] = _EndStatsClass.Default.BestPlayers[i];
	}

    for (i = 0; i < 32; i++)
    {
	    if (GameReplicationInfo.PRIArray[i] != None)
	    {
            PRI =  GameReplicationInfo.PRIArray[i];
            if (Caps(PRI.PlayerName) != "PLAYER")
		      EmptyBestCTFSlot(MyCRI.CurrentRanking[PRI.PlayerID], PRI.PlayerName);
        }
    }
    for (i = 0; i < 3; i++)
    {
        _EndStatsClass.Default.BestPlayers[i] = BestPlayers[i];
        _EndStatsClass.Default.BestRanking[i] = BestRanking[i];
    }

    EndStatsClass.Default.TotalGames++;
	EndStatsClass.Static.StaticSaveConfig();
	_EndStatsClass.Static.StaticSaveConfig();

	for (P = Level.PawnList; P != None; P = P.NextPawn)
	{
	    if (P.IsA('Bot') || P.IsA('PlayerPawn'))
	    {
            if (P.PlayerReplicationInfo != none && (P.PlayerReplicationInfo.PlayerName != "Player"))
            {
                pid = P.PlayerReplicationInfo.PlayerID;
                if (Level.Game.LocalLog != none && (bStatLink))
                {
                    Level.Game.LocalLog.LogSpecialEvent("stat_player", "accuracy", pid, string(MyCRI.CurrentTotalAccuracy[pid]));
                    //Weapon Specific Accuracy
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Enforcer",pid, string(MyCRI.PlayerAccuracy1[pid].Enforcer));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","GES Bio Rifle",pid, string(MyCRI.PlayerAccuracy1[pid].BioGun));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Shock Rifle",pid, string(MyCRI.PlayerAccuracy1[pid].ShockRifle));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Ripper",pid, string(MyCRI.PlayerAccuracy2[pid].Ripper));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Pulse Gun",pid, string(MyCRI.PlayerAccuracy2[pid].PulseGun));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Minigun",pid, string(MyCRI.PlayerAccuracy2[pid].MiniGun));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Flak Cannon",pid, string(MyCRI.PlayerAccuracy3[pid].FlakCannon));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Rocket Launcher",pid, string(MyCRI.PlayerAccuracy3[pid].EightBall));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Sniper Rifle",pid, string(MyCRI.PlayerAccuracy3[pid].SniperRifle));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Enhanced Shock Rifle",pid, string(MyCRI.PlayerAccuracy3[pid].InstaGib));
                    Level.Game.LocalLog.LogSpecialEvent("weap_accuracy","Custom Weapon",pid,string(MyCRI.PlayerAccuracy4[pid].CustomWeapon));
                    //Weapon Hit Count
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Enforcer",pid, string(MyCRI.EnforcerHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","GES Bio Rifle",pid, string(MyCRI.BioGunHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Shock Rifle",pid, string(MyCRI.ShockRifleHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Ripper",pid, string(MyCRI.RipperHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Pulse Gun",pid, string(MyCRI.PulseGunHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Minigun",pid, string(MyCRI.MiniGunHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Flak Cannon",pid, string(MyCRI.FlakGunHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Rocket Launcher",pid, string(MyCRI.EightBallHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Sniper Rifle",pid, string(MyCRI.SniperRifleHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Enhanced Shock Rifle",pid, string(MyCRI.SuperShockRifleHitCount[pid]));
                    Level.Game.LocalLog.LogSpecialEvent("weap_hitcount","Custom Weapon",pid, string(MyCRI.CustomWeaponHitCount[pid]));
                    //Weapon Damage
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Enforcer",pid, string(WeaponDamage[pid].Enforcer));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","GES Bio Rifle",pid, string(WeaponDamage[pid].BioGun));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Shock Rifle",pid, string(WeaponDamage[pid].ShockRifle));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Ripper",pid, string(WeaponDamage[pid].Ripper));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Pulse Gun",pid, string(WeaponDamage[pid].PulseGun));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Minigun",pid, string(WeaponDamage[pid].MiniGun));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Flak Cannon",pid, string(WeaponDamage[pid].FlakGun));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Rocket Launcher",pid, string(WeaponDamage[pid].EightBall));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Sniper Rifle",pid, string(WeaponDamage[pid].SniperRifle));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Enhanced Shock Rifle",pid, string(WeaponDamage[pid].SuperShockRifle));
                    Level.Game.LocalLog.LogSpecialEvent("weap_damagegiven","Custom Weapon",pid, string(WeaponDamage[pid].CustomWeapon));
                    //Weapon Shot Count
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Enforcer",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy1[pid].Enforcer,MyCRI.EnforcerHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","GES Bio Rifle",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy1[pid].BioGun,MyCRI.BioGunHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Shock Rifle",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy1[pid].ShockRifle,MyCRI.ShockRifleHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Ripper",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy2[pid].Ripper,MyCRI.RipperHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Pulse Gun",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy2[pid].PulseGun,MyCRI.PulseGunHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Minigun",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy2[pid].MiniGun,MyCRI.MiniGunHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Flak Cannon",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy3[pid].FlakCannon,MyCRI.FlakGunHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Rocket Launcher",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy3[pid].EightBall,MyCRI.EightBallHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Sniper Rifle",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy3[pid].SniperRifle,MyCRI.SniperRifleHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Enhanced Shock Rifle",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy3[pid].InstaGib,MyCRI.SuperShockRifleHitCount[pid])));
                    Level.Game.LocalLog.LogSpecialEvent("weap_shotcount","Custom Weapon",pid, string(CalculateShotCount(MyCRI.PlayerAccuracy4[pid].CustomWeapon,MyCRI.CustomWeaponHitCount[pid])));
                }
            }
        }
    }
}

//-------------------------------------
//  CalculateShotCount
//-------------------------------------
function int CalculateShotCount(float a, int h)
{
   local int i;
   a = a/100;
   i = h / a;
   return i;
}

//-------------------------------------
// EmptyBestCTFSlot
//------------------------------------
function EmptyBestCTFSlot(int Rank, string PlayerName)
{
	if (Rank > BestRanking[2])
	{
	   BestRanking[0] = BestRanking[1];
	   BestPlayers[0] = BestPlayers[1];
	   BestRanking[1] = BestRanking[2];
	   BestPlayers[1] = BestPlayers[2];
       BestRanking[2] = Rank;
	   BestPlayers[2] = PlayerName;
       return;
	}
	else if (Rank > BestRanking[1])
	{
	   BestRanking[0] = BestRanking[1];
	   BestPlayers[0] = BestPlayers[1];
       BestRanking[1] = Rank;
	   BestPlayers[1] = PlayerName;
       return;
	}
	else if (Rank > BestRanking[0])
	{
	   BestRanking[0] = Rank;
	   BestPlayers[0] = PlayerName;
       return;
	}
}

//-------------------------------------
//   ScoreFlag
//-------------------------------------
function ScoreFlag(Pawn Scorer, CTFFlag _Flag)
{
	local Pawn P;
	local Actor A;
	local bool bUneven;

    if (Scorer.PlayerReplicationInfo.Team == _Flag.Team)
	{
        if (Level.Game.WorldLog != None)
			Level.Game.WorldLog.LogSpecialEvent("flag_returned", Scorer.PlayerReplicationInfo.PlayerID, Teams[_Flag.Team].TeamIndex);

		if (Level.Game.LocalLog != None)
			Level.Game.LocalLog.LogSpecialEvent("flag_returned", Scorer.PlayerReplicationInfo.PlayerID, Teams[_Flag.Team].TeamIndex);

		BroadcastLocalizedMessage( class'CTFMessage', 1, Scorer.PlayerReplicationInfo, None, _Flag );
		for (P = Level.PawnList; P != None; P = P.NextPawn)
		{
			if (MyCRI.SealsSpreeCount[P.PlayerReplicationInfo.PlayerID] != 0)
                MyCRI.SealsSpreeCount[P.PlayerReplicationInfo.PlayerID] = 0;

            if (MyCRI.CoversSpreeCount[P.PlayerReplicationInfo.PlayerID] != 0)
                MyCRI.CoversSpreeCount[P.PlayerReplicationInfo.PlayerID] = 0;

            if (P.IsA('PlayerPawn'))
				PlayerPawn(P).ClientPlaySound(_ReturnSound);

			if (P.IsA('Bot'))
				Bot(P).SetOrders(BotReplicationInfo(P.PlayerReplicationInfo).RealOrders, BotReplicationInfo(P.PlayerReplicationInfo).RealOrderGiver, true);

		    if (Scorer.PlayerReplicationInfo.Team == 0)
		    {
                if (BlueFlag.bHome && (FlagSpread(RedFlag.Location, BlueFlag.Location) < FlagSaveDistance))
                {
                    if (Scorer == P)
                    {
                        Scorer.PlayerReplicationInfo.Score += SavesBonus;
                        MyCRI.IStats2[Scorer.PlayerReplicationInfo.PlayerID].FlagSaves++;
                        _EndStatsClass.Default.TotalSaves++;

                        if (Level.Game.LocalLog != None)
                            Level.Game.LocalLog.LogSpecialEvent("flag_saved", Scorer.PlayerReplicationInfo.PlayerID, Teams[_Flag.Team].TeamIndex);
                    }
                    if (Teams[1].Score == GoalTeamScore -1 || (bOverTime))
                    {
                        if (CanPlaySound(P) && (bEnhancedMessages))
                            TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 10);

                        MyCRI.IStats2[Scorer.PlayerReplicationInfo.PlayerId].GameSaves++;
                        BroadcastLocalizedMessage( class'EUTHudMessages',8,Scorer.PlayerReplicationInfo,None,None);
                    }
                    if (Teams[1].Score != GoalTeamScore -1)
                    {
                       if (CanPlaySound(P) && (bEnhancedMessages))
                          TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 10);

                       BroadcastLocalizedMessage( class'EUTHudMessages',7,Scorer.PlayerReplicationInfo,None,None);
                    }
                }
            }
            else if (Scorer.PlayerReplicationInfo.Team == 1)
		    {
                if (RedFlag.bHome && (FlagSpread(BlueFlag.Location, RedFlag.Location) < FlagSaveDistance))
                {
                    if (Scorer == P)
                    {
                        Scorer.PlayerReplicationInfo.Score += SavesBonus;
                        MyCRI.IStats2[Scorer.PlayerReplicationInfo.PlayerID].FlagSaves++;
                        _EndStatsClass.Default.TotalSaves++;

                        if (Level.Game.LocalLog != None)
                            Level.Game.LocalLog.LogSpecialEvent("flag_saved", Scorer.PlayerReplicationInfo.PlayerID, Teams[_Flag.Team].TeamIndex);

                    }
                    if (Teams[0].Score == GoalTeamScore -1 || (bOverTime))
                    {
                        if (CanPlaySound(P) && (bEnhancedMessages))
                            TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 10);

                        BroadcastLocalizedMessage( class'EUTHudMessages',8,Scorer.PlayerReplicationInfo,None,None);
                        MyCRI.IStats2[Scorer.PlayerReplicationInfo.PlayerID].GameSaves++;
                    }
                    if (Teams[0].Score != GoalTeamScore -1)
                    {
                       if (CanPlaySound(P) && (bEnhancedMessages))
                          TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 10);

                       BroadcastLocalizedMessage( class'EUTHudMessages',7,Scorer.PlayerReplicationInfo,None,None);
                    }
                }
            }
        }
		return;
	}

    if (!bUneven)
        Teams[Scorer.PlayerReplicationInfo.Team].Score += 1.0;

    CalculateCaps(Scorer);

    if (bRatedGame && (Scorer.IsA('PlayerPawn')))
		bFulfilledSpecial = true;

	if (Scorer == none || (Scorer.PlayerReplicationInfo == none))
	   return;

	for (P = Level.PawnList; P != None; P = P.NextPawn)
	{
		if (P.IsA('PlayerPawn') && (!bEnhancedMessages))
            PlayerPawn(P).ClientPlaySound(_CaptureSound[Scorer.PlayerReplicationInfo.Team]);

		if (CanPlaySound(P) && (bEnhancedMessages) && (!bUneven))
		{
			if (MyCRI.IStats1[Scorer.PlayerReplicationInfo.PlayerID].FlagCaps != 3 && (!bOverTime))
			{
                switch(Scorer.PlayerReplicationInfo.Team)
                {
                    case 0:
                        if (Teams[0].Score <= Teams[1].Score)
                 	        TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 0);

                        else if (Teams[0].Score - 1 == Teams[1].Score && (Teams[0].Score != GoalTeamScore))
                     	    TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 2);

                        else if (Teams[0].Score -2 == Teams[1].Score && (Teams[0].Score != GoalTeamScore))
                     	    TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 4);

                        else if (Teams[0].Score - 2 > Teams[1].Score && (Teams[0].Score != GoalTeamScore))
                     	    TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 6);

                        break;

                    case 1:
                        if (Teams[1].Score <= Teams[0].Score)
                 	         TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 1);

                        else if (Teams[1].Score -1 == Teams[0].Score && (Teams[1].Score != GoalTeamScore))
                     	     TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 3);

                        else if (Teams[1].Score -2 == Teams[0].Score && (Teams[1].Score != GoalTeamScore))
                 	         TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 5);

                        else if (Teams[1].Score -2 > Teams[0].Score && (Teams[1].Score != GoalTeamScore))
                     	     TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 7);
                        break;
                }
            }
            if (MyCRI.IStats1[Scorer.PlayerReplicationInfo.PlayerID].FlagCaps == 3)
               TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 8);

		}
		else if (P.IsA('Bot'))
			Bot(P).SetOrders(BotReplicationInfo(P.PlayerReplicationInfo).RealOrders, BotReplicationInfo(P.PlayerReplicationInfo).RealOrderGiver, true);
	}

	if (Level.Game.WorldLog != None)
		Level.Game.WorldLog.LogSpecialEvent("flag_captured", Scorer.PlayerReplicationInfo.PlayerID, Teams[_Flag.Team].TeamIndex);

	if (Level.Game.LocalLog != None)
		Level.Game.LocalLog.LogSpecialEvent("flag_captured", Scorer.PlayerReplicationInfo.PlayerID, Teams[_Flag.Team].TeamIndex);

	EndStatsClass.Default.TotalFlags++;
	BroadcastLocalizedMessage( class'CTFMessage', 0, Scorer.PlayerReplicationInfo, None, _Flag );
	if (_Flag.HomeBase.Event != '')
		foreach allactors(class'Actor', A, _Flag.HomeBase.Event)
			A.Trigger(_Flag.HomeBase,	Scorer);

	if ((bOverTime || ( GoalTeamScore != 0 ))
    && (Teams[Scorer.PlayerReplicationInfo.Team].Score >= GoalTeamScore))
		EndGame("teamscorelimit");

	else if (bOverTime)
		EndGame("timelimit");
}

//-------------------------------------
//   RestartPlayer
//-------------------------------------
function bool RestartPlayer(Pawn Restart)
{
	local NavigationPoint NP;
	local float tw, sel, pw;
	local bool rv, bPP;
	local Bot _Bot;
	local Pawn P;

    rv = super(TeamGamePlus).RestartPlayer(Restart);

	_Bot = Bot(Restart);
	if (_Bot == None) return rv;

	_Bot.AlternatePath = None;

	if (_Bot.bPowerPlay || (BotReplicationInfo(_Bot.PlayerReplicationInfo).RealOrders == 'Defend'))
	{
		if (FRand() < 0.5)
		{
			_Bot.bPowerPlay = false;
			_Bot.SetOrders('Defend', None, true);
		}
		else
		{
			for (P = Level.PawnList; P != None; P = P.NextPawn)
			{
				if (P.bIsPlayer && (P.PlayerReplicationInfo.Team == _Bot.PlayerReplicationInfo.Team) )
				{
					if (P.IsA('PlayerPawn'))
					{
						bPP = false;
						break;
					}
					else if ((P != _Bot) && P.IsA('Bot') && (Bot(P).Orders == 'Defend'))
						bPP = true;
				}
			}
			if (bPP)
			{
				_Bot.bPowerPlay = true;
				_Bot.SetOrders('Attack', None, true);
			}
		}
	}

	if (BotReplicationInfo(_Bot.PlayerReplicationInfo).RealOrders != 'Attack')
		return rv;

	if (FRand() < 0.8)
	{
		for (NP = Level.NavigationPointList; NP != None; NP = NP.nextNavigationPoint)
		{
            if (NP.IsA('AlternatePath')
            && (AlternatePath(NP).team != _Bot.PlayerReplicationInfo.team)
			&& !AlternatePath(NP).bReturnOnly)
				tw += AlternatePath(NP).selectionWeight;
		}

		sel = FRand() * tw;
		for (NP = Level.NavigationPointList; NP != None; NP = NP.nextNavigationPoint)
		{
            if (NP.IsA('AlternatePath') && (AlternatePath(NP).team != _Bot.PlayerReplicationInfo.team) )
			{
				_Bot.AlternatePath = AlternatePath(NP);
				pw += AlternatePath(NP).SelectionWeight;
				if (pw > sel)
					break;
			}
		}
	}
	Restart.ViewRotation.Pitch = 55554;
	return rv;
}

//-------------------------------------
// ReduceDamage
//-------------------------------------
function int ReduceDamage(int DamageAmmount, name DamageType, Pawn Injured, Pawn Instigator)
{
    if (Injured != none && (!Injured.bIsPlayer))
          return Super(TeamGamePlus).ReduceDamage(DamageAmmount, DamageType, Injured, Instigator);

    if ((Instigator != None)
    && (Injured.PlayerReplicationInfo.Team != Instigator.PlayerReplicationInfo.Team)
    && Injured.IsA('Bot')
    && ((Injured.health < 35)
    || (Injured.PlayerReplicationInfo.HasFlag != None)))
        Bot(Injured).SendTeamMessage(None, 'Other', 4, 15);

    if (Instigator != None && Injured != None)
    {
        If (Injured.PlayerReplicationInfo != None && Instigator.PlayerReplicationInfo != None)
        {
            if (Injured.PlayerReplicationInfo.Team != Instigator.PlayerReplicationInfo.Team)
            {
                MyCRI.TotalDamageAmmount[Instigator.PlayerReplicationInfo.PlayerID]++;
                if (Instigator.Weapon != none)
                    CalculateDamage(Instigator, Injured, DamageType, DamageAmmount);

	            if (MyCRI.ClientHitSound[Instigator.PlayerReplicationInfo.PlayerID] == 1
                && (bHitSounds))
	                TournamentPlayer(PlayerPawn(Instigator)).ReceiveLocalizedMessage( class'EUTHitSoundMessage', 0);

	            return Super(TeamGamePlus).ReduceDamage(DamageAmmount, DamageType, Injured, Instigator);
            }

            if (Injured.PlayerReplicationInfo.Team == Instigator.PlayerReplicationInfo.Team
            && (MyCRI.ClientHitSound[Instigator.PlayerReplicationInfo.PlayerID] == 1)
            && (Instigator != Injured)
            && (bHitSounds))
                TournamentPlayer(PlayerPawn(Instigator)).ReceiveLocalizedMessage( class'EUTHitSoundMessage', 1);
        }
    }

	return Super(TeamGamePlus).ReduceDamage(DamageAmmount, DamageType, Injured, Instigator);
}

//-------------------------------------
//   Timer
//-------------------------------------
function Timer()
{
	local Pawn P;
	local string IP, S;
	local int pid;
	local Inventory Inv;

    if (NumSpectators < MaxSpectators) MyCRI.bCanSpectate = true;
    else MyCRI.bCanSpectate = false;

    for (P = Level.PawnList; P != None; P = P.NextPawn)
	{
        if (P.PlayerReplicationInfo != none)
        {
            pid = P.PlayerReplicationInfo.PlayerID;

            if (P.PlayerReplicationInfo.Team == 0 && (MyCRI.Teams[0].Size == 0))
                AddToTeam(0,P);
            if (P.PlayerReplicationInfo.Team == 1 && (MyCRI.Teams[1].Size == 0))
                AddToTeam(1,P);
        }

        if (P.IsA('Bot') || P.IsA('PlayerPawn'))
	    {
            if (P.PlayerReplicationInfo != none && (P.PlayerReplicationInfo.PlayerName != "Player"))
            {
                MyCRI.ClientPing[pid] = P.PlayerReplicationInfo.Ping;

                if (P.PlayerReplicationInfo.HasFlag != none
                && (!P.PlayerReplicationInfo.HasFlag.IsA('EUTReadyFlag'))
                && (NumFlagGrabs[pid] == 0))
                {
                    MyCRI.IStats1[pid].FlagGrabs++;
                    NumFlagGrabs[pid] = 1;
                    FlagGrabs[pid] = P;
                    FlagAssists[pid] = P;
                    _EndStatsClass.Default.TotalGrabs++;
                }
                switch(P.PlayerReplicationInfo.Team)
                {
                    case RedFlag.Team:
                        if (!BlueFlag.bHeld)
                        {
                            if (FlagGrabs[pid] == P)
                            {
                                NumFlagGrabs[pid] = 0;
                                FlagGrabs[pid] = none;
                            }
                        }
                        if (BlueFlag.bHome)
                        {
                            if (FlagAssists[pid] != none)
                                FlagAssists[pid] = none;
                        }
                        break;

                    case BlueFlag.Team:
                        if (!RedFlag.bHeld)
                        {
                            if (FlagGrabs[pid] == P)
                            {
                                NumFlagGrabs[pid] = 0;
                                FlagGrabs[pid] = none;
                            }
                        }
                        if (RedFlag.bHome)
                        {
                            if (FlagAssists[pid] != none)
                                FlagAssists[pid] = none;
                        }
                        break;

                }
                MyCRI.TotalKills[pid] = P.KillCount;
                MyCRI.TotalDeaths[pid] = P.DieCount;

                if (!P.IsA('Bot'))
                {
                    if (MyCRI.StoredPlayerIP[pid] == "")
                    {
                        IP = PlayerPawn(P).GetPlayerNetworkAddress();
                        IP = Left(IP,InStr(IP,":"));
                        MyCRI.StoredPlayerIP[pid] = IP;
                    }

                    if (MyCRI.StoredPlayerIP[pid] != ""
                    && (bIpToCountry)
                    && (IpToCountry != none)
                    && (MyCRI.ClientIdentified[pid] < MaxTries))
                    {
                        S = IpToCountry.GetItemName(MyCRI.StoredPlayerIP[pid]);

                        if(caps(S) == "!DISABLED")
                        {
                            MyCRI.IPCTexture[pid] = "";
                            MyCRI.ClientIdentified[pid] = MaxTries;
                        }
                        else if(Left(S, 1) != "!")
                        {
                            MyCRI.IPCTexture[pid] = SelElem(S, 5);
                            if (MyCRI.IPCTexture[pid] == "")
                            {
                                MyCRI.IPCTexture[pid] = "";
                                MyCRI.ClientIdentified[pid] = MaxTries;
                            }
                            else
                                MyCRI.ClientIdentified[pid] = MaxTries;
                        }
                        MyCRI.ClientIdentified[pid]++;
                    }
                }
                CalculateRanking(P);

                if (P.Health >= 0)
                    MyCRI.HealthAmmount[pid] = P.Health;
                else
                    MyCRI.HealthAmmount[pid] = 0;

                MyCRI.ArmorAmmount[pid] = 0;
                for (Inv = P.Inventory; Inv != None; Inv = Inv.Inventory)
	               if (Inv.bIsAnArmor)
	                   MyCRI.ArmorAmmount[pid] += Inv.Charge;
            }
        }
    }
    if (RemainingTime <= 0 && (!bAltOvertime) && (bNoOverTime))
       AltEndGame("timelimit");

    if (bNoDroppedFlags)
    {
        if (FlagToReturn != none
        && (FlagToReturn.IsInState('Dropped'))
        && (FlagDropper != none)
        && (FlagDropper.PlayerReplicationInfo != none)
        && (FlagDropper.PlayerReplicationInfo.bFeigningDeath))
        {
            FlagToReturn.SendHome();
            FlagToReturn = none;
        }
    }

    super(DeathMatchPlus).Timer();
}

//-------------------------------------
//   SelElem
//-------------------------------------
static final function string SelElem(string s, int e)
{
	local int i;

	while (e-->1) s = Mid(s, InStr(s,":") + 1);
	i = InStr(s, ":");
	if (i != -1) s = Left(s, i);
    return s;
}

//-------------------------------------
//   CalculateCaps
//-------------------------------------
function CalculateCaps(Pawn Scorer)
{
    local Pawn P;
    local int pid;

    Scorer.PlayerReplicationInfo.Score += FlagCap;
    MyCRI.IStats1[Scorer.PlayerReplicationInfo.PlayerID].FlagCaps++;
    NumFlagGrabs[Scorer.PlayerReplicationInfo.PlayerID] = 0;
    FlagGrabs[Scorer.PlayerReplicationInfo.PlayerID] = none;
    FlagAssists[Scorer.PlayerReplicationInfo.PlayerID] = none;

    for (P = Level.PawnList; P != None; P = P.NextPawn)
    {
        pid = P.PlayerReplicationInfo.PlayerID;
        if (P.IsA('Bot') || P.IsA('PlayerPawn'))
        {
            if (P.PlayerReplicationInfo != none && (P.PlayerReplicationInfo.PlayerName != "Player"))
            {
                if (P.PlayerReplicationInfo.Team == Scorer.PlayerReplicationInfo.Team)
                {
                    if (P != Scorer)
                    {
                        if (FlagAssists[pid] != none)
                        {
                            MyCRI.IStats1[pid].FlagAssists++;

                            if (Level.Game.LocalLog != None)
                                level.game.LocalLog.LogSpecialEvent("flag_assist", MyCRI.IStats1[pid].FlagAssists);

                            _EndStatsClass.Default.TotalAssists++;
                            FlagAssists[pid] = none;
                            P.PlayerReplicationInfo.Score += AssistsBonus;
                            P.clientmessage("You get " $ AssistsBonus $ " bonus pts for the assist!");
                        }

                        if (MyCRI.SealsSpreeCount[pid] != 0)
	                    {
                            P.clientmessage("You killed " $ MyCRI.SealsSpreeCount[pid] $ " people sealing off the base. You get " $ MyCRI.SealsSpreeCount[pid]*SealsBonus $ " bonus pts!");
                            MyCRI.SealsSpreeCount[pid] = 0;
                        }

                        if (MyCRI.CoversSpreeCount[pid] != 0)
	                    {
                            P.clientmessage("You killed " $ MyCRI.CoversSpreeCount[pid] $ " people covering your FC. You get " $ MyCRI.CoversSpreeCount[pid]*CoversBonus $ " bonus pts!");
                            MyCRI.CoversSpreeCount[pid] = 0;
                        }
                    }
                }
            }
        }
    }
}

//-------------------------------------
//   CalculateRanking
//-------------------------------------
function CalculateRanking(Pawn P)
{
    local int pid;

    if (P.PlayerReplicationInfo == none ||(P.PlayerReplicationInfo.PlayerName == "Player"))
        return;

   pid = P.PlayerReplicationInfo.PlayerID;

    MyCRI.CurrentRanking[pid] = 1000
    + (Clamp(int((float(MyCRI.TotalKills[pid]) / float(MyCRI.TotalKills[pid] + MyCRI.TotalDeaths[pid])) * 100), 0, 100) * 10)
    + (MyCRI.CurrentTotalAccuracy[pid] * 10)
    + (MyCRI.IStats1[pid].FlagCaps * 500)
    + (MyCRI.IStats1[pid].FlagAssists * 300)
    + (MyCRI.IStats3[pid].FlagCovers * 400)
    + (MyCRI.IStats1[pid].FlagGrabs * 500)
    + (MyCRI.IStats2[pid].FlagSaves * 800)
    + (MyCRI.IStats2[pid].FlagsDenied * 500)
    + (MyCRI.IStats1[pid].BaseSeals * 400)
    + (MyCRI.IStats2[pid].FlagKills * 200)
    + (MyCRI.IStats2[pid].GameSaves * 1000);

    CalculateAccuracy(P);
}

//-------------------------------------
// CalculateAccuracy
//-------------------------------------
function CalculateAccuracy(Pawn P)
{
     local int pid;
     local int f, t;

     if (P.PlayerReplicationInfo == none ||(P.PlayerReplicationInfo.PlayerName == "Player"))
        return;

     pid = P.PlayerReplicationInfo.PlayerID;
     f = 0;

     t =
     MyCRI.PlayerAccuracy1[pid].Enforcer +
     MyCRI.PlayerAccuracy1[pid].BioGun +
     MyCRI.PlayerAccuracy1[pid].ShockRifle +
     MyCRI.PlayerAccuracy2[pid].MiniGun +
     MyCRI.PlayerAccuracy2[pid].PulseGun +
     MyCRI.PlayerAccuracy2[pid].Ripper +
     MyCRI.PlayerAccuracy3[pid].EightBall +
     MyCRI.PlayerAccuracy3[pid].FlakCannon +
     MyCRI.PlayerAccuracy3[pid].SniperRifle +
     MyCRI.PlayerAccuracy3[pid].InstaGib +
     MyCRI.PlayerAccuracy4[pid].CustomWeapon;

     if (MyCRI.PlayerAccuracy1[pid].Enforcer != 0) f++;
     if (MyCRI.PlayerAccuracy1[pid].BioGun != 0) f++;
     if (MyCRI.PlayerAccuracy1[pid].ShockRifle != 0) f++;
     if (MyCRI.PlayerAccuracy2[pid].MiniGun != 0) f++;
     if (MyCRI.PlayerAccuracy2[pid].PulseGun != 0) f++;
     if (MyCRI.PlayerAccuracy2[pid].Ripper != 0) f++;
     if (MyCRI.PlayerAccuracy3[pid].EightBall != 0) f++;
     if (MyCRI.PlayerAccuracy3[pid].FlakCannon != 0) f++;
     if (MyCRI.PlayerAccuracy3[pid].SniperRifle != 0) f++;
     if (MyCRI.PlayerAccuracy3[pid].InstaGib != 0) f++;
     if (MyCRI.PlayerAccuracy4[pid].CustomWeapon != 0) f++;

     MyCRI.CurrentTotalAccuracy[pid] = t/f;
}

//-------------------------------------
//   GetRules
//-------------------------------------
function string GetRules()
{
	local string ResultSet;
	ResultSet = super(TeamGamePlus).GetRules();

	ResultSet = ResultSet$"\\FlagCap\\"$FlagCap;
	ResultSet = ResultSet$"\\AssistsBonus\\"$AssistsBonus;
	ResultSet = ResultSet$"\\FlagKill\\"$FlagKill;
	ResultSet = ResultSet$"\\CoversBonus\\"$CoversBonus;
	ResultSet = ResultSet$"\\SealsBonus\\"$SealsBonus;
	ResultSet = ResultSet$"\\DeniedBonus\\"$DeniedBonus;
	ResultSet = ResultSet$"\\SavesBonus\\"$SavesBonus;
	ResultSet = ResultSet$"\\bEnhancedSprees\\"$bEnhancedSprees;
	ResultSet = ResultSet$"\\bEnhancedMessages\\"$bEnhancedMessages;
	ResultSet = ResultSet$"\\bShowIPS\\"$bShowIPS;
	ResultSet = ResultSet$"\\bLogMods\\"$bLogMods;
	ResultSet = ResultSet$"\\bCheckDefaults\\"$bCheckDefaults;
	ResultSet = ResultSet$"\\HitSoundSounds\\"$bHitSounds;
	ResultSet = ResultSet$"\\DemoRequest\\"$bDemoRequest;
	ResultSet = ResultSet$"\\AnnouncerLevel\\"$AnnouncerLevel;
	ResultSet = ResultSet$"\\RedTeamName\\"$RedTeamName;
	ResultSet = ResultSet$"\\BlueTeamName\\"$BlueTeamName;
	//Log("GetRules: "$ResultSet,'Rules');
	return ResultSet;
}

//-------------------------------------
//   LogGameParameters
//-------------------------------------
function LogGameParameters(StatLog _StatLog)
{
	local bool bTemp;

	if ( _StatLog == None )
    {
        GameName = "Smart Capture the Flag";
		return;
	}
    GameName = "Capture the Flag";
	bTemp = bCoopWeaponMode;

	if ( Level.Netmode != NM_Standalone )
		bCoopWeaponMode = bMultiWeaponStay;

	super(TeamGamePlus).LogGameParameters(_StatLog);

	bCoopWeaponMode = bTemp;

    _StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"FlagCap"$Chr(9)$FlagCap);
	_StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"AssistsBonus"$Chr(9)$AssistsBonus);
	_StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"FlagKill"$Chr(9)$FlagKill);
	_StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"CoversBonus"$Chr(9)$CoversBonus);
	_StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"SealsBonus"$Chr(9)$SealsBonus);
	_StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"DeniedBonus"$Chr(9)$DeniedBonus);
	_StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"SavesBonus"$Chr(9)$SavesBonus);
	_StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"bEnhancedSprees"$Chr(9)$bEnhancedSprees);
	_StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"bEnhancedMessages"$Chr(9)$bEnhancedMessages);
    _StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"bHitSounds"$Chr(9)$bHitSounds);
    _StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"bDemoRequest"$Chr(9)$bDemoRequest);
	_StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"BlueTeamName"$Chr(9)$BlueTeamName);
	_StatLog.LogEventString(_StatLog.GetTimeStamp()$Chr(9)$"game"$Chr(9)$"RedTeamName"$Chr(9)$RedTeamName);
	GameName = "Smart Capture the Flag";
}

//-------------------------------------
//   PickupQuery
//-------------------------------------
function bool PickupQuery(Pawn Other, Inventory Inv)
{
	local byte x;
    local int st, at, rt, it, kt, mt, bt, i;
    local string s;

    s = caps(mid(string(Inv.Class), instr(string(Inv.Class), ".") + 1));

    if (!bAntiTimer)
    {
        if (bCheckDefaults)
        {
            switch (s)
            {
                case "UT_SHIELDBELT": Inv.DrawScale = 1.0; break;
                case "UDAMAGE": Inv.DrawScale = 1.0; break;
                case "WARHEADLAUNCHER": Inv.DrawScale = 1.0; break;
                case "UT_INVISIBILITY": Inv.DrawScale = 1.0; break;
                case "HEALTHPACK": Inv.DrawScale = 1.0; break;
                case "ARMOR2": Inv.DrawScale = 1.0; break;
                case "UT_JUMPBOOTS": Inv.DrawScale = 1.0; break;
            }
        }
        if (BaseMutator.HandlePickupQuery(Other, Inv, x)) return ( x == 1 );
        if ( Other.Inventory == none ) return true;
	    else return !Other.Inventory.HandlePickupQuery(Inv);
    }

    st = rand(30) + 55;
    at = rand(40) + 100;
    rt = st;
    it = at;
    kt = rand(40) + 100;
    mt = rand(20) + 20;
    bt = mt;

    switch (s)
    {
        case "UT_SHIELDBELT": Inv.ReSpawnTime = st; Inv.DrawScale = 1.0; break;
        case "UDAMAGE": Inv.ReSpawnTime = at; Inv.DrawScale = 1.0; break;

        case "WARHEADLAUNCHER":
            for (i = 0; i < WarheadCount; i++)
            {
                if (Inv.location == WarheadLocation[i])
                {
                    Inv.ReSpawnTime = rt;
                    Inv.DrawScale = 1.0;
                    break;
                }
            }
            break;

        case "UT_INVISIBILITY": Inv.ReSpawnTime = it; Inv.DrawScale = 1.0; break;
        case "HEALTHPACK": Inv.ReSpawnTime = kt; Inv.DrawScale = 1.0; break;
        case "ARMOR2": Inv.ReSpawnTime = mt; Inv.DrawScale = 1.0; break;
        case "UT_JUMPBOOTS": Inv.ReSpawnTime = bt; Inv.DrawScale = 1.0; break;
    }

    if (BaseMutator.HandlePickupQuery(Other, Inv, x)) return (x == 1);
	if (Other.Inventory == none) return true;
	else return !Other.Inventory.HandlePickupQuery(Inv);
}

//-------------------------------------
//   CalculateDamage
//-------------------------------------
function CalculateDamage(Pawn Killer, Pawn Victim, name DamageType, int DamageAmmount)
{
    local int kid, vid;
    local byte i;
    local int health;
    local string s;

    if (Killer == none || (Victim == none) || (bGameEnded)) return;

    if (Killer.PlayerReplicationInfo == none
    || (Victim.PlayerReplicationInfo == none)
    || (Killer.Weapon == none))
       return;

    kid = Killer.PlayerReplicationInfo.PlayerID;
    vid = Victim.PlayerReplicationInfo.PlayerID;
    i = 0;
    health = Victim.Health + MyCRI.ArmorAmmount[vid];
    s = _GetItemName(Killer.Weapon);

    switch (s)
    {
        case "ENFORCER":
        case "DOUBLEENFORCER":
        case "ZP_ENFORCER":
            MyCRI.EnforcerHitCount[kid]++;
            WeaponDamage[kid].Enforcer = WeaponDamage[kid].Enforcer + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            if (DamageType == 'Shot')
            {
                if (Victim.Physics == PHYS_Falling
                && (DamageKills(health, DamageAmmount)
                && (CheckZ(Victim))))
                {
                    i = 1;
                    ParseNotification(Killer, Victim, 'Enf', i);
                    return;
                }
            }
            break;

        case "UT_BIORIFLE":
            MyCRI.BioGunHitCount[kid]++;
            WeaponDamage[kid].BioGun = WeaponDamage[kid].BioGun + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            if (DamageType == 'Corroded')
            {
                if (Victim.Physics == PHYS_Falling
                && (DamageKills(health, DamageAmmount)
                && (CheckZ(Victim))))
                {
                    i = 1;
                    ParseNotification(Killer, Victim, 'Bio', i);
                    return;
                }
            }
            break;

        case "SHOCKRIFLE":
            MyCRI.ShockRifleHitCount[kid]++;
            WeaponDamage[kid].ShockRifle = WeaponDamage[kid].ShockRifle + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            if (DamageType == 'Jolted')
            {
                if (health - DamageAmmount < -100)
                {
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Combo', i);
                        return;
                    }
                }
            }
            break;

        case "SUPERSHOCKRIFLE":
        case "ZP_SHOCKRIFLE":
        case "ZP_SUPERSHOCKRIFLE":
            MyCRI.SuperShockRifleHitCount[kid]++;
            WeaponDamage[kid].SuperShockRifle = WeaponDamage[kid].SuperShockRifle + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            if (Victim.Physics == PHYS_Falling
            && (DamageKills(health, DamageAmmount)
            && (CheckZ(Victim))))
            {
                i = 1;
                ParseNotification(Killer, Victim, 'SuperShock', i);
                return;
            }
            break;

        case "PULSEGUN":
            MyCRI.PulseGunHitCount[kid]++;
            WeaponDamage[kid].PulseGun = WeaponDamage[kid].PulseGun + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            switch (DamageType)
            {
                case 'Pulsed':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Pulse', i);
                        return;
                    }
                    break;

                case 'zapped':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Pulse', i);
                        return;
                    }
                    break;
            }
            break;

        case "RIPPER":
            MyCRI.RipperHitCount[kid]++;
            WeaponDamage[kid].Ripper = WeaponDamage[kid].Ripper + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            switch (DamageType)
            {
                case 'RipperAltDeath':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Ripper', i);
                        return;
                    }
                    break;

                case 'shredded':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Ripper', i);
                        return;
                    }
                    break;

                case 'Decapitated':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Ripper', i);
                        return;
                    }
                    break;
            }
            break;

        case "MINIGUN2":
            MyCRI.MiniGunHitCount[kid]++;
            WeaponDamage[kid].MiniGun = WeaponDamage[kid].MiniGun + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            if (DamageType == 'shot')
            {
                if (Victim.Physics == PHYS_Falling
                && (DamageKills(health, DamageAmmount)
                && (CheckZ(Victim))))
                {
                    i = 1;
                    ParseNotification(Killer, Victim, 'Mini', i);
                    return;
                }
            }
            break;

        case "UT_FLAKCANNON":

            if (Level.TimeSeconds - SplashKills[kid].FlakTime > 1)
            {
                MyCRI.FlakGunHitCount[kid]++;
                WeaponDamage[kid].FlakGun = WeaponDamage[kid].FlakGun + DamageAmmount;
                SplashKills[kid].FlakTime = Level.TimeSeconds;
                SplashKills[kid].LastHit = Victim;
            }
            else if (SplashKills[kid].LastHit != Victim && Level.TimeSeconds - SplashKills[kid].FlakTime < 1)
            {
                MyCRI.FlakGunHitCount[kid]++;
                WeaponDamage[kid].FlakGun = WeaponDamage[kid].FlakGun + DamageAmmount;
                SplashKills[kid].FlakTime = Level.TimeSeconds;
                SplashKills[kid].LastHit = Victim;
            }
            if (!bEnhancedDeathMessages) return;

            switch (DamageType)
            {
                case 'shredded':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Flak', i);
                        return;
                    }
                    break;

                case 'FlakDeath':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Flak', i);
                        return;
                    }
                    break;
            }
            break;

        case "UT_EIGHTBALL":
            MyCRI.EightBallHitCount[kid]++;
            WeaponDamage[kid].EightBall = WeaponDamage[kid].EightBall + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            switch (DamageType)
            {
                case 'GrenadeDeath':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Rockets', i);
                        return;
                    }
                    break;

                case 'RocketDeath':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Rockets', i);
                        return;
                    }
                    break;
            }
            break;

        case "SNIPERRIFLE":
        case "ZP_SNIPERRIFLE":
            MyCRI.SniperRifleHitCount[kid]++;
            WeaponDamage[kid].SniperRifle = WeaponDamage[kid].SniperRifle + DamageAmmount;

            if (!bEnhancedDeathMessages) return;

            switch (DamageType)
            {
                case 'shot':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Sniper', i);
                        return;
                    }
                    break;

                case 'Decapitated':
                    if (Victim.Physics == PHYS_Falling
                    && (DamageKills(health, DamageAmmount)
                    && (CheckZ(Victim))))
                    {
                        i = 1;
                        ParseNotification(Killer, Victim, 'Sniper', i);
                        return;
                    }
                    break;
            }
            break;

        case "IMPACTHAMMER":
            if (!bEnhancedDeathMessages) return;

            if (DamageType == 'Impact')
            {
                if (Victim.Physics == PHYS_Falling
                && (DamageKills(health, DamageAmmount)
                && (CheckZ(Victim))))
                {
                    i = 1;
                    ParseNotification(Killer, Victim, 'Impact', i);
                    return;
                }
            }
            break;

        case "TRANSLOCATOR":
            if (!bEnhancedDeathMessages) return;

            if (DamageType == 'Gibbed')
            {
                if (Victim.Physics == PHYS_Falling
                && (DamageKills(health, DamageAmmount)
                && (CheckZ(Victim))))
                {
                    i = 1;
                    ParseNotification(Killer, Victim, 'Trans', i);
                    return;
                }
            }
            break;

        case CustomWeaponName:
            if (bUsesCustomWeapon)
            {
                MyCRI.CustomWeaponHitCount[kid]++;
                WeaponDamage[kid].CustomWeapon = WeaponDamage[kid].CustomWeapon + DamageAmmount;

                if (!bEnhancedDeathMessages) return;

                switch (DamageType)
                {
                    case 'shot':
                        if (Victim.Physics == PHYS_Falling
                        && (DamageKills(health, DamageAmmount)
                        && (CheckZ(Victim))))
                        {
                            i = 1;
                            ParseNotification(Killer, Victim, 'Sniper', i);
                            return;
                        }
                        break;

                    case 'Decapitated':
                        if (Victim.Physics == PHYS_Falling
                        && (DamageKills(health, DamageAmmount)
                        && (CheckZ(Victim))))
                        {
                            i = 1;
                            ParseNotification(Killer, Victim, 'Sniper', i);
                            return;
                        }
                        break;
                }
            }
            break;
    }
}

//-------------------------------------
//   DamageKills
//-------------------------------------
function bool DamageKills(int x, int i)
{
   if (x <= i) return true;
   else return false;
}

//-------------------------------------
//   CheckZ
//-------------------------------------
function bool CheckZ(Pawn P)
{
    local vector X;

    X.X = P.Location.X;
    X.Y = P.Location.Y;
    X.Z = P.Location.Z + (-150 * LowGravityAerialKillAdjuster);

    if ( FastTrace(X,P.Location) )
       return true;
    else
       return false;
}

//-------------------------------------
//   ParseNotification
//-------------------------------------
function ParseNotification(Pawn Killer, Pawn Victim, name DamageInstigator, byte i)
{
    if (Killer == none || (Victim == none) || (i == 0))
        return;

    if (Killer.IsA('Bot')) return;

    if (i == 1)
    {
        if (DamageInstigator == 'bio'
        || (DamageInstigator == 'Ripper')
        || (DamageInstigator == 'Flak')
        || (DamageInstigator == 'Rockets')
        || (DamageInstigator == 'Sniper')
        || (DamageInstigator == 'SuperShock')
        || (DamageInstigator == 'Trans')
        || (DamageInstigator == 'Combo')
        || (DamageInstigator == 'Enf')
        || (DamageInstigator == 'Pulse')
        || (DamageInstigator == 'Mini')
        || (DamageInstigator == 'Piston')
        || (DamageInstigator == 'Impact'))
        {
            if(CanPlaySound(Killer))
                TournamentPlayer(PlayerPawn(Killer)).ReceiveLocalizedMessage(class'EUTMultiKillMessage', 20);

            AKMS[Killer.PlayerReplicationInfo.PlayerID] = 1;
            BroadcastRegularDeathMessage(Killer, Victim, DamageInstigator);
            return;
        }
    }
}

//-------------------------------------
//   BroadcastRegularDeathMessage
//-------------------------------------
function BroadcastRegularDeathMessage(Pawn Killer, Pawn Other, name DamageType)
{
    local int i;
    local string s;
    local bool b;

    if (Killer == none || (Other == none)) return;

    if (Killer.PlayerReplicationInfo == none
    || (Other.PlayerReplicationInfo == none)
    || (Killer.Weapon == none))
       return;

    if (bEnhancedDeathMessages)
    {
        if (EUTDamageType(DamageType))
        {
            switch (DamageType)
            {
               case 'bio':
                  i = 51;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Ripper':
                  i = 52;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Flak':
                  i = 53;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Rockets':
                  i = 54;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Sniper':
                  i = 55;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'SuperShock':
                  i = 56;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Trans':
                  i = 57;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Combo':
                  i = 58;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Enf':
                  i = 59;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Pulse':
                  i = 60;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Mini':
                  i = 71;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
               case 'Impact':
                  i = 73;
                  BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                  break;
            }
        }

        if (!EUTDamageType(DamageType))
        {
            if (AKMS[Killer.PlayerReplicationInfo.PlayerID] == 1)
            {
               AKMS[Killer.PlayerReplicationInfo.PlayerID] = 0;
               return;
            }

            switch (_GetItemName(Killer.Weapon))
            {
                case "ENFORCER":
                case "DOUBLEENFORCER":
                case "ZP_ENFORCER":
                    i = 11;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "UT_BIORIFLE":
                    i = 12;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "SHOCKRIFLE":
                case "SUPERSHOCKRIFLE":
                case "ZP_SHOCKRIFLE":
                case "ZP_SUPERSHOCKRIFLE":
                    i = 13;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "PULSEGUN":
                    i = 14;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "RIPPER":
                    i = 15;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "MINIGUN2":
                    i = 16;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "UT_FLAKCANNON":
                    i = 17;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "UT_EIGHTBALL":
                    i = 18;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "SNIPERRIFLE":
                case "ZP_SNIPERRIFLE":
                    i = 19;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "IMPACTHAMMER":
                    i = 75;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
                case "TRANSLOCATOR":
                    i = 77;
                    BroadcastLocalizedMessage(DeathMessageClass, i, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);
                    b = true;
                    break;
            }
        }
    }
    if (!bEnhancedDeathMessages && (!b))
        BroadcastLocalizedMessage(DeathMessageClass, 30, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo, Killer.Weapon.Class);

}

//-------------------------------------
//   EUTDamageType
//-------------------------------------
function bool EUTDamageType(name DamageType)
{
   if (DamageType == 'bio'
   || (DamageType == 'Ripper' )
   || (DamageType == 'Flak' )
   || (DamageType == 'Rockets' )
   || (DamageType == 'Sniper' )
   || (DamageType == 'SuperShock' )
   || (DamageType == 'Trans' )
   || (DamageType == 'Combo' )
   || (DamageType == 'Enf' )
   || (DamageType == 'Pulse' )
   || (DamageType == 'Mini' )
   || (DamageType == 'Impact' ))
      return true;
   else
      return false;
}

//-------------------------------------
//   EndSpree
//-------------------------------------
function EndSpree(Pawn Killer, Pawn Other)
{
	local Pawn P;

	if (Other != none)
        if (!Other.bIsPlayer)
		    return;

	for (P = Level.PawnList; P != None; P = P.NextPawn)
    {
        if (P.IsA('TournamentPlayer'))
        {
            if (!bExpandSpree)
            {
                if ((Killer == None) || !Killer.bIsPlayer)
                {
                    TournamentPlayer(P).EndSpree(None, Other.PlayerReplicationInfo);
                    return;
                }
                else
                {
                    TournamentPlayer(P).EndSpree(Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo);
                    return;
                }
            }
            if (bExpandSpree)
            {
                if ((Killer == None) || !Killer.bIsPlayer)
                {
                    TournamentPlayer(P).EndSpree(None, Other.PlayerReplicationInfo);
                    return;
                }
                else
                {
                    TournamentPlayer(P).EndSpree(Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo);

                    switch (ExpandedSpreeSwitch)
                    {
                          case 1:
                              ExpandedSpreeSwitch = 0;
                              bExpandSpree = false;
                              BroadcastMessage(class'EUTMultiKillMessage'.static.GetBroadCastString(21, Killer.PlayerReplicationInfo,Other.PlayerReplicationInfo,None));
                              break;
                          case 2:
                              ExpandedSpreeSwitch = 0;
                              bExpandSpree = false;
                              BroadcastMessage(class'EUTMultiKillMessage'.static.GetBroadCastString(22, Killer.PlayerReplicationInfo,Other.PlayerReplicationInfo,None));
                              break;
                          case 3:
                              ExpandedSpreeSwitch = 0;
                              bExpandSpree = false;
                              BroadcastMessage(class'EUTMultiKillMessage'.static.GetBroadCastString(23, Killer.PlayerReplicationInfo,Other.PlayerReplicationInfo,None));
                              break;
                          case 4:
                              ExpandedSpreeSwitch = 0;
                              bExpandSpree = false;
                              BroadcastMessage(class'EUTMultiKillMessage'.static.GetBroadCastString(24, Killer.PlayerReplicationInfo,Other.PlayerReplicationInfo,None));
                              break;
                          case 5:
                              ExpandedSpreeSwitch = 0;
                              bExpandSpree = false;
                              BroadcastMessage(class'EUTMultiKillMessage'.static.GetBroadCastString(25, Killer.PlayerReplicationInfo,Other.PlayerReplicationInfo,None));
                              break;
                          case 6:
                              ExpandedSpreeSwitch = 0;
                              bExpandSpree = false;
                              BroadcastMessage(class'EUTMultiKillMessage'.static.GetBroadCastString(26, Killer.PlayerReplicationInfo,Other.PlayerReplicationInfo,None));
                              break;
                          default:
                            break;
                    }
                }
            }
        }
	}
}

//-------------------------------------
//   AltEndGame
//-------------------------------------
function AltEndGame(string Reason)
{
	local Actor A;

	AltSetEndCams(Reason);

	bGameEnded = true;
	bAltOvertime = true;

	foreach AllActors(class'Actor', A, 'EndGame')
		A.trigger(self, none);

	if (LocalLog != None)
	{
		LocalLog.LogGameEnd(Reason);
		LocalLog.StopLog();

		if (bBatchLocal)
			LocalLog.ExecuteSilentLogBatcher();

		LocalLog.Destroy();
		LocalLog = None;
	}
	if (WorldLog != None)
	{
		WorldLog.LogGameEnd(Reason);
		WorldLog.StopLog();
		WorldLog.ExecuteWorldLogBatcher();
		WorldLog.Destroy();
		WorldLog = None;
	}
}

//-------------------------------------
//   AltSetEndCams
//-------------------------------------
function bool AltSetEndCams(string Reason)
{
	local TeamInfo BestTeam;
	local FlagBase BestBase;
	local CTFFlag BestFlag;
	local Pawn P;
	local int i;
	local PlayerPawn PP;
	local string EndGameNotify;

	for (i = 0; i < MaxTeams; i++)
	{
        if ((BestTeam == None) || ( BestTeam.Score < Teams[i].Score))
	    {
		    BestTeam = Teams[i];
		    EndGameNotify = TeamPrefix@BestTeam.TeamName@GameEndedMessage;
	    }
    }

	if (BestTeam == none)
	{
        EndGameNotify = "Match Ended for Time Limit!";
	    i = Rand(2);
	    BestTeam = Teams[i];
    }

	ForEach AllActors(class'CTFFlag', BestFlag)
		if ( BestFlag.Team == BestTeam.TeamIndex )
			break;

	BestBase = BestFlag.HomeBase;
	GameReplicationInfo.GameEndedComments = EndGameNotify;

	EndTime = Level.TimeSeconds + 3.0;

	for (P = Level.PawnList; P != None; P = P.nextPawn)
	{
		CalculateRanking(P);
        P.GotoState('GameEnded');
		PP = PlayerPawn(P);

		if (PP != None)
		{
			PP.bBehindView = true;
			PP.ViewTarget = BestBase;
			PP.ClientGameEnded();

			if (!bTutorialGame && (!bEnhancedMessages))
				PlayWinMessage(PP, (PP.PlayerReplicationInfo.Team == BestTeam.TeamIndex));

            if (!bTutorialGame && (bEnhancedMessages))
			{
				if (CanPlaySound(P))
				{
				   if (Teams[0].Score > Teams[1].Score && (Teams[1].Score != 0))
				      TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 11);

                   if (Teams[0].Score > Teams[1].Score && (Teams[1].Score == 0))
				      TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 13);

                   if (Teams[1].Score > Teams[0].Score && (Teams[0].Score != 0))
				      TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 12);

                   if (Teams[1].Score > Teams[0].Score && (Teams[0].Score == 0))
				      TournamentPlayer(PlayerPawn(P)).ReceiveLocalizedMessage( class'EUTTeamGameSounds', 13);

                }
            }
		}
	}
	BestBase.bHidden = false;
	BestFlag.bHidden = true;
	CalcEndStats();
	return true;
}

//-------------------------------------
//    CanPlaySound
//-------------------------------------
function bool CanPlaySound( Pawn P )
{
    if (P.IsA('PlayerPawn')
    && (P.IsA('TournamentPlayer')))
        return true;
    else return false;
}

//-------------------------------------
// _GetItemName
//-------------------------------------
function string _GetItemName(Weapon W)
{
    return caps(mid(string(W.Class), instr(string(W.Class), ".") + 1));
}

//-------------------------------------
//   defaultproperties
//-------------------------------------

defaultproperties
{
    _EndStatsClass=Class'EUTEndStats'
    _CaptureSound(0)=Sound'Botpack.CTF.CaptureSound2'
    _CaptureSound(1)=Sound'Botpack.CTF.CaptureSound3'
    _CaptureSound(2)=Sound'Botpack.CTF.CaptureSound2'
    _CaptureSound(3)=Sound'Botpack.CTF.CaptureSound3'
    _ReturnSound=Sound'Botpack.CTF.ReturnSound'
    bEnhancedSprees=True
    bEnhancedMessages=True
    bShowIPS=True
    bLogMods=True
    bCheckDefaults=True
    bHitSounds=True
    bReport=True
    bAntiTimer=True
    bNoFlockPawns=True
    FlagCap=10
    AssistsBonus=6
    FlagKill=4
    CoversBonus=2
    SealsBonus=2
    DeniedBonus=2
    SavesBonus=2
    AnnouncerLevel=2
    FlagSaveDistance=600.00
    FlagDeniedDistance=600.00
    FlagCoverVisibleDistance=1280.00
    FlagCoverHiddenDistance=700.00
    TraceDistance=3500
    TransKillMessage="%k telefragged %o!"
    ImpactKillMessage="%o got smeared by %k's piston."
    EnforcerKillMessage="%k riddled %o full of holes with the %w."
    BioKillMessage="%o drank a glass of %k's dripping green load."
    ShockRifleKillMessage="%k inflicted mortal damage upon %o with the %w."
    PulseGunKillMessage="%o ate %k's burning plasma death."
    RipperKillMessage="%k ripped a chunk of meat out of %o with the %w."
    MiniGunKillMessage="%k's %w turned %o into a leaky piece of meat."
    FlakCannonKillMessage="%o was ripped to shreds by %k's %w."
    RocketLauncherKillMessage="%o was smacked down by %k's %w."
    SniperRifleKillMessage="%k put a bullet through %o's head."
    AerialKillBio="%k smacked %o out of the air with his %w."
    AerialKillRipper="%k smacked %o out of the air with his %w."
    AerialKillFlak="%k smacked %o out of the air with his %w."
    AerialKillRockets="%k smacked %o out of the air with his %w."
    AerialKillSniper="%k smacked %o out of the air with his %w."
    AerialKillSuper="%k smacked %o out of the air with his %w."
    AerialKillTrans="%k smacked %o out of the air with his %w."
    AerialKillCombo="%k smacked %o out of the air with his %w."
    AerialKillEnforcer="%k smacked %o out of the air with his %w."
    AerialKillPulse="%k smacked %o out of the air with his %w."
    AerialKillMini="%k smacked %o out of the air with his %w."
    AerialKillPiston="%k smacked %o out of the air with his %w."
    RedTeamName="Red Team"
    BlueTeamName="Blue Team"
    SoundPackage="EUT_Sounds"
    RulesMenuType="EUT_Source.EUTCTFRulesClient"
    GameReplicationInfoClass=Class'EUTGameReplicationInfo'
}
